#if 0
#include "vxWorks.h"
#include "taskLib.h"
#include <sockLib.h>
#include <types.h>
#include <net/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stat.h>
#include <stdio.h>
#include <string.h>
#include "htmpages.h"
#include "httpvend.h"
#include "http.h"
#include "app_driver_api.h"
#include "pform_types.h"
#include "rt_os.h"
#endif	/*  */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <arpa/inet.h>
    
#include "wcfglib.h"
#include "cli.h"
#include "httpvend.h"
#include "http.h"
#include "htmpages.h"
    
#define REPORT_LEVEL(x) 0
#define wapp_utilsPrintf(x, y, z) 
    
#define	MAX_REQUEST_LEN	1000
    
/* HTTP/1.0 Title Options upon image sending:
 * 0 - No HTTP title to send. Only the given buffer.
 * 1 - Use HTTP title, but without the Content-Length.
 * 2 - Use HTTP title.
*/ 
#define HTTP_SHOW_IMAGE_OPTION_NO_TITLE			0
#define HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH	1
#define HTTP_SHOW_IMAGE_OPTION_FULL_TITLE		2


wcfgd *wd;
    
/*
	On server startup user may assign up to MAX_HTTP_FUNCS functions.
	Those functions used to create dynamic pieces of html pages.
	If page template has a tag <?N PARAM1 PARAM2 PARAM3> page builder
	will call http_param_func[N]( PARAM1, PARAM2, PARAM3).
	If PARAM has a prefix '?' (i.e. ?PARAMNAME), page bulder parses
	URL /device_ip/page.htm?PARAMNAME1=PARAMVALUE1&PARAMNAME2=PARAMVALUE2
	and passes to the function corresponding PARAMVALUE. 
*/ 
    HTTP_PARAM_FUNC_T * http_param_func[MAX_HTTP_FUNCS];

/*
	it is called rc_buf, but actually this is both recv and send buffer
*/ 
static char rc_buf[RCV_BUF_LEN];

/*
	page builder arrea
*/ 
static unsigned char page_buf[IMAGE_BUF_LEN];
static int page_len;
int client;
struct sockaddr_in sockin;
static int sock = -1;		/* socket for HTTP connection */

/****************************************************************************/ 
struct sockaddr_in sa_local;
struct sockaddr_in sa_remote;

/*
	name_value array and variable used for GET parameters parsing
*/ 
    
#define MAX_HTTP_TAG_STR_LEN	1024
#define MAX_HTTP_PARAM_LEN	128
#define MAX_HTTP_PARAM_NAME_LEN	32
static struct {
	char name[MAX_HTTP_PARAM_NAME_LEN];
	char value[MAX_HTTP_PARAM_LEN];
} params[MAX_PARAM];
static int param_cnt;
static char tag_str[MAX_HTTP_TAG_STR_LEN];
static char param1[MAX_HTTP_PARAM_LEN];
static char param2[MAX_HTTP_PARAM_LEN];
static char param3[MAX_HTTP_PARAM_LEN];
static char param4[MAX_HTTP_PARAM_LEN];
static char param5[MAX_HTTP_PARAM_LEN];
static char param6[MAX_HTTP_PARAM_LEN];
static char param7[MAX_HTTP_PARAM_LEN];
static char param8[MAX_HTTP_PARAM_LEN];
static char param9[MAX_HTTP_PARAM_LEN];
static char param10[MAX_HTTP_PARAM_LEN];
static char param11[MAX_HTTP_PARAM_LEN];
static char param12[MAX_HTTP_PARAM_LEN];
static char param13[MAX_HTTP_PARAM_LEN];
static char param14[MAX_HTTP_PARAM_LEN];
static char param15[MAX_HTTP_PARAM_LEN];
static char param16[MAX_HTTP_PARAM_LEN];
static char param17[MAX_HTTP_PARAM_LEN];
static char param18[MAX_HTTP_PARAM_LEN];
static char param19[MAX_HTTP_PARAM_LEN];
static char param20[MAX_HTTP_PARAM_LEN];
static char param21[MAX_HTTP_PARAM_LEN];
static char param22[MAX_HTTP_PARAM_LEN];
static char param23[MAX_HTTP_PARAM_LEN];
static char param24[MAX_HTTP_PARAM_LEN];
static char param25[MAX_HTTP_PARAM_LEN];
static char param26[MAX_HTTP_PARAM_LEN];
static char param27[MAX_HTTP_PARAM_LEN];
static char param28[MAX_HTTP_PARAM_LEN];
static char param29[MAX_HTTP_PARAM_LEN];
static char param30[MAX_HTTP_PARAM_LEN];
static char param31[MAX_HTTP_PARAM_LEN];
static char param32[MAX_HTTP_PARAM_LEN];
static char param33[MAX_HTTP_PARAM_LEN];
static char param34[MAX_HTTP_PARAM_LEN];
static char param35[MAX_HTTP_PARAM_LEN];
static char param36[MAX_HTTP_PARAM_LEN];
static char param37[MAX_HTTP_PARAM_LEN];
static char param38[MAX_HTTP_PARAM_LEN];
static char param39[MAX_HTTP_PARAM_LEN];
static char param40[MAX_HTTP_PARAM_LEN];
static int tag_ind;

/*static unsigned long httpTaskId;*/ 
    
/* 
	this is dummy TAG handler. It is called for tags those don't have
	a user handler. Currently returns debug string
*/ 
static char p_buf[512];
static unsigned char HtmlEnable = TRUE;
void httpMainLoop(void);
char *http_param_dummy(char *s1, char *s2, char *s3, char *s4, char *s5,
			char *s6, char *s7, char *s8, char *s9, char *s10,
			char *s11, char *s12, char *s13, char *s14, char *s15,
			char *s16, char *s17, char *s18, char *s19, char *s20,
			char *s21, char *s22, char *s23, char *s24, char *s25,
			char *s26, char *s27, char *s28, char *s29, char *s30,
			char *s31, char *s32, char *s33, char *s34, char *s35,
			char *s36, char *s37, char *s38, char *s39, char *s40);
int http_show_image(int, unsigned char *, int, char *, int);

void wdrv_dbInitRangeTables(void);


int create_listening_socket(__u32 ip)
{
	int opt;
	
	if( sock != -1 ) {
		fprintf(stderr, "tiweb: BUG, sock is not -1.\n");
		return 1;
	}
	
	if( (sock = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
		fprintf(stderr, "tiweb: Failed to create socket.\n");
		return 1;
	}

	opt = 1;
	if((setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void *)&opt, sizeof(opt))) == -1) {
		fprintf(stderr, "tiweb: Failed to reuse address.\n");
		close(sock);
		sock = -1;
		return 1;
	}

	memset(&sockin, 0, sizeof(struct sockaddr_in));
	sockin.sin_family = AF_INET;
	sockin.sin_port = htons(HTTP_PORT);
	sockin.sin_addr.s_addr = ip;

	if (bind(sock, (struct sockaddr *) &sockin, sizeof(sockin)) < 0) {
		fprintf(stderr, "tiweb: Failed to bind.\n");
		close(sock);
		sock = -1;
		return 1;
	}
	if (listen(sock, 3) < 0) {
		fprintf(stderr, "tiweb: Failed to listen.\n");
		close(sock);
		sock = -1;
		return 1;
	}

	return 0;
}

int close_listening_socket(void)
{
	int ret;
	
	ret = close(sock);
	sock = -1;
	return ret;
}

/***************************************************************************/ 
/*                      wapp_utilsHttpInit()		                                 */ 
/***************************************************************************/ 
/* DESCRIPTION: Initialize the HTTP server task                            */ 
/*																		                     */ 
/*																		                     */ 
/* INPUT:       Task Priority					                                 */ 
/* OUTPUT:      NONE.                                                      */ 
/*                                                                         */ 
/* RETURNS:     OK for success, NOK otherwise                              */ 
/*                                                                         */ 
/***************************************************************************/ 
    STATUS wapp_utilsHttpInit(__u32 serv_ip) 
{
	
#if 0
	int true = 1;
	int rc;
	int j;
	unsigned long lanIp;
	for (j = 0; j < MAX_HTTP_FUNCS; j++)
		http_param_func[j] = http_param_dummy;
	
	    /* index.htm */ 
	    http_param_func[1] = wlan_htmlGetApMacAddress;
	http_param_func[2] = wlan_htmlGetApEnable;
	http_param_func[3] = wlan_htmlSavePageSetup;
	http_param_func[4] = wlan_htmlGetSsid;
	http_param_func[5] = wlan_htmlGetChannelSelectBandBG;
	http_param_func[6] = wlan_htmlGetFwVersion;
	http_param_func[7] = wlan_htmlGetSwVersion;
	http_param_func[8] = wlan_htmlGetDomain;
	http_param_func[9] = wlan_htmlGetBandMode;
	http_param_func[10] = wlan_htmlGetChannelSelectBandA;
	
	    /* Ipsettings.htm */ 
	    http_param_func[11] = wlan_htmlSavePageIpSettings;
	http_param_func[12] = wlan_htmlGetIpAddr1;
	http_param_func[13] = wlan_htmlGetIpAddr2;
	http_param_func[14] = wlan_htmlGetIpAddr3;
	http_param_func[15] = wlan_htmlGetIpAddr4;
	http_param_func[16] = wlan_htmlGetMask1;
	http_param_func[17] = wlan_htmlGetMask2;
	http_param_func[18] = wlan_htmlGetMask3;
	http_param_func[19] = wlan_htmlGetMask4;
	
	    /* download.htm */ 
	    http_param_func[20] = wlan_htmlSoftwareDownload;
	http_param_func[21] = wlan_htmlGetRunningSector;
	http_param_func[22] = wlan_htmlGetRunningFilename;
	
	    /* statistics.htm */ 
	    http_param_func[23] = wlan_htmlGetLanSendUnicast;
	http_param_func[24] = wlan_htmlGetLanSendMulticast;
	http_param_func[25] = wlan_htmlGetLanRecvUnicast;
	http_param_func[26] = wlan_htmlGetLanRecvMulticast;
	http_param_func[27] = wlan_htmlGetWirelessSendFragments;
	http_param_func[28] = wlan_htmlGetWirelessSendMsdus;
	http_param_func[29] = wlan_htmlGetWirelessSendMulticasts;
	http_param_func[30] = wlan_htmlGetWirelessSendFailed;
	http_param_func[31] = wlan_htmlGetWirelessSendRetry;
	http_param_func[32] = wlan_htmlGetWirelessRecvFragments;
	http_param_func[33] = wlan_htmlGetWirelessRecvMsdus;
	http_param_func[34] = wlan_htmlGetWirelessRecvMulticasts;
	http_param_func[35] = wlan_htmlGetWirelessRecvFcsError;
	
	    /* privacy */ 
	    http_param_func[36] = wlan_htmlGetPrivacyAuthMode;
	http_param_func[37] = wlan_htmlSavePagePrivacy;
	http_param_func[38] = wlan_htmlGetPrivacyWepCipher;
	http_param_func[39] = wlan_htmlGetStationTypes;
	http_param_func[40] = wlan_htmlGetPrivacyPskStringValue;
	http_param_func[41] = wlan_htmlGetKeyIdCheck;
	http_param_func[42] = wlan_htmlGetPrivacyOn;
	http_param_func[43] = wlan_htmlGetPrivacyPsk;
	http_param_func[44] = wlan_htmlGetPrivacyRadiusAddr;
	http_param_func[45] = wlan_htmlGetPrivacyPskHexValue;
	http_param_func[46] = wlan_htmlGetKeyVal0;
	http_param_func[47] = wlan_htmlGetKeyVal1;
	http_param_func[48] = wlan_htmlGetKeyVal2;
	http_param_func[49] = wlan_htmlGetKeyVal3;
	http_param_func[50] = wlan_htmlGetPrivacyGroupKeyInterval;
	http_param_func[51] = wlan_htmlGetPrivacyRadiusPort;
	http_param_func[52] = wlan_htmlGetPrivacyRadiusSecret;
	
	    /* AP Enable/Disable - index.htm */ 
	    http_param_func[53] = wlan_htmlUpdateEnableDisableAP;
	http_param_func[54] = wlan_htmlGetEnableDisableButtonName;
	http_param_func[55] = wlan_htmlGetUpdateButtonValueApEnable;
	http_param_func[56] = wlan_htmlNotYet;
	
	    /* Default Gateway */ 
	    http_param_func[57] = wlan_htmlGetPrivacyDefaultGateway;
	
	    /* config */ 
	    http_param_func[58] = wlan_htmlRestoreDefaults;
	http_param_func[59] = wlan_htmlGetBeaconPeriod;
	http_param_func[60] = wlan_htmlGetDtimPeriod;
	http_param_func[61] = wlan_htmlGetRtsThreshold;
	http_param_func[62] = wlan_htmlGetFragThreshold;
	http_param_func[63] = wlan_htmlDot11ModeCheck;
	http_param_func[64] = wlan_htmlSavePageConfig;
	http_param_func[65] = wlan_htmlGetHiddenSsid;
	http_param_func[66] = wlan_htmlGetPucketBurstSupport;	/* Packet Bursting Support */
	http_param_func[67] = wlan_htmlGetOutputPowerLevel;	/* Output Power Level */
	http_param_func[68] = wlan_htmlGet_A_G_PlusMode;	/* TI a/g+ Support */
	http_param_func[69] = wlan_htmlVhcfCheck;
	http_param_func[70] = wlan_htmlVhcfGetIpAddr1;
	http_param_func[71] = wlan_htmlVhcfGetIpAddr2;
	http_param_func[72] = wlan_htmlVhcfGetIpAddr3;
	http_param_func[73] = wlan_htmlVhcfGetIpAddr4;
	http_param_func[74] = wlan_htmlVhcfGetProtocol1;
	http_param_func[75] = wlan_htmlVhcfGetPort1;
	http_param_func[76] = wlan_htmlVhcfGetProtocol2;
	http_param_func[77] = wlan_htmlVhcfGetPort2;
	
	    /* mgmt */ 
	    http_param_func[78] = wlan_htmlUpdateStationPageMgmt;
	http_param_func[79] = wlan_htmlGetMgmtTableFirstRow;
	http_param_func[80] = wlan_htmlGetMgmtTableSecondRow;
	http_param_func[81] = wlan_htmlGetMgmtTableDynamicRow;
	http_param_func[82] = wlan_htmlGetMgmt_BW_TableFirstRow;
	http_param_func[83] = wlan_htmlGetMgmt_BW_TableDynamicRow;
	http_param_func[84] = wlan_htmlUpdate_BW_DeletePageMgmt;
	http_param_func[85] = wlan_htmlUpdate_BW_AddMacPageMgmt;
	http_param_func[86] = wlan_htmlGetBWTableStatusPageMgmt;
	http_param_func[87] = wlan_htmlSavePageMgmt;
	http_param_func[88] = wlan_htmlGetMultipleSsidStatusPageMgmt;
	http_param_func[89] = wlan_htmlUpdate_SSID_AddMultipleSSIDPageMgmt;
	http_param_func[90] = wlan_htmlUpdate_SSID_DeleteSSIDPageMgmt;
	http_param_func[91] = wlan_htmlGetMgmt_SSID_TableFirstRow;
	http_param_func[92] = wlan_htmlGetMgmt_SSID_TableDynamicRow;
	
	    /* advanced */ 
	    http_param_func[93] = wlan_htmlGetPreambleCheck;
	http_param_func[94] = wlan_htmlGetSlotTimeCheck;
	http_param_func[95] = wlan_htmlGetPbccCheck;
	http_param_func[96] = wlan_htmlErpCheck;
	http_param_func[97] = wlan_htmlGetMaxBasicRate;
	http_param_func[98] = wlan_htmlGetMaxActiveRate;
	http_param_func[99] = wlan_htmlGetAdditionalOperRateSet_G_Band;
	http_param_func[100] = wlan_htmlGetOFDMOperRateSet_G_Band;
	http_param_func[101] = wlan_htmlGetAdditionalOperRateSet_A_Band;
	http_param_func[102] = wlan_htmlSavePageAdvanced;
	http_param_func[103] = wlan_htmlRestoreDefaults;
	
	    /* Download - TFTP */ 
	    http_param_func[104] = wlan_htmlGetTftpIpAddr;
	
	    /* statistics  - cont. */ 
	    http_param_func[105] = wlan_htmlGetMicFailureMSDUs;
	http_param_func[106] = wlan_htmlGetDecryptErrorMPDUs;
	
	    /* Privacy - Multiple SSID activated note */ 
	    http_param_func[107] =
	    wlan_htmlPrivacyPageNotePerMultipleSsidActivated;
	http_param_func[108] = wlan_htmlMgmtPageNotePerPrivacyActivated;
	
	    /* Configuration - Energy Detection */ 
	    http_param_func[109] = wlan_htmlConfigEnergyDetection;
	
	    /* Advanced - Band Balance */ 
	    http_param_func[110] = wlan_htmlAdvancedGetUsageTimeMode;
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		if (REPORT_LEVEL(RL_HTTP))
			wapp_utilsPrintf(RL_HTTP, PRI_INFORMATION,
					  "HTTP: socket error");
		return NOK;
	}
	
	    /*if((setsockopt(sock, SOL_SOCKET, SO_REUSEADDR,
	       (void *)&true, sizeof(true))) == -1) {
	       if (REPORT_LEVEL(RL_HTTP))
	       wapp_utilsPrintf (RL_HTTP, PRI_INFORMATION,"HTTP: setsockopt failed");
	       
	       return NOK;
	       } */ 
	    (void) cm_hwGetLanIP(&lanIp);
	
	    /*bzero ((char *) &sockin, sizeof (sockin)); */ 
	    memset(&sockin, 0, sizeof(struct sockaddr_in));
	sockin.sin_family = AF_INET;
	sockin.sin_port = htons(HTTP_PORT);
	sockin.sin_addr.s_addr = lanIp;
	if (bind(sock, (struct sockaddr *) &sockin, sizeof(sockin)) < 0) {
		if (REPORT_LEVEL(RL_HTTP))
			wapp_utilsPrintf(RL_HTTP, PRI_INFORMATION,
					  "tiweb: bind fail");
		return NOK;
	}
	if (listen(sock, 3) < 0) {
		if (REPORT_LEVEL(RL_HTTP))
			wapp_utilsPrintf(RL_HTTP, PRI_INFORMATION,
					  "tiweb: listen fail");
		return NOK;
	}
	
	    /* Create the HTTP deamon Task */ 
	    rc =
	    rt_osTaskCreate("HTTP", TaskPriority, HTTP_TASK_STACKSIZE,
			    &httpTaskId);
	
	    /* Check if the task was created */ 
	    if (rc != OS_NOERR) {
		wapp_utilsPrintf(RL_HTTP, PRI_EMERGENCY,
				  "HTTP: Error creating http task.");
		return NOK;
	}
	return OK;
	
#endif	/*  */
	int j;

	for (j = 0; j < MAX_HTTP_FUNCS; j++)
		http_param_func[j] = http_param_dummy;
	
	    /* index.htm */ 
	    http_param_func[1] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetApMacAddress;
	http_param_func[2] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetApEnable;
	http_param_func[3] = (HTTP_PARAM_FUNC_T *) wlan_htmlSavePageSetup;
	http_param_func[4] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetSsid;
	http_param_func[5] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetChannelSelectBandBG;
	http_param_func[6] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetFwVersion;
	http_param_func[7] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetSwVersion;
	http_param_func[8] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetDomain;
	http_param_func[9] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetBandMode;
	http_param_func[10] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetChannelSelectBandA;
	
	    /* Ipsettings.htm */ 
	    http_param_func[11] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlSavePageIpSettings;
	http_param_func[12] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetIpAddr1;
	http_param_func[13] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetIpAddr2;
	http_param_func[14] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetIpAddr3;
	http_param_func[15] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetIpAddr4;
	http_param_func[16] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMask1;
	http_param_func[17] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMask2;
	http_param_func[18] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMask3;
	http_param_func[19] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMask4;
	
	    /* download.htm */ 
	    http_param_func[20] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlSoftwareDownload;
	http_param_func[21] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetRunningSector;
	http_param_func[22] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetRunningFilename;
	
	    /* statistics.htm */ 
	    http_param_func[23] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetLanSendUnicast;
	http_param_func[24] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetLanSendMulticast;
	http_param_func[25] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetLanRecvUnicast;
	http_param_func[26] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetLanRecvMulticast;
	http_param_func[27] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessSendFragments;
	http_param_func[28] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessSendMsdus;
	http_param_func[29] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessSendMulticasts;
	http_param_func[30] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessSendFailed;
	http_param_func[31] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessSendRetry;
	http_param_func[32] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessRecvFragments;
	http_param_func[33] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessRecvMsdus;
	http_param_func[34] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessRecvMulticasts;
	http_param_func[35] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetWirelessRecvFcsError;
	
	    /* privacy */ 
	    http_param_func[36] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyAuthMode;
	http_param_func[37] = (HTTP_PARAM_FUNC_T *) wlan_htmlSavePagePrivacy;
	http_param_func[38] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyWepCipher;
	http_param_func[39] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetStationTypes;
	http_param_func[40] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyPskStringValue;
	http_param_func[41] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetKeyIdCheck;
	http_param_func[42] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyOn;
	http_param_func[43] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyPsk;
	http_param_func[44] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyRadiusAddr;
	http_param_func[45] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyPskHexValue;
	http_param_func[46] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetKeyVal0;
	http_param_func[47] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetKeyVal1;
	http_param_func[48] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetKeyVal2;
	http_param_func[49] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetKeyVal3;
	http_param_func[50] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyGroupKeyInterval;
	http_param_func[51] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyRadiusPort;
	http_param_func[52] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyRadiusSecret;
	
	    /* AP Enable/Disable - index.htm */ 
	    http_param_func[53] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdateEnableDisableAP;
	http_param_func[54] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetEnableDisableButtonName;
	http_param_func[55] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetUpdateButtonValueApEnable;
	http_param_func[56] = (HTTP_PARAM_FUNC_T *) wlan_htmlNotYet;
	
	    /* Default Gateway */ 
	    http_param_func[57] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPrivacyDefaultGateway;
	
	    /* config */ 
	    http_param_func[58] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlRestoreDefaults;
	http_param_func[59] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetBeaconPeriod;
	http_param_func[60] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetDtimPeriod;
	http_param_func[61] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetRtsThreshold;
	http_param_func[62] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetFragThreshold;
	http_param_func[63] = (HTTP_PARAM_FUNC_T *) wlan_htmlDot11ModeCheck;
	http_param_func[64] = (HTTP_PARAM_FUNC_T *) wlan_htmlSavePageConfig;
	http_param_func[65] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetHiddenSsid;
	http_param_func[66] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetPucketBurstSupport;	/* Packet Bursting Support */
	http_param_func[67] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetOutputPowerLevel;	/* Output Power Level */
	http_param_func[68] = (HTTP_PARAM_FUNC_T *) wlan_htmlGet_A_G_PlusMode;	/* TI a/g+ Support */
	http_param_func[69] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfCheck;
	http_param_func[70] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetIpAddr1;
	http_param_func[71] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetIpAddr2;
	http_param_func[72] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetIpAddr3;
	http_param_func[73] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetIpAddr4;
	http_param_func[74] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetProtocol1;
	http_param_func[75] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetPort1;
	http_param_func[76] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetProtocol2;
	http_param_func[77] = (HTTP_PARAM_FUNC_T *) wlan_htmlVhcfGetPort2;
	
	    /* mgmt */ 
	    http_param_func[78] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdateStationPageMgmt;
	http_param_func[79] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmtTableFirstRow;
	http_param_func[80] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmtTableSecondRow;
	http_param_func[81] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmtTableDynamicRow;
	http_param_func[82] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmt_BW_TableFirstRow;
	http_param_func[83] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmt_BW_TableDynamicRow;
	http_param_func[84] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdate_BW_DeletePageMgmt;
	http_param_func[85] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdate_BW_AddMacPageMgmt;
	http_param_func[86] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetBWTableStatusPageMgmt;
	http_param_func[87] = (HTTP_PARAM_FUNC_T *) wlan_htmlSavePageMgmt;
	http_param_func[88] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMultipleSsidStatusPageMgmt;
	http_param_func[89] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdate_SSID_AddMultipleSSIDPageMgmt;
	http_param_func[90] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlUpdate_SSID_DeleteSSIDPageMgmt;
	http_param_func[91] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmt_SSID_TableFirstRow;
	http_param_func[92] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMgmt_SSID_TableDynamicRow;
	
	    /* advanced */ 
	    http_param_func[93] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetPreambleCheck;
	http_param_func[94] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetSlotTimeCheck;
	http_param_func[95] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetPbccCheck;
	http_param_func[96] = (HTTP_PARAM_FUNC_T *) wlan_htmlErpCheck;
	http_param_func[97] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMaxBasicRate;
	http_param_func[98] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetMaxActiveRate;
	http_param_func[99] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetAdditionalOperRateSet_G_Band;
	http_param_func[100] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetOFDMOperRateSet_G_Band;
	http_param_func[101] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetAdditionalOperRateSet_A_Band;
	http_param_func[102] = (HTTP_PARAM_FUNC_T *) wlan_htmlSavePageAdvanced;
	http_param_func[103] = (HTTP_PARAM_FUNC_T *) wlan_htmlRestoreDefaults;
	
	    /* Download - TFTP */ 
	    http_param_func[104] = (HTTP_PARAM_FUNC_T *) wlan_htmlGetTftpIpAddr;
	
	    /* statistics  - cont. */ 
	    http_param_func[105] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetMicFailureMSDUs;
	http_param_func[106] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlGetDecryptErrorMPDUs;
	
	    /* Privacy - Multiple SSID activated note */ 
	    http_param_func[107] =
	    (HTTP_PARAM_FUNC_T *)
	    wlan_htmlPrivacyPageNotePerMultipleSsidActivated;
	http_param_func[108] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlMgmtPageNotePerPrivacyActivated;
	
	    /* Configuration - Energy Detection */ 
	    http_param_func[109] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlConfigEnergyDetection;
	
	    /* Advanced - Band Balance */ 
	    http_param_func[110] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlAdvancedGetUsageTimeMode;

		/* Configuration - Radar detection */
	    http_param_func[111] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlConfigRadarDetectMode;

		/* Configuration - BSS Isolation */
	    http_param_func[112] =
	    (HTTP_PARAM_FUNC_T *) wlan_htmlConfigBssIsolationMode;

	create_listening_socket(serv_ip);
	    

	httpMainLoop();

	return OK;
}


/***************************************************************************/ 
/*                      wapp_utilsHttpStart()                              */ 
/***************************************************************************/ 
/* DESCRIPTION: Start the HTTP server task                                 */ 
/*                                                                         */ 
/*                                                                         */ 
/* INPUT:       Task Priority                                              */ 
/* OUTPUT:      NONE.                                                      */ 
/*                                                                         */ 
/* RETURNS:     OK for success, NOK otherwise                              */ 
/*                                                                         */ 
/***************************************************************************/ 
    STATUS wapp_utilsHttpStart(void) 
{
	
#if 0
	int rc;
	
	    /* Start the HTTP deamon Task */ 
	    rc = rt_osTaskStart(httpTaskId, OS_TASK_PREEMPT, httpMainLoop);
	
	    /* Check if the task was started */ 
	    if (rc != OS_NOERR)
		 {
		wapp_utilsPrintf(RL_HTTP, PRI_EMERGENCY,
				  "HTTP: Error starting http task.");
		return NOK;
		}
	return OK;
	
#endif	/*  */
	    return OK;
}
char *
http_param_dummy(char *s1, char *s2, char *s3, char *s4, char *s5, char *s6,
		 char *s7, char *s8, char *s9, char *s10, char *s11, char *s12,
		 char *s13, char *s14, char *s15, char *s16, char *s17,
		 char *s18, char *s19, char *s20, char *s21, char *s22,
		 char *s23, char *s24, char *s25, char *s26, char *s27,
		 char *s28, char *s29, char *s30, char *s31, char *s32,
		 char *s33, char *s34, char *s35, char *s36, char *s37,
		 char *s38, char *s39, char *s40) 
{
	sprintf(p_buf,
		  "\n<br>param1 - %s<br>\nparam2 - %s<br>\nparam3 - %s<br>\nparam4 - %s<br>\nparam5 - %s<br>\n
					param6 - %s<br>\nparam7 - %s<br>\nparam8 - %s<br>\nparam9 - %s<br>\nparam10 - %s<br>\n
					param11 - %s<br>\nparam12 - %s<br>\nparam13 - %s<br>\nparam14 - %s<br>\nparam15 - %s<br>\n
					param16 - %s<br>\nparam17 - %s<br>\nparam18 - %s<br>\nparam19 - %s<br>\nparam20 - %s<br>\n
					param21 - %s<br>\nparam22 - %s<br>\nparam23 - %s<br>\nparam24 - %s<br>\nparam25 - %s<br>\n
					param26 - %s<br>\nparam27 - %s<br>\nparam28 - %s<br>\nparam29 - %s<br>\nparam30 - %s<br>\n
					param31 - %s<br>\nparam32 - %s<br>\nparam33 - %s<br>\nparam34 - %s<br>\nparam35 - %s<br>\n
					param36 - %s<br>\nparam37 - %s<br>\nparam38 - %s<br>\nparam39 - %s<br>\nparam40 - %s<br>",
		  s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26, s27, s28, s29, s30, s31, s32, s33, s34, s35, s36, s37, s38, s39, s40);
	return p_buf;	/* "NO_HANDLER"; */
}


/*
	Reads HTTP request.
	It stops reading when meet CR/LF/CR/LF. Checks if this is a GET method
	and return 1 and URL in "req". For others return 999. -1 for error.
*/ 
char lookup_str[] = { 0x0d, 0x0a, 0x0d, 0x0a, 0xff };
int
http_read_req(int sock, char *req)
{
	int rcv_len;
	int tot_len = 0;
	char *ch_ptr = rc_buf;
	char *lookup_ptr = rc_buf;
	int lookup_state = 0;
	char *tok;
	int res, i;
	fd_set rfds;
	struct timeval tv;
	FD_ZERO(&rfds);
	FD_SET(sock, &rfds);
	tv.tv_sec = 1 /*HTTP_TIMEOUT */ ;
	tv.tv_usec = 0;
	i = select(sock + 1, &rfds, NULL, NULL, &tv);
	if (i == 0) {		/* time out */
		return -1;
	}
	if (i == -1) {		/* select error */
		return -1;
	}
	while ((tot_len < RCV_BUF_LEN)
		 && (rcv_len =
		     recv(sock, ch_ptr, RCV_BUF_LEN - tot_len, 0)) >= 0) {
		FD_ZERO(&rfds);
		FD_SET(sock, &rfds);
		tv.tv_sec = 1;	/*HTTP_TIMEOUT */
		tv.tv_usec = 0;
		tot_len += rcv_len;
		ch_ptr += rcv_len;
		
		    /* CR/LF/CR/LF lookup */ 
		    while (lookup_ptr < ch_ptr) {
			if (*lookup_ptr++ == lookup_str[lookup_state])
				lookup_state++;
			
			else
				lookup_state = 0;
			if (lookup_state > 3)
				break;	/* we found that */
		}
		if (lookup_state > 3) {
			*ch_ptr = 0;	/* terminate received string */
			break;
		}
		res = select(sock + 1, &rfds, NULL, NULL, &tv);
		
		    /* here res should be 1 as we checked only 1 socket */ 
#if 1
		    if (!FD_ISSET(sock, &rfds)) {
			
			    /* for only one checked socket "sock" FD_ISSET should always return TRUE,
			       who others could couse exit w/o timeout
			     */ 
			    return -1;
		}
		
#endif	/*  */
		    if (res == 0)	/* time out */
			break;
		if (res == -1)	/* select error */
			break;
	}			/* while */
	if (tot_len >= RCV_BUF_LEN)
		return -1;
	if ((tot_len < 14) || (lookup_state < 4))
		return -1;
	tok = strtok(rc_buf, " ");
	if (!tok)
		return -1;
	if (!strcmp(tok, "GET")) {
		res = 1;
		tok = strtok(NULL, " ");
		if (tok)
			strcpy(req, tok);
		
		else
			res = -1;
	} else
		res = 999;
	return res;
}


/*
	search for param_name and return param_value if found,
	otherwise ... 
*/ 
char *
http_param_lookup(char *name) 
{
	int j;
	for (j = 0; j < param_cnt; j++) {
		if (!strcmp(params[j].name, name))
			return params[j].value;
	}
	return "NO_PARAM";
}


/*
	parses <?N .... tag. extract handler number, parameter names, and
	in case ?param_name tries to replace for param_values
*/ 
    void
http_pars_tag(void)
{
	char *tok;
	tag_ind = 0;
	strcpy(param1, "NOPARAM");
	strcpy(param2, "NOPARAM");
	strcpy(param3, "NOPARAM");
	strcpy(param4, "NOPARAM");
	strcpy(param5, "NOPARAM");
	strcpy(param6, "NOPARAM");
	strcpy(param7, "NOPARAM");
	strcpy(param8, "NOPARAM");
	strcpy(param9, "NOPARAM");
	strcpy(param10, "NOPARAM");
	strcpy(param11, "NOPARAM");
	strcpy(param12, "NOPARAM");
	strcpy(param13, "NOPARAM");
	strcpy(param14, "NOPARAM");
	strcpy(param15, "NOPARAM");
	strcpy(param16, "NOPARAM");
	strcpy(param17, "NOPARAM");
	strcpy(param18, "NOPARAM");
	strcpy(param19, "NOPARAM");
	strcpy(param20, "NOPARAM");
	strcpy(param21, "NOPARAM");
	strcpy(param22, "NOPARAM");
	strcpy(param23, "NOPARAM");
	strcpy(param24, "NOPARAM");
	strcpy(param25, "NOPARAM");
	strcpy(param26, "NOPARAM");
	strcpy(param27, "NOPARAM");
	strcpy(param28, "NOPARAM");
	strcpy(param29, "NOPARAM");
	strcpy(param30, "NOPARAM");
	strcpy(param31, "NOPARAM");
	strcpy(param32, "NOPARAM");
	strcpy(param33, "NOPARAM");
	strcpy(param34, "NOPARAM");
	strcpy(param35, "NOPARAM");
	strcpy(param36, "NOPARAM");
	strcpy(param37, "NOPARAM");
	strcpy(param38, "NOPARAM");
	strcpy(param39, "NOPARAM");
	strcpy(param40, "NOPARAM");

	tok = strtok(tag_str, " \0");
	if (!tok)
		return;
	tag_ind = atoi(tok);
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param1, tok);
	if (*param1 == '?') {
		strcpy(param1, http_param_lookup(&param1[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param2, tok);
	if (*param2 == '?') {
		strcpy(param2, http_param_lookup(&param2[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param3, tok);
	if (*param3 == '?') {
		strcpy(param3, http_param_lookup(&param3[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param4, tok);
	if (*param4 == '?') {
		strcpy(param4, http_param_lookup(&param4[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param5, tok);
	if (*param5 == '?') {
		strcpy(param5, http_param_lookup(&param5[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param6, tok);
	if (*param6 == '?') {
		strcpy(param6, http_param_lookup(&param6[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param7, tok);
	if (*param7 == '?') {
		strcpy(param7, http_param_lookup(&param7[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param8, tok);
	if (*param8 == '?') {
		strcpy(param8, http_param_lookup(&param8[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param9, tok);
	if (*param9 == '?') {
		strcpy(param9, http_param_lookup(&param9[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param10, tok);
	if (*param10 == '?') {
		strcpy(param10, http_param_lookup(&param10[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param11, tok);
	if (*param11 == '?') {
		strcpy(param11, http_param_lookup(&param11[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param12, tok);
	if (*param12 == '?') {
		strcpy(param12, http_param_lookup(&param12[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param13, tok);
	if (*param13 == '?') {
		strcpy(param13, http_param_lookup(&param13[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param14, tok);
	if (*param14 == '?') {
		strcpy(param14, http_param_lookup(&param14[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param15, tok);
	if (*param15 == '?') {
		strcpy(param15, http_param_lookup(&param15[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param16, tok);
	if (*param16 == '?') {
		strcpy(param16, http_param_lookup(&param16[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param17, tok);
	if (*param17 == '?') {
		strcpy(param17, http_param_lookup(&param17[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param18, tok);
	if (*param18 == '?') {
		strcpy(param18, http_param_lookup(&param18[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param19, tok);
	if (*param19 == '?') {
		strcpy(param19, http_param_lookup(&param19[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param20, tok);
	if (*param20 == '?') {
		strcpy(param20, http_param_lookup(&param20[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param21, tok);
	if (*param21 == '?') {
		strcpy(param21, http_param_lookup(&param21[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param22, tok);
	if (*param22 == '?') {
		strcpy(param22, http_param_lookup(&param22[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param23, tok);
	if (*param23 == '?') {
		strcpy(param23, http_param_lookup(&param23[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param24, tok);
	if (*param24 == '?') {
		strcpy(param24, http_param_lookup(&param24[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param25, tok);
	if (*param25 == '?') {
		strcpy(param25, http_param_lookup(&param25[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param26, tok);
	if (*param26 == '?') {
		strcpy(param26, http_param_lookup(&param26[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param27, tok);
	if (*param27 == '?') {
		strcpy(param27, http_param_lookup(&param27[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param28, tok);
	if (*param28 == '?') {
		strcpy(param28, http_param_lookup(&param28[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param29, tok);
	if (*param29 == '?') {
		strcpy(param29, http_param_lookup(&param29[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param30, tok);
	if (*param30 == '?') {
		strcpy(param30, http_param_lookup(&param30[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param31, tok);
	if (*param31 == '?') {
		strcpy(param31, http_param_lookup(&param31[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param32, tok);
	if (*param32 == '?') {
		strcpy(param32, http_param_lookup(&param32[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param33, tok);
	if (*param33 == '?') {
		strcpy(param33, http_param_lookup(&param33[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param34, tok);
	if (*param34 == '?') {
		strcpy(param34, http_param_lookup(&param34[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param35, tok);
	if (*param35 == '?') {
		strcpy(param35, http_param_lookup(&param35[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param35, tok);
	if (*param35 == '?') {
		strcpy(param35, http_param_lookup(&param35[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param36, tok);
	if (*param36 == '?') {
		strcpy(param36, http_param_lookup(&param36[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param37, tok);
	if (*param37 == '?') {
		strcpy(param37, http_param_lookup(&param37[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param38, tok);
	if (*param38 == '?') {
		strcpy(param38, http_param_lookup(&param38[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param39, tok);
	if (*param39 == '?') {
		strcpy(param39, http_param_lookup(&param39[1]));
	}
	tok = strtok(NULL, " \0");
	if (!tok)
		return;
	strcpy(param40, tok);
	if (*param40 == '?') {
		strcpy(param40, http_param_lookup(&param40[1]));
	}
}


/*
	stupidly copies image (page template) into page_buf.
	But if meets <?... tag, calles the hanlder function and
	put result into the page_buf.
	
	Actually you can have <?...> tag only in templete and
	build your page yourself
*/ 
    int
http_build_page(unsigned char *image, int img_len)
{
	int j;
	unsigned char *sptr, *dptr;
	char *tptr;
	BOOL firstTime = TRUE;
	BOOL fileWasSentFromHere = FALSE;
	memset(page_buf, 0, sizeof(page_buf));
	page_len = 0;
	sptr = image;
	dptr = page_buf;
	for (j = 0; j < img_len; j++)
	{
		if ((*sptr == '<') && (sptr[1] == '?'))
		{

			/* <?NN PARAM1 PARAM2 PARAM3> */ 
			sptr += 2;
			j += 2;
			if( !(tptr = (char *) tag_str)) {
				fprintf(stderr, "%s: NULL pointer (%d)\n", __func__, __LINE__);
				return -1;
			}
			while (*sptr != '>')
			{
				*tptr++ = *sptr++;
				j++;
			}
			*tptr = 0;
			sptr++;

			http_pars_tag();
			tptr = http_param_func[tag_ind] (param1, param2, param3,
					param4, param5, param6,
					param7, param8, param9,
					param10, param11,
					param12, param13, param14,
					param15, param16, param17,
					param18, param19, param20,
					param21, param22,
					param23, param24, param25,
					param26, param27, param28,
					param29, param30,
					param31, param32,
					param33, param34, param35,
					param36, param37, param38,
					param39, param40);

			if( !tptr ) {
				fprintf(stderr, "%s: NULL pointer tag=%d (%d)\n", __func__, tag_ind, __LINE__);
				return -1;
			}

			while (*tptr != 0)
			{
				*dptr++ = *tptr++;
				page_len++;
				if (page_len + 2 == IMAGE_BUF_LEN)
				{
					if (firstTime)
						http_show_image(client,
								page_buf,
								page_len,
								"text/html",
								HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);

					else
						http_show_image(client,
								page_buf,
								page_len,
								"text/html",
								HTTP_SHOW_IMAGE_OPTION_NO_TITLE);
					firstTime = FALSE;
					dptr = page_buf;
					page_len = 0;
					fileWasSentFromHere = TRUE;
					continue;
				}
			}
		}

		else
		{
			*dptr++ = *sptr++;
			page_len++;
			if (page_len + 2 == IMAGE_BUF_LEN)
			{
				if (firstTime)
					http_show_image(client, page_buf,
							page_len, "text/html",
							HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);

				else
					http_show_image(client, page_buf,
							page_len, "text/html",
							HTTP_SHOW_IMAGE_OPTION_NO_TITLE);
				firstTime = FALSE;
				dptr = page_buf;
				page_len = 0;
				fileWasSentFromHere = TRUE;
				continue;
			}
		}
	}
	if (fileWasSentFromHere)
	{
		if (page_len > 0)
		{
			http_show_image(client, page_buf, page_len,
					"text/html",
					HTTP_SHOW_IMAGE_OPTION_NO_TITLE);
			return 0;
		}
	}
	return page_len;
}


/*
	send image to a client
*/ 
/* Title Options:
 * 0 - No HTTP title to send. Only the given buffer.
 * 1 - Use HTTP title, but without the Content-Length.
 * 2 - Use HTTP title.
*/ 
    int
http_show_image(int sock, unsigned char *image, int img_len, char *mime,
		int showTitleOption) 
{
	int j = 0;
	int reminder = img_len;
	if (showTitleOption == 2)
		 {
		sprintf(rc_buf,
			 "HTTP/1.0 200 OK\nContent-Type: %s\nContent-Length %d\n\n",
			 mime, img_len);
		if (send(sock, rc_buf, strlen(rc_buf), 0) == -1)
			return -1;
		}
	
	else if (showTitleOption == 1)
		 {
		sprintf(rc_buf, "HTTP/1.0 200 OK\nContent-Type: %s\n\n", mime);
		if (send(sock, rc_buf, strlen(rc_buf), 0) == -1)
			return -1;
		}
	while (reminder > 0) {
		if (reminder > 512) {
			if (send(sock, &image[j], 512, 0) == -1)
				return -1;
			reminder -= 512;
			j += 512;
		} else {
			if (send(sock, &image[j], reminder, 0) == -1)
				return -1;
			reminder = 0;
		}
	}
	return 0;
}


/*
	may be there is an ANSI function to translate [0-9,A-F] to binary.
*/ 
    static char
hex2int(char c)
{
	char ret;
	ret = c - 48;
	if (ret > 9)
		ret -= 7;
	if (ret > 15)
		ret -= 32;
	return ret;
}


/*
	splits URL on page name and parameters, fill parameter table
	returns clear page name in req.

	ATTENTION: parameter string limited to 255 character.
			   In the next version I will replace to macro	
*/ 

int http_pars_param(char *req)
{
	char param_str[MAX_REQUEST_LEN];
	char *prm_start, *tok, *vl;
	unsigned long len;
	memset(params, 0, sizeof(params));
	param_cnt = 0;
	prm_start = strchr(req, '?');
	if (!prm_start)	/* no parameters */
		return 0;
	*prm_start = 0;	/* terminate URL */
	prm_start++;
	strcpy(param_str, prm_start);
	prm_start = strtok(param_str, "&\n\0");
	while (prm_start)
	{
		tok = strchr(prm_start, '=');

		/* do not handle error, just skip parsing */ 
		if (!tok)
			break;

		*tok = 0;
		if (strlen(prm_start) > MAX_HTTP_PARAM_NAME_LEN) {
			fprintf(stderr, "tiweb: param name overflow.\n");
			fflush(stderr);
			return 1;
		}

		strcpy(params[param_cnt].name, prm_start);
		tok++;
		vl = params[param_cnt].value;
		len = 0;

		/* copy parameter value */ 
		while (*tok != 0)
	       	{
			if (*tok == '+') {	/* SPACE gets here as '+', while '+' gets here as %2B */
				*vl = ' ';
				tok++; 
			} else if (*tok == '%') {
				*vl = hex2int(tok[1]) * 16 + hex2int(tok[2]);
				tok += 3;
			} else {
				*vl = *tok++;
			}
			vl++;
			len++;
			
			if (len >= MAX_HTTP_PARAM_LEN) {
				fprintf(stderr, "tiweb: param len overflow.\n");
				fflush(stderr);
				return 1;
			}
		}
		
		*vl = 0;
		param_cnt++;
		if (param_cnt >= MAX_PARAM) {
			fprintf(stderr, "tiweb: param number overflow.\n");
			fflush(stderr);
			return 1;
		}
		prm_start = strtok(NULL, "&\n\0");
	}
	return 0;
}


/*
	htmpages.c contains a page_list table. This function search for the
	page n_page and return its number if found, otherwise ...
*/ 
    int
http_find_page(char *n_page)
{
	int j, index;
	index = strlen(n_page);
	if (n_page[index - 1] == 'l' || n_page[index - 1] == 'L')
		n_page[index - 1] = '\0';
	for (j = 0; j < pages_cnt; j++)
		if (!strcmp(page_list[j].page_name, n_page))
			return j;
	return -1;
}
int
is_that_friend(unsigned long rip)
{
	unsigned char ipc[4];
	memcpy(ipc, &rip, 4);
	printf("Request from %u.%u.%u.%u\n", ipc[0], ipc[1], ipc[2], ipc[3]);
	return 1;
}


/*
***************************************************************************
	void httpMainLoop(void) - http task

	INPUT: NONE

	OUTPUT: NONE
	
	RETURN: NONE

*/ 

void httpMainLoop(void) 
{
	
#if 0
	int res;
	int sa_rem_len;
	struct sockaddr_in clientAddress;
	int page_index;
	char req_str[MAX_REQUEST_LEN];
	int page_len;
	long ifnumber;
	unsigned long dst_addr;
	long cableIfNum;
	while (1) {
		sa_rem_len = sizeof(sa_remote);
		client =
		    accept(sock, (struct sockaddr *) &sa_remote, &sa_rem_len);
		if (client < 0) {
			printf("Accept error\n");
			continue;
		}
		if (!HtmlEnable) {
			shutdown(client, 2);
			close(client);
			continue;
		}
		
		    /* somebody call us, let's look what they want */ 
		    /* before that it is a good idea to check whether that
		       is our frend */ 
#if 0 /* is_that_friend() will be implemented in the next version */ 
		    if (!is_that_friend(sa_remote.sin_addr.s_addr ))
			continue;
		
#endif	/*  */
		    res = http_read_req(client, req_str);
		if (strlen(req_str) > MAX_REQUEST_LEN)
			 {
			if (REPORT_LEVEL(RL_HTTP))
				wapp_utilsPrintf(RL_HTTP, PRI_INFORMATION,
						  "request len overflow.\n");
			shutdown(client, 2);
			close(client);
			continue;
			}
		if (res == 1) {
			res = http_pars_param(req_str);
			if (res != 0)
				 {
				if (REPORT_LEVEL(RL_HTTP))
					wapp_utilsPrintf(RL_HTTP,
							  PRI_INFORMATION,
							  "http parse params error.\n");
				shutdown(client, 2);
				close(client);
				continue;
				}
			if (!strcmp(req_str, "/"))
				strcpy(req_str, "/index.htm");
			page_index = http_find_page(req_str);
			if (page_index >= 0) {
				switch (page_list[page_index].mime) {
				case MIME_HTML:
					page_len =
					    http_build_page(page_list
							    [page_index].
							    page_ptr,
							    page_list
							    [page_index].
							    page_len);
					if (page_len > 0)
						http_show_image(client,
								 page_buf,
								 page_len,
								 "text/html",
								 HTTP_SHOW_IMAGE_OPTION_FULL_TITLE);
					break;
				case MIME_GIF:
					http_show_image(client,
							 page_list[page_index].
							 page_ptr,
							 page_list[page_index].
							 page_len, "image/gif",
							 HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);
					break;
				case MIME_JPEG:
					http_show_image(client,
							 page_list[page_index].
							 page_ptr,
							 page_list[page_index].
							 page_len, "image/jpeg",
							 HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);
					break;
				default:
					break;
				}
			}
		}
		
#if 0
		    cm_brgResetIpHttpIfNum();
		
#endif	/*  */
		    shutdown(client, 2);
		close(client);
	}
	
#endif	/*  */
	int res;
	int sa_rem_len;
	int page_index;
	char req_str[MAX_REQUEST_LEN];
	int page_len;
	while (1) {
		sa_rem_len = sizeof(sa_remote);
		client =
		    accept(sock, (struct sockaddr *) &sa_remote, &sa_rem_len);
		if (client < 0) {
			printf("Accept error\n");
			continue;
		}
		if (!HtmlEnable) {
			shutdown(client, SHUT_RDWR);
			fprintf(stderr, "tiweb: cannot process current request, disabled.\n");
			fflush(stderr);
			close(client);
			continue;
		}

		    res = http_read_req(client, req_str);
		    if (strlen(req_str) > MAX_REQUEST_LEN)
		    {
			    fprintf(stderr, "tiweb: request len overflow.\n");
			    fflush(stderr);
			    shutdown(client, SHUT_RDWR);
			    close(client);
			    continue;
		    }

		if (res == 1) 
		{
			res = http_pars_param(req_str);
			if (res != 0)
			{
				fprintf(stderr, "tiweb: parse params error.\n");
				fflush(stderr);
				shutdown(client, SHUT_RDWR);
				close(client);
				continue;
			}

			if (!strcmp(req_str, "/"))
				strcpy(req_str, "/index.htm");
			page_index = http_find_page(req_str);

			if (page_index >= 0)
			{
				switch (page_list[page_index].mime)
			       	{
					case MIME_HTML:
						page_len =
							http_build_page(page_list[page_index].  page_ptr,
									page_list [page_index].  page_len);
						if (page_len > 0)
							http_show_image(client, page_buf,
									page_len, "text/html",
									HTTP_SHOW_IMAGE_OPTION_FULL_TITLE);
						break;

					case MIME_GIF:
						http_show_image(client, page_list[page_index].
								page_ptr, page_list[page_index].
								page_len, "image/gif",
								HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);
						break;

					case MIME_JPEG:
						http_show_image(client, page_list[page_index].
								page_ptr, page_list[page_index].
								page_len, "image/jpeg",
								HTTP_SHOW_IMAGE_OPTION_TITLE_NO_LENGTH);
						break;

					default:
						break;
				}
			}
		}
		
#if 0
		    cm_brgResetIpHttpIfNum();
		
#endif	/*  */

		    if( client > 0 ) {
			    shutdown(client, SHUT_RDWR);
			    close(client);
		    }
	}
}

int
wapp_utilsHttpGetDisplayHtmlEnable(unsigned char *state)
{
	*state = HtmlEnable;
	return OK;
}
int
wapp_utilsHttpSetDisplayHtmlEnable(unsigned char state)
{
	HtmlEnable = state;
	return OK;
}

int
main(int argc, char *argv[]) 
{
	wcfginit init;

	memset(&init, 0, sizeof(init));
	strcpy(init.storage_file, WCFG_MTDBLOCK);

	if( !(wd = tiap_wcfg_init(&init)) ) {
		fprintf(stderr, "tiweb: Failed to initialize wcfglib, terminating.\n");
		fflush(stderr);
		return 1;
	}

	wdrv_dbInitRangeTables();
	wapp_utilsHttpInit(INADDR_ANY);
	return 0;
}


