/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/**************************************************************************/
/*                                                                        */
/*   MODULE:  httpfunc.h                                                  */
/*   PURPOSE: HTTP functions	 - HEADER file  					      */
/*                                                                        */
/**************************************************************************/

/********************************
*		SETUP PAGE				*	
*********************************/
char* wlan_htmlGetApMacAddress(void);
char* wlan_htmlGetApEnable(void);
char* wlan_htmlGetChannel(void);
char* wlan_htmlGetSsid(void);
char* wlan_htmlGetHiddenSsid(void);
char* wlan_htmlSavePageSetup(void);
char* wlan_htmlGetChannelSelectBandBG(void);
char* wlan_htmlGetChannelSelectBandA(void);
char* wlan_htmlGetBandMode(void);
char* wlan_htmlGetFwVersion(void);
char* wlan_htmlGetSwVersion(void);
char* wlan_htmlGetEnableDisableButtonName(void);
char* wlan_htmlUpdateEnableDisableAP(void);
char* wlan_htmlGetUpdateButtonValueApEnable(void);

char* wlan_htmlGetDomain(void);
char* wlan_htmlReboot(void);

/********************************
*       IP SETTINGS PAGE        *
********************************/
char *wlan_htmlSavePageIpSettings(void);

char* wlan_htmlGetIpAddr1(void);
char* wlan_htmlGetIpAddr2(void);
char* wlan_htmlGetIpAddr3(void);
char* wlan_htmlGetIpAddr4(void);

char* wlan_htmlGetMask1(void);
char* wlan_htmlGetMask2(void);
char* wlan_htmlGetMask3(void);
char* wlan_htmlGetMask4(void);



/********************************
*		CONFIG PAGE				*	
*********************************/
char* wlan_htmlGetBeaconPeriod(void);
char* wlan_htmlGetDtimPeriod(void);
char* wlan_htmlGetRtsThreshold(void);
char* wlan_htmlGetFragThreshold(void);
char* wlan_htmlSavePageConfig(void);

char* wlan_htmlRestoreDefaults(void);
char* wlan_htmlGetPreambleCheck(void);
char* wlan_htmlGetPbccCheck(void);
char* wlan_htmlGetSlotTimeCheck(void);
char* wlan_htmlErpCheck(void);
char* wlan_htmlDot11ModeCheck(void);
char *wlan_html4xCheck(void);
char *wlan_html4xConcatCheck(void);
char *wlan_html4xAckEmulCheck(void);
char* wlan_htmlDummyFunc(void);

char* wlan_htmlSoftwareDownload(void);
char* wlan_htmlGetRunningSector(void);
char* wlan_htmlGetRunningFilename(void);
char* wlan_htmlGetTftpIpAddr(void);

char* wlan_htmlGetMaxBasicRate(void);
char* wlan_htmlGetMaxActiveRate(void);
char* wlan_htmlGetAllRates(void);
char* wlan_htmlGetAdditionalOperRateSet_G_Band(void);
char* wlan_htmlGetOFDMOperRateSet_G_Band(void);
char* wlan_htmlGetAdditionalOperRateSet_A_Band(void);
char* wlan_htmlAdvancedGetUsageTimeMode(void);

char* wlan_htmlGetPucketBurstSupport(void);
char* wlan_htmlGetOutputPowerLevel(void);
char* wlan_htmlGet_A_G_PlusMode(void);
char* wlan_htmlConfigEnergyDetection(void);
char *wlan_htmlConfigRadarDetectMode(char *value);
char *wlan_htmlConfigBssIsolationMode(char *value);

char* wlan_htmlVhcfCheck(void);
char* wlan_htmlVhcfGetIpAddr1(void);
char* wlan_htmlVhcfGetIpAddr2(void);
char* wlan_htmlVhcfGetIpAddr3(void);
char* wlan_htmlVhcfGetIpAddr4(void);
char* wlan_htmlVhcfGetProtocol1(void);
char* wlan_htmlVhcfGetPort1(void);
char* wlan_htmlVhcfGetProtocol2(void);
char* wlan_htmlVhcfGetPort2(void);

char* wlan_htmlNotYet(void);
char* wlan_htmlNotYetValue(void);
char* wlan_htmlSavePageAdvanced(void);

/********************************
*		STATISTICS PAGE				*	
*********************************/
char* wlan_htmlGetLanSendUnicast(void);
char* wlan_htmlGetLanSendMulticast(void);
char* wlan_htmlGetLanRecvUnicast(void);
char* wlan_htmlGetLanRecvMulticast(void);

char* wlan_htmlGetWirelessSendFragments(void);
char* wlan_htmlGetWirelessSendMsdus(void);
char* wlan_htmlGetWirelessSendMulticasts(void);
char* wlan_htmlGetWirelessSendFailed(void);
char* wlan_htmlGetWirelessSendRetry(void);

char* wlan_htmlGetWirelessRecvFragments(void);
char* wlan_htmlGetWirelessRecvMsdus(void);
char* wlan_htmlGetWirelessRecvMulticasts(void);
char* wlan_htmlGetWirelessRecvFcsError(void);
char* wlan_htmlGetMicFailureMSDUs(void);
char* wlan_htmlGetDecryptErrorMPDUs(void);

/********************************
*       PRIVACY PAGE            *	
*********************************/
char* wlan_htmlGetWepCheck(void);
char* wlan_htmlSavePagePrivacy(void);
char* wlan_htmlGetKeyIdCheck(void);

char* wlan_htmlGetKeyLenSelect0(void);
char* wlan_htmlGetKeyLenSelect1(void);
char* wlan_htmlGetKeyLenSelect2(void);
char* wlan_htmlGetKeyLenSelect3(void);

char* wlan_htmlGetKeyVal0(void);
char* wlan_htmlGetKeyVal1(void);
char* wlan_htmlGetKeyVal2(void);
char* wlan_htmlGetKeyVal3(void);

char* wlan_htmlGetPrivacyAuthMode(void);
char* wlan_htmlGetPrivacyWepCipher(void);
char* wlan_htmlGetStationTypes(void); 
char* wlan_htmlGetPrivacyDefaultGateway(void);
char* wlan_htmlGetPrivacyOn(void);
char* wlan_htmlGetPrivacyPsk(void);
char* wlan_htmlGetPrivacyPskHexValue(void);
char* wlan_htmlGetPrivacyRadiusAddr(void);
char* wlan_htmlGetPrivacyRadiusPort(void);
char* wlan_htmlGetPrivacyRadiusSecret(void);
char* wlan_htmlGetPrivacyPskStringValue(void); 
char* wlan_htmlGetPrivacyGroupKeyInterval(void);
char* wlan_htmlPrivacyPageNotePerMultipleSsidActivated(void);
char* wlan_htmlMgmtPageNotePerPrivacyActivated(void);

/********************************
*		MGMT PAGE				*	
*********************************/
char* wlan_htmlGetMgmtTableFirstRow(void);
char* wlan_htmlGetMgmtTableSecondRow(void);
char* wlan_htmlGetMgmtTableDynamicRow(void);
char* wlan_htmlGetMgmt_BW_TableFirstRow(void);
char* wlan_htmlGetMgmt_BW_TableDynamicRow(void);

char* wlan_htmlUpdateStationPageMgmt(void);
char* wlan_htmlUpdate_BW_DeletePageMgmt(void);
char* wlan_htmlUpdate_BW_AddMacPageMgmt(void);
char* wlan_htmlGetBWTableStatusPageMgmt(void);
char* wlan_htmlSavePageMgmt(void);

char* wlan_htmlGetMultipleSsidStatusPageMgmt(void);
char* wlan_htmlUpdate_SSID_AddMultipleSSIDPageMgmt(void);
char* wlan_htmlUpdate_SSID_DeleteSSIDPageMgmt(void);
char* wlan_htmlGetMgmt_SSID_TableFirstRow(void);
char* wlan_htmlGetMgmt_SSID_TableDynamicRow(void);
