#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <sys/ioctl.h>
#include <net/if_arp.h>         /* For ARPHRD_ETHER */
#include <sys/socket.h>         /* For AF_INET & struct sockaddr */
#include <netinet/in.h>         /* For struct sockaddr_in */
#include <netinet/if_ether.h>

#include <linux/wireless.h>

#include "wcfglib.h"


wcfgd *tiap_wcfg_init(wcfginit *);

int main(int argc, char *argv[])
{
wcfgd *wd = NULL;
wcfginit init;

	if( argc < 4 || argc > 5 ) {
		fprintf(stderr, "usage: %s wpa_auth module wlan0 [br0]\n", argv[0]);
		return 1;
	}

	memset(&init, 0, sizeof(init));

	strncpy(init.storage_file, WCFG_MTDBLOCK, sizeof(init.storage_file));
	init.storage_file[sizeof(init.storage_file)-1] = '\0';

	strncpy(init.wpaauth_file, argv[1], sizeof(init.wpaauth_file));
	init.wpaauth_file[sizeof(init.wpaauth_file)-1] = '\0';

	strncpy(init.apmodule_file, argv[2], sizeof(init.apmodule_file));
	init.apmodule_file[sizeof(init.apmodule_file)-1] = '\0';

	strncpy(init.dev_name, argv[3], sizeof(init.dev_name));
	init.dev_name[sizeof(init.dev_name)-1] = '\0';

	if( argc == 5 ) {
		strncpy(init.br_name, argv[4], sizeof(init.br_name));
		init.br_name[sizeof(init.br_name)-1] = '\0';
	}

	if( !(wd = tiap_wcfg_init(&init)) )
		return 1;

	tiap_wcfg_light_deinit(wd);
	printf("\ninit: lightly deinitializing wcfglib\n\n"); fflush(NULL);

	return 0;
}

