/*
 * WCFG         An implementation of the wcfglib library.
 *		See wcfg_lib companion document.
 *
 *
 * Version:     0.1.0
 *
 * Authors:     Alexandra Aronov, <alexandraa@ti.com>
 *              Felix Rubinstein, <felixr@ti.com>
 *
 */

#ifndef WCFG_IOCTL_H
#define WCFG_IOCTL_H

#include <linux/config.h>

#ifdef CONFIG_NET_RADIO
#include <linux/wireless.h>
#else
#error Linux wireless LAN is not enabled
#endif /* CONFIG_NET_RADIO */

#include "wcfg_storage.h"
#include "wcfglib.h"

#define MAX_FW_SIZE 100000

#define IW_MAX_PRIV_DEF	128


int wcfg_ioctl_init(wcfgd *wcfg_data);

int ioctl_get_tx_info(int Qid, int QprintEn, char * buf, int buf_len, char * ifname);
int ioctl_get_challenge(int index, char * buf, int buf_len, char * ifname);
int ioctl_get_find_sta(char * mac, char * buf, int buf_len, char * ifname);
int ioctl_get_insert_sta(char * mac, int wone_index, char * buf, int buf_len, char * ifname);
int ioctl_get_tx_queue(int Qid, char * buf, int buf_len, char * ifname);
int ioctl_get_eer(int addr, char * buf, int buf_len, char * ifname);
int ioctl_get_mac_reg_read(int addr, char * buf, int buf_len, char * ifname);
int ioctl_get_phy_reg_read(int addr, char * buf, int buf_len, char * ifname);
int ioctl_get_trace_print(int num, int from, char * buf, int buf_len, char * ifname);
int ioctl_get_wlan_params(int wone_index, char *buf, int buf_len, char *ifname);
int ioctl_get_max_rates(__u8, __u8 *, char *);
int ioctl_set_burst_limit(__u32 burst_limit, int ioctl_sock, char *ifname);
int ioctl_get_burst_limit(char *buf, int buf_len, int ioctl_sock, char *ifname);
#ifdef REPORT_DEBUG
int ioctl_get_logged_chars(char *buf, int buf_len, int ioctl_sock, char *ifname);
int ioctl_set_logged_chars(__u32 logged_chars, int ioctl_sock, char *ifname);
#endif

int exec_priv_ioctl_get (const __u32 we_id, void *param, int param_size, int ioctl_sock, char *ifname);
int exec_priv_ioctl_set (const __u32 we_id, void *param, int param_size, int ioctl_sock, char *ifname);
int ioctl_get_essid (char *essid, int ioctl_sock, char *ifname);
int ioctl_get_rts(__s32 *rts,int ioctl_sock, char *ifname);
int ioctl_get_frag(__s32 *frag, int ioctl_sock, char *ifname);
int ioctl_get_retry(__s32 *retry, int type, int ioctl_sock, char *ifname);
int ioctl_get_txpow(tiap_param_txpower_t *txpow, int ioctl_sock, char *ifname);

#endif
