# kernel specific staff

CFLAGS +=  \
	 -idirafter $(WLANPREFIX)/src/os/linux	                   \
	 -idirafter $(WLANPREFIX)/src/ddc/csl/board                \
	 -idirafter $(WLANPREFIX)/src/ddc/utils	                   \
	 -idirafter $(WLANPREFIX)/src/h							   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/4x/				   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Advanced			   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Advanced/Shutdown   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Advanced/WONE	   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/BssBridge		   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/DB				   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/MainSm			   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Mgmt				   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Mgmt/Test		   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Rx				   \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Tx				   \
	 -idirafter $(WLANPREFIX)/src/ddc/hal/AcxControl		   \
	 -idirafter $(WLANPREFIX)/src/ddc/hal/AcxDma			   \
	 -idirafter $(WLANPREFIX)/src/ddc/hal/WhalTest			   \
	 -idirafter $(WLANPREFIX)/src/ddc/hal/AcxInc/TNET1130_base \
	 -idirafter $(WLANPREFIX)/src/ddc/hal/AcxInc/TNET1130		\
	 -idirafter $(WLANPREFIX)/src \
	 -idirafter $(WLANPREFIX)/src/ddc/core/Advanced/Shutdown 	

# use cross compile option
# uncomment the following line (and change if needed) in case if CROSS_COMPILE_PREFIX is not in your PATH
#CROSS_COMPILE_PREFIX = /opt/hardhat/devkit/mips/fp_le/bin/ 
KERNEL_CROSS_COMPILE = $(CROSS_COMPILE_PREFIX)mips_fp_le-


# kernel specific section
CFLAGS += -Wall -D__KERNEL__ -DMODULE -mlong-calls \
	 -Wno-trigraphs -fno-strict-aliasing -fno-common \
	-fno-pic -I$(KERNELINCLUDE)  -mno-abicalls -mcpu=r4600 -mips2 -Wa,-m4100,--trap \
	-DWLAN_BUS_TYPE=2 -DWLAN_ADAPTOR_VERSION=1130 -DWLAN_ADAPTOR_WORK_MODE=2 \
	-DDDA_WLAN_LED \
	-I$(KERNELINCLUDE)/asm/avalanche/generic/hal_modules

# modules names
DDADIR := $(shell cd $(WLANPREFIX)/src/os/linux; pwd)
DDCDIR := $(shell cd $(WLANPREFIX)/src/ddc; pwd)

DDAOBJ := $(DDADIR)/dda.o
DDCAR := $(DDCDIR)/ddc.a

CROSS_COMPILE:=$(KERNEL_CROSS_COMPILE)