include $(WLANPREFIX)/make/Config.make

CFLAGS 	+=  -Wall -Wstrict-prototypes -G 0  -pipe
# All include directories 
CFLAGS += -I$(WLANPREFIX)/src/h -I$(WLANPREFIX)/src/os/linux

KERNELINCLUDE = $(KERNELDIR)/include

# This is useful if cross-compiling. Taken from kernel Makefile (CC changed)
AS      =$(CROSS_COMPILE)gcc
LD      =$(CROSS_COMPILE)ld
CC      =$(CROSS_COMPILE)gcc
CPP     =$(CC) -E
AR      =$(CROSS_COMPILE)ar
NM      =$(CROSS_COMPILE)nm
STRIP   =$(CROSS_COMPILE)strip
OBJCOPY =$(CROSS_COMPILE)objcopy
OBJDUMP =$(CROSS_COMPILE)objdump
RANLIB  =$(CROSS_COMPILE)ranlib
STRIP   =$(CROSS_COMPILE)strip

ifeq (cfiles.mk,$(wildcard cfiles.mk))
include cfiles.mk
endif

objects := $(subst .S,.o,$(subst .c,.o,$(CFILES)))

ifeq (.depend,$(wildcard .depend))
include .depend 
endif

%.o : %.c
	@echo Building $<
	$(CCPREFIX)$(CC) -c $< $(CFLAGS)  -o $@

%.o : %.S
	@echo Building $<
	$(CCPREFIX)$(AS) $(CFLAGS) -c $< -o $@

dep : 
	rm -f .depend
	for cfile in $(CFILES) ; do \
		$(CC) $(CFLAGS) -M -MM $$cfile >> .depend ; \
	done


