/* LICENSE_CODE JUNGO */

#ifndef _AUTH1X_PKTFIL_H_
#define _AUTH1X_PKTFIL_H_

#include <rg_ioctl.h>

#ifdef __KERNEL__
#include <kos/knet.h>
#else
#define OS_INCLUDE_NETIF
#include <os_includes.h>
#endif

/* Structure used by auth1x_pktfil chardev */
typedef struct {
    char name[IFNAMSIZ];
} auth1x_dev_t;

/* SIOCSAUTH1XFILDEV should be called immediately after open() to bind to a
 * specific device */
#define SIOCSAUTH1XFILDEV _IOW(RG_IOCTL_PREFIX_AUTH1X, 1, auth1x_dev_t)
#define SIOCSAUTH1XSETMODE _IOW(RG_IOCTL_PREFIX_AUTH1X, 2, auth1x_mode_t)
#define SIOCGAUTH1XGETMODE _IOR(RG_IOCTL_PREFIX_AUTH1X, 3, auth1x_mode_t)
#define SIOCSAUTH1XAUTHMAC _IOW(RG_IOCTL_PREFIX_AUTH1X, 4, knet_ether_addr_t)
#define SIOCSAUTH1XUNAUTHMAC _IOW(RG_IOCTL_PREFIX_AUTH1X, 5, knet_ether_addr_t)
#define SIOCGAUTH1XGETNEXTMAC _IOWR(RG_IOCTL_PREFIX_AUTH1X, 6, \
    knet_ether_addr_t)
#define SIOCGAUTH1XGETUSECOUNT _IOR(RG_IOCTL_PREFIX_AUTH1X, 7, int)
#define SIOCSAUTH1XSETPASSSINGLEUNAUTH _IOW(RG_IOCTL_PREFIX_AUTH1X, 8, int)
#define SIOCGAUTH1XGETPASSSINGLEUNAUTH _IOR(RG_IOCTL_PREFIX_AUTH1X, 9, int)

#endif

