/* LICENSE_CODE JGPL */

#ifndef _BT_DEFS_H_
#define _BT_DEFS_H_

#include <sys/ioctl.h>
/* Define the ioctls to the bt driver */
#define BT_IOC_MAGIC 'B' /* Use B as a magic number */
#define BTGETNUMCONDEV _IO(BT_IOC_MAGIC, 6) 
#define BTGETICONDEV _IOW(BT_IOC_MAGIC, 7, unsigned long)

#define BTREADBDADDR _IOR(BT_IOC_MAGIC, 0x10, unsigned char[6])
#define BTINQUIRY _IOW(BT_IOC_MAGIC, 0x23, unsigned long)
#define BTGETINQELEM _IOW(BT_IOC_MAGIC, 0x24, unsigned long) 
#define BTPING _IOW(BT_IOC_MAGIC, 0x30, unsigned char[6])
#define BTSETWRITEDELAY _IOW(BT_IOC_MAGIC, 0x31, int)

#define BT_CONNECT_STARTUP	"Connect On Startup"
#define BT_ACCEPT		"Accept"
#define BT_REJECT		"Reject"

#define BT_STATUS_CONNECTED	"Connected"
#define BT_STATUS_REACHABLE	"Reachable"
#define BT_STATUS_KNOWN		"Known"
#define BT_STATUS_STANDBY	"Standby"

#define BT_ERICSSON		"Ericsson"
#define BT_DIGIANSWER		"Digianswer"

typedef enum
{
    BT_READ_BD_ADDR,
    BT_INQUIRY,
    BT_COUNT_CONS,
    BT_UPDATE_CONS,
} bt_op_t;

typedef struct 
{
    unsigned char lap[3];
    unsigned char inq_len;
    unsigned char num_resp;
} bt_inquiry_t;

typedef struct bd_list_t
{
    unsigned char bd_addr[6];
    struct bd_list_t *next;
} bd_list_t;

typedef struct 
{    	
    unsigned int ind;
    unsigned char bd_addr[6];
} con_dev_t;

#endif

