/* LICENSE_CODE JUNGO */

/* I/O Wrappers
 */
#ifndef _IO_WRAPPERS_H_
#define _IO_WRAPPERS_H_

#define OS_INCLUDE_IO
#include <os_includes.h>
#include <rg_def.h>

#ifdef CONFIG_RG_EFSS
#include <build/efss.h>
#endif

#ifdef CONFIG_RG_EFSS
#define IOW(func,a...) wfs_##func(##a)
#else
#define IOW(func,a...) func(##a)
#endif

static __inline__ void iow_init(void)
{
#ifdef CONFIG_RG_EFSS
    wfs_init();
#endif
}

static __inline__ int iow_stat(char *file_name, struct stat *buf)
{
    return IOW(stat, file_name, buf);
}

static __inline__ int iow_fstat(int fd, struct stat *buf)
{
    return IOW(fstat, fd, buf);
}

static __inline__ int iow_open(const char *pathname, int flags)    
{
    return IOW(open, pathname, flags);
}

static __inline__ int iow_close(int fd)
{
    return IOW(close, fd);
}

static __inline__ ssize_t iow_read(int fd, void *buf, size_t count)
{
    return IOW(read, fd, buf, count);
}

static __inline__ off_t iow_lseek(int fd, off_t offset, int whence)
{
    return IOW(lseek, fd, offset, whence);
}

static __inline__ int iow_chdir(const char *path)
{
    return IOW(chdir, path);
}

static __inline__ DIR *iow_opendir(const char *name)
{
    return IOW(opendir, name);
}

static __inline__ int iow_closedir(DIR *dir)
{
    return IOW(closedir, dir);
}

static __inline__ struct dirent *iow_readdir(DIR *dir)
{
    return IOW(readdir, dir);
}

#endif
