/* LICENSE_CODE JUNGO */

#ifndef _OAM_PING_H_
#define _OAM_PING_H_

/* OAM ping statistics struct */
typedef struct {
    int cells_count;
    int cells_sent;
    int cells_match;
    int cells_fail;
} oam_ping_stats_t;

/* OAM ping state */
typedef enum {
    OAM_PING_FAIL = -1,
    OAM_PING_CELL_SENT = 0,
    OAM_PING_REPLY_MATCH = 1,
    OAM_PING_REPLY_FAIL = 2,
    OAM_PING_DONE = 3,
} oam_ping_status_t;

typedef struct {
    void (*state_changed)(oam_ping_status_t ,void *);
} oam_ping_callback_t;

typedef enum {
    OAM_PING_F4_ETE = 0,
    OAM_PING_F4_SEG = 1,
    OAM_PING_F5_ETE = 2,
    OAM_PING_F5_SEG = 3,
} oam_ping_type_t;

typedef struct {
    oam_ping_type_t type;
    int vpi;
    int vci; 
    int cell_count; /* number of cells to send in this request */
} oam_ping_params_t;

typedef struct oam_ping_task oam_ping_task_t;

oam_ping_task_t *oam_ping_open(oam_ping_params_t *params, 
    oam_ping_callback_t *cb, void *context);

void oam_ping_close(void *data);

#endif
