/* LICENSE_CODE JUNGO */

#ifndef _OS_LIBC_EXTRA_H_
#define _OS_LIBC_EXTRA_H_



#ifdef CONFIG_RG_TARGET_LINUX
#include <sys/param.h>
#elif defined (CONFIG_RG_TARGET_VXWORKS)
#include <stdarg.h>

/* Macros for min/max. */
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

#ifndef LINE_MAX
#define LINE_MAX 2048
#endif

/* TODO: Check if needed (used only inside set.c). */
#define strtoll strtol

/* alphasort conforms to BSD 4.3 */
int alphasort(const void *, const void *);

/* snprintf, vsnprintf conform to ISO/IEC */
int snprintf(char *str, size_t n, char const *fmt, ...);
int vsnprintf(char *str, size_t n, const char *fmt, va_list ap);

/* strcasecmp, strncasecmp conform to BSD 4.3 */
int strcasecmp(const char *s1, const char *s2);
int strncasecmp(const char *s1, const char *s2, size_t n);

/* strdup conforms to BSD 4.3 */
char *strdup(const char *str);

/* declarations of getopt  */
int getopt(int, char *const *, const char *);
extern char *optarg;
extern int optind, opterr, optopt, optreset;
#endif

#endif
