/* LICENSE_CODE JUNGO */

#ifndef _PORT_CTL_TYPES_H_
#define _PORT_CTL_TYPES_H_

#define EAPOL_TYPE 0x888e

typedef enum {
    ACD_BOTH = 0, /* authentication controls incoming and outgoing packets */
    ACD_IN = 1, /* authentication controls only incoming packets */
} auth1x_admin_controlled_direction_t;

typedef enum {
    ACPC_FORCE_UNAUTHORIZED = 0, /* force unauthorized state */
    ACPC_FORCE_AUTHORIZED = 1, /* force authorized state */
    ACPC_AUTO = 2, /* authorization set from authentication */
} auth1x_auth_controlled_port_control_t;

typedef struct {
    auth1x_admin_controlled_direction_t dir;
    auth1x_auth_controlled_port_control_t auth_ctl;
    int promisc; /* if != 0 - switch dev to promiscuous mode */
} auth1x_mode_t;

#endif

