/* LICENSE_CODE JUNGO */

#ifndef _PROCCESS_FUNCS_H_
#define _PROCCESS_FUNCS_H_

#include "rg_def.h"
#define OS_INCLUDE_PROCESS
#include <os_includes.h>
#include <event.h>

#define DHCPD_PROC "dhcpd"
#define CARDMGR_PROC "cardmgr"
#define BTD_PROC "btd"
#define FW_CONFIG_PROC "fw_config"
#define OHPHONE_PROC "ohphone"
#define DHCLIENT_PROC "dhclient"
#define PPPD_PROC "pppd"
#define CONEXANT_PROC "cnxadsld"

enum {ACTIVE, DEAD_PID_EXIST, SUBSYS_LOCKED, STOPPED};

typedef struct pid_info_t {
    struct pid_info_t *next;
    int pid;
} pid_info_t;

void killall(char *proc, int signal);
void cleanup_pid_list(pid_info_t **pids);
int pidof(char *proc, pid_info_t **pids);
void kill_proc_by_cmdline(char *proc, char *cmd_substr);
int get_pid_by_cmdline(char *proc, int subs_num, ...);
int get_process_status(char *proc);
int is_pid_active(pid_t pid);

void sigchild_signal_handler(int sig, void *data);
char *get_process_name(char *buf, int buf_len);
pid_t start_process(char *cmd, int flags, esigchild_func_t func, void *data);
pid_t start_process_pipe_std(char *cmd, int flags, esigchild_func_t func,
    void *data, int std_fds[]);
void stop_process(pid_t pid);

#endif
