/* LICENSE_CODE JUNGO */

#ifndef _READ_CONF_FILE_H_
#define _READ_CONF_FILE_H_

#define RCF_POSSIBLY_ZERO 0x01

/* General parser function definition. Receives pointer to the input buffer,
 * which is changed by the function to point to the next location after parsing;
 * p is a parameter, flags are flags and out, if not NULL, points to a buffer
 * which will be filled with the parsed value.
 * The function return 1 if parsing succeeded, 0 if parsing failed, -1 on error.
 */
typedef int (*rcf_parser_t)(char **in, void *p, int flags, void *out);

typedef struct {
    rcf_parser_t parser; /* NULL = last entry in a series/end of array */
    void *p;
    int flags;
    void *out;
} rcf_grammer_t;

/* main function - read the configuration file filename according to grammer.
 * If the file contains a line with unrecognized grammer - the number of that
 * line is returned. Otherwise the function return 0 on success, -1 on error.
 */
int read_conf_file(char *filename, rcf_grammer_t *grammer);

int rcf_white_spaces(char **in, void *p, int flags, void *out);

int rcf_comment(char **in, void *p, int flags, void *out);

int rcf_word_match(char **in, void *p, int flags, void *out);

int rcf_word_copy(char **in, void *p, int flags, void *out);

int rcf_ip(char **in, void *p, int flags, void *out);

#endif

