/* LICENSE_CODE JUNGO */

#ifndef _RG_CONF_ENTRIES_H_
#define _RG_CONF_ENTRIES_H_

#include <rg_config.h>

#define Sadmin "admin"
#define Suser "user"
#define Spermissions "permissions"
#define Smgt "mgt"
#define Sfs_read "fs_read"
#define Sfs_write "fs_write"
#define Sfull_name "full_name"
#define Semail "email"
#define Spassword "password"
#define Stz_offset "tz_offset"
#define Stz_name "tz_name"
#define Stimezone "timezone"
#ifdef CONFIG_RG_AUTO_DST
#define ENTRY_TZ_NAME Stimezone
#else
#define ENTRY_TZ_NAME Stz_name
#endif
#define Sdaylight_saving "daylight_saving"
#define Soffset "offset"
#define Sminute "minute"
#define Stod "tod"
#define Supdate_period "update_period"
#define Snotify_level "notify_level"
#define Ssystem_log "0"
#define Ssecurity_log "1"

/* File server */
#define Sfs "fs"
#define Sworkgroup "workgroup"
#define Scodepage "codepage"

/* /network - Network Configuration Section */
#define Snetwork "network"
#define Swan_data_client_id "wan_data_client_id"
#define Sprovisioning_timer "provisioning_timer"
#define Srg_mac "rg_mac"

#define Swbm "wbm"
#define Sadvanced "advanced"
#define Ssession_lifetime "session_lifetime"
#define Sinit_page "init_page"
#define Slicense_agreed "license_agreed"
#define Sis_login_welcome_done "is_login_welcome_done"
#define Sis_login_setup_done "is_login_setup_done"
#define Sauto_refresh "auto_refresh"
#define Sconfirm_needed "confirm_needed"
#define Sconn_list "conn_list"
#define Shttp_auth_type "http_auth_type"

/* WBM diagnostics */
#define Sdiagnostics "diagnostics"
#define Sping_dest "ping_dest"
#define Soam_ping "oam_ping"
#define PATH_OAM_PING Swbm "/" Sdiagnostics "/" Soam_ping
#define Stype "type"
#define Scount "count"

#define Sdistribution "distribution"
#define Ssystem "system"
#define Sboard_id "board_id"
#define Sfailure_boots "failure_boots"
#define Sname "name"
#define Senabled "enabled"
#define Srand_seed "rand_seed"
#define Sboot "boot"
#define Sversion "version"
#define Srelease "release"
#define Shostname "hostname"
#define Susername "username"
#define Sis_clamp_mtu "is_clamp_mtu"
#define Sservice_name "service_name"
#define Smax_idle "max_idle"
#define Sreconnect_time "reconnect_time"
#define Sis_on_demand "is_on_demand"
#define Snetwork_name "network_name"
#define Sencryption "encryption"
#define Scontact "contact"
#define Slocation "location"
#define Ssmtp "smtp"
#define Sreply_to "reply_to"
#define Sradius "radius"

#define Smanufacturer "manufacturer"
#define Shardware "hardware"
#define Sserial_num "serial_num"
#define Svendor_name "vendor_name"
#define Sboot_rom_version "boot_rom_version"
#define Ssys_object_id "sys_object_id"
#define Smodel_number "model_number"

/* System logs */
#define Slogin_success "login_success"
#define Slogin_fail "login_fail"
#define Ssystem_errors "system_errors"
#define Sconf_change "conf_change"

/* UPnP */
#define Supnp "upnp"
#define Sreadonly "readonly"
#define Sconn_readonly "conn_readonly"

/* CableHome */
#define Sch_mng_device "ch_mng_device"
#define Sch_data_device "ch_data_device"

#define Sip "ip"
#define Ssource "source"

#define Srmt_upd "rmt_upd"
#define Slast_check "last_check"
#define Swan_ver "wan_ver"
#define Swan_upgrade_type "wan_upgrade_type"
#define Scheck_interval "check_interval"
#define Surl "url"
#define Scvc_download_status "cvc_download_status"
#define Scode "code"
#define Sstring "string"

#define Stel "tel"
#define Sext "ext"
#define Snum "num"

#define Svoip "voip"
#define Spstngw "pstngw"

#define Svoatm "voatm"
#define Selcp "elcp"
#define Scas "cas"
#define Scas_emu "cas_emu"
#define Sl3addr "l3addr"

#define Svpn "vpn"
#define Sregistered_vpn "registered_vpn"
#define Slicenses "licenses"
#define Sppp "ppp"
#define Spptps "pptps"
#define Spptpc "pptpc"
#define Slocal_ip "local_ip"
#define Sremote_host "remote_host"
#define Slocal "local"
#define Sremote "remote"
#define Slisten_on_all "listen_on_all"
#define Sserver_name "server_name"
#define Sverbose "verbose"
#define Sauth "auth"
#define Srequired "required"
#define Spap "pap"
#define Schap "chap"
#define Sms_chap_v1 "ms_chap_v1"
#define Sms_chap_v2 "ms_chap_v2"
#define Smppe_40 "mppe_40"
#define Smppe_128 "mppe_128"
#define Smppe_stateless "mppe_stateless"
#define Sbsdcomp "bsdcomp"
#define Sdeflate "deflate"
#define Sauth_protocol "auth_protocol"
#define Sauth_protocol_advanced "auth_protocol_advanced"
#define Sencrypt_protocol "encrypt_protocol"
#define Sencrypt_protocol_advanced "encrypt_protocol_advanced"
#define Sidle_timeout "idle_timeout"

/* IPSec entries */
#define Sipsec "ipsec"
#define Saddr "addr"
#define Strans_type "trans_type"
#define Scompressed "compressed"
#define Sauto "auto"
#define Smanual "manual"
#define Sdifferent_keys "different_keys"
#define Sreject_num "reject_num"
#define Speriod "period"
#define Sblock_ip "block_ip"

/* Manual */
#define Sspi "spi"
#define Sesp "esp"
#define Sah "ah"
#define Shash "hash"

/* Automatic */
#define Snegotiate_attempts "negotiate_attempts"
#define Sphase1 "phase1"
#define Sphase2 "phase2"
#define Slifetime "lifetime"
#define Srekey_margin "rekey_margin"
#define Srekey_fuzz "rekey_fuzz"
#define Sdh_group "dh_group"
#define Speer_auth "peer_auth"
#define Suse_pfs "use_pfs"

/* Authentication Algorithems */
#define Smd5 "md5"
#define Ssha1 "sha1"

/* Encryption Algorithems */
#define Snull "null"
#define Sdes "des"
#define S3des "3des"

/* Group Algorithem */
#define Sgrp1 "grp1"
#define Sgrp2 "grp2"
#define Sgrp5 "grp5"

#define Sshared_secret "shared_secret"
#define Srsa_sig "rsa_sig"

/* Private-Public RSA Signature */
#define Sremote_rsa "remote_rsa"
#define Slocal_id "local_id"
#define Sauth_type "auth_type"
#define Sencrypt_type "encrypt_type"
#define Sencrypt "encrypt"
#define Sauth_key "auth_key"
#define Senc_key "enc_key"
#define Srsa "rsa"
#define Spublic "public"
#define Smodulus "modulus"
#define Spublic_exponent "public_exponent"
#define Sprivate_exponent "private_exponent"
#define Sprime1 "prime1"
#define Sprime2 "prime2"
#define Sexponent1 "exponent1"
#define Sexponent2 "exponent2"
#define Scoefficient "coefficient"
#define Sproto_type "proto_type"
#define Skx_type "kx_type"
#define Ssignature "signature"
/* IPSec log settings */
#define Sraw_bytes "raw_bytes"
#define Sinput "input"
#define Soutput "output"
#define Spluto "pluto"
#define Sklips "klips"
#define Sprivate_keys "private_keys"
#define Stunneling "tunneling"
#define Stransmit "transmit"
#define Suserspace "userspace"
#define Stransform "transform"
#define Seroute "eroute"
#define Ssa "sa"
#define Sradij "radij"
#define Senc_transform "enc_transform"
#define Sauth_transform "auth_transform"
#define Srecieve "recieve"
#define Scompression "compression"
#define Smore "more"

#define Srg_conf "rg_conf"
#define Srg_factory "rg_factory"
#define Spersist_log "persist_log"
#define Srouters "routers"
#define Sdev "dev"
#define Sfirewall_level "firewall_level"
#define Sis_trusted "is_trusted"
#define Sdepend_on_name "depend_on_name"
#define Senslaved "enslaved"
#define Sstp "stp"
#define Sstatic "static"
#define Sfallback "fallback"
#define Snetmask "netmask"
#define Suse_override_netmask "use_override_netmask"
#define Soverride_netmask "override_netmask"
#define Sgateway "gateway"
#define Sis_sync "is_sync"
#define Shas_ip "has_ip"
#define Sis_support_promisc "is_support_promisc"
#define Sdhcps "dhcps"
#define Sdhcpr "dhcpr"
#define Sroute "route"
#define Smetric "metric"
#define Srip "rip"
#define Sgen_limit "gen_limit"
#define Sinput_version "input_version"
#define Soutput_version "output_version"
#define Sproxy_arp "proxy_arp"
#define Sroute_level "route_level"
#define Sbridge_level "bridge_level"
#define Sdefault_route "default_route"
#define Srenew_time "renew_time"
#define Svalid_time "valid_time"
#define Suid "uid"
#define Sflags "flags"
#define Sdyn "dyn"
#define Sstart_ip "start_ip"
#define Send_ip "end_ip"
#define Slease_time "lease_time"
#define Slogical_network "logical_network"
#define Sdescription "description"
#define Stype "type"
#define Sprotocol "protocol"
#define Slease "lease"
#define Sis_dynamic "is_dynamic"
#define Shardware_mac "hardware_mac"
#define Smac "mac"
#define Shas_mac "has_mac"
#define Smac_cur "mac_cur"
#define Smac_company_id "mac_company_id"
#define Senslaved_macs "enslaved_macs"
#define Sstart_time "start_time"
#define Send_time "end_time"
#define Sis_ms_null_terminated "is_ms_null_terminated"
#define Sis_abandoned "is_abandoned"
#define Sstability "stability"
#define Svendor_id "vendor_id"
#define Sis_time_absolute "is_time_absolute"
#define Sis_hostname_fixed "is_hostname_fixed"
#define Stime_offset "time_offset"
#define Sttl "ttl"
#define Smtu "mtu"
#define Sis_auto_mtu "is_auto_mtu"
#define Svendor_specific "vendor_specific"
#define Sserver_ip "server_ip"
#define Sdhcps_routers "routers"
#define Sdhcps_dns_servers "dns_servers"
#define Swins_server "wins_server"
#define Sdhcps_syslog_servers "syslog_servers"
#define Screate_hostname "create_hostname"
#define Sbroute "broute"
#define Sis_wan_man "is_wan_man"
#define Sis_wan_data "is_wan_data"
#define Sname_server "name_server"
#define Sprimary_dns "0"
#define Ssecond_dns "1"
#define Sis_dns_neg "is_dns_neg"
#define Salias "alias"
#define Sis_dhcp_client "is_dhcp_client"
#define Sis_waiting_for_lease "is_waiting_for_lease"
#define Sdhcp_server "dhcp_server"
#define Sis_alternate "is_alternate"

#define Sdevname_pppoe "ppp0"
#define Sdevname_pppoa "ppp1"
#define Sdevname_ethoa "ethoa0"

#define Svisible_to_dns "visible_to_dns"
#define Skey "key"

#define Satm "atm"
#define Saal5 "aal5"
#define Saal2 "aal2"
#define Spvc "pvc"
#define Svpi "vpi"
#define Svci "vci"
#define Sencaps "encaps"
#define Sroute_mode "route_mode"
#define Spvc_scan "pvc_scan"

#define Sdns "dns"
#define Sdomainname "domainname"
#define Sentry "entry"

#define Sddns "ddns"
#define Sprovider "provider"
#define Sstatus "status"
#define Smx "mx"
#define Slast_ip "last_ip"
#define Slast_update "last_update"

/* /service */
#define Sservice "service"
/* #define Sname "name" */
#define Sports "ports"
#define Sprimary "primary"
#define Ssecondary "secondary"
#define Sserver "server"
#define Sclient "client"
#define Sfwd "fwd"
/* #define Stype "type" */
#define Sfrom "from"
#define Sto "to"
/* Syslog */
#define Ssyslog "syslog"
#define Sbuffers "buffers"
#define Sseverity_threshold "severity_threshold"
#define Smax_size "max_size"
/* Time rules */
#define Stime "time"
#define Sday "day"
#define Shour "hour"
/* Firewall Section: /fw */
#define Sfw "fw"
#define Saccept "accept"
#define Sconn_internal "conn_internal"
#define Ssuccess "success"
#define Sfail "fail"
#define Sconf_version "conf_version"
#define Stftp_url "tftp_url"
/* Firewall policy options: /fw/policy */
#define Spolicy "policy"
#define Sacpt_input "acpt_input"
#define Sacpt_output "acpt_output"
#define Sip_frags "ip_frags"
#define Sactive "active"
/* Firewall log options: /fw/log */
#define Slog "log"
#define Sconn_accepted "conn_accepted"
#define Sconn_blocked "conn_blocked"
#define Sspoofed "spoofed"
#define Swinnuke "winnuke"
#define Ssynflood "synflood"
#define Sbadfrag "badfrag"
#define Sstate "state"
/* Firewall chains: /fw/policy/%/chain */
#define Schain "chain"
/* User-defined Firewall rules: /fw/rule */
#define Srule "rule"
#define Smatch "match"
#define Sip_src_start "ip_src_start"
#define Sip_src_end "ip_src_end"
#define Sip_dst_start "ip_dst_start"
#define Sip_dst_end "ip_dst_end"
#define Sip_version "ip_version" 
#define Sip_option "ip_option"
#define Smac_src "mac_src"
#define Smac_dst "mac_dst"
#define Smac_protocol "mac_protocol"
#define Sif "if"
#define Sip_frag "ip_frag"
/* Types of firewall rules: /fw/rule/<type> */
#define Slocal_servers "loc_srv"
#define Saccess_ctrl "acc_ctrl"
#define Sparental_ctrl "prntl_ctrl"
#define Sdmz_host "dmz_host"
#define Smcast "mcast"
#define Sspecial_apps "special_apps"
#define Sremote_access "remote_access"
#define Srule_in "rule_in"
#define Srule_out "rule_out"
/* Firewall rule fields: /fw/rule/<type>/%  */
/* #define Senabled "enabled" */
#define Sservice_id "service_id"
#define Sservices "services"
#define Ssrc "src"
#define Sdst "dst"
#define Srdir "rdir" /* Redirection address - for RNAT rules */
#define Saction "action" /* Firewall action */
#define Sstart "start"
#define Send "end"
#define Sopen "open"
#define Strigger "trigger"
#define Sicmp_code "icmp_code"
#define Sicmp_type "icmp_type"
#define Sowner "owner"
#define Sreject_type "reject_type"
#define Sreject_icmp_code "reject_icmp_code"

/* ADSL defaults */
#define Sdsl "dsl"
/* For Conexant ADSL exist prototype -
 * see static struct  DefaultADSLParameters in cnxtatm.c */
#define SRxMaxLatency "RxMaxLatency"
#define SRxMinLatency "RxMinLatency"
#define STxMaxLatency "TxMaxLatency"
#define STxMinLatency "TxMinLatency"
#define SRxInterruptRate "RxInterruptRate"
#define STxInterruptRate "TxInterruptRate"
#define	SRxSpeed "RxSpeed"
#define	STxSpeed "TxSpeed"
#define	SAutoSenseHandshake "AutoSenseHandshake"
#define	SAutoSenseWiresFirst "AutoSenseWiresFirst"
#define	SAutoWiringSelection "AutoWiringSelection"
#define	SAutoWiringRelayDelay "AutoWiringRelayDelay"
#define	SAutoWiringRelayEnrg "AutoWiringRelayEnrg"
#define	SAutoWiringNumCombos "AutoWiringNumCombos"
#define	SAutoWiringComboGPIO "AutoWiringComboGPIO"
#define SAutoWiringOrder "AutoWiringOrder"
#define	SAdslHeadEnd "AdslHeadEnd"
#define	SAdslHeadEndEnvironment "AdslHeadEndEnvironment"
#define	SLineAutoActivation "LineAutoActivation"
#define	SVendorNearId "VendorNearId"
#define	SRXBufAllocLimit "RXBufAllocLimit"
#define	SRXBufRatioLimit "RXBufRatioLimit"
#define	SRxMaxFrameSize "RxMaxFrameSize"
#define	STxMaxFrameSize "TxMaxFrameSize"
#define	SMaxTransmit "MaxTransmit"
#define SRfcEncapsulationMode "RfcEncapsulationMode"
#define	SCellBurstSize "CellBurstSize "
#define	SPeakCellRate "PeakCellRate"
#define	SOverrideMacAddress "OverrideMacAddress"
#define	SMACAddress "MACAddress"
#define	SSendOAMCell "SendOAMCell"
#define	SAdslOptions "AdslOptions"

/* Values for Saction */
typedef enum {
    FW_DROP = 0,
    FW_ACCEPT = 1,
    FW_ACCEPT_STATELESS = 2,
    FW_NAT = 3,
    FW_NAPT = 4,
    FW_REJECT = 5,
    FW_CALL = 6,
} fw_action_t;
#define FW_BLOCK FW_DROP /* old fw api compatibility */

/* NAT Section */
#define Snat "nat"
#define Sport "port"
/* #define Srule "rule" */

#define Sch_rmt_upg "ch_rmt_upg"
#define Sswserver "swserver"
#define Sswfilename "swfilename"
#define Sadminstatus "adminstatus"
#define Soperstatus "operstatus"
#define Strynum "trynum"

/* Certificate keys fields */
#define Scert "cert"
#define Sowner "owner"
#define Sprivate "private"
#define Srequest "request"
#define Slocal_id "local_id"
#define Speer_id "peer_id"

/* Certificate type prefix */
#define Scl_cvc_root_ca "cl_cvc_root_ca"
#define Scl_cvc_ca "cl_cvc_ca"
#define Smfg_cvc "mfg_cvc"
#define Scosigner_cvc "cosigner_cvc"
#define Scl_mfg_root_ca "mfg_root_ca"
#define Smfg_ca "mfg_ca"
#define Sps_cert "ps_cert"
#define Scl_sp_root_ca "cl_sp_root_ca"
#define Ssp_ca "sp_ca"
#define Slcl_sys_ca "lcl_sys_ca"
#define Skdc_cert "kdc_cert"
/* Certificate content suffix */
#define Stext "text"
#define Spriv_key "priv_key"
#define Sorg_name "org_name"
#define Scvc_access_start "cvc_access_start"
#define Scode_access_start "code_access_start"
#define Ssnmp "snmp"
#define Srow_status "row_status"
#define Sch_cdp_lan_not_active "ch_cdp_lan_not_active"
#define Sch_cap_pass_active "ch_cap_pass_active"
#define Spersist_conf "persist_conf"

/* Kerberos tree start */
#define Skerb "kerb"
/* Realm string */
#define Sap_timeout "ap_timeout"

/* RGLoader string */
#define Sbootloader "bootloader"
#define Sautoboot "autoboot"
#define Stimeout "timeout"

#ifdef CONFIG_RG_AUTO_DST
#define DEFAULT_TZ_NAME "GMT"
#else
#define DEFAULT_TZ_NAME "Greenwich Mean Time"
#endif
#define DEFAULT_TZ_OFFSET 0
/* 28-Mar (approx. last Sunday of March) */
#define DEFAULT_TZ_DAYLIGHT_FROM "28;2"
/* 28-Oct (approx. last Sunday of October) */
#define DEFAULT_TZ_DAYLIGHT_TO "28;9"
/* "0"-disable, "1"-enable */
#define DEFAULT_TZ_DAYLIGHT "0"
/* 1 hour offset */
#define DST_DEFAULT_OFFSET 60
#define DST_DEFAULT_START_HOUR 0
#define DST_DEFAULT_START_MIN 0
#define DST_DEFAULT_END_HOUR 1
#define DST_DEFAULT_END_MIN 0

/* NMS string */
#define Snms "nms"

/* Multicast/IGMP proxy */
#define Sigmp_proxy_default "igmp_proxy_default"

/* VLAN ID in dev */
#define Svlan_id "vlan_id"

/* How WBM displays the routing section for this device */
#define Sis_advanced_wbm_routing "is_advanced_wbm_routing"

/* Hidden flag for device (device is not visible in WBM) */
#define Sis_hidden "is_hidden"

/* 802.1x */
#define S8021x_eap_method "8021x_eap_method"
#define S8021x_port_auth "8021x_port_auth"
#define S8021x "8021x"
#define S8021x_auth "8021x_auth"
#define Sport_auth "port_auth"
#define Sre_auth_period "re_auth_period"
#define Stx_period "tx_period"
#define Swlan "wlan"
#define Skey_mgt "key_mgt"
#define Srekey_timeout "rekey_timeout"
#define Skey "key"
#define Sis_ascii "is_ascii"
#define Slength "length"
#define Sactive_key "active_key"

/* WPA */
#define Swpa "wpa"
#define Sauth_mode "auth_mode"
#define Spreshared_key "preshared_key"
#define Swep_rekeying_key_length "wep_rekeying_key_length"
#define Saccept_wpa_stas "accept_wpa_stas"
#define Saccept_non_8021x_wep_stas "accept_non_8021x_wep_stas"
#define Saccept_8021x_wep_stas "accept_8021x_wep_stas"
#define Sprivacy_enabled "privacy_enabled"

/* RADIUS */
#define Sradius "radius"
#define Sservers "servers"

/* Email Notification */
#define Senotify "enotify"
#define Squeue_length "queue_length"
#define Ssend_period "send_period"
#define Sretry_period "retry_period"

/* Wireless Access Point */
#define Swl_ap "wl_ap"
#define Swl_ssid "wl_ssid"
#define Swl_wep "wl_wep"
#define Swl_wep_restricted "wl_wep_restricted"
#define Swl_curr_key "wl_curr_key"
#define Swl_lazywds "wl_lazywds"
#define Swl_plcphdr_long "wl_plcphdr_long"
#define Swl_bcn "wl_bcn"
#define Swl_dtim "wl_dtim"
#define Swl_rts "wl_rts"
#define Swl_frag "wl_frag"
#define Swl_rate "wl_rate"
#define Swl_channel "wl_channel"
#define Swl_rateset_all "wl_rateset_all"
#define Swl_d11g_shortslot_restrict "wl_d11g_shortslot_restrict"
#define Swl_d11g_shortslot "wl_d11g_shortslot"
#define Swl_d11g_mode "wl_d11g_mode"
#define Swl_radio "wl_radio"
#define Swl_macmode "wl_macmode"
#define Swl_auth "wl_auth"
#define Swl_country "wl_country"
#define Swl_closed "wl_closed"
#define Swl_mode_ap "wl_mode_ap"
#define Swl_mac_filter "wl_mac_filter"
#define Swl_wds_list "wl_wds_list"
#define Swl_dot11_mode "wl_dot11_mode"

typedef enum loc_srv_src_t
{
    LS_SRC_WBM = 1,
    LS_SRC_UPNP = 2
} loc_srv_src_t;

typedef enum {
    RANGE_NONE = -1,
    RANGE_TCP = 0,
    RANGE_UDP = 1,
    RANGE_ICMP = 2,
    RANGE_LAST = RANGE_ICMP, /* ICMP is not displayed */
} range_type_t;

typedef enum {
    /* mind the order.. */
    CHAIN_PRE = 1,
    CHAIN_DEV = 2,
    CHAIN_POST = 3,
    CHAIN_SYSTEM = 4,
    CHAIN_ROOT = 5,
} fw_chain_type_t;

#define CHAIN_FIRST_TYPE CHAIN_PRE
#define CHAIN_LAST_TYPE CHAIN_SYSTEM /* system will not be displayed */
    
#define RIP_DEFAULT 0

#endif

