/* LICENSE_CODE JUNGO */

#ifndef _RG_IOCTL_H_
#define _RG_IOCTL_H_

#ifdef __KERNEL__
#if defined(CONFIG_RG_TARGET_LINUX)
#include <linux/ioctl.h>
#elif defined(CONFIG_RG_TARGET_VXWORKS)
#include <sys/ioctl.h>
#else
#error Unknown kernel
#endif
#else
#include <sys/ioctl.h>
#endif

/* This is the start of a free window of IOCTL prefixes for ALL RG ioctls.
 * for Linux OS generic ioctls (not RG related) see [1] for prefixes.
 */
#define RG_IOCTL_PREFIX_BASE 0xD0

#define RG_IOCTL_PREFIX_DHCP (RG_IOCTL_PREFIX_BASE + 0)
#define RG_IOCTL_PREFIX_LOG (RG_IOCTL_PREFIX_BASE + 1)
#define RG_IOCTL_PREFIX_FW (RG_IOCTL_PREFIX_BASE + 2)
#define RG_IOCTL_PREFIX_BRIDGE (RG_IOCTL_PREFIX_BASE + 3)
#define RG_IOCTL_PREFIX_CHWAN (RG_IOCTL_PREFIX_BASE + 4)
#define RG_IOCTL_PREFIX_USFS (RG_IOCTL_PREFIX_BASE + 5)
#define RG_IOCTL_PREFIX_RAUL (RG_IOCTL_PREFIX_BASE + 6)
#define RG_IOCTL_PREFIX_AUTH1X (RG_IOCTL_PREFIX_BASE + 7)
#define RG_IOCTL_PREFIX_KOS (RG_IOCTL_PREFIX_BASE + 8)

/* add here additional prefixes (modules) for ioctls */

#endif
