/* LICENSE_CODE JGPL */

#ifndef _RG_OS_H_
#define _RG_OS_H_
/* This file contains header files which should be included always for an OS.
 * For example, in case of VxWorks, it's always needed to include vxWorks.h
 */
#ifdef CONFIG_RG_TARGET_VXWORKS

#include <vxWorks.h>

#if _BYTE_ORDER == _BIG_ENDIAN
#define BIG_ENDIAN_HOST 1
#endif
#ifndef BYTE_ORDER
#define BYTE_ORDER _BYTE_ORDER
#endif

#define RG_OS_CONSOLE "/tyCo/0"

#define CONFIG_RG_TARGET_BSD

#elif defined(CONFIG_RG_TARGET_LINUX)

#ifdef __KERNEL__
#include <asm/byteorder.h>
#else
#include <endian.h>
#endif

#if __BYTE_ORDER == __BIG_ENDIAN
#define BIG_ENDIAN_HOST 1
#endif

#define RG_OS_CONSOLE "/dev/console"
#endif

#ifndef BIG_ENDIAN_HOST
#define LITTLE_ENDIAN_HOST 1
#endif

#endif
