/* LICENSE_CODE JUNGO */

#ifndef _RG_VERSION_H_
#define _RG_VERSION_H_

#define RG_MAJOR_NUM 2
#define RG_MINOR_NUM 6
#define RG_REVISION_NUM 19

#define RG_VERSION_MAKE_(a,b,c) (((a) * 10000) + ((b) * 100) + (c))
#define RG_VERSION_MAKE(a,b,c) RG_VERSION_MAKE_(a,b,c)
#define RG_VERSION_MAJOR_GET(ver) ((ver) / 10000)
#define RG_VERSION_MINOR_GET(ver) (((ver) / 100 ) % 100)
#define RG_VERSION_REVISION_GET(ver) ((ver) % 100)
#define RG_VERSION_MAKE_STR_(a,b,c) #a "." #b "." #c
#define RG_VERSION_MAKE_STR(a,b,c) RG_VERSION_MAKE_STR_(a,b,c)

#define RG_VERSION_STR RG_VERSION_MAKE_STR(RG_MAJOR_NUM, RG_MINOR_NUM, \
    RG_REVISION_NUM)
#define RG_VERSION RG_VERSION_MAKE(RG_MAJOR_NUM, RG_MINOR_NUM, RG_REVISION_NUM)

/* Get a version in rg format and convert it to a string format in a static
 * buffer
 */
char *rg_version_to_str(int ver);

/* Translate a string formatted as a.b.c to version number */
int str_to_rg_version(char *ver);

extern char *rg_version_str;
extern int rg_version;

#endif
