/* LICENSE_CODE JUNGO */

#ifndef _SET_UTILS_H_
#define _SET_UTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <set.h>
#include <rg_conf_entries.h>
#include <misc_funcs.h>
#include <util/conv.h>

#define MAX_PORT_RANGE 12

/* Don't use with elements that end with a '\' - set APIs consider this
 * as an escape sequence.
 * Last parameter MUST be NULL.
 * return a pointer to a static buffer.
 */
char *set_path_create(char *first, ...);

set_t **set_lookfor_value(set_t **parent, char *token, char *value);

/* Store ip under set/path unless it is 0.0.0.0. in that case set/path is
 * removed */
void ip_set_set_or_free(set_t **set, char *path, struct in_addr ip);

void set_set_path_key_list(set_t **set, char *path, key2str_t *list, int val);

/* Get an IP from a set path, with a non-zero default */
struct in_addr set_get_path_ip_default(set_t **top, char *path, char *def_addr);

/* Get an int from a set path, with a non-zero default */
int set_get_path_int_default(set_t **top, char *path, int defval);

#endif
