/* LICENSE_CODE JUNGO */

#ifndef _STACK_BUF_H_
#define _STACK_BUF_H_

#include <rg_def.h>

#ifdef CONFIG_SMALL_STACK
#ifdef _LIBC 
#define SET_ERRNO(val) __set_errno(val)
#else
#define SET_ERRNO(val) errno = val;
#endif

#include <errno.h>
#include <stdlib.h>

#define STBUF_DECLR(type, name, size) \
    type *name = NULL; \
    static const int _RG_##name##_size = size;

#define STBUF_DECLR_VAR_SIZE(type, name, size) \
    type *name = NULL; \
    const int _RG_##name##_size = size;

#define STBUF_DECLR_STATIC static

#define STBUF_ALLOC(name) \
{ \
    name = (void *)malloc(_RG_##name##_size * sizeof(*name)); \
    if (!name) \
        exit(1); \
}

#define STBUF_ALLOC_F(name, action_upon_failure) \
{ \
    name = (void *)malloc(_RG_##name##_size * sizeof(*name)); \
    if (!name) \
    { \
	action_upon_failure; \
	SET_ERRNO(ENOMEM); \
	goto Exit; \
    } \
}

#define STBUF_SIZEOF(name) (_RG_##name##_size * sizeof(*name))

#define STBUF_FREE(name) free(name);

#define STBUF_RET(ret, x) \
{ \
    ret = x; \
    goto Exit; \
}
    
#else

#define STBUF_DECLR(type, name, size) type name[size];
#define STBUF_DECLR_VAR_SIZE(type, name, size) type name[size];
#define STBUF_DECLR_STATIC
#define STBUF_ALLOC(name) 
#define STBUF_ALLOC_F(name, action_upon_failure) 
#define STBUF_SIZEOF(name) sizeof(name)
#define STBUF_FREE(name)
#define STBUF_RET(ret, x) \
{ \
    if (0) goto Exit; \
    return x; \
}
#endif
#endif
