/* LICENSE_CODE JUNGO */

#ifndef _KOS_ENDIAN_H_
#define _KOS_ENDIAN_H_

#include "kos_common.h"


/* In user-mode __BYTE_ORDER is defined by the compiler, in kernel we have to
 * define it by ourselves
 */
#if defined(CONFIG_RG_TARGET_LINUX) && defined(__KERNEL__)
#include <asm/byteorder.h>  /* endianess */
#ifdef __LITTLE_ENDIAN
#define __BYTE_ORDER __LITTLE_ENDIAN
#elif defined(__BIG_ENDIAN)
#define __BYTE_ORDER __BIG_ENDIAN
#else
#error "<asm/byteorder.h> doesn't define endianess!"
#endif
#elif defined(CONFIG_RG_TARGET_VXWORKS)
#include <vxWorks.h>
#endif

/* The modules are encouraged to use KOS_ARCH_LITTLE_ENDIAN and 
 * KOS_ARCH_BIG_ENDIAN only. (#ifdef KOS_ARCH_LITTLE_ENDIAN ...).
 * Don't use KOS_LITTLE_ENDIAN/KOS_BIG_ENDIAN.
 */
#define KOS_BYTE_ORDER KOS_IFDEF(__BYTE_ORDER, _BYTE_ORDER)
#define KOS_LITTLE_ENDIAN KOS_IFDEF(__LITTLE_ENDIAN, _LITTLE_ENDIAN)
#define KOS_BIG_ENDIAN KOS_IFDEF(__BIG_ENDIAN, _BIG_ENDIAN)

#if KOS_BYTE_ORDER == KOS_LITTLE_ENDIAN
#define KOS_ARCH_LITTLE_ENDIAN KOS_LITTLE_ENDIAN
#undef KOS_ARCH_BIG_ENDIAN
#elif KOS_BYTE_ORDER == KOS_BIG_ENDIAN
#define KOS_ARCH_BIG_ENDIAN KOS_BIG_ENDIAN
#undef KOS_ARCH_LITTLE_ENDIAN
#else
#error Endianess undefined
#endif

#endif
