ifndef WLANPREFIX
	WLANPREFIX = /vobs/wlan
endif

include ti_wpa_export.mak


all: libcrypto.a libssl.a

include $(WLANPREFIX)/make/Rules.make
include $(WLANPREFIX)/make/URules.make

#CFLAGS=-D_LIBC_REENTRANT -Wall -g -EB -mgp32 -mcpu=r4000 -mips2 -non_shared -DRW_MULTI_THREAD -D_REENTRANT -funroll-loops -fno-for-scope -DMIPSEB -msoft-float -DCPU=RC32364 

#CFLAGS+=-O0 -G 0 -ansi -nostdinc
#CFLAGS=-mips2  -Wno-trigraphs  -fno-strict-aliasing -G 0  -mlong-calls -mlong32 -msplit-addresses -mmemcpy  -frerun-loop-opt -fgcse -fdelayed-branch -fschedule-insns2 -fmove-all-movables -nostdinc -I/vobs/psp_linux_wlan/mipsel-linux-uClibc/include  -I/opt/hardhat/devkit/mips/fp_le/lib/gcc-lib/mipsel-hardhat-linux/2.95.3/include -Wall  -pipe -pthread   -D__USE_XOPEN2K  -DTIWLAN_TX_MSG_QUEUE_WATCHDOG -DTIWLAN_APDK_VER=1130 -DTIWLAN_PSP_VER=4 -DWLAN_BUS_TYPE=2 -DWLAN_ADAPTOR_VERSION=1130 -DWLAN_ADAPTOR_WORK_MODE=2 -DCONFIG_RG_TARGET_LINUX -DTI_INCLUDE_SHELL -DTIWLAN_OUTPUT -DTIWLAN_CONF_MANAGER -DTIWLAN_NO_FIRMWARE_TFTP=1 -DNDEBUG -O3 -funroll-loops -fomit-frame-pointer -DTIWLAN_USE_INTERRUPT -DCOMPILE_CLI=1
#CC=/vobs/psp_linux_wlan/mipsel-linux-uClibc/bin/mipsel-uclibc-gcc

CFLAGS+=-DNO_ASM -DNO_BF -DNO_CAST -DNO_MDC2 -DNO_MD2 -DNO_RC2 -DNO_RC5 \
  -DNO_IDEA -DTERMIO -DCONFIG_RG_TARGET_LINUX -DNDEBUG

CFLAGS+=-DL_ENDIAN

#PLATFORM=vxworks
#CFLAGS+=-DVXWORKS -DCONFIG_RG_TARGET_VXWORKS

BN_ASM=bn_asm.o
DES_ENC=des_enc.o fcrypt_b.o
BF_ENC=bf_enc.o
CAST_ENC=c_enc.o
RC4_ENC=rc4_enc.o
RC5_ENC=rc5_enc.o

# XXX OpenSSL's headers are not strict ANSI (do not have full prototypes).
# Therefore we must disable the strict prototype checking only for this package
CFLAGS:=$(filter-out -Wstrict-prototypes,$(CFLAGS))

INCLUDES=	-I$(OPENSSL_DIR)/../include/openssl -I$(OPENSSL_DIR)/crypto \
  -I$(WPA_DIR)/include  

CFLAGS+=$(INCLUDES) -mips2 -Wno-trigraphs

#CC=ccmips
#AR=armips
#ARFLAGS=crus

clean : 
	rm -f $(CRYPTO_FILES) $(SSL_FILES) libcrypto.a libssl.a

libcrypto.a: $(CRYPTO_FILES)
	$(AR) $(ARFLAGS) $@ $^

libssl.a: $(SSL_FILES)
	$(AR) $(ARFLAGS) $@ $^
