/* LICENSE_CODE JUNGO */

#ifndef _FILE_H_
#define _FILE_H_

#include <rg_def.h>
#include <sys/types.h>
#include <stdarg.h>
#include <stdio.h>

enum {LOPT_DONT_OPEN_LOG=0x01};

typedef enum {
    TEXT_FILE = 0,
    PROC_CMDLINE_FILE = 1
} rg_grep_file_t;

int cp_file(const char *src, const char *dst);
int mv_file(const char *src, const char *dst);
int wc(const char *file, int *lines, int *bytes);
int tail(const char *dst_file, const char *src_file, const int num);
char *reverse(const char *file);
FILE *tmp_file_open(void);
void stdout2null(void);
void close_fds(void);
char *rg_grep(char *file_name, rg_grep_file_t type, int subs_num, ...);
char *rg_vgrep(char *file_name, rg_grep_file_t type, int subs_num,
    va_list ap);
int proc_filesystem_set(char *path, int val);
char *make_full_fname(char *path, char *file);
void mv_tmp_to_file(char *file, char *tmp_file);
void chown_root(char *file);
void rg_openlog(char *ident, int option, int  facility);
/* Protected read syscall. Retry if interrupted (EINTR) */
ssize_t force_read(int fd, void *buf, size_t count);
/* Protected write syscall. Retry if interrupted (EINTR) */
ssize_t force_write(int fd, const void *buf, size_t count);

#endif

