#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <asm/types.h>
#include <sys/socket.h>
#include <linux/netlink.h>
#include <linux/rtnetlink.h>
#include "linux_ipc_user.h"

int ipc_accept_buf_read(int fd, void *data, int data_len) {
	int res;
	struct sockaddr_nl sanl;
	socklen_t sanllen;

	sanllen = sizeof(struct sockaddr_nl);
	res = recvfrom(fd, data, data_len, MSG_DONTWAIT, (struct sockaddr*)&sanl, &sanllen);

	if (res <= 0) {
		fprintf(stderr, "%s: %s\n", __func__,
			(res == -1 ? strerror(errno) : "warning, zero length received"));
		return -1;
	}

	return 0;
}

int ipc_bind_listen_port(unsigned short port) {
	int fd;
	struct sockaddr_nl      local;

	fd = socket(AF_NETLINK, SOCK_DGRAM, NETLINK_USERSOCK);
	if (fd < 0) {
		perror(__FUNCTION__);
		return -1;
	}

	memset(&local, 0, sizeof(local));
	local.nl_family = AF_NETLINK;
	//	local.nl_groups = RTMGRP_LINK;

	if (bind(fd, (struct sockaddr*)&local, sizeof(local)) < 0) {
		perror(__FUNCTION__);
		return -1;
	}

	return fd;
}

int ipc_connect_buf_write(int fd, void *data, int data_len) {
	
	struct sockaddr_nl  danl;

	danl.nl_family = AF_NETLINK;
	danl.nl_pad = 0;
	danl.nl_pid = 0;		// target in kernel
	danl.nl_groups = 0;

	return sendto(fd, data, data_len, 0, (struct sockaddr *)&danl, sizeof(struct  sockaddr_nl));
}
