/* LICENSE_CODE JGPL */

#ifndef _MEMORY_H_
#define _MEMORY_H_

#define OS_INCLUDE_STD
#include <os_includes.h>

void *bufdup_e(void *buf, size_t size);
void *bufdup_l(void *buf, size_t size);
char *strdup_n(char *str);
char *strdup_e(char *str);
char *strdup_l(char *str);
void *zalloc_l(size_t size);
void *zalloc_e(size_t size);
void *malloc_l(size_t size);
void *malloc_e(size_t size);
void *realloc_l(void *ptr, size_t size);
void *realloc_e(void *ptr, size_t size);
void *memdup(void *src, int len);
int kmemcpy(char *buf, long pos, int n);

/* nfree indicates that the pointer can be NULL */
#define nfree(x) free(x)
#define zfree(x) _zfree((void **) &(x))

#endif

