/* LICENSE_CODE JUNGO */

#ifndef _STR_H_
#define _STR_H_

#define OS_INCLUDE_STDARG
#define OS_INCLUDE_STD
#include <os_includes.h>
#include <rg_def.h>

#define VAL2HEX(s) ((s) + ((s)>=10 ? 'a'-10 : '0'))

typedef struct {
    int alloc_size;
    char *str;
} str_t;

typedef struct split_t {
    struct split_t *next;
    str_t *str;
} split_t;

str_t *str_alloc(void);
void str_free(str_t *s);
void str_cpy(str_t *dest, char *src);
/* Return number of characters written, not including trailing NULL, or
 * -1 on error
 */
int str_vsprintf(str_t *s, char *fmt, va_list ap);
int str_sprintf(str_t *s, char *fmt, ...);

void str_cat(str_t *s, char *new_str);

split_t *split_alloc(void);
void split_free(split_t *split);

/* Split input by any of the characters in 'characters'. Return a list of
 * str_t.
 */
split_t *str_split(char *input, char *characters);
char *find_first_of(char *s, char *chars);
char *strncpyz(char *dest, char const *src, size_t size);
char *strncatz_total(char *dest, char const *src, size_t size);
char *strcpy_line(char *dst, const char *src);
size_t strlen_line(const char *str);
char *strtolower(char *str);
int nstrcmp(char *str1, char *str2);

#define TRIM_SPACES_LEADING	0x01
#define TRIM_SPACES_TRAILING	0x02
#define TRIM_SPACES_ALL		TRIM_SPACES_LEADING | TRIM_SPACES_TRAILING

char *trim_spaces(char *str, u8 how);
char *remove_end_line(char *str);

#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof((arr)[0]))

void extract_pty_ip(char *ptycmd, char *buf, int bufsize);
#endif

