/* LICENSE_CODE JUNGO */

#ifndef _WPA_TYPES_H_
#define _WPA_TYPES_H_

#include <net_utils.h>
#include "wpa.h"

/*#define WPA_DEBUG_ON*/

#ifdef WPA_DEBUG_ON
#define WPA_DEBUG(args...) /*rg_error(LERR, args)*/
#else
#define WPA_DEBUG(args...) /*rg_error(LDEBUG, args)*/
#endif

/* Authenticated key management suites */ 
typedef enum {
    WPA_AUTH_8021X = 0x1, /* 802.1X key management and authentication */ 
    WPA_AUTH_PSK   = 0x2, /* 802.1X key management using PSK */ 
} wpa_auth_suite_t;
    
/* Pairwise Master Key (256 bits) */ 
typedef struct {
    u8 data[32];
} wpa_pmk_t; 

/* Group Master Key (256 bits) */
typedef struct {
    u8 data[32];
} wpa_gmk_t;

/* MIC Key 128 bits */ 
typedef struct {
    u8 data[16];
} wpa_eapol_mic_t;

/* MIC Key 64 bits */ 
typedef struct {
    u8 data[8];
} wpa_michael_mic_t;

/* Pairwise Transient Key (512 bits) */ 
typedef struct { 
    wpa_eapol_mic_t eapol_key_mic_key; 
    u8 eapol_key_encryption_key[16]; 
    wpa_temporal_key_t temporal_key;
} wpa_ptk_t; 

/* Group Transient Key (256 bits) */ 
typedef wpa_temporal_key_t wpa_gtk_t; 

/* Nonce (256 bits) */ 
typedef struct {
    u8 data[32];
} wpa_nonce_t;

#endif

