/* LICENSE_CODE JUNGO */

#ifndef _WPA_INFO_ELEM_H_
#define _WPA_INFO_ELEM_H_

#include <wpa.h>
#include "wpa_common.h"

typedef struct wpa_info_elem_t wpa_info_elem_t;

/* Allocates and initializes a wpa_info_elem_t object */
wpa_info_elem_t *wpa_info_elem_open(wpa_cipher_t multicast_cipher, 
    wpa_cipher_t unicast_ciphers, wpa_auth_suite_t auth_suites);

/* Get the length of the entire info element buffer */
int wpa_info_elem_get_len(wpa_info_elem_t *t);

/* Parses the information element */
int wpa_info_elem_parse(wpa_info_elem_t *t, wpa_cipher_t *multicast_cipher, 
    wpa_cipher_t *unicast_ciphers, wpa_auth_suite_t *auth_suites, int len);

/* Frees a wpa_info_elem_t object */
void wpa_info_elem_close(wpa_info_elem_t *t);

#endif
