/* LICENSE_CODE JUNGO */

#include <stdio.h>
#include "wpa_log.h"

#define BUF_SIZE 1024

char *wpa_log_format_buf(u8 *buf, int len)
{
    static char out[BUF_SIZE];
    char *pos = out;
    int i;

    for (i = 0; i < len; i++)
    {
	sprintf(pos, "%02X ", buf[i]);
	pos += 3;

	/* Insert a new line every 8 bytes except in case we just printed the 
	 * last byte
	 */
	if (!((i + 1) % 8) && i < (len - 2))
	{
	    sprintf(pos, "\n");
	    pos++;
	}
    }
    
    return out;
}

char *wpa_log_sta_type_to_str(wpa_sta_type_t sta_type)
{
    char *str;
    
    switch (sta_type)
    {
    case WPA_STA_TYPE_WPA:
	str = "WPA";
	break;
    case WPA_STA_TYPE_WEP_LEGACY:
	str = "WEP-legacy";
	break;
    case WPA_STA_TYPE_WEP_8021X:
	str = "WEP-802.1X";
	break;
    default:
	str = "<unknown>";
	break;
    }

    return str;
}

char *wpa_log_cipher_to_str(wpa_sta_type_t sta_type)
{
    char *str;
    
    switch (sta_type)
    {
    case WPA_CIPHER_TKIP:
	str = "TKIP";
	break;
    case WPA_CIPHER_WEP_40:
	str = "WEP-40";
	break;
    case WPA_CIPHER_WEP_104:
	str = "WEP-104";
	break;
    case WPA_CIPHER_WEP_232:
	str = "WEP-232";
	break;
    case WPA_CIPHER_WRAP:
	str = "WRAP";
	break;
    case WPA_CIPHER_CCMP:
	str = "CCMP";
	break;
    default:
	str= "<unknown>";
	break;
    }

    return str;
}
