/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:	mgmtSm.h												   */
/*    PURPOSE:	Authorization/association state machine implementation	   */
/*																	 	   */
/***************************************************************************/

#ifndef _WPA_H
#define _WPA_H

#include "pform_types_user.h"
#include <wpa.h>
/*#include "memMngr.h"*/
#include <radius/radiusct.h>
#include <802.1x/eap_radius.h>
#include "public_security_keys.h"


#if 0 
STATUS wdrv_wpaInit(void);
STATUS wdrv_wpaNotifyStationConnect(UINT16 idx);
STATUS wdrv_wpaNotifyStationDisConnect(UINT16 idx);
STATUS wdrv_wpaNotifyEapolReceived(mem_MSDU_T*  msduPtr, BOOL encrypted);
STATUS wdrv_wpaFirstDataFromStation(UINT16 idx, BOOL isEapol);
STATUS wdrv_wpaRxMicFailure(UINT16 idx);
#endif



STATUS wdrv_wpaInitDb(wpa_port_params_t *pWpaDbParams, radius_params_t	*pRadiusParams);
STATUS wdrv_wpaReConf(wpa_port_params_t *pWpaDbParams);


/* ap_dev prototypes */
STATUS wdrv_wpaApDevInitCallbacks(ap_dev_ops_t *deviceCBs);
STATUS wdrv_wpaApPortInitCallbacks(auth1x_pc_ops_t *portCBs);
STATUS wdrv_wpaCanStationAssc(u8 *info_elem, int info_elem_len);


void   wdrv_wpaSetStationSecAttack(UINT16 index, BOOL value);	
int    wdrv_wpaGetListenSock(void); 

#endif /* _WPA_H */
