/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>

#include "wpaLinux.h"
/*#define WPA_CFG_TEST_ONLY*/


int wpa_send_cfg(tiap_wpa_auth_t *init_struct)
{
    int sock;
    struct sockaddr_un name;


    /* Create socket on which to send. */
    sock = socket(AF_UNIX, SOCK_DGRAM, 0);
    if (sock < 0)
	{
        printf("wpa_send_cfg:error opening datagram socket\n");
		return -1;
	}
    /* Construct name of socket to send to. */
    name.sun_family = AF_UNIX;
    strcpy(name.sun_path, TIAP_WPA_SOCKADDR_WPAAUTH);
    /* Send message. */
/*	*init_struct = 56;*/
   
	if (sendto(sock,init_struct , sizeof(tiap_wpa_auth_t), 0,
        &name, sizeof(struct sockaddr_un)) < 0)
	{
        printf("wpa_send_cfg:error sending datagram message\n");
		return -1;	
	}
    close(sock);
	return 0;	
}



#ifdef WPA_CFG_TEST_ONLY

int main(void) {
	tiap_wpa_auth_t tmp = 5;
	wpa_send_cfg(&tmp);
	
	return 0;
}


#endif