/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																	       */
/*	   MODULE:	WoneBalance.c							            	   */
/*    PURPOSE:	Wone feature dynamic balancing mechanism implementation    */
/*																		   */
/***************************************************************************/

#ifndef WONE_BALANCE_H
#define WONE_BALANCE_H

#include "pform_types.h"

#ifndef WONE_BALANCE_C
	#define PUBLIC
#else
	#define PUBLIC extern
#endif


PUBLIC	void	wdrv_WoneBalanceInit	( void );
PUBLIC  void    wdrv_WoneBalanceUnload  ( void );
PUBLIC	void	wdrv_WoneBalanceShutdown( void );

PUBLIC	void	wdrv_WoneBalanceSuspend	( void );
PUBLIC	void	wdrv_WoneBalanceResume	( void );
PUBLIC	void	wdrv_WoneBalanceReset	( void );

PUBLIC  void    wdrv_PeriodicWoneSliceUpdate ( void );
void wdrv_WoneStartBalanceTimer(void);

#endif
