/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																									*/
/*		MODULE:	bssbridgeInit.h															*/
/*   PURPOSE:	Bss bridge init functions	 											*/
/*																									*/
/***************************************************************************/
#ifndef _BSS_BRIDGE_INIT_H_
#define _BSS_BRIDGE_INIT_H_

#include "pform_types.h"
#include "memMngr.h"
#include "mainsm.h"
#include "802_11Defs.h"

#define LLC_CONTROL_UNNUMBERED_INFORMATION 0x03

#define SNAP_OUI_RFC1042_BYTE0 0x00
#define SNAP_OUI_RFC1042_BYTE1 0x00
#define SNAP_OUI_RFC1042_BYTE2 0x00

#define EAPOL_ETHER_TYPE		0x888E


#pragma pack(1)
typedef struct
{
  macAddress_T	DstAddr;
  macAddress_T	SrcAddr;
  UINT16		TypeLength;
} EthernetHeader_T;
#pragma pack()

#define CopyMacAddress(src,dest)  PAL_memCopy( src,dest,6)


STATUS wdrv_bssbridgeInit(void);
void   wdrv_bssBridgeFromWlanFrame(mem_MSDU_T *pMsdu,UINT32 pktEmulate, BOOL micOK, UINT16 srcStaIndex);
void   wdrv_bssBridgeSendPktToEthernet(mem_MSDU_T *pMsdu);
STATUS wdrv_bssBridgePktFromEthrToWlan(mem_MSDU_T *pMsdu);
void   wdrv_bssBridgeGetLanSendUnicast(UINT32 *LanSendUnicast);
void   wdrv_bssBridgeGetLanSendMulticast(UINT32 *LanSendMulticast);
void   wdrv_bssBridgeGetLanRecvUnicast(UINT32 *LanRecvUnicast);
void   wdrv_bssBridgeGetLanRecvMulticast(UINT32 *LanRecvMulticast);
int    wdrv_bssBridgeShowStatistics( char *buf );

UINT32 wdrv_bssbridgeGetExcludedCount(void);
UINT32 wdrv_bssbridgeGetTKIPMicFailure(void);
void   wdrv_bssbridgeSetExcludeUnencrypted(BOOL value);

#endif
