/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************/
/*																			*/
/*	 MODULE:	drvDbInit.c													*/
/*   PURPOSE:	Driver database init functions	 							*/
/*																			*/
/***************************************************************************/
#include "pform_types.h"
#include "drvDbInit.h"
#include "drvDbHash.h"
#include "drvDbMain.h"
#include "memMngr.h"
#include "mainsm.h"
#include "drvDbRegDomain.h"

/*************************************************************************
 *                        wdrv_dbInit                                    *
 *************************************************************************
DESCRIPTION: Driver database init function                 
                                                                                                   
INPUT:       

OUTPUT:      

RETURN:      OK : Initialization succesfull.
             NOK: Initialization unsuccesfull.                                                                                                                                             
************************************************************************/
STATUS wdrv_dbInit(initConfigStruct *pInitConfigStruct) 
{
	int rc;

	rc = wdrv_dbMainInit(pInitConfigStruct);
	if (rc != OK)
		return NOK;

	rc = wdrv_dbHashInit();
	if (rc != OK)
		return NOK;

	wdrv_mainsmSendModuleUp(WDRV_DB_MODULE_ID);

	return OK;
}

/*************************************************************************
 *                        wdrv_dbUnload                                    *
 *************************************************************************
DESCRIPTION: Driver database unload function                 
                                                                                                   
INPUT:       

OUTPUT:      

RETURN:                                                                                                                                    
************************************************************************/
void wdrv_dbUnload(void)
{
	wdrv_dbRegDomainUnload();

	printf("DB unloaded !!!\n");
}

