/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2003 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:		drvDbMain.h											   */
/*		PURPOSE:	AP Main database									   */
/*																	 	   */
/***************************************************************************/

#ifndef _DB_MAIN_H
#define _DB_MAIN_H

#include "drvDbDefs.h"
#include "whal.h"

/* init func */
INIT_RET_CODE	wdrv_dbMainInit(initConfigStruct *pInitConfigStruct);

/* Function to set/get global data */
void    wdrv_dbGetElementFromMultipleSsidActualTable(char *value, UINT16 index);
void    wdrv_dbSetAccessList(char * list);
void	wdrv_dbGetAccessList(char *pList); 
void    wdrv_dbGetAccessListEnable(UINT8 *value); 
void    wdrv_dbSetAccessListEnable(UINT8 value); 
void    wdrv_dbGetAccessListType(UINT8 *value); 
void    wdrv_dbSetAccessListType(UINT8 value); 
void	wdrv_dbGetBssid(char *macAddressPtr);
void	wdrv_dbSetSsid(char *value, UINT8 len);
void	wdrv_dbGetSsid(char *value);
void	wdrv_dbGetApCapabilities(UINT8 woneIndex, UINT16 *cap);
void	wdrv_dbSetApCapabilities(UINT8 woneIndex, UINT16 cap);
void	wdrv_dbGetDefaultActiveRate(UINT8 woneIndex ,UINT8 *defaultRate);
void	wdrv_dbGetDefaultActiveRateAcx(UINT8 woneIndex ,UINT16 *defaultRate, UINT16 *defaultRateWithFallback, UINT8);
void	wdrv_dbGetMaxActiveRate(UINT8 *activeRate);
void 	wdrv_dbGetMaxCCKactiveRate(UINT8 woneIndex ,UINT8 *maxActiveCCKRate);
void    wdrv_dbGetMaxOFDMbasicRate(UINT8 woneIndex ,UINT8 *maxBasicOFDMRate);
void    wdrv_dbGetMinOFDMbasicRate(UINT8 woneIndex ,UINT8 *minBasicOFDMRate);
void	wdrv_dbGetMaxCCKbasicRate(UINT8 woneIndex ,UINT8 *maxBasicCCKRate);
void	wdrv_dbGetMinCCKbasicRate(UINT8 woneIndex ,UINT8 *minBasicCCKRate);
void	wdrv_dbRestoreNvramDefaults(void);
void	wdrv_dbSetAgile(BOOL value);
void	wdrv_dbGetAgile(BOOL *value);
void	wdrv_dbSetPreambleMode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetPreambleMode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetRadioCalibrateOption(UINT32 value);
void	wdrv_dbGetRadioCalibrateOption(UINT32 *value);
void	wdrv_dbSetRadioCalibrateInterval(UINT16 value);
void	wdrv_dbGetRadioCalibrateInterval(UINT16 *value);
void	wdrv_dbGetDomain(UINT8 *value);
void    wdrv_dbGetPowerLevel(UINT8 channel, UINT8 *value);
void 	wdrv_dbSetBssIsolationState(UINT8 value);
void	wdrv_dbGetBssIsolationState(BOOL *value);
void	wdrv_dbSetPBCCAlgorithmMode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetPBCCAlgorithmMode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbGetRateFallback(UINT8 *value);
void	wdrv_dbSetRateFallback(UINT8 value);
void	wdrv_dbGetRateAdaptation(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetRateAdaptation(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbSetSlotTimeMode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetSlotTimeMode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbGetSlotTimeThreshold(UINT16 *value);
void    wdrv_dbSetERPprotectionMode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetERPProtectionMode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetERPProtectionType(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetERPProtectionType(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetERPProtectionTI(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetERPProtectionTI(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetFeatureSet(UINT8 value);
void    wdrv_dbGetFeatureSet(UINT8 *value);
void	wdrv_dbSetDot11Mode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetDot11Mode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetLastStoredDot11Mode(UINT8 woneIndex ,UINT8 value);
void	wdrv_dbGetLastStoredDot11Mode(UINT8 woneIndex ,UINT8 *value);
void	wdrv_dbSetPrivacyBitFlag(BOOL value);	
void	wdrv_dbGetPrivacyBitFlag(BOOL *value);	
void	wdrv_dbGet4xEnable(BOOL *value);
void	wdrv_dbSet4xEnable(BOOL value);
void	wdrv_dbGetTIInfoElement(char *value, UINT8 *len);
void	wdrv_dbGetConcatEnable(BOOL *value);
void	wdrv_dbSetConcatEnable(BOOL value);
void	wdrv_dbGetAckEmulEnable(BOOL *value);
void	wdrv_dbSetAckEmulEnable(BOOL value);
void	wdrv_dbGetCwMinEnable(BOOL *value);
void	wdrv_dbSetCwMinEnable(BOOL value);
void	wdrv_dbGet4xMixMode(BOOL *value);
void	wdrv_dbSet4xMinMode(BOOL value);
void 	wdrv_dbGetEnRestart(UINT8 *value);
void 	wdrv_dbSetEnRestart(UINT8 value, BOOL updateNvram);
void 	wdrv_dbGetEnergyDetect(UINT8 *value);
void 	wdrv_dbSetEnergyDetect(UINT8 value);
void	wdrv_dbGetRespRateMode(UINT8 *value);
void	wdrv_dbSetRespRateMode(UINT8 value);
void 	wdrv_dbSetCwMinWinSize(UINT16 value);
void 	wdrv_dbGetCwMinWinSize(UINT16 *value);
void wdrv_dbSetPBCCdynamicStatus(BOOL status);
void wdrv_dbGetPBCCdynamicStatus(BOOL *status);
void wdrv_dbSetERPdynamicStatus(BOOL status);
void wdrv_dbGetERPdynamicStatus(BOOL *status);
void wdrv_dbSetNotPBCCTimestamp(UINT32 timestamp);
void wdrv_dbGetNotPBCCTimestamp(UINT32 *timestamp);
void wdrv_dbSetRxTxBrate(UINT32 timestamp, UINT32 count);
void wdrv_dbGetRxTxBrate(UINT32 *timestamp, UINT32 *count);
void wdrv_dbSetNotErpTimestamp(UINT32 timestamp);
void wdrv_dbGetNotErpTimestamp(UINT32 *timestamp);
void wdrv_dbGetRadioFrequency(UINT8 *value);
void wdrv_dbSetRadioFrequency(UINT8 value);
void wdrv_dbGetWlanServiceState(BOOL *state);
void wdrv_dbSetWlanServiceState(BOOL state);
void wdrv_dbUpdateUsageTime(UINT8 woneIndex ,UINT8 value);
void wdrv_dbGetWAoptions(UINT8 *rxFreeMem,UINT8 *bcnNotSent,UINT8 *txStuck, UINT16 *consFcsErr, UINT8 *aci, UINT8 *nb);
void wdrv_dbSetAciStateTimeout(UINT32 timeout);
void wdrv_dbGetAciStateTimeout( UINT32 *timeout);
void wdrv_dbSetNbStateTimeout(UINT32 timeout);
void wdrv_dbGetNbStateTimeout( UINT32 *timeout);
void wdrv_dbSetAciRateThreshold(UINT32 thresh);
void wdrv_dbGetAciRateThreshold( UINT32 *thresh);
void wdrv_dbSetAciEventsThreshold(UINT32 thresh);
void wdrv_dbGetAciEventsThreshold( UINT32 *thresh);
void wdrv_dbSetPacketDetectHighThresh(UINT16 pdHighThresh);
void wdrv_dbGetPacketDetectHighThresh(UINT16 *pdHighThresh);
void wdrv_dbSetPacketDetectLowThresh(UINT16 pdLowThresh);
void wdrv_dbGetPacketDetectLowThresh(UINT16 *pdLowThresh);
void wdrv_dbSetMediumBusyThresh(UINT32 mediumBusyThresh);
void wdrv_dbGetMediumBusyThresh(UINT32 *thresh);
void wdrv_dbSetBurstLimit(UINT16 val);
void wdrv_dbGetBurstLimit(UINT16 *val);
/* Radio Parameters */
void wdrv_dbGetRadioParams( RadioParam_t *ptr);
void wdrv_dbSetRadioParams( RadioParam_t *ptr, UINT32 parameterType, BOOL updateNvram);

/* Interface functions called by the mgmt module in order to perform the system check stage */
BOOL wdrv_dbRatesSupport(UINT8 woneIndex, dot11_supRates_T *ratesP, dot11_extSupRates_T *extRatesP);
BOOL wdrv_dbSSIDSupport(dot11_SSID_T *ssid);
BOOL wdrv_dbAuthAlgoSupported(UINT16	algoNumber);
BOOL wdrv_dbApSupport(char *mac);
BOOL wdrv_dbCapabilitiesSupport(UINT8 woneIndex ,UINT16	*caps);
void wdrv_dbPrivacySupport(UINT8 woneIndex ,BOOL *value);
BOOL wdrv_dbIsVhcfEnabled(void);
BOOL wdrv_dbGetEdcfParams(UINT8 woneIndex, UINT8 localQueueId, edcf_info_t * edcfInfoPtr);
void wdrv_dbGetVhcfParams(tVHCF_PARAMS * vhcfParamsPtr);
void wdrv_dbGetHiddenSsidStatus(UINT16 *value);
void wdrv_dbGetMultipleSsidStatus(UINT16 *value);
BOOL wdrv_dbGetQueueThresh(UINT8 woneIndex, UINT8 localQueueId, UINT32 * thresholdPtr);
void wdrv_dbGetElementFromMultipleSsidActualTable(char *value, UINT16 index);
void wdrv_dbGetRadarDetectMode(UINT8 *val);

/* RSN Section */
void	wdrv_dbGetRsne(dot11_rsne_T *rsne);	
void	wdrv_dbSetRsne(UINT8 len, UINT8 *pInfo);	

/* MIB Get & Set functions */
/* TODO: add MIB notification objects */

/* The following functions implement the MIB. Each group is correspond to a mib table */	
/***************************
	Station Config table
****************************/
void wdrv_dbGetStationConfigAuthRspTimeout(UINT32 *value);	
void wdrv_dbGetStationConfigPrivacyOptionImplemented(BOOL *value);	
void wdrv_dbGetStationConfigOperationalRateSet(UINT8 woneIndex, char *value, UINT8 *len);
void wdrv_dbGetStationConfigOperationalAllRateSet(UINT8 woneIndex, char *value, UINT8 *len);
void wdrv_dbGetStationConfigBeaconPeriod(UINT16 *value);
void wdrv_dbGetStationConfigDtimPeriod(UINT8 *value);
void wdrv_dbGetStationConfigDisassociateReason(UINT16 *value);
void wdrv_dbGetStationConfigDisassociateStation(char *value);
void wdrv_dbGetStationConfigDeauthenticateReason(UINT16 *value);
void wdrv_dbGetStationConfigDeauthenticateStation(char *value);
void wdrv_dbGetStationConfigDeauthenticateFailStatus(UINT16 *value);
void wdrv_dbGetStationConfigDeauthenticateFailStation(char *value);
void wdrv_dbSetStationConfigOperationalOFDMRateSet(UINT8 woneIndex, char *value, UINT8 len);
void wdrv_dbGetStationConfigOperationalOFDMRateSet(UINT8 woneIndex, char *value, UINT8 *len);


void wdrv_dbSetStationConfigAuthRspTimeout(UINT32 value);	
void wdrv_dbSetStationConfigPrivacyOptionImplemented(BOOL value);	

void wdrv_dbSetStationConfigOperationalRateSet(UINT8 woneIndex, char *value, UINT8 len);
void wdrv_dbSetStationConfigOperationalAdditionalRateSet(UINT8 woneIndex, char *value, UINT8 len);
void wdrv_dbSetStationConfigOperationalOFDMRateSet(UINT8 woneIndex, char *value, UINT8 len);

void wdrv_dbSetStationConfigBeaconPeriod(UINT16 value);
void wdrv_dbSetStationConfigDtimPeriod(UINT8 value);
void wdrv_dbSetStationConfigDisassociateReason(UINT16 value);
void wdrv_dbSetStationConfigDisassociateStation(char *value);
void wdrv_dbSetStationConfigDeauthenticateReason(UINT16 value);
void wdrv_dbSetStationConfigDeauthenticateStation(char *value);
void wdrv_dbSetStationConfigDeauthenticateFailStatus(UINT16 value);
void wdrv_dbSetStationConfigDeauthenticateFailStation(char *value);

/*************************************
	Authentication Algorithms table
**************************************/
void wdrv_dbGetAuthAlgo(UINT32 index, UINT16 *value);	
void wdrv_dbGetAuthAlgoEnable(UINT32 index, BOOL *value);	

void wdrv_dbSetAuthAlgo(UINT32 index, UINT16 value);	
void wdrv_dbSetAuthAlgoEnable(UINT32 index, BOOL value);	

/*************************************
	WEP Default Keys table
**************************************/
void wdrv_dbGetWEPDefaultKey(UINT16 index, UINT8 *len, UINT8 *value);

void wdrv_dbSetWEPDefaultKey(UINT16 index, UINT8 len, UINT8 *value);

/*************************************
	WEP Key Mapping table
**************************************/
void wdrv_dbGetWEPKeyMappingAddress(UINT16 index, UINT8 *value);	
void wdrv_dbGetWEPKeyMappingWEPOn(UINT16 index, BOOL *value);	
void wdrv_dbGetWEPKeyMappingValue(UINT16 index, UINT8 *len, UINT8 *value);	

void wdrv_dbSetWEPKeyMappingAddress(UINT16 index, UINT8 *value);	
void wdrv_dbSetWEPKeyMappingWEPOn(UINT16 index, BOOL value);	
void wdrv_dbSetWEPKeyMappingValue(UINT16 index, UINT8 len, UINT8 *value);	

/*************************************
	Privacy table
**************************************/
void wdrv_dbGetPrivacyInvoked(BOOL *value);
void wdrv_dbGetWepDefaultKeyId(UINT8 *index);	
void wdrv_dbGetPrivacyWEPDefaultKeyId(UINT8 *value);	
void wdrv_dbGetPrivacyWEPKeyMappingLength(UINT32 *value);	
void wdrv_dbGetPrivacyExcludeUnencrypted(BOOL *value);	
void wdrv_dbGetPrivacyWEPICVErrorCount(UINT32 *value);	
void wdrv_dbGetPrivacyWEPExcludedCount(UINT32 *value);	
void wdrv_dbGetPrivacyTKIPMicFailure(UINT32 *value);	
void wdrv_dbGetDynamicAlgorithmsTimeout(UINT32 *value);
void wdrv_dbGetCwMinMode(UINT8 woneIndex, UINT8 *value);

void wdrv_dbSetPrivacyInvoked(BOOL value);	
void wdrv_dbSetPrivacyWEPDefaultKeyId(UINT8 value);	
void wdrv_dbSetPrivacyWEPKeyMappingLength(UINT32 value);	
void wdrv_dbSetPrivacyExcludeUnencrypted(BOOL value);	

/*************************************
	MultiDomainCapability table
**************************************/
void wdrv_dbGetChannel(UINT8 woneIndex ,UINT8 *value);	

void wdrv_dbSetChannel(UINT8 woneIndex ,UINT8 value);	


void wdrv_dbGetBand(UINT8 woneIndex ,UINT8 *value);	

void wdrv_dbSetBand(UINT8 woneIndex ,UINT8 value);	

void wdrv_dbGetPrimaryAcxQindex(UINT8 woneIndex ,UINT8 *value);
void wdrv_dbSetPrimaryAcxQindex(UINT8 woneIndex ,UINT8 value);

void wdrv_dbGetPsBroadcastQindex(UINT8 woneIndex ,UINT8 *value);
void wdrv_dbSetPsBroadcastQindex(UINT8 woneIndex ,UINT8 value);

void wdrv_dbGetUsageTime(UINT8 woneIndex ,UINT8 *value);
void wdrv_dbSetUsageTime(UINT8 woneIndex ,UINT8 value);


/*************************************
	Operation table
**************************************/
void wdrv_dbGetOperationMacAddress(char *value);	
void wdrv_dbGetOperationRTSThreshold(UINT16 *value);	
void wdrv_dbGetOperationShortRetryLimit(UINT8 *value);	
void wdrv_dbGetOperationLongRetryLimit(UINT8 *value);	
void wdrv_dbGetOperationFragmentationThreshold(UINT16 *value);	
void wdrv_dbGetOperationMaxTransmitMSDULifetime(UINT32 *value);	
void wdrv_dbGetOperationMaxReceiveLifetime(UINT32 *value);	

void wdrv_dbSetOperationMacAddress(char *value);	
void wdrv_dbSetOperationRTSThreshold(UINT16 value);	
void wdrv_dbSetOperationShortRetryLimit(UINT8 value);	
void wdrv_dbSetOperationLongRetryLimit(UINT8 value);	
void wdrv_dbSetOperationFragmentationThreshold(UINT16 value);	
void wdrv_dbSetOperationMaxTransmitMSDULifetime(UINT32 value);	
void wdrv_dbSetOperationMaxReceiveLifetime(UINT32 value);	

/*************************************
	Counters table
**************************************/
void wdrv_dbGetCountersTransmittedFragmentCount(UINT32 *value);	
void wdrv_dbGetCountersMulticastTransmittedFrameCount(UINT32 *value);	
void wdrv_dbGetCountersFailedCount(UINT32 *value);	
void wdrv_dbGetCountersRetryCount(UINT32 *value);	
void wdrv_dbGetCountersMultipleRetryCount(UINT32 *value);	
void wdrv_dbGetCountersFrameDuplicateCount(UINT32 *value);	
void wdrv_dbGetCountersRTSSuccessCount(UINT32 *value);	
void wdrv_dbGetCountersRTSFailureCount(UINT32 *value);	
void wdrv_dbGetCountersACKFailureCount(UINT32 *value);	
void wdrv_dbGetCountersReceivedFragmentCount(UINT32 *value);	
void wdrv_dbGetCountersMulticastReceivedFrameCount(UINT32 *value);	
void wdrv_dbGetCountersFCSErrorCount(UINT32 *value);	
void wdrv_dbGetCountersTransmittedFrameCount(UINT32 *value);	
void wdrv_dbGetCountersWEPUndecryptableCount(UINT32 *value);	



BOOL	wdrv_dbIsNvramIdenticalToDatabase(void);



/***************************
	Wone
*************************** */
void wdrv_dbSetNumSupWone(UINT8 value, BOOL rebootNow);
void wdrv_dbGetNumSupWone(UINT8 *value);
                         
void wdrv_dbGetNumSupWoneQueues(UINT8 woneIndex, UINT8 *value);
void wdrv_dbSetNumSupWoneQueues(UINT8 woneIndex, UINT8 value);

void wdrv_dbGetAcxQindex(UINT8 woneIndex,
                                 UINT8 localQueueId,
                                 UINT8 *type,
                                 UINT8 *priority) ;

void wdrv_dbSetAcxQindex(UINT8 woneIndex,
                                 UINT8 localQueueIndex,
                                 UINT8 type,
                                 UINT8 priority);

        
void wdrv_dbGetAcxGlobalQindex(UINT8 woneIndex,int localQueueType ,int *globalQid);


/*====================================
			WPA   Section
====================================*/

void wdrv_dbSetBroadcastSuiteType(UINT8 cipher);	
void wdrv_dbGetBroadcastSuiteType(UINT8 *cipher);	
void wdrv_dbGetBroadcastTkipKey(UINT8 *keyValue,UINT8 *index);
void wdrv_dbSetBroadcastTkipKey(UINT8 *keyValue,UINT8 index);
void wdrv_dbSetBroadcastMicKey(UINT8 *keyValue);	
void wdrv_dbGetBroadcastMicKey(UINT8 *keyValue);	
void wdrv_dbSetDefaultWepKey(UINT8 index,UINT16 keySize,UINT8 *keyValue);
void wdrv_dbGetDefaultWepKey(UINT8 index,UINT16 *keySize,UINT8 *keyValue);
void wdrv_dbSetWepDefaultKeyId(UINT8 index);
void wdrv_dbGetWEP_DefaultKeyId(UINT8 *index);

void wdrv_dbSetWpaMode(UINT32 mode);	
void wdrv_dbGetWpaMode(UINT32 *mode);	

void wdrv_dbSetUsageTimeMode(UINT8 value, BOOL rebootNow);
void wdrv_dbGetUsageTimeMode(UINT8 *value);
void wdrv_dbGetStationConfigeauthenticateFailStation(char *value);

void wdrv_dbGetRadarDetectMode(UINT8 *val);
UINT8 wdrv_dbGetApBridgeMode(void);

#endif
