/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*                                                                         */
/*		MODULE:		drvDbRegDomain.h                                       */
/*		PURPOSE:	AP database for 802.11 d & h                           */
/*                                                                         */
/***************************************************************************/

#ifndef _DB_REG_DOMAIN__H_
#define _DB_REG_DOMAIN__H_

#include "drvDbDefs.h"

/* init 802.11 d & h DB */
INIT_RET_CODE  wdrv_dbRegDomainInit(RegDomainInitStrcut *pInitStruct,UINT8 band);

void		   wdrv_dbRegDomainUnload(void);
void		   wdrv_dbGetNumOfPrivateRanges(wlan_bandType bandType, UINT8 *pNumOfRanges);
STATUS         wdrv_dbRegDomainGetDefaultChannel(UINT8 regDomain ,UINT8 *pChannel );

void		   wdrv_dbGetdot11CountryString(char* pCountryString);
void		   wdrv_dbGetLegacyStatusEnableStatus(UINT8 *value);
void		   wdrv_dbGetdot11SpectrumManagementRequiredStatus(UINT8 *value);
int			   wdrv_dbGetdot11CurrentRegDomain(UINT8 band, UINT8 *pRegDomain);
BOOL		   IsChannelAllowed(UINT8 woneIndex, UINT8 channel);
void		   wdrv_dbGetMaxTxPowerLevel(INT8 *pMaxTxPowerLevel);
void		   wdrv_dbGetdot11MultiDomainCapabilityStatus(UINT8 *value);
void		   wdrv_dbGetdot11SpectrumManagementRequiredStatus(UINT8 *value);
void		   wdrv_dbGetMaxTxPowerLevel(INT8 *pMaxTxPowerLevel);
void		   wdrv_dbGetTxPowerLevels(UINT32 band, UINT32 level, INT8 *pPowerLevel);
void		   wdrv_dbGetPrivateRegulatoryDomain(UINT8 *pRegDomain);
STATUS wdrv_dbGetPrivateRangeElement(wlan_bandType bandType,
                                     UINT8 RangeIndex,
                                     tChannelRangeElementStruct *pRangeElementStruct);
STATUS wdrv_dbGetRegDomainInformation(wlan_bandType bandType,
                                      UINT8 *currentRegDomain, 
                                      UINT8 *numOfRanges,
                                      UINT8 *isPrivateDomain);
STATUS wdrv_dbGetRangeElement(wlan_bandType bandType, 
                              IntegerRegulatoryDomains_e RegDomain, 
                              UINT8         RangeIndex,
                              tChannelRangeElementStruct *pRangeElementStruct);
void wdrv_dbGetdot11LocalPowerConstraint(INT8 *value);
void wdrv_dbGetNumOfPrivateRanges(wlan_bandType bandType, UINT8 *pNumOfRanges);
void wdrv_dbGetdot11SpectrumManagementRequiredStatus(UINT8 *value);
void wdrv_dbGetLegacyStatusEnableStatus(UINT8 *value);
void wdrv_dbGetdot11CountryString(char* pCountryString);
STATUS wdrv_dbFillChannelsInformation(wlan_bandType bandType, UINT8 *pBuffer, UINT8 *length);
        
#endif // _DB_REG_DOMAIN__H_
