/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*                                                                         */
/*		MODULE:		drvDbRegDomainDefs.h                                   */
/*		PURPOSE:	AP database for 802.11 d & h                           */
/*                                                                         */
/***************************************************************************/

#ifndef _DB_REG_DOMAIN_DEFS_H_
#define _DB_REG_DOMAIN_DEFS_H_

#define NO_OFDM_OPT 		    0x10

#define REG_DOMAIN_US_START_CH_0			36
#define REG_DOMAIN_US_STOP_CH_0				48
#define REG_DOMAIN_US_STEP_OPT_0			4
#define REG_DOMAIN_US_POWER_LIMIT_CH_0			16
#define REG_DOMAIN_US_START_CH_1			52
#define REG_DOMAIN_US_STOP_CH_1				64
#define REG_DOMAIN_US_STEP_OPT_1			4
#define REG_DOMAIN_US_POWER_LIMIT_CH_1			23

#define REG_DOMAIN_WORLD_START_CH_0			36
#define REG_DOMAIN_WORLD_STOP_CH_0			64
#define REG_DOMAIN_WORLD_STEP_OPT_0			4
#define REG_DOMAIN_WORLD_POWER_LIMIT_CH_0			23
#define REG_DOMAIN_WORLD_START_CH_1			100
#define REG_DOMAIN_WORLD_STOP_CH_1			140
#define REG_DOMAIN_WORLD_STEP_OPT_1			4
#define REG_DOMAIN_WORLD_POWER_LIMIT_CH_1			30
#define REG_DOMAIN_WORLD_START_CH_2			149
#define REG_DOMAIN_WORLD_STOP_CH_2			161
#define REG_DOMAIN_WORLD_STEP_OPT_2			4
#define REG_DOMAIN_WORLD_POWER_LIMIT_CH_2			29

#define REG_DOMAIN_FCC_START_CH_0			1
#define REG_DOMAIN_FCC_STOP_CH_0			11
#define REG_DOMAIN_FCC_STEP_OPT_0			1
#define REG_DOMAIN_FCC_POWER_LIMIT_CH_0			30

#define REG_DOMAIN_IC_START_CH_0			1
#define REG_DOMAIN_IC_STOP_CH_0				11
#define REG_DOMAIN_IC_STEP_OPT_0			1
#define REG_DOMAIN_IC_POWER_LIMIT_CH_0			20

#define REG_DOMAIN_ETSI_START_CH_0			1
#define REG_DOMAIN_ETSI_STOP_CH_0			13
#define REG_DOMAIN_ETSI_STEP_OPT_0			1
#define REG_DOMAIN_ETSI_POWER_LIMIT_CH_0			20

#define REG_DOMAIN_SPAIN_START_CH_0			10
#define REG_DOMAIN_SPAIN_STOP_CH_0			11
#define REG_DOMAIN_SPAIN_STEP_OPT_0			1
#define REG_DOMAIN_SPAIN_POWER_LIMIT_CH_0			20

#define REG_DOMAIN_FRANCE_START_CH_0			10
#define REG_DOMAIN_FRANCE_STOP_CH_0			13
#define REG_DOMAIN_FRANCE_STEP_OPT_0			1
#define REG_DOMAIN_FRANCE_POWER_LIMIT_CH_0			20

#define REG_DOMAIN_MKK_START_CH_0			14
#define REG_DOMAIN_MKK_STOP_CH_0			14
#define REG_DOMAIN_MKK_STEP_OPT_0			1
#define REG_DOMAIN_MKK_POWER_LIMIT_CH_0			22

#define REG_DOMAIN_MKK1_START_CH_0			1
#define REG_DOMAIN_MKK1_STOP_CH_0			13
#define REG_DOMAIN_MKK1_STEP_OPT_0			1
#define REG_DOMAIN_MKK1_POWER_LIMIT_CH_0			22

#define REG_DOMAIN_MKK1_START_CH_1			14
#define REG_DOMAIN_MKK1_STOP_CH_1			14
#define REG_DOMAIN_MKK1_STEP_OPT_1			1
#define REG_DOMAIN_MKK1_POWER_LIMIT_CH_1			22

#endif // _DB_REG_DOMAIN_DEFS_H_
