/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:	mgmtIf.h												   */
/*    PURPOSE:	Management module interface								   */
/*																	 	   */
/***************************************************************************/

#ifndef _MGMT_IF_H
#define _MGMT_IF_H

/*#include "wpaIfc.h"
*/
#include "mgmtSm.h"


BOOL 		wdrv_mgmtIsSrcAllowed(char *mac, UINT8 mpduType, UINT8 woneIndex, UINT16 *idx, BOOL *assocInd);
BOOL		wdrv_mgmtIsDstAllowed(char *mac, UINT16 *idx);
STATUS		wdrv_mgmtForwardMgmtFrame(mem_MSDU_T *msduP, UINT16 idx);
void 		wdrv_mgmtProbeRequestPacketMgmt(mem_BD_T *pMpdu, UINT32 mpduLen, UINT8 woneIndex);
STATUS 		wdrv_mgmtForwardBeacon(mem_BD_T* pMpdu, UINT32 mpduLen);
STATUS 		wdrv_mgmtSendTemplateUpdateRequest(UINT32 reqCont, UINT32 val);
void		wdrv_mgmtClass3Notify(char *mac, UINT16 idx, UINT8 woneIndex );
void		wdrv_mgmtDeAuthMng(char *mac, UINT16 reason);
void		wdrv_mgmtDisAssocMng(char *mac, UINT16 reason);
void		wdrv_mgmtMacAuthorize(char *mac);
void		wdrv_mgmtMacDeAuthorize(char *mac);
BOOL		wdrv_mgmtIsStationAuthorized(UINT16 index);
BOOL		wdrv_mgmtIsBroadcastAuthorized(void);
void		setBcastState(BOOL authorized);

/* This function is for debug purposes only!!!!! */
void		wdrv_mgmtSetStationStateDebug(UINT16 index, states state);

#endif
