/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:		mgmtParser.h										   */
/*		PURPOSE:	Management parser object							   */
/*																	 	   */
/***************************************************************************/

#ifndef _MGMT_PARSER_H
#define _MGMT_PARSER_H

#include "memMngr.h"
#include "802_11Defs.h"

STATUS	wdrv_mgmtMmpduParse(mem_MSDU_T *msduPtr, UINT16 index, UINT32 *protoEvent, void *protoPtr);
int 	wdrv_mgmtPrintCounters(char *buf);
void	wdrv_mgmtPrintFrame(mem_MSDU_T *msduPtr);

/* ERP */
STATUS BeaconParse(mem_MSDU_T *msduPtr,
				   UINT8 *nonERPpresentBit,
				   UINT8 *useProtectionBit,
				   UINT8 *noOFDMap,
				   UINT16 *beaconInterval,
				   BOOL   *pbcc);


STATUS probeReqParse(char *bodyPtr, UINT32 totalLen, UINT32 *protoEvent, dot11_probeReq *probeReqPtr);

#endif
