 /***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:	rx.h													   */
/*    	PURPOSE:	Rx module functions header file						   */
/*																		   */
/***************************************************************************/

#ifndef _WLAN_RX_H_
#define _WLAN_RX_H_

#include "memMngr.h"
#include "pal.h"

typedef enum {
    MSDU_READY = 0,
    MSDU_IN_PROGRESS,
    MPDU_DROP,
    MSDU_DROP
} collect_status_T;

typedef enum {
   MSG_MPDU_RECEIVE = 1,
   MSG_4X_WACK
} RxMsg_T;

typedef struct {
   RxMsg_T type;  /* Type of message (from the list above) */
   union {
      long MessageInfo[3]; /* queue-message size */
      struct {
         long  station;
         long  info;
      } wack;
   } msg;
} RxMessage_T;


STATUS wdrv_rxEnable(void);
STATUS wdrv_rxDisable(void);

/* COUNTERS */
void wdrv_rxGetCountersFrameDuplicateCount(UINT32* count);
void wdrv_rxGetReceivedFragmentCount(UINT32* count);
void wdrv_rxGetMulticastReceivedFrameCount(UINT32* count);
void wdrv_rxGetRxMsduReadyCount(UINT32* count); 

void wdrv_rxTerminateCollection(UINT16 index); 

STATUS wdrv_txDeConcatMsdu( mem_MSDU_T* firstMsduPtr, UINT16 staIndex,UINT8 MicStatus );
STATUS wdrv_rxPacketRecvNotify(void);
STATUS wdrv_rx_getEvent(RxMessage_T *pRxMessage);
STATUS wdrv_rxInit(void);
void   wdrv_rxUnload(void);

#endif
