/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalAcxCmd.h
 *   PURPOSE: ACX100 commands handler
 *		The object support the followinf ACX100 commands:
 *			StartBss
 *			EnableRx
 *			EnableTx
 *			InitMemory
 *			ProbeRespTemplate
 *			BeaconTemplate
 *			TimTemplate
 *			WepMgmt
 * 
 ****************************************************************************/

#ifndef _WHAL_ACX_CMD_H
#define _WHAL_ACX_CMD_H

extern int whal_acxCmdReset(void);
extern int whal_acxCmdSleep(void);
extern int whal_acxCmdWake(void);
extern int whal_acxCmdStartBss(UINT8 WoneIndex);
extern int whal_acxCmdEnableRx(void);
extern int whal_acxCmdEnableTx(void);
extern int whal_acxCmdDisableRx(void);
extern int whal_acxCmdDisableTx(void);
extern int whal_acxCmdInitMemory(void);
extern int whal_acxCmdProbeRespTemplate(UINT8	WoneIndex);
extern int whal_acxCmdBeaconTemplate(UINT8	WoneIndex);
extern int whal_acxCmdTimTemplate(UINT8	WoneIndex);
extern int whal_acxCmdWoneToggleTemplate(void);
extern int whal_acxCmdSetKey(int Action, char *MacAddr, int EntryIndex, int KeySize, int KeyType, int KeyId, char *Key);
extern int whal_acxCmdRadioInit(UINT32 Addr, UINT32 NumBytes);
extern int whal_acxCmdRadioCalibrate(UINT32 Option);
extern UINT8  RateConvertMask_Mask16_to_Val8(UINT16 ratemask);
/* radar detection*/
extern int whal_acxCmdSendRDStopCmd(UINT16 *p_time_vector,UINT8 *events_num);
extern int whal_acxCmdSendRDStartCmd(UINT8 channel,UINT8 band);
extern void whal_acxCrtRadioCalibrateNeedAsync(void);
void whal_acxCrtRadioCalibrateNeedAsyncCallback(BOOL status, UINT8 * buf);
#endif
