/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2002 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalAcxCmd.h
 *   PURPOSE: ACX100 BIT commands header file
 *		The object support the followinf ACX100 commands:
 *		
 *		
 *		whal_acxCmdBit_Fcc	
 *		whal_acxCmdBit_Telec	
 *    whal_acxCmdBit_perTxCfg
 *    whal_acxCmdBit_perRxCfg
 *    whal_acxCmdBit_perClrStats
 *    whal_acxCmdBit_perTxStop
 *    whal_acxCmdBit_perRxStats
 *    whal_acxCmdBit_perTxStats
 *		whal_acxCmdBit_Exit	
 * 
 ****************************************************************************/

#ifndef _WHAL_ACX_CMDBIT_H
#define _WHAL_ACX_CMDBIT_H

/* Function prototypes */

#ifdef _cplusplus
extern "C" {
#endif

/* 0x01 */  int whal_acxCmdBit_Fcc(int band, int chID, int rate, int mode);
/* 0x02 */  int whal_acxCmdBit_Telec(int band, int chID);

/********************
   PER TEST
 ********************/

/* 0x03 */  int whal_acxCmdBit_perTxCfg
            (
			   int   band,
               int   chID,
               int   rate,
               int   mode,
               int   preamble,     /* 0=long 1=short*/
               int   numFrames,
               int   gap,          /* should be >= 200usec */
               int   bodySize,     /* [0..2304] multiples of 4 */
               char *destMac       /* destination MAC address (6 octets) */
            );
/* 0x04 */  int whal_acxCmdBit_perRxCfg(int band, int chID);
/* 0x05 */  int whal_acxCmdBit_perClrStats(void);
/* 0x06 */  int whal_acxCmdBit_perTxStop(void);
/* 0x07 */  int whal_acxCmdBit_perRxStats(void  *ParamsBuf,
										  whal_userMboxCB userCB, 
										  UINT8 *replyBuf);
/* 0x08 */  int whal_acxCmdBit_perTxStats(void  *ParamsBuf,
										  whal_userMboxCB userCB, 
										  UINT8 *replyBuf);

/* 0xff */  int whal_acxCmdBit_Exit(void);

#ifdef _cplusplus
}
#endif

#endif   /* _WHAL_ACX_CMDBIT_H */
