/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalAcxConfig.h
 *   PURPOSE: ACX100 configuration information elements
 * 
 ****************************************************************************/

#ifndef _WHAL_ACX_CONFIG_H
#define _WHAL_ACX_CONFIG_H

#include "AcxInfoElements.h"
#include "whalAcxMbox.h"

#define RX_DOT11_MODE_OFDM 1
#define RX_DOT11_MODE_CCK  2

#define ENERGY_DETECT_ON  0x140A
#define ENERGY_DETECT_OFF 0xFFEF


extern int whal_acxConfigMemoryMap( AcxElm_MemoryMap_T *pMap );
extern int whal_acxConfigRead_MemoryMap(AcxElm_MemoryMap_T *pMap);
extern int whal_acxConfigGetSet_MemoryMap( AcxElm_MemoryMap_T *pMap, int Idx);
int whal_acxConfigMemory(UINT32 RxHostAddr);
int whal_acxConfigRead_QueueHead(WlanElm_QueueHead_T *pCfg);
extern int whal_acxConfigFragThreshold(void);
extern void whal_acxConfigCWminWin(void);
extern int whal_acxConfigRxConfig(void);
extern int whal_acxConfigStationId(void);
extern int whal_acxConfigRateFallback(void);
extern int whal_acxConfigRead_ConfigOptions(void);
extern int whal_acxConfigCurrRegDomain(UINT8 apRegDomain, UINT8 radioBand);
extern int whal_acxConfigPowerLevel(void);
extern int whal_acxConfigShortRetryLimit(void);
extern int whal_acxConfigLongRetryLimit(void);
extern int whal_acxConfigRead_FwVersion(void);
extern int whal_acxConfigRead_FwVersionForRestart(whal_userMboxCB userCB);
extern int whal_acxConfigBssPowerSave(int BssInPs_Val);
extern int whal_acxConfigFeatureOptions(UINT32 FeatureOptions);
extern int whal_acxConfigFeatureOptions(UINT32 FeatureOptions);
extern int whal_acxConfigRead_Statistics( ACXStatisticsStruct *pElem, whal_userMboxCB userCB, UINT8 *replyBuf);
extern int whal_acxConfigRead_FcsError( WlanElm_FcsError_T *pElem, whal_userMboxCB userCB, UINT8 *replyBuf);
extern int whal_acxConfigRxIntr(UINT32 Threshold, UINT32 Timeout_Usec);
extern int whal_acxConfigPrint_ConfigRxIntr(void);
extern int whal_acxConfigSlotTime(UINT8 SlotTimeVal, UINT8 woneIndex);
extern int whal_acxConfigWoneSlice(void);
extern int whal_acxConfigRadioParams(RadioParam_t * ptr);
extern int whal_acxConfigWepDefaultKeyId(int Key);
extern int whal_acxConfigAccessCategory(TxQueueId_T Qid, edcf_info_t * edcfInfo);
extern int whal_acxConfigQueueThresh(TxQueueId_T Qid, UINT32 Threshold);
extern int whal_acxConfigWoneConfig (void);
extern int whal_acxConfigPrint_Statistics( char *buf);
extern int whal_acxConfigRead_HDK_Version(WlanElm_HDKModuleVersion_t *  pElem, whal_userMboxCB userCB, UINT8 *replyBuf);

int whal_acxConfigMisc(void);
int whal_acxConfigVWiLeds(void);

int whal_acxConfigReadMediumUsage(AcxElm_MediumUsage_T *acxElem, whal_userMboxCB userCB, UINT8 *replyBuf);
int whal_acxConfigReadEnergyDetection(WlanElm_EDThreshold_T *acxElem, whal_userMboxCB userCB, UINT8 *replyBuf);
int whal_acxConfigEnergyDetect(UINT32 edThresh);
int whal_acxConfigPDThreshold(UINT16 pdThresh);
int whal_acxConfigReadPacketDetection( WlanElm_PDThreshold_T *acxElem, whal_userMboxCB userCB, UINT8 *replyBuf);
int whal_acxConfigRXdot11Mode(UINT32 mode);
int whal_acxConfigReadRXdot11Mmode(WlanElm_RxDot11Mode_T *acxElem, whal_userMboxCB userCB, UINT8 *replyBuf);
int whal_acxConfigReadAciCounter(AcxElm_AciEvent_T *pCfg, whal_userMboxCB userCB, UINT8 *replyBuf);



#endif
