/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalAcxProcess.h
 *   PURPOSE: Implements action on the Acx card (Reset, Run, SendCmd, Sw Download)
 *
 ****************************************************************************/

#ifndef _WHAL_ACX_PROCESS_H
#define _WHAL_ACX_PROCESS_H

extern int whal_acxProcInitiate(void);
extern int whal_acxProcMemoryConfigure(void);
extern int whal_acxProcPrintFwVersions(char *buf);
extern int whal_acxProcPrintRadioVersions(char *buf);


/* Firmware versions */
extern UINT8   _Acx100_bin_0_Version[];        /* image 0 version       */
extern UINT8   _Acx100_bin_0_ArrayStart[];     /* binary image 0        */
extern UINT8   _Acx100_bin_0_ArrayEnd[];       /* end of binary image 0 */
extern UINT8 * Acx100_bin_0_Array;
extern UINT8 * Acx100_bin_0_Array_Extra;
extern UINT32 Acx100_bin_0_Array_Len;
extern UINT32 Acx100_bin_0_Array_Extra_Len;

#define RADIO_TYPE_RADIA        0x16
#define RADIO_TYPE_RADIA_DB     0x17
#define RADIO_TYPE_RADIA_CRT    0x19
#endif
