/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalFrameBuilder.h
 *   PURPOSE: build 802.11 frames
 *		Beacon template
 *		Probe Response template
 *		Authentication frame #2 - For unit testing
 *		Association Response	- For unit testing
 *		Data frame header		- For unit testing
 * 
 ****************************************************************************/

#ifndef _WHAL_FRAME_BUILDER_H
#define _WHAL_FRAME_BUILDER_H

#include "802_11Defs.h"

extern int whal_frameBuildBeacon(UINT8 WoneIndex, dot11_beacon *pFrame, int *FrameSize);
extern int whal_frameBuildBeaconFromTim(UINT8 WoneIndex, char *pInfoElements, int *FrameSize);
extern int whal_frameBuildProbeResp(UINT8 WoneIndex, 
                                    dot11_probeRsp *pFrame, 
                                    int *FrameSize, 
                                    UINT8 *DstMac, 
                                    dot11_SSID_T *pWlanElm_Ssid);
extern int whal_frameBuildAssResp(UINT8 WoneIndex, dot11_mgmtFrame_T *pAcxFrm_AssResp, UINT32 *FrameSize, UINT8 *DstMac);
extern int whal_frameBuildAuth(dot11_mgmtFrame_T *pFrame, UINT32 *FrameSize, UINT8 *DstMac);
extern int whal_frameBuildDataHeader(UINT8 *pHdrBlock, int *HdrBlockSize, UINT8 *DstMac);
extern int whal_frameBuildHdrTxFromRx(UINT8 *pHdrBlock);

#endif