/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalRx.c
 *   PURPOSE: manages the receive of MPDU from the ACX100
 *   
 ****************************************************************************/

#include "whalCommon.h"
#include "whal.h"
#include "whalRx.h"
#include "acx_hw.h"
#include "whalRxMaster.h"

/****************************************************************************
 *                      whal_rxRecv()
 ****************************************************************************
 * DESCRIPTION:	Test function, Recv buffer from the ACX100.
 * 
 * INPUTS:	
 *		char *MpduBuf		The buffer to copy to from the ACX100
 *		int  MpduBufLen		The length of the buffer
 *		RxAttr_T *pRxAttr	The Receive attributes
 * 
 * OUTPUT:	None
 * 
 * RETURNS:	OK or NOK.
 ****************************************************************************/
MEM_HANDLE whal_rxRecv(int *MpduBufLen, RxAttr_T *pRxAttr)
{
	return whal_rxMasterRecv( MpduBufLen, pRxAttr );	
}

/****************************************************************************
 *                      whal_rxInit()
 ****************************************************************************
 * DESCRIPTION:	Initiate the Rx queue object and the Rx bufs object.
 *
 * INPUTS:	None	
 * 
 * OUTPUT:	None
 * 
 * RETURNS:	OK. 
 ****************************************************************************/
int whal_rxInit(void)
{
	return whal_rxMasterInit();	
}

/****************************************************************************
 *                      whal_rxClean()
 ****************************************************************************
 * DESCRIPTION:	Clean the already processed Queue descriptors and buffers.
 *
 * INPUTS:	None
 * 
 * OUTPUT:	None
 * 
 * RETURNS:	OK. 
 ****************************************************************************/
void whal_rxClean(void)
{
	return;	
}

/****************************************************************************
 *                      whal_rxInfoPrint()
 ****************************************************************************
 * DESCRIPTION:	Print Rx queue/bufs info.
 *
 * INPUTS:	None
 * 
 * OUTPUT:	None
 * 
 * RETURNS:	OK. 
 ****************************************************************************/
int  whal_rxInfoPrint(char *buf)
{
	int len = 0;
	return (len + whal_rxMasterInfoPrint(buf));
}

