/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalRxBufs.h
 *   PURPOSE: ACX100 Rx buffers object
 * 
 ****************************************************************************/

#ifndef _WHAL_RX_BUFS_H
#define _WHAL_RX_BUFS_H

typedef struct
{
	char *BufAddr;

	char *BlockAddr;
	int  BlockOffset;
} RxBuf_Handle_T;

extern int		whal_rxBufs_InitBufHandle(RxBuf_Handle_T *pHandle, UINT8 *MpduAddr, int MpduOffset, int MpduLen);
extern int		whal_rxBufs_AppendBuf(RxBuf_Handle_T *pHandle, char *HostBufAddr, int HostBufLen);
extern int		whal_rxBufs_Init(void);
extern UINT32	whal_rxBufs_Config(UINT32 RxBufs_StartAddress);
extern UINT32	whal_rxBufs_GetNumBlocks(void);
extern UINT32	whal_rxBufs_GetSize(void);
extern UINT32	whal_rxBufs_GetOffsetAddr(void);
extern int		whal_rxBufs_Print(void);
extern int		whal_rxBufs_InfoPrint(char *buf);

#endif