/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalRxDesc.h
 *   PURPOSE: ACX100 Rx descriptors object
 * 
 ****************************************************************************/

#ifndef _WHAL_RX_DESC_H
#define _WHAL_RX_DESC_H

#include "AcxDataIf.h"

extern void      whal_rxDesc_Init(RxDesc_T *pRxDesc);
extern RxDesc_T *whal_rxDesc_GetHostNext(RxDesc_T *pRxDesc);
extern void      whal_rxDesc_SetHostNext(RxDesc_T *pRxDesc, UINT32 HostAddr);
extern UINT32    whal_rxDesc_GetAcxBufAddr(RxDesc_T *pRxDesc);
extern UINT8	 whal_rxDesc_GetCtl(RxDesc_T *pRxDesc);
extern void      whal_rxDesc_SetCtl(RxDesc_T *pRxDesc, UINT8 Val);
extern int       whal_rxDesc_GetAttr(RxDesc_T *pRxDesc, UINT32 *MpduAddr, int *MpduOffset, int *MpduLen, RxAttr_T *pRxAttr);
extern int       whal_rxDesc_Read(RxDesc_T *pDstDesc, RxDesc_T *pSrcDesc);
extern void      whal_rxDesc_Print(RxDesc_T *pHwRxDesc);

#endif