/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalRxQueue.h
 *   PURPOSE: ACX100 Rx Queues manager
 * 
 ****************************************************************************/

#ifndef _WHAL_RX_QUEUE_H
#define _WHAL_RX_QUEUE_H

#include "AcxDataIf.h"

typedef enum 
{
	RxQid,
	NUM_RX_QUEUES
} RxQueueId_T;

extern RxDesc_T *whal_rxQueue_GetNext(RxQueueId_T Qid);
extern int		whal_rxQueue_Free(RxQueueId_T Qid, RxDesc_T *pRxDesc);
extern int		whal_rxQueue_ReclaimIntr(RxQueueId_T Qid);
extern int		whal_rxQueue_Init(RxQueueId_T Qid);
extern UINT32	whal_rxQueue_Config(RxQueueId_T Qid, UINT32 RxQueue_StartAddress);
extern UINT32	whal_rxQueue_GetSize(RxQueueId_T Qid);
extern UINT32	whal_rxQueue_GetBaseAddr(RxQueueId_T Qid);
extern int		whal_rxQueue_GetExcludeUnencryptedCount(RxQueueId_T Qid);
extern int      whal_rxQueue_GetUnencryptableCount(RxQueueId_T Qid);
extern int		whal_rxQueue_CheckFilter(RxQueueId_T Qid, RxDesc_T *pRxDesc);
extern int      whal_rxQueue_Print(RxQueueId_T Qid);
extern int      whal_rxQueue_InfoPrint(RxQueueId_T Qid,char *buf);

#endif