/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalTrace.h
 *   PURPOSE: Trace on Rx/Tx packets
 * 
 ****************************************************************************/

#ifndef _WHAL_TRACE_H
#define _WHAL_TRACE_H

#include "AcxDataIf.h"


extern void whal_trcInit(void);
extern void whal_trcUnload(void);
extern int  whal_trcAddTx(TxDesc_T *pTxDesc,UINT32 FrameAddress, char *Action);
extern int  whal_trcAddTc(TxDesc_T *pTxDesc, char *Action);
extern int  whal_trcAddCtrl(char *Action, char *String, int IntValue);
extern void whal_trcInfo(void);
extern int  whal_trcPrint(int Num, int From,char *buf);
extern int whal_trcPrintRxStat( char *buf );
extern int  whal_trcIsEnable(void);
extern void whal_trcEnable(int val);
extern int  whal_trcAddRx( WlanRxStatusInfo_T *rxStatusInfo,  char *Action);



#endif