/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalTx.h
 *   PURPOSE: Main transmit module
 * 
 ****************************************************************************/

#ifndef _WHAL_TX_H
#define _WHAL_TX_H

#include "whalTxQueue.h"
#include "whalCommon.h"

extern int  whal_txInit(void);
extern void whal_txMasterUnload(void);
extern int  whal_txClean(TxQueueId_T TxQid);
extern void whal_txHandleTxData(void);
extern int  whal_txSetTxDataUserCB(TxDataUser_Callback_T externalTxDataUserCB);
extern int  whal_txReset(TxQueueId_T TxQid);
extern int  whal_txSendMsdu(TxQueueId_T TxQid, MEM_HANDLE Msdu_Handle, TxAttr_T *pTxAttr);
extern int  whal_txCheckSize(TxQueueId_T TxQid, UINT32 Len);
extern int whal_txCheckSpace(TxQueueId_T TxQid, UINT32 MsduLen, int *HostFreeDesc);
extern int  whal_txSetStatusCB(TxStatus_Callback_T externalTxStatusCB);
extern void whal_txSetStatus(UINT8 *DestMacAddress, UINT16 ActualTxRate, UINT8 TxStatus);
extern int  whal_txSetRecv4xWackInfoCB(Recv4xWackInfo_Callback_T externalRecv4xWackInfoCB);
extern void whal_txSetRecv4xWackInfo(UINT8 *DestMacAddress, UINT8 Recv4xWackInfo);
extern void whal_txGetRecv4xWackParams(UINT32 *CallbackAddr, UINT8 *Recv4xWackInfo);
extern int  whal_txTxFrameCount(TxQueueId_T TxQid);
extern int whal_txInfoPrint(int Qid, BOOL QprintEn,char *buf);

#endif