/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalTxBufs.h
 *   PURPOSE: ACX100 Tx buffers object
 * 
 ****************************************************************************/

#ifndef _WHAL_TX_BUFS_H
#define _WHAL_TX_BUFS_H

typedef struct
{
	char *BufAddr;

	char *BlockAddr;
	int  BlockOffset;
} TxBuf_Handle_T;

extern int		whal_txBufs_AllocBuf(TxBuf_Handle_T *pTxBuf_Handle, UINT32 Len);
extern int		whal_txBufs_AppendBuf(TxBuf_Handle_T *pTxBuf_Handle, char *Buf, int Len);
extern int		whal_txBufs_FreeBuf(UINT8 *TxBufAddr);
extern int		whal_txBufs_CheckSize(UINT32 FragSize, UINT32 NumFrags, UINT32 LastFragSize);
extern int		whal_txBufs_Init(void);
extern UINT32	whal_txBufs_Config(UINT32 TxBufs_StartAddress);
extern UINT32	whal_txBufs_GetNumBlocks(void);
extern UINT32	whal_txBufs_GetSize(void);
extern UINT32	whal_txBufs_GetOffsetAddr(void);
extern int		whal_txBufs_Print(void);
extern int		whal_txBufs_InfoPrint(int Qid);

#endif