/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2001 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/****************************************************************************
 *
 *   MODULE:  whalTxDesc.h
 *   PURPOSE: ACX100 Tx descriptors object
 * 
 ****************************************************************************/

#ifndef _WHAL_TX_DESC_H
#define _WHAL_TX_DESC_H

#include "AcxDataIf.h"

/* Mpdu flags bitmap */
#define MPDU_FLAGS_RTS_SET				0x01
#define MPDU_FLAGS_SHORT_PREAMBLE_SET	0x02
#define MPDU_FLAGS_ERP_PROTECTION_SET	0x04
#define MPDU_FLAGS_TI_PROTECTION_SET	0x08

/****************************************
* Functions prototypes
*****************************************/
#ifdef __cplusplus
extern "C" {
#endif

void      whal_txDesc_Init(TxDesc_T *pTxDesc);
TxDesc_T *whal_txDesc_GetHostNext(TxDesc_T *pTxDesc);
void      whal_txDesc_SetHostNext(TxDesc_T *pTxDesc, UINT32 HostAddr);
UINT32    whal_txDesc_GetAcxBufAddr(TxDesc_T pTxDesc);
UINT8	    whal_txDesc_GetCtl(TxDesc_T *pTxDesc);
void      whal_txDesc_SetCtl(TxDesc_T *pTxDesc, UINT8 Val);
int		 whal_txDesc_SetMpduInfo(TxDesc_T *pTxDesc, UINT8 *BufAddr, int BufLen, int Frag, int NumFrags, UINT16 Rate, UINT32 MpduFlags, char *DstMac);
int		 whal_txDesc_SetMpduInfoMaster(TxDesc_T *pTxDesc, UINT32 hostDescAddr, int BufLen, /*int Frag, int NumFrags,*/ UINT16 Rate, UINT32 MpduFlags, char *DstMac);
UINT16     whal_txDesc_GetRate(TxDesc_T *pTxDesc);
void		 whal_txDesc_ResetCtlOwn(TxDesc_T *pTxDesc);
int		whal_txDesc_Print(TxDesc_T *pHwTxDesc,char *buf);
UINT8	whal_txDesc_GetStatus(TxDesc_T *pTxDesc, UINT8 *AckFail, UINT8 *RtsFail, UINT8 *RtsSucc);
int		whal_txDesc_Read(TxDesc_T *pDstDesc, TxDesc_T *pSrcDesc);
void 	whal_txDesc_reinit(TxDesc_T *pTxDesc);
#ifdef __cplusplus
}
#endif

#endif /* _WHAL_TX_DESC_H */
