/**********************************************************************************************************************

  FILENAME:       public_channels.h

  DESCRIPTION:    Channels/Band/802.11 Regulatory Domain definitions


   Copyright (c) 2002 Texas Instruments Inc. 
   All Rights Reserved This program is the confidential and proprietary 
   product of Texas Instruments Inc.  Any Unauthorized use, reproduction or 
   transfer of this program is strictly prohibited.


***********************************************************************************************************************/
#ifndef _PUBLIC_CHANNELS_H
#define _PUBLIC_CHANNELS_H

typedef enum
{
    NO_CHANNEL = 0,
    DOMAIN_DEFAULT_CHANNEL = 0,
    CHANNEL_B_1  = 1 ,
    CHANNEL_B_2  = 2 ,
    CHANNEL_B_3  = 3 ,
    CHANNEL_B_4  = 4 ,
    CHANNEL_B_5  = 5 ,
    CHANNEL_B_6  = 6 ,
    CHANNEL_B_7  = 7 ,
    CHANNEL_B_8  = 8 ,
    CHANNEL_B_9  = 9 ,
    CHANNEL_B_10 = 10,
    CHANNEL_B_11 = 11,
    CHANNEL_B_12 = 12,
    CHANNEL_B_13 = 13,
    CHANNEL_B_14 = 14,

    FCC_DEFAULT_CHANNEL_B       = CHANNEL_B_11,
    IC_DEFAULT_CHANNEL_B        = CHANNEL_B_1,
    ETSI_DEFAULT_CHANNEL_B      = CHANNEL_B_1,
    SPAIN_DEFAULT_CHANNEL_B     = CHANNEL_B_1,
    FRANCE_DEFAULT_CHANNEL_B    = CHANNEL_B_1,
    MKK_DEFAULT_CHANNEL_B       = CHANNEL_B_14,
    MKK1_DEFAULT_CHANNEL_B      = CHANNEL_B_14,
    
    CHANNEL_A_1  = 1,
    CHANNEL_A_200 = 200,
    
    FCC_DEFAULT_CHANNEL_A       = CHANNEL_A_1,
    IC_DEFAULT_CHANNEL_A        = CHANNEL_A_1,
    ETSI_DEFAULT_CHANNEL_A      = CHANNEL_A_1,
    SPAIN_DEFAULT_CHANNEL_A     = CHANNEL_A_1,
    FRANCE_DEFAULT_CHANNEL_A    = CHANNEL_A_1,
    MKK_DEFAULT_CHANNEL_A       = CHANNEL_A_1,
    MKK1_DEFAULT_CHANNEL_A      = CHANNEL_A_1,

    MIN_CHANNEL_B = CHANNEL_B_1,
    MAX_CHANNEL_B = CHANNEL_B_14,

    MIN_CHANNEL_A = CHANNEL_A_1,
    MAX_CHANNEL_A = CHANNEL_A_200,

    ALL_CHANNELS = 0xFF,
    ALL_DOMAIN_CHANNELS = 0xFE
}IntegerChannel_e;
typedef uint8 Channel_e;

#if 0
typedef enum
{
    /* regulatory domains */
    REG_DOMAIN_FCC     = 0x10,
    REG_DOMAIN_IC      = 0x20,
    REG_DOMAIN_ETSI    = 0x30,
    REG_DOMAIN_SPAIN   = 0x31,
    REG_DOMAIN_FRANCE  = 0x32,
    REG_DOMAIN_MKK     = 0x40,
    REG_DOMAIN_MKK1    = 0x41,
    REG_DOMAIN_US      = 0x50,
    REG_DOMAIN_WORLD   = 0x51,

    DEFAULT_DOMAIN     = REG_DOMAIN_WORLD
}IntegerRegulatoryDomains_e;

typedef uint8 RegulatoryDomains_e;
#endif /* 0 */


typedef uint8 RadioBand_e;
#define RADIO_BAND_2_4GHZ 0  /*2.4 Ghz band */
#define RADIO_BAND_5GHZ 1    /*5 Ghz band */

#define MAX_CHAN_BITMAP_BYTES 26    //used in channel bitmask implementation for sizing Rev A bitmask arrays

#endif
