#ifndef _WHAL_HOST_BUFS_H
#define _WHAL_HOST_BUFS_H

/* Tested = 100, 500, 1000 */
#define HOST_BUF_SIZE	1000

/*
 * MSDU and HOST buffers
 */
typedef struct Host_Buf_Desc
{
	int Offset;
	int Size;
	char *pData;
	struct Host_Buf_Desc *Next;

} HOST_BUF_DESC;

#define memMgr_GetBufLength(BufAddr) ( ((HOST_BUF_DESC *)BufAddr)->Size   )
#define memMgr_GetBufOffset(BufAddr) ( ((HOST_BUF_DESC *)BufAddr)->Offset )
#define memMgr_GetBufData(BufAddr)   ( ((HOST_BUF_DESC *)BufAddr)->pData )
#define memMgr_GetBufNext(BufAddr)   ( ((HOST_BUF_DESC *)BufAddr)->Next )

typedef struct
{
	char *pHdrBlock;
	int HdrBlockSize;
	int NumDataBlocks;
	HOST_BUF_DESC *pHostBufDesc;
	int DataBlocksSize;
} MSDU_DESC;

#define memMgr_GetMsduHdrAddr(MsduAddr)	( ((MSDU_DESC *)MsduAddr)->pHdrBlock )
#define memMgr_GetMsduDataAddr(MsduAddr)	( ((MSDU_DESC *)MsduAddr)->pHostBufDesc )
#define memMgr_GetMsduHdrSize(MsduAddr)	( ((MSDU_DESC *)MsduAddr)->HdrBlockSize )
#define memMgr_GetMsduDataSize(MsduAddr)	( ((MSDU_DESC *)MsduAddr)->DataBlocksSize )

extern MSDU_DESC *MsduAlloc(int DataLen);
extern int  MsduFree(MSDU_DESC *pMsdu);
extern HOST_BUF_DESC *BufsAlloc(int DataLen);
extern int BufsFree(HOST_BUF_DESC *pBufDesc);
extern void MsduDataFill(MSDU_DESC *pMsdu);

#endif