/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																									*/
/*		MODULE:	utils.h																		*/
/*    PURPOSE:	Driver utilities				 								*/
/*																									*/
/***************************************************************************/
#ifndef _UTILS_H_
#define _UTILS_H_

#define WDRV_UTILS_HTONL(data) ((unsigned long) (data))
#define WDRV_UTILS_HTONS(data) ((unsigned short)(data))

#define WDRV_UTILS_GETSHORT(x) ( ((unsigned char)(*((unsigned char *)(x)))   << 8) + \
							((unsigned char)(*((unsigned char *)(x)+1))) )

#define WDRV_UTILS_GETLONG(x)  ( ((unsigned char)(*((unsigned char *)(x)))   << 24) + \
							((unsigned char)(*((unsigned char *)(x)+1)) << 16) + \
							((unsigned char)(*((unsigned char *)(x)+2)) <<  8) + \
							((unsigned char)(*((unsigned char *)(x)+3))) )

#define WDRV_UTILS_MAX(a,b)  (((a) > (b)) ? (a) : (b) )
#define WDRV_UTILS_MIN(a,b)  (((a) < (b)) ? (a) : (b))

#define	PRINT_MAC(repLevel, prio, mac) 	wdrv_utilsReport(repLevel, prio, "MAC = %02X-%02X-%02X-%02X-%02X-%02X\n", (UINT8)*(mac), (UINT8)*(mac + 1), (UINT8)*(mac + 2), (UINT8)*(mac + 3), (UINT8)*(mac + 4), (UINT8)*(mac + 5))
 
#endif
