#ifndef __TI_TYPES_H__
#define __TI_TYPES_H__


#ifndef __KERNEL__
#include <stdint.h>
#else
#include <linux/types.h>
#endif

#ifndef K1BASE
#define K1BASE KSEG1
#endif

#ifndef PHYS_ADDR
#define PHYS_ADDR(x) PHYSADDR(x)
#endif

#ifndef PHYS_TO_K1
#define PHYS_TO_K1(X) (PHYSADDR(X) | K1BASE)
#endif

#ifndef PHYS_TO_K0
#define PHYS_TO_K0(X) (PHYSADDR(X) | K0BASE)
#endif


#define IMPORT extern
#define FAST   register

#define TRUE 1
#define FALSE 0

#define OFF    0
#define ON     1


#define MAC_ADDR_LEN    6   /* MAC Address length in bytes  */

//#define UINT32_T uint32_t;

/*
#ifndef __KERNEL__

typedef uint32_t UINT32;
typedef uint16_t UINT16;
typedef uint8_t UINT8;
typedef unsigned long ULONG;
typedef unsigned char UCHAR;
typedef unsigned int UINT;
typedef unsigned short USHORT;
typedef unsigned char BOOL;
typedef int32_t INT32;
typedef int16_t INT16;
typedef int8_t  INT8;
#endif

#ifndef UINT32
typedef enum {
  OK    = 0,
  ERROR = -1
} STATUS;
typedef uint32_t UINT32;
typedef uint16_t UINT16;
typedef uint8_t UINT8;
typedef unsigned long ULONG;
typedef unsigned char UCHAR;
typedef unsigned int UINT;
typedef unsigned short USHORT;
typedef unsigned char BOOL;
typedef int32_t INT32;
typedef int16_t INT16;
typedef int8_t  INT8;
#endif
*/

#define NOK    1
#define OK	   0
#define ERROR -1


/*
#else 

typedef __u8 UINT8;
typedef __u32 UINT32;
typedef __u16 UINT16;
typedef __u32 ULONG;
typedef __u8 UCHAR;
typedef __u32 UINT;
typedef __u16 USHORT;
typedef __u8 BOOL;

#endif // __KERNEL__

typedef enum {
  OK = 0,
  ERROR = -1
} STATUS;
typedef __u8 UINT8;
typedef __u32 UINT32;
typedef __u16 UINT16;
typedef __u32 ULONG;
typedef __u8 UCHAR;
typedef __u32 UINT;
typedef __u16 USHORT;
typedef __u8 BOOL;
typedef int32_t INT32;
typedef int16_t INT16;
typedef int8_t  INT8;
*/


#ifndef uint32
#define uint32 UINT32
#endif

#ifndef uint16
#define uint16 UINT16
#endif

#ifndef uint8
#define uint8 UINT8
#endif


/* Type safe MAC comparison macros, assuming MAC are at least 2 bytes aligned */
#define UST1(a,x)      (*( (unsigned char *) ( ((unsigned long)(a)) + ((int)(x)) ) ))
#define UST2(a,x)      (*( (unsigned short*) ( ((unsigned long)(a)) + ((int)(x)) ) ))
#define UST4(a,x)      (*( (unsigned long *) ( ((unsigned long)(a)) + ((int)(x)) ) ))
#define XORUST1(a,b,x) ( UST1((a),(x)) ^ UST1((b),(x)))
#define XORUST2(a,b,x) ( UST2((a),(x)) ^ UST2((b),(x)))
#define XORUST4(a,b,x) ( UST4((a),(x)) ^ UST4((b),(x)))
#define MACCMPNZ(a)    ( UST2((a),0) | UST2((a),2) | UST2((a),4))
#define MACCMPZ(a)     ( MACCMPNZ(a) == 0)
#define MACCMPF(a)     (( UST2((a),0) & UST2((a),2) & UST2((a),4)) == 0xffff)
#define MACNCMP(a,b)   ( XORUST2((a),(b),0) | XORUST2((a),(b),2) | XORUST2((a),(b),4))
#define MACCMP(a,b)    ( MACNCMP((a),(b)) == 0)
#define MACDUP2(dst,src) { \
   UST2((dst),0) = UST2((src),0); \
   UST2((dst),2) = UST2((src),2); \
   UST2((dst),4) = UST2((src),4); \
}

#ifdef  __cplusplus
//typedef int             (*FUNCPTR) (...);     
typedef void            (*VOIDFUNCPTR) (...); 
typedef double          (*DBLFUNCPTR) (...);  
typedef float           (*FLTFUNCPTR) (...);  
#else
//typedef int             (*FUNCPTR) ();    
typedef void            (*VOIDFUNCPTR) (void);
typedef double          (*DBLFUNCPTR) (void); 
typedef float           (*FLTFUNCPTR) (void); 
#endif

#endif // __TI_TYPES_H__
