/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*	  MODULE:	dda_contexts.h												   */
/*    PURPOSE:	dda api functions					 					   */
/*																		   */
/***************************************************************************/

#ifndef _DDA_CONTEXTS_H_
#define _DDA_CONTEXTS_H_

/****************************
    includes
*****************************/
#include "memMngr.h"
#include "pal.h" 
#include "mgmtSm.h"
#include "rx.h"
#include "tx.h"
#include "mainsm.h"
#include "whalAcxMbox.h"
#include <linux/wait.h>


#define DDA_DECLARE_WAIT_MECHANISM(wait) DECLARE_WAIT_QUEUE_HEAD(wait)
#define DDA_TASKLET_BUFFER_POOL_SIZE   300

STATUS dda_tasklet_init(unsigned long pool_size);
STATUS wdrv_DDA_tx_setEvent(TxMessage_T *message);
STATUS wdrv_DDA_rx_setEvent(RxMessage_T *message);
STATUS wdrv_DDA_mainSm_setEvent(mainsmMessage_T *message);
STATUS wdrv_DDA_mgmt_setEvent(mgmtMessage_T *message);
STATUS wdrv_DDA_mailbox_setEvent(unsigned long  event_type);
STATUS wdrv_DDA_restart_setEvent(void);
long   wdrv_DDA_sleep_timeout(void *wait_q,long timeout);
void   wdrv_DDA_wake(void *wait_q);
void inline wdrv_DDA_init_tx_complete_count(void);
void dda_tasklet_kill(void);
void restart_queue_init(void);
void inline wdrv_DDA_init_tx_sched_count(void);
void inline wdrv_DDA_init_rx_sched_count(void);

#endif /*_DDA_CONTEXTS_H_*/
