
/*#include <linux/modversions.h>*/
#include <linux/config.h>
#include <linux/version.h>
#include <linux/skbuff.h>
#include <linux/mm.h>
#include <linux/wireless.h>
#include <linux/netlink.h>
#include <linux/rtnetlink.h>

#include <asm/uaccess.h>

#include <net/sock.h>

#include "dda_wpa_interface.h"
#include "dda.h"
#include "pal.h"
//#include "vlynq.h"
#include "dda_proc.h"
#include "dda_contexts.h"
#include "mainsm.h"    
#include "memMngr.h"
#include "whalInterrupt.h"
#include "bssbridge.h"
#include "drvDbMain.h"
#include "drvDbHash.h"
#include "whalApi.h"
#include "tx.h"

#include "whalAcxRegs.h"

#include <asm/avalanche/generic/avalanche_intc.h>
#include <asm/avalanche/generic/avalanche_misc.h>
#include <linux/random.h>
/*#include <br_private.h>*/
/*#include <asm/avalanche/generic/vlynq_hal.h>*/


#include <asm/avalanche/generic/vlynq_hal.h>

#include "dda_wpa.h"
#include "dda_wext_ioctl.h"
/*#include <linux/netlink.h>
#include <linux/rtnetlink.h>
#include <net/sock.h>*/

#ifndef CONFIG_MIPS_PUMAS
#ifdef DDA_WLAN_LED
#include <asm/avalanche/generic/led_hal.h>
#endif
#endif

#include <whalAcxProcess.h>

MODULE_AUTHOR("Texas Instruments");
MODULE_DESCRIPTION("TI WLAN AP driver, version 5.6"); 

#define WAIT_FOR_WPA_MAX_RETRY    10
#define DDA_RX_SKIP_BLINK 16

 

extern const struct iw_handler_def dda_iw_handler_def;
/*
	Single Global variable. We need DDA context of some kind to get rid of it.
*/
struct net_device *wlan_dev = NULL;
signed int pal_replev;

#if REPORT_DEBUG
   int logged_chars = 0; /* current number of characters logged in kernel message buffer */
#endif
UINT16 configTxopLimit;

atomic_t spinLockNestCnt;
atomic_t intrLockNestCnt;

/* Local prototypes, defined here for convinience */
static int tiwlan_ddaInit(struct net_device *dev);
static int tiwlan_ddaSend(struct sk_buff * skb, struct net_device * dev);
static void tiwlan_ddaTxTimeoutHandler(struct net_device * dev);
static int tiwlan_ddaOpen(struct net_device *dev);
static int tiwlan_ddaStop(struct net_device *dev);
//static int tiwlan_ddaDoIoctl(struct net_device *, struct ifreq *, int);
static int tiwlan_ddaSetMacAddress(struct net_device *, void *);
struct net_device_stats * tiwlan_ddaGetStats(struct net_device * dev);
static void tiwlan_ddaNetlinkRecv(struct sock *sk, int len) ;

/* list of timers which used for stopping/resuming timers upon recovery */
LIST_HEAD(pal_tcb_list_head);

/* list of netlink socket messages */
LIST_HEAD(netlink_list_head);
static STATUS tilwan_ddaAddMsgToNetLinkList(void *data, int data_len);
static STATUS tiwlan_ddaNetLinkTransmit(void * data, int data_len);
static void   tiwlan_ddaUnloadNetlinkList(void);

struct netlink_list {
	struct list_head list;
	void   *data;
	int    data_len;
};

#define NETLINK_LIST_MAX_SIZE 128
static int netlinkListCurrSize;

__u16 tiap_activity_led_mask;
__u8 tiap_gpio_owner = 1; /*1 for driver, 0 for fw*/
#if !defined(CONFIG_MIPS_PUMAS) && !defined(CONFIG_MIPS_AR7VWI)
#ifdef DDA_WLAN_LED
void *wlan_led;
#endif
#elif defined(CONFIG_MIPS_AR7VWI)
#define TIAP_LED_TIMER_PERIOD 30
PALSRV_TcbObjTYPE tiap_led_timer;


atomic_t tiap_led_cur_state = ATOMIC_INIT(TIAP_LED_OFF),
	tiap_led_oper_state = ATOMIC_INIT(TIAP_LED_OFF),
	tiap_led_blinked = ATOMIC_INIT(0);

void tiap_led_timer_func(__u32 data)
{
	if ((atomic_read(&tiap_led_oper_state) == TIAP_LED_OFF) || !tiap_gpio_owner)
		goto out;
		
	if (atomic_read(&tiap_led_cur_state) == TIAP_LED_OFF) {
		whal_apiMacWrite(ACX_GPIO_OUT_REG, ~tiap_activity_led_mask); /*turn it on*/
		atomic_set(&tiap_led_cur_state, TIAP_LED_ON);
		goto out_blinked;
	}

	if (atomic_read(&tiap_led_blinked)) {
		/*if (atomic_read(&tiap_led_cur_state) == TIAP_LED_ON) */ /*no reason, see above if*/
		whal_apiMacWrite(ACX_GPIO_OUT_REG, tiap_activity_led_mask); /*turn it off*/
		atomic_set(&tiap_led_cur_state, TIAP_LED_OFF);
	}

out_blinked:
	atomic_set(&tiap_led_blinked, 0);
out:
	if (tiap_gpio_owner)
		PALSRV_tcbQueueAct(&tiap_led_timer, TIAP_LED_TIMER_PERIOD, tiap_led_timer_func, 0, 0);
}
#endif	

static int tiwlan_ddaPutFwImage(unsigned char * buf, int len) {
#if 0
	if (len > _Acx100_bin_0_ArrayEnd - _Acx100_bin_0_ArrayStart) {
		printk("%s : New FS is bigger (%d) then the old one (%d). Not enough memory.\n", __FUNCTION__,
					 len, (int)_Acx100_bin_0_ArrayEnd - (int)_Acx100_bin_0_ArrayStart);
		return NOK;
	}
#endif

	if (! Acx100_bin_0_Array ) {
		Acx100_bin_0_Array = _Acx100_bin_0_ArrayStart;
		Acx100_bin_0_Array_Len =  _Acx100_bin_0_ArrayEnd - _Acx100_bin_0_ArrayStart;		
	}
	copy_from_user(Acx100_bin_0_Array, buf, _Acx100_bin_0_ArrayEnd - _Acx100_bin_0_ArrayStart);
	Acx100_bin_0_Array_Extra_Len = len - (_Acx100_bin_0_ArrayEnd - _Acx100_bin_0_ArrayStart);
	if (Acx100_bin_0_Array_Extra_Len) {
		if (Acx100_bin_0_Array_Extra)
			kfree(Acx100_bin_0_Array_Extra);
		Acx100_bin_0_Array_Extra = kmalloc(Acx100_bin_0_Array_Extra_Len, GFP_KERNEL);
		copy_from_user(Acx100_bin_0_Array_Extra, buf + (_Acx100_bin_0_ArrayEnd - _Acx100_bin_0_ArrayStart), Acx100_bin_0_Array_Extra_Len);
	} else {
		Acx100_bin_0_Array_Extra_Len = 0;
		Acx100_bin_0_Array_Extra = NULL;
	}
	

	return OK;
}


static int tiwlan_ddaDoIoctl(struct net_device * dev, struct ifreq * rq, int cmd) {
	int ret = 0;
	generic_ioctl_buf_t ioctl_buf;
	char *buf = NULL;
	UINT16 idx;

	if (cmd != SIOCDEVPRIVATE) {
		printk("%s : Unknown ioctl %d\n", __FUNCTION__, cmd);
		ret = -1;
		goto out;
	}

	copy_from_user(&ioctl_buf, rq->ifr_data, sizeof(generic_ioctl_buf_t));

	if (ioctl_buf.buf && ioctl_buf.buf_len) {
		if ( ioctl_buf.cmd != TIAP_GENERIC_IOCTL_UPLOAD_FW &&
			 ioctl_buf.cmd != TIAP_GENERIC_IOCTL_SET_BURST_LIMIT ){  //  hack - we don't want to allocate 100K memory
			buf = kmalloc(ioctl_buf.buf_len, GFP_KERNEL);
			if (!buf) {
				//		if (!(buf = kmalloc(ioctl_buf.buf_len, GFP_KERNEL))) {
				printk("%s : failed to allocate %d bytes of memory \n", __FUNCTION__, ioctl_buf.buf_len);
				return -ENOMEM;
			}
			copy_from_user(buf, ioctl_buf.buf, ioctl_buf.buf_len);
		}
	}  else {
		printk(KERN_ERR "dda: Both buf and buf_len must be valid.\n");
		return -EINVAL;
	}

	switch (ioctl_buf.cmd) {
	case TIAP_GENERIC_IOCTL_GET_TX_INFO:
		whal_apiPrintTxInfo(ioctl_buf.param1, /* Qid */ ioctl_buf.param2, /* QprintEn */ buf);
		break;
		
	case TIAP_GENERIC_IOCTL_TST_FINDSTA: 
		if (wdrv_dbFindStaIndex(ioctl_buf.mac, &idx) == OK) 
			sprintf(buf, "station found for mac %s,idex %d", ioctl_buf.mac, idx);	
		else {
			ret = -1;
			goto out;
		}
		break;
		
	case TIAP_GENERIC_IOCTL_TST_FIND_INS:
		if (wdrv_dbFindAndInsertStaIndex(ioctl_buf.mac, ioctl_buf.param1, /* current wone index*/&idx) == OK)
			sprintf(buf, "station found/created for mac %s,idex %d", ioctl_buf.mac, idx);	
		else {
			ret = -1;
			goto out;
		}
		break;
		
	case TIAP_GENERIC_IOCTL_TST_CHALLENGE:			
		wdrv_mgmtPrintChallenge(ioctl_buf.param1,/* index */buf);
		break;

	case TIAP_GENERIC_IOCTL_GET_TX_QUEUE:
		whal_apiPrintTxQueue(ioctl_buf.param1/* Qid */,buf);
		break;
		
	case TIAP_GENERIC_IOCTL_GET_EER:
		whal_apiReadEEPROM(ioctl_buf.param1/* address*/, buf);
		break;

	case TIAP_GENERIC_IOCTL_GET_MAC_REGREAD:
		whal_apiMacRead(ioctl_buf.param1/* read mac addr reg*/, buf);
		break;
	case TIAP_GENERIC_IOCTL_GET_PHY_REGREAD:
		whal_apiPhyRead(ioctl_buf.param1, /* read phy addr reg*/buf);
		break;
	case TIAP_GENERIC_IOCTL_TRACE_PRINT:
		whal_apiTracePrint(ioctl_buf.param1/*NUM */, ioctl_buf.param2/*FROM */, buf);
		break;
	case TIAP_GENERIC_IOCTL_WLAN_PARAMS:
		proc_srv_read_wlan_params(ioctl_buf.param1/* woneIndex */,buf);
		break;
	case TIAP_GENERIC_IOCTL_UPLOAD_FW:
		if (atomic_read(&after_go)) {
			printk("%s : Not after AP is started !\n", __FUNCTION__);
			ret = -1;
			goto out;
		}

		ret = tiwlan_ddaPutFwImage(ioctl_buf.buf, ioctl_buf.buf_len) == OK ? 0 : -1;
		if (ret == 0) {
			configured_params.fw = 1;
		} else
			printk("%s : whal_acxProcPutFwImage() failed !\n", __FUNCTION__);
		goto out;

		break;
	case TIAP_GENERIC_IOCTL_SET_BURST_LIMIT:
		configTxopLimit = ioctl_buf.param1;
		goto out;
		break;
	case TIAP_GENERIC_IOCTL_GET_BURST_LIMIT:
		wdrv_dbGetBurstLimit((UINT16 *)buf);
		break;
#if defined(CONFIG_MIPS_AR7VWI)
	case TIAP_GENERIC_IOCTL_SET_GPIO_OWNER:
		tiap_gpio_owner = (__u8)ioctl_buf.param1;
		goto out;
#endif
#if REPORT_DEBUG
	case TIAP_GENERIC_IOCTL_GET_LOGGED_CHARS:
		
		
		{
			int flags = 0;
			PAL_intrLock(flags);
			printk("\n\nlogged_chars = %d\n\n",logged_chars);
			logged_chars = 0;
			PAL_intrUnLock(flags);
		}
		
		break;
	
	case TIAP_GENERIC_IOCTL_SET_LOGGED_CHARS:
		
		{
			int flags = 0;
		PAL_intrLock(flags);

		logged_chars = ioctl_buf.param1; 

		PAL_intrUnLock(flags);
		}
		
		break;
#endif
	default:
		printk("%s : Unknown ioctl command %d\n", __FUNCTION__, ioctl_buf.cmd);
		ret = -1;
		goto out;
		break;
	}


	copy_to_user(rq->ifr_data, &ioctl_buf, sizeof(generic_ioctl_buf_t));
	if( buf )
		copy_to_user(((generic_ioctl_buf_t *)rq->ifr_data)->buf, buf, ioctl_buf.buf_len);

out:
	if (buf)
	kfree(buf);

	return ret;
}

BOOL netlinkSockUp = FALSE;
STATUS  tiwlan_ddaCreateWpaNL(void) {
	struct sock * ret;
	
	ret = netlink_kernel_create(NETLINK_USERSOCK, tiwlan_ddaNetlinkRecv);
	if (ret == NULL){
		printk(KERN_INFO "dda: netlink_kernel_create() failed !\n");
		return NOK;
	}
	
	((struct dda_priv *)wlan_dev->priv)->user_nl = ret;
	netlinkSockUp = TRUE;

	netlinkListCurrSize = 0;
	
	return OK;
}

static void tiwlan_ddaNetlinkRecv(struct sock *sk, int len) 
{
	struct sk_buff * skb;

	if (!sk) return;

	while (recoveryIsInProcess) {
		PAL_sleepLong(10);
	}

	
	while ((skb = skb_dequeue(&sk->receive_queue)) != NULL)
	{
		((struct dda_priv *)wlan_dev->priv)->wpa_authenticator_pid = NETLINK_CB(skb).pid;

		dda_wpa_receive(skb->data,skb->len);

		kfree_skb(skb);
	}
}

STATUS tiwlan_ddaNetLinkSend(void * data, int data_len) {
	struct netlink_list * netlink_list_elem = NULL;
	struct list_head * current = NULL; 
	BOOL   sendFailed = FALSE;
	struct dda_priv * priv;
	__u32 pid;

	priv = (struct dda_priv *)wlan_dev->priv;
	pid = priv->wpa_authenticator_pid;


	if (pid == 0) {
		printk("%s : WPA authenticator is not connected !\n", __FUNCTION__);
		return NOK;
	}

	/* try to send messages from the list, if any */
	list_for_each(current, &netlink_list_head) {
		netlink_list_elem = list_entry(current, struct netlink_list, list);
		if(tiwlan_ddaNetLinkTransmit(netlink_list_elem->data, netlink_list_elem->data_len) == OK) {			
			list_del(&netlink_list_elem->list); 
			kfree(netlink_list_elem->data);
			kfree(netlink_list_elem); 
			netlinkListCurrSize--;
		}
		else {
			sendFailed = TRUE;
			break;
		}
	}

	if(!sendFailed) {
		/* send the new message */
		if(tiwlan_ddaNetLinkTransmit(data, data_len) == OK)
			return OK;
	}

	/* insert the new message to the list */
	return tilwan_ddaAddMsgToNetLinkList(data, data_len);
}

STATUS tilwan_ddaAddMsgToNetLinkList(void *data, int data_len) {

	struct netlink_list * netlink_list_elem = kmalloc(sizeof(struct netlink_list), GFP_ATOMIC); 	
	if(!netlink_list_elem)
		return NOK;

	if(netlinkListCurrSize >= NETLINK_LIST_MAX_SIZE)
	{
		printf("tilwan_ddaAddMsgToNetLinkList: the list is full\n");
		kfree(netlink_list_elem);
		return NOK;
	}		
	
	netlink_list_elem->data = kmalloc(data_len, GFP_ATOMIC);
	if(netlink_list_elem->data)
	{
		memcpy(netlink_list_elem->data, data, data_len);
	}
	else
	{
		kfree(netlink_list_elem);
		return NOK;
	}
	netlink_list_elem->data_len = data_len;
	list_add_tail(&netlink_list_elem->list, &netlink_list_head);
	netlinkListCurrSize++;

	return OK;
}

STATUS tiwlan_ddaNetLinkTransmit(void * data, int data_len) {
	struct sk_buff *skb;
	int res;
	struct dda_priv * priv;
	__u32 pid;

	priv = (struct dda_priv *)wlan_dev->priv;
	pid = priv->wpa_authenticator_pid;


	skb = alloc_skb(data_len, GFP_ATOMIC);
	if (!skb) {
		printk("%s : alloc_skb failed !\n", __FUNCTION__);
		return NOK;
	}

	memcpy(skb_put(skb, data_len), data, data_len);

	NETLINK_CB(skb).dst_groups = RTMGRP_LINK;
	NETLINK_CB(skb).dst_pid = pid;

	res = netlink_unicast(priv->user_nl, skb, pid, MSG_DONTWAIT);
	if (res != data_len) {
		return NOK;
	}

	return OK;
}

void tiwlan_ddaUnloadNetlinkList(void)
{
	struct netlink_list * netlink_list_elem = NULL;
	struct list_head * current = NULL;

	list_for_each(current, &netlink_list_head) {
		netlink_list_elem = list_entry(current, struct netlink_list, list);
		list_del(&netlink_list_elem->list); 
		kfree(netlink_list_elem->data);
		kfree(netlink_list_elem); 
		netlinkListCurrSize--;
	}
}


#define VLYNQ_ACX111_MEM_SIZE       0x00040000

STATUS tiwlan_ddaInitPSPVlynq(UINT32 * RegAddr, UINT32 * MemAddr) {

	/* verify whether vlynq was initialized */
	if (vlynq_get_status(0))
	{
		avalanche_reset_ctrl(64, IN_RESET);
		PAL_sleepLong(40);
		avalanche_reset_ctrl(64, OUT_OF_RESET);

		*MemAddr = AVALANCHE_LOW_VLYNQ_MEM_MAP_BASE;
		*RegAddr = AVALANCHE_LOW_VLYNQ_MEM_MAP_BASE + VLYNQ_ACX111_MEM_SIZE;

		return tiwlan_ddaInitInterrupts();
	}

	return NOK;
}

STATUS tiwlan_ddaUnloadPSPVlynq(void) {
	if (((struct dda_priv *)wlan_dev->priv)->driver_started & DDA_DRV_STARTED) {
		avalanche_reset_ctrl(64, IN_RESET);
		PAL_sleepShort(10);
		avalanche_reset_ctrl(64, OUT_OF_RESET);
	}
	return OK;
}

#ifdef TIWLAN_DEBUG
atomic_t pal_alloc_count;
#endif


#ifdef TIWLAN_DEBUG
#define BM_NUM_ENTRIES 64
#define BM_NUM_MASK 0x3F

int tmp;
inline void BM_GET_TIMESTAMP(void)
{
   __asm __volatile ( "mfc0    %0,$9"  : "=d" (tmp));
}

#define VLYNQ_ACX111_MEM_SIZE       0x00040000


typedef struct {
      unsigned long loc;/* trace entry identification */
      unsigned long ts; /* Timestamp */
      unsigned long p1; /* Parameter 1 */
      unsigned long p2; /* Parameter 2 */
} bm_entry_t;

typedef struct {
      int pos;
      UINT32 count;
      int print_on;
      unsigned long self_delay;
      bm_entry_t entry; /* Array of entries */
} bm_control_t;

bm_control_t *bm_control = NULL;
bm_entry_t   *bm_entry[BM_NUM_ENTRIES];

char *bm_trace_print_lut[16] =
							   {"EMPTY     ",
								"TX START  ",
								"BSS_WLAN_R",
								"CHKSIZE_F ",
								"RX INTR   ",
								"RX EVENT  ",
								"TX_C_INTR ",
								"SND_Q_OK  ",
								"SND_Q_BUSY",
								"TX_C_EVENT",
								"TX_E_START",
								"TX_MASTR_E",
								"TX_TIMEOUT",
								"SKB_FAIL  ",
								"RX_EN_TO  "};

int bm_init(void)
{
   int i;

   bm_control = (bm_control_t *)PAL_memAlloc(0,sizeof(bm_control_t),0,0);
   PAL_memSet(bm_control, 0, sizeof(bm_control));
   for(i=0; i<BM_NUM_ENTRIES; i++)
   {
	   bm_entry[i] = PAL_memAlloc(0,sizeof(bm_entry_t),0,0);
	   PAL_memSet(bm_entry[i], 0, sizeof(bm_entry_t));
   }
   bm_control->print_on = FALSE;
   return 0;
}

void bm_shutdown(void) {
   int i;
	 
	 for(i=0; i<BM_NUM_ENTRIES; i++) 
	   PAL_memFree(0, bm_entry[i], 0);

	 PAL_memFree(0, bm_control, 0);

}

void inline bm_trace(int loc, unsigned long p1, unsigned long p2)
{   
   int pos;

   if(bm_control->print_on)
	   return;

   pos = bm_control->pos;
   bm_control->pos = (pos+1) & BM_NUM_MASK;
   ++bm_control->count;
   BM_GET_TIMESTAMP();
   bm_entry[pos]->ts = tmp;
   bm_entry[pos]->loc= loc;
   bm_entry[pos]->p1 = p1;
   bm_entry[pos]->p2 = p2;
}

void bm_disable(void) {
	bm_control->print_on = TRUE;
}

void bm_print(char *buf, int *length)
{
	int len=0, i;


	bm_control->print_on = TRUE;

	len += sprintf(buf+len, "\n------------------ TRACE BUFFER, pos = %d, count = %ul --------------------\n\n", bm_control->pos, bm_control->count); 
	for(i=0; i<BM_NUM_ENTRIES; i++)
	{
		len += sprintf(buf+len, "entry %d  event %s  time %lu  p1 %lu  p2 %lu\n",
					   i, bm_trace_print_lut[bm_entry[i]->loc], bm_entry[i]->ts, bm_entry[i]->p1, bm_entry[i]->p2);
	}
	len += sprintf(buf+len, "\n------------------------ END OF TRACE BUFFER -------------------------\n\n"); 

	bm_control->print_on = FALSE;
	*length = len;
}
#endif // TIWLAN_DEBUG

void tiwlan_ddaDeleteMacAddrFunc(char *mac)
{	
#if 0
	struct net_bridge_fdb_entry *ent;

	ent = br_fdb_get(wlan_dev->br_port->br, mac);
	if(!ent)
	{
		printk("deleteMacAddrFunc: there is no mac entry: %02X-%02X-%02X-%02X-%02X-%02X in the bridge\n", (UINT8)*(mac), (UINT8)*(mac + 1), (UINT8)*(mac + 2), (UINT8)*(mac + 3), (UINT8)*(mac + 4), (UINT8)*(mac + 5));
		return;
	}
	*(ent->pprev_hash) = ent->next_hash;
	if (ent->next_hash != NULL)
		ent->next_hash->pprev_hash = ent->pprev_hash;
	ent->next_hash = NULL;
	ent->pprev_hash = NULL;
#endif
}

UINT8 tiwlan_ddaRand(void)
{
	UINT8 temp;
	get_random_bytes(&temp, 1);
	return temp;
}

void tiwlan_ddaSrand(UINT16 seed)
{
	/* empty function in Linux */
}


/* To be as much compatible, as it is possible with 2.6, follow these guidelines:
   return IRQ_HANDLED - when we did have a valid interrupt and handled it
          IRQ_NONE - the opposite of IRQ_HANDLED
 */

static irqreturn_t tiwlan_ddaVlynqIsr(int irq, void *dev_id, struct pt_regs *regs) {
#if 0
int val, val1;

	val = *(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x10)));

	if (val & 1)  { /* local vlynq interrupt */
		val1 = *(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x8)));
		*(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x8))) = val1;
	} else if (val & 2) { /* remove vlynq interrupts */
		val1 = *(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x88)));
		*(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x88))) = val1;
	} else if (val == 0x80) {
		whal_acxIntrHandler() ;
	}

	*(volatile __u32 *)(KSEG1ADDR((vbase1 + 0x10))) = val;
#endif

	whal_acxIntrHandler() ;
	return IRQ_HANDLED;
}


STATUS tiwlan_dda_waitForWpa(void)
{
	int retryCount = 0;
	/* create net link socket,connection to wpa module*/
	if( tiwlan_ddaCreateWpaNL() == NOK )
		return NOK;
	
	/* connect to wpa module */
	/* wait for hello msg */
	while(retryCount++ < WAIT_FOR_WPA_MAX_RETRY)
	{
		if(dda_wpa_wait_for_wpaHello() != OK)
			printk("\nDRV WAITING FOR WPA MODULE TO COME UP !!!\n");
		else
			return OK;
	}
	return NOK;
}

STATUS tiwlan_dda_wpaGo(void)
{
	dda_wpa_drv_send_hello();
	return OK;
}



STATUS tiwlan_ddaInitInterrupts(void) {
	/* 0 is pulsed/edge and 1 is level based interrupt */
	/* new psp : pulse, lebel*/
	//	avalanche_intr_type_set(LNXINTNUM(AVALANCHE_LOW_VLYNQ_INT), 1);
	avalanche_intr_type_set(80, 1);
	/*  0 is active high and 1 is active low */
	/* new psp : active high, active*/
	//	avalanche_intr_polarity_set(LNXINTNUM(AVALANCHE_LOW_VLYNQ_INT), 0);
	avalanche_intr_polarity_set(80, 0);
	if (request_irq(80/*LNXINTNUM(AVALANCHE_LOW_VLYNQ_INT8)*/, tiwlan_ddaVlynqIsr, 0, "TNETW1130", wlan_dev)) {
		printk("Interrupt handler registration (request_irq) failed !\n");
		return NOK;
	}

	((struct dda_priv *)wlan_dev->priv)->driver_started |= DDA_DRV_STARTED;

	return OK;
}

STATUS tiwlan_ddaGo(initConfigStruct *init_cfg) {
	//	int ret;

	/* init tasklet module*/
	if(dda_tasklet_init(DDA_TASKLET_BUFFER_POOL_SIZE) != OK)
	{
		printk(KERN_INFO "dda: error init tasklet module\n");
		return NOK;		
	}

	/* restart kernel queue init*/
	restart_queue_init();

	/*init proc fs support*/
	if(dda_init_proc_fs() != OK)
	{
		printk(KERN_INFO "dda: error init proc module\n");
		dda_tasklet_kill();
		return NOK;		
	}

	((struct dda_priv *)wlan_dev->priv)->driver_started |= DDA_DRV_RECEIVED_GO;
	return OK;


}

#if 0
static BOOL queue_stopped_flow_control = FALSE;
static BOOL queue_stopped_protection = FALSE;
STATUS wdrv_DDA_queue_stop(void)
{
	if(!queue_stopped_protection)
		netif_stop_queue(wlan_dev);
	queue_stopped_flow_control = TRUE;
	
	return OK;
}

STATUS wdrv_DDA_queue_start(void)
{
	if(!queue_stopped_protection)
		netif_wake_queue(wlan_dev);
	queue_stopped_flow_control = FALSE;

	return OK;
}
#endif

static int tiwlan_ddaSend(struct sk_buff * skb, struct net_device * dev) {
#define HEADER_EXTRA_LENGTH 32
	mem_MSDU_T * pMSDU;
    mem_BD_T   * pBD;
	struct net_device_stats * stats;

	netif_stop_queue(wlan_dev);

#if 0
	queue_stopped_protection = TRUE;
#endif

	/* neutralize the spinlock/spinunlock operations in the driver since
	   the BH are disabled before this function is called */
	PAL_spinLockNestInc();

	bm_trace(1,0,0);

	/*
		Currently no skb fragmentation support
	*/
#ifdef TIWLAN_DEBUG
	SKB_FRAG_ASSERT(skb);
#endif // TIWLAN_DEBUG


#if 0
	printk("\n$$$$$$$$$$$$$$$$$$$$$$$$$$dataPtr=0x%X$$$$$$$$$$$$$$$$$$$$\n",(int)skb->data);
	for(i=0; i<skb->len; i++)
	{
		printk("%02X-", skb->data[i]);
	}
	printk("\n$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");
	printk("TX packet of %d bytes\n", skb->len);
#endif

	wlan_memMngrAllocMSDU (&pMSDU, HEADER_EXTRA_LENGTH);
    if (pMSDU == NULL)
	{
		printk("wlan_memMngrAllocMSDU failed !\n");
		kfree_skb(skb);
		goto exit;
	}
	
	pMSDU->dataLen = skb->len;
	pMSDU->freeFunc = (ap_FreeMemFunc)kfree_skb;
	pMSDU->freeArgs[0] = (UINT32)skb;
	pMSDU->firstBDPtr->bufToken = 1;

    wlan_memMngrAllocBDs(1, &pBD);
    if (pBD == NULL)
    {
		printk("wlan_memMngrAllocBDs failed !\n");
		wlan_memMngrFreeMSDU(pMSDU->handle);
		goto exit;
	}

    pBD->data = skb->data;
    pBD->length = skb->len;
    pMSDU->firstBDPtr->nextBDPtr = pMSDU->lastBDPtr = pBD;

	wdrv_bssBridgePktFromEthrToWlan(pMSDU);

	dev->trans_start = jiffies;
	stats = &((struct dda_priv *)dev->priv)->stats;

	stats->tx_bytes += skb->len;
	stats->tx_packets++;
	
#if 0
	if(!queue_stopped_flow_control)
#endif
	netif_wake_queue(wlan_dev);
 exit:
#if 0
	queue_stopped_protection = FALSE;
#endif
	PAL_spinLockNestDec();
	return 0;
}

STATUS tiwlan_ddaReceive(mem_MSDU_T * pMSDU) {
	register struct sk_buff * skb;
	int    res = OK;
	struct net_device_stats * stats;
	register mem_BD_T   * pBD = pMSDU->firstBDPtr;
#ifndef CONFIG_MIPS_PUMAS
#ifdef DDA_WLAN_LED
	static int skip_blink;
#endif
#endif

	/* For BSS bridging purpose only, when interface is down */
	if (!netif_running(wlan_dev)) {
		if( (res = wlan_memMngrFreeMSDU(pMSDU->handle)) != OK)
			printk("%s: wlan_memMngrFreeMSDU failed !\n", __func__);
		return res;
	}
	
	/*
		Assumes that MSDU has only one BD
	*/
#ifdef TIWLAN_DEBUG
	if (pBD->nextBDPtr) {
		printk("%s : Only single BD MSDUs are supported !\n", __func__);
		return NOK;
	}
#endif // TIWLAN_DEBUG


	skb = (struct sk_buff *)pBD->bufToken;
	if(!skb)
	{
		printk("tiwlan_ddaReceive: NULL skb received\n");
		return NOK;
	}

	skb->dev = wlan_dev ;

	stats = &((struct dda_priv *)wlan_dev->priv)->stats;

	skb_reserve(skb,(int)memMgr_BufData(pBD) + (int)memMgr_BufOffset(pBD) - (int)skb->data);
    skb_put(skb, memMgr_BufLength(pMSDU->firstBDPtr));

#if 0
	printk("\n^^^^^^^^###############^^^^^^^^^dataPtr=0x%X^^^^^^^^^^^^^^^^^^^^^^^^^\n",(int)skb->data);
	for(i=0; i<skb->len; i++)
	{
		printk("%02X-", skb->data[i]);
	}
	printk("\n^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n");
#endif
	printk("wlan_dev->br_port = %d\n", wlan_dev->br_port);
#ifndef TI_SLOW_PATH
#error "ti_slow_path"
	if (!wlan_dev->br_port)
#endif
		skb->protocol = eth_type_trans(skb, wlan_dev);
	skb->ip_summed = CHECKSUM_NONE;

	wlan_dev->last_rx = jiffies;

	netif_rx(skb);
#ifndef CONFIG_MIPS_PUMAS
#ifdef DDA_WLAN_LED
	if (!wdrv_dbGetApBridgeMode() && !(++skip_blink % DDA_RX_SKIP_BLINK))
		tiwlan_ddaLedAction(TIAP_LED_BLINK_OFF);
#endif
#endif

	stats->rx_packets++;
	stats->rx_bytes += skb->len;
	
	/* signal to memMngr not to free the skb */
	pBD->bufToken = 0;
	res = wlan_memMngrFreeMSDU(pMSDU->handle);
	if (res != OK) {
		printk("%s: wlan_memMngrFreeMSDU failed !\n", __func__);
	}

	return res;
}

static void tiwlan_ddaTxTimeoutHandler(struct net_device * dev) {
	bm_trace(12,0,0);
	if (!recoveryIsInProcess) {
		printk("tiwlan_ddaTxTimeoutHandler activated => start queue !!!!!!!!!!!\n");
		netif_wake_queue(wlan_dev);
	}
}

/* This function returns OK in case the allocation is needed and NOK otherwise */
STATUS tiwlan_ddaRxAllocBufferIfNeeded(UINT32 len, UINT32 * dataBufToken, UINT8 ** buf) {

	*dataBufToken = (UINT32)alloc_skb(len, GFP_ATOMIC);

	if((*dataBufToken) != 0 )
	{
		*buf = (UINT8 *)((struct sk_buff *)*dataBufToken)->data;
	}
	else
	{
		*buf = NULL;
	}
		
	return OK;
}

int tiwlan_ddaOpen(struct net_device *dev) {
	netif_start_queue(dev);
	printk(KERN_INFO "%s device is activated\n", dev->name);
	return 0;
}

static int tiwlan_ddaInit(struct net_device *dev) {

	SET_MODULE_OWNER(dev);

	dev->wireless_handlers = (struct iw_handler_def *)&dda_iw_handler_def;
	dda_wext_init();
	
	dev->hard_start_xmit = tiwlan_ddaSend;
	dev->open = tiwlan_ddaOpen;
	dev->stop = tiwlan_ddaStop;
	dev->get_stats = tiwlan_ddaGetStats;
	dev->do_ioctl = tiwlan_ddaDoIoctl;
	dev->set_mac_address = tiwlan_ddaSetMacAddress;

	dev->tx_timeout = tiwlan_ddaTxTimeoutHandler;
	dev->watchdog_timeo = 1000; /* 1 jiffies = 10 ms */

	dev->if_port = 3; /* QoS support for NSP */

	init_etherdev(dev, sizeof(struct dda_priv));

	memset(dev->priv, 0, sizeof(struct dda_priv));
		
	wlan_dev = dev;

	return 0;
}


struct net_device_stats * tiwlan_ddaGetStats(struct net_device * dev) {
	return &((struct dda_priv *)dev->priv)->stats;
}



static int tiwlan_ddaStop(struct net_device *dev) {
	netif_stop_queue(dev);
	printk(KERN_INFO "%s device is de-activated\n", dev->name);
	return 0;
}


static int __init tiwlan_ddaInitModule(void) 
{
#if !defined(CONFIG_MIPS_PUMAS) && !defined(CONFIG_MIPS_AR7VWI)
#ifdef DDA_WLAN_LED
	if( !(wlan_led = avalanche_led_register("wlan", 0)) ) {
		printk("\ndda: Failed to register wlan led\n\n");
		return -ENODEV;
	}
#endif
#elif defined(CONFIG_MIPS_AR7VWI)
	PALSRV_tcbNew(&tiap_led_timer);
	PALSRV_tcbQueueAct(&tiap_led_timer, TIAP_LED_TIMER_PERIOD, tiap_led_timer_func, 0, 0);
#endif

	if( !(wlan_dev = alloc_etherdev(sizeof(struct dda_priv))) )
		return -ENODEV;

	strncpy(wlan_dev->name, DDA_DEVNAME, IFNAMSIZ);
	wlan_dev->init = tiwlan_ddaInit;

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
	dev->destructor = free_netdev;
#else
	/* Linux 2.4.x uses dev entry (reads dev->features) after
	 * dev->destructor has returned, so must not free struct net_device
	 * here. Set NETIF_F_DYNALLOC flag so that netdev_finish_unregister()
	 * frees the entry. */
	wlan_dev->features |= NETIF_F_DYNALLOC;
#endif
	
	if( register_netdev(wlan_dev) ) {
		printk(KERN_INFO "dda: error registering %s\n", wlan_dev->name);
		kfree(wlan_dev);
		return -ENODEV;
	}

#ifdef TIWLAN_DEBUG	
	atomic_set(&pal_alloc_count, 0);
#endif

	bm_init();

	PAL_lockNesting_init();

	return 0;
}

char *get_mac_addr(void);

int tiwlan_ddaSetMacAddress(struct net_device *dev, void *addr)
{
	struct  sockaddr *hwaddr = addr;
	u8 *p = get_mac_addr();
	
	if( !p || !dev ) return -EINVAL;

	memcpy(dev->dev_addr, hwaddr->sa_data, ETH_ALEN);
	dev->addr_len = ETH_ALEN;
	memcpy(p, dev->dev_addr, dev->addr_len);
	p = dev->dev_addr;
	printk("\n\n%s: set hw addr=%02X:%02X:%02X:%02X:%02X:%02X\n\n\n", __func__,
			p[0], p[1], p[2], p[3], p[4], p[5]);

        return 0;
}

extern struct tasklet_struct  main_system_tasklet; 

STATUS tiwlan_ddaSuspend(void) {	
	PALSRV_tcbSuspend();	
	netif_stop_queue(wlan_dev);
	tasklet_disable(&main_system_tasklet);
	//	disable_irq(80);

	return OK;
}

STATUS tiwlan_ddaResume(void) {	
	tasklet_enable(&main_system_tasklet);
	//	enable_irq(80);
	PALSRV_tcbResume();
	netif_wake_queue(wlan_dev);

	return OK;
}

static void __exit tiwlan_ddaCleanupModule(void) {
	struct sock * sock /*ret*/;

	printk("dda: starting cleanup: \n");
	netif_stop_queue(wlan_dev);

	if(netlinkSockUp)
	{
		if( !(sock =  (struct sock *)((struct dda_priv *)wlan_dev->priv)->user_nl) )
			printk("\n%s: BUG line=%d !!!\n", __func__, __LINE__);
		else sock_release(sock->socket);

		tiwlan_ddaUnloadNetlinkList();
	}
	
	if (((struct dda_priv *)wlan_dev->priv)->driver_started & DDA_DRV_STARTED) {
		free_irq(80, wlan_dev);
		printk("dda: cleanup finish succesfully ,good-bye.\n");
	}

	if (((struct dda_priv *)wlan_dev->priv)->driver_started & DDA_DRV_RECEIVED_GO) {
		dda_tasklet_kill();
		dda_clean_proc();
		wdrv_unload();
	}

	if (Acx100_bin_0_Array_Extra)
		kfree(	Acx100_bin_0_Array_Extra);

	
#ifdef TIWLAN_DEBUG
	printk("Memory debug : pal_alloc_count = %d\n", atomic_read(&pal_alloc_count));
#endif

	bm_disable();
	bm_shutdown();

#if !defined(CONFIG_MIPS_PUMAS) && !defined(CONFIG_MIPS_AR7VWI)
#ifdef DDA_WLAN_LED
	if( wlan_dev ) {
		tiwlan_ddaLedAction(TIAP_LED_OFF);
		avalanche_led_unregister(wlan_led);
	}
#endif
#elif defined(CONFIG_MIPS_AR7VWI)
	PALSRV_tcbDelete(&tiap_led_timer);
#endif

	unregister_netdev(wlan_dev);
	wlan_dev = NULL;
	printk("dda: cleanup finish succesfully, good-bye.\n");
}


module_init(tiwlan_ddaInitModule);
module_exit(tiwlan_ddaCleanupModule);

