/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2003 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*                                                                         */
/*   MODULE:  dda_wpa_if.h                                                 */
/*   PURPOSE: gives API for ddc core to access the wpa module 			   */										       
/*                                                                         */
/***************************************************************************/
#ifndef  _DDA_WPA_IF_
#define  _DDA_WPA_IF_


#include "pal.h"
#include "mainsm.h"
#include "dda_wpa.h"

STATUS dda_wpa_receive(void */*wpaMessage_T **/ msg,UINT32 len);

/* function api:driver sending to wpa */
STATUS dda_wpa_notify_station_connect(Uint16 idx); /*  wdrv_wpaNotifyStationConnect */
STATUS dda_wpa_notify_station_disconnect(Uint16 idx); /* wdrv_wpaNotifyStationDisConnect */
STATUS dda_wpa_notify_eapolReceived(mem_MSDU_T*  msduPtr, BOOL encrypted); /* wdrv_wpaNotifyEapolReceived */
STATUS dda_wpa_first_dataFromStation(Uint16 idx, BOOL isEapol); /*  wdrv_wpaFirstDataFromStation */
STATUS dda_wpa_rxMicFailure(Uint16 idx); /* wdrv_wpaRxMicFailur */
STATUS dda_wpa_canStationAss(Uint16 index,Uint8 *info_elem, int info_elem_len);
STATUS dda_wpa_SetStationSecAttack(Uint16 index,BOOL flag);

/* function api:receive from wpa */
void dda_wpa_canStationAssRes(Uint16 index,int ret);
void dda_wpa_set_default_key(int index,wpa_cipher_t cipher,wpa_temporal_key_t *temporal_key);
void dda_wpa_set_default_key_id(int index);
void dda_wpa_remove_default_key(int index,wpa_cipher_t cipher);
void dda_wpa_set_mapping_key(char/*ether_mac_t */*mac,wpa_cipher_t cipher,wpa_temporal_key_t *temporal_key);
void dda_wpa_remove_mapping_key(ether_mac_t mac,wpa_cipher_t cipher);
void dda_wpa_deauth_sta(ether_mac_t mac);
void dda_wpa_disassoc_sta(ether_mac_t mac);
int  dda_wpa_send_eapol(void *buf, int len, int encrypt); 

/* TODO */
STATUS dda_wpa_restart_module(void);
STATUS dda_wpa_drv_send_hello(void);
void dda_wpa_set_ap_wpa_info_elem(u8 *wpa_info_elem,int len);
u64  dda_wpa_get_tsc(void); 
void dda_wpa_block_multicast_traffic(int block);
void dda_wpa_block_unicast_traffic(int block,ether_mac_t mac);
int  dda_wpa_get_max_num_of_mapping_keys(void);
STATUS dda_wpa_wait_for_wpaHello(void);  
void   dda_wpa_receive_hello(void);  

#endif /* _DDA_WPA_IF_ */
