#include "pal.h"


STATUS PALSRV_tcbSuspend(void) {
	struct pal_tcb_list * pal_tcb_list_elem = NULL; 
	struct list_head * current = NULL; 

	list_for_each(current, &pal_tcb_list_head) {
		pal_tcb_list_elem = list_entry(current, struct pal_tcb_list, list); 
		if (timer_pending(pal_tcb_list_elem->timer)) {
			pal_tcb_list_elem->pending = 1;
			pal_tcb_list_elem->expires = pal_tcb_list_elem->timer->expires - jiffies;
			printk("%s: deleting timer %#x\n", __func__, (int)pal_tcb_list_elem->timer->function);
			del_timer(pal_tcb_list_elem->timer);
		} else
			pal_tcb_list_elem->pending = 0;	
	}

	return OK;
}

STATUS PALSRV_tcbResume(void) {
	struct pal_tcb_list * pal_tcb_list_elem = NULL; 
	struct list_head * current = NULL; 
	
	list_for_each(current, &pal_tcb_list_head) {
		pal_tcb_list_elem = list_entry(current, struct pal_tcb_list, list); 
		if (pal_tcb_list_elem->pending) {
			pal_tcb_list_elem->timer->expires = jiffies + pal_tcb_list_elem->expires + 1;
/*			printk("%s: adding timer %#x\n", __func__, pal_tcb_list_elem->timer->function); */
			add_timer(pal_tcb_list_elem->timer);
		}
	}

	return OK;
}

STATUS PALSRV_tcbNew(PALSRV_TcbObjTYPE * timer) {
	struct pal_tcb_list * pal_tcb_list_elem = kmalloc(sizeof(struct pal_tcb_list), GFP_KERNEL); 	

	init_timer(timer); 
	pal_tcb_list_elem->timer = timer; 
	list_add_tail(&pal_tcb_list_elem->list, &pal_tcb_list_head); 

	return PAL_SOK; 
}

STATUS PALSRV_tcbDelete(PALSRV_TcbObjTYPE * timer) {
	struct pal_tcb_list * pal_tcb_list_elem = NULL; 
	struct list_head * current = NULL; 

	list_for_each(current, &pal_tcb_list_head) {
		pal_tcb_list_elem = list_entry(current, struct pal_tcb_list, list); 
		if (pal_tcb_list_elem->timer == timer) {
			list_del(&pal_tcb_list_elem->list); 
			kfree(pal_tcb_list_elem); 
		} 
	} 

	del_timer(timer); 

	return PAL_SOK;
}

STATUS PALSRV_tcbCancel(PALSRV_TcbObjTYPE * timer) {
	struct pal_tcb_list * pal_tcb_list_elem = NULL; 
	struct list_head * current = NULL; 

	list_for_each(current, &pal_tcb_list_head) {
		pal_tcb_list_elem = list_entry(current, struct pal_tcb_list, list); 
		if (pal_tcb_list_elem->timer == timer) {
			list_del(&pal_tcb_list_elem->list); 
			kfree(pal_tcb_list_elem); 
		} 
	} 

	del_timer(timer); 

	return PAL_SOK;
}

