/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2003 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*                                                                         */
/*   MODULE:  command.c                                                    */
/*   PURPOSE: Demo application console commands                            */
/*                                                                         */
/***************************************************************************/
/***************************************************************************/
/* The Implementation of the command console is divided to two modules,    */
/* The first module, implemented in the file utilsConsole.c,is parsing the */
/* user input according to a table of commands (CommandArray[]), which     */
/* includes the command name, parameters and function. If the user's input */
/* is found in the table, the command function is called, and the parsed   */
/* parameters are passed to it. The command's functions are implemented    */
/* in command.c module.                                                    */
/***************************************************************************/

/*#include "pform_types.h"
#include "rt_os.h"

#include "mgmtAccess.h"

#include "platConfig.h"*/
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/if_ether.h>
#include <sys/klog.h>


#include "dda_wext_ioctl.h"

#include "utilsConsole.h"

#include "wcfglib.h"
#include "wcfg_ioctl.h"
#include "wcfg_net.h"
#include "cfg_proc_if.h"
#include "dda_proc_fs_defs.h"

#include "drvDbRegDomainDefs.h"

/*#include "app_driver_api.h"
#include "whalDefs.h"
#include "whalNVRAM.h"
#include "boot_msg.h"*/
/*#include "802_11Defs.h"
#include <rt_os.h>
#include "whal.h"
#include "memMngr.h"
#include "public_security_keys.h"
#include "release.h"
#include "boot_msg.h"
#include "tnetd53xx_emac.h"*/

/*
#ifdef INCLUDE_TESTAPP
#include "tstcmnd.h"
#endif
#include <sample/make/release.h>*/

#define LAST_COMMAND  "!" /* the string for 'last command' command */

/*typedef struct
{
	BOOL	exist;
	BOOL	basic;
} ratesCheck_t;*/

wcfgd *wd;
static const char fmtMac[] = "%02x-%02x-%02x-%02x-%02x-%02x";   /* MAC address */

char smStateDesc[TIAP_PARAM_SM_NUM_STATES][MAX_PRINT_STRING] = {
	"     IDLE    ",
	"   AUTH_KEY  ",
	"AUTHENTICATED",
	"  ASSOCIATED ",
	"  AUTHORIZED ",
};

typedef struct {    /* This is a storage for a list of Channel Range elements */
	tiap_param_cur_reg_domain_t cur_regdomain;
	UINT8                       ranges_nr;
	tiap_param_channel_rang_elem_t *rang_elem;
} cli_channel_range_tbl_elem_t;

/* 802.11d Allowed Channel Tables - hardcoded values */
static cli_channel_range_tbl_elem_t ch_rang_a[NUM_OF_REGULATORY_DOMAINS_A];
static cli_channel_range_tbl_elem_t ch_rang_b[NUM_OF_REGULATORY_DOMAINS_B];


__u8 reportMode = IMMEDIATE;

static void wdrv_dbInitRangeTables(void)
{
	ch_rang_a[0].cur_regdomain.type = TIAP_PARAM_RD_US;
	ch_rang_a[0].ranges_nr = NUM_OF_RANGE_ELEMENTS_US;
	if( !(ch_rang_a[0].rang_elem = 
			(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t)*2)) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	
	ch_rang_a[0].rang_elem[0].start = REG_DOMAIN_US_START_CH_0;
	ch_rang_a[0].rang_elem[0].stop = REG_DOMAIN_US_STOP_CH_0;
	ch_rang_a[0].rang_elem[0].step = REG_DOMAIN_US_STEP_OPT_0;
	ch_rang_a[0].rang_elem[0].power_limit = REG_DOMAIN_US_POWER_LIMIT_CH_0;
	ch_rang_a[0].rang_elem[1].start = REG_DOMAIN_US_START_CH_1;
	ch_rang_a[0].rang_elem[1].stop = REG_DOMAIN_US_STOP_CH_1;
	ch_rang_a[0].rang_elem[1].step = REG_DOMAIN_US_STEP_OPT_1;
	ch_rang_a[0].rang_elem[1].power_limit = REG_DOMAIN_US_POWER_LIMIT_CH_1;

	ch_rang_a[1].cur_regdomain.type = TIAP_PARAM_RD_WORLD;
	ch_rang_a[1].ranges_nr = NUM_OF_RANGE_ELEMENTS_WORLD;
	if( !(ch_rang_a[1].rang_elem =
			(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t)*3)) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_a[1].rang_elem[0].start = REG_DOMAIN_WORLD_START_CH_0;
	ch_rang_a[1].rang_elem[0].stop  = REG_DOMAIN_WORLD_STOP_CH_0;
	ch_rang_a[1].rang_elem[0].step = REG_DOMAIN_WORLD_STEP_OPT_0;
	ch_rang_a[1].rang_elem[0].power_limit = REG_DOMAIN_WORLD_POWER_LIMIT_CH_0;
	ch_rang_a[1].rang_elem[1].start = REG_DOMAIN_WORLD_START_CH_1;
	ch_rang_a[1].rang_elem[1].stop  = REG_DOMAIN_WORLD_STOP_CH_1;
	ch_rang_a[1].rang_elem[1].step = REG_DOMAIN_WORLD_STEP_OPT_1;
	ch_rang_a[1].rang_elem[1].power_limit = REG_DOMAIN_WORLD_POWER_LIMIT_CH_1;
	ch_rang_a[1].rang_elem[2].start = REG_DOMAIN_WORLD_START_CH_2;
	ch_rang_a[1].rang_elem[2].stop = REG_DOMAIN_WORLD_STOP_CH_2;
	ch_rang_a[1].rang_elem[2].step = REG_DOMAIN_WORLD_STEP_OPT_2;
	ch_rang_a[1].rang_elem[2].power_limit = REG_DOMAIN_WORLD_POWER_LIMIT_CH_2;

	/*              - G - band              */
	ch_rang_b[0].cur_regdomain.type = TIAP_PARAM_RD_FCC;
	ch_rang_b[0].ranges_nr = 1;
	if( !(ch_rang_b[0].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[0].rang_elem[0].start = REG_DOMAIN_FCC_START_CH_0;
	ch_rang_b[0].rang_elem[0].stop  = REG_DOMAIN_FCC_STOP_CH_0;
	ch_rang_b[0].rang_elem[0].step = REG_DOMAIN_FCC_STEP_OPT_0;
	ch_rang_b[0].rang_elem[0].power_limit = REG_DOMAIN_FCC_POWER_LIMIT_CH_0;

	ch_rang_b[1].cur_regdomain.type = TIAP_PARAM_RD_IC;
	ch_rang_b[1].ranges_nr = 1;
	if( !(ch_rang_b[1].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[1].rang_elem[0].start = REG_DOMAIN_IC_START_CH_0;
	ch_rang_b[1].rang_elem[0].stop  = REG_DOMAIN_IC_STOP_CH_0;
	ch_rang_b[1].rang_elem[0].step = REG_DOMAIN_IC_STEP_OPT_0;
	ch_rang_b[1].rang_elem[0].power_limit = REG_DOMAIN_IC_POWER_LIMIT_CH_0;

	ch_rang_b[2].cur_regdomain.type = TIAP_PARAM_RD_ETSI;
	ch_rang_b[2].ranges_nr = 1;
	if( !(ch_rang_b[2].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[2].rang_elem[0].start = REG_DOMAIN_ETSI_START_CH_0;
	ch_rang_b[2].rang_elem[0].stop  = REG_DOMAIN_ETSI_STOP_CH_0;
	ch_rang_b[2].rang_elem[0].step = REG_DOMAIN_ETSI_STEP_OPT_0;
	ch_rang_b[2].rang_elem[0].power_limit = REG_DOMAIN_ETSI_POWER_LIMIT_CH_0;

	ch_rang_b[3].cur_regdomain.type = TIAP_PARAM_RD_SPAIN;
	ch_rang_b[3].ranges_nr = 1;
	if( !(ch_rang_b[3].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[3].rang_elem[0].start = REG_DOMAIN_SPAIN_START_CH_0;
	ch_rang_b[3].rang_elem[0].stop  = REG_DOMAIN_SPAIN_STOP_CH_0;
	ch_rang_b[3].rang_elem[0].step = REG_DOMAIN_SPAIN_STEP_OPT_0;
	ch_rang_b[3].rang_elem[0].power_limit = REG_DOMAIN_SPAIN_POWER_LIMIT_CH_0;

	ch_rang_b[4].cur_regdomain.type = TIAP_PARAM_RD_FRANCE;
	ch_rang_b[4].ranges_nr = 1;
	if( !(ch_rang_b[4].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[4].rang_elem[0].start = REG_DOMAIN_FRANCE_START_CH_0;
	ch_rang_b[4].rang_elem[0].stop  = REG_DOMAIN_FRANCE_STOP_CH_0;
	ch_rang_b[4].rang_elem[0].step = REG_DOMAIN_FRANCE_STEP_OPT_0;
	ch_rang_b[4].rang_elem[0].power_limit = REG_DOMAIN_FRANCE_POWER_LIMIT_CH_0;

	ch_rang_b[5].cur_regdomain.type = TIAP_PARAM_RD_MKK;
	ch_rang_b[5].ranges_nr = 1;
	if( !(ch_rang_b[5].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t))) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[5].rang_elem[0].start = REG_DOMAIN_MKK_START_CH_0;
	ch_rang_b[5].rang_elem[0].stop = REG_DOMAIN_MKK_STOP_CH_0;
	ch_rang_b[5].rang_elem[0].step = REG_DOMAIN_MKK_STEP_OPT_0 | NO_OFDM_OPT;
	ch_rang_b[5].rang_elem[0].power_limit = REG_DOMAIN_MKK_POWER_LIMIT_CH_0;

	ch_rang_b[6].cur_regdomain.type = TIAP_PARAM_RD_MKK1;
	ch_rang_b[6].ranges_nr = 2;
	if( !(ch_rang_b[6].rang_elem =
		(tiap_param_channel_rang_elem_t *)malloc(sizeof(tiap_param_channel_rang_elem_t)*2)) ) {
		fprintf(stderr, "Allocation error.\n\n");
		exit(1);
	}
	ch_rang_b[6].rang_elem[0].start = REG_DOMAIN_MKK1_START_CH_0;
	ch_rang_b[6].rang_elem[0].stop  = REG_DOMAIN_MKK1_STOP_CH_0;
	ch_rang_b[6].rang_elem[0].step = REG_DOMAIN_MKK1_STEP_OPT_0;
	ch_rang_b[6].rang_elem[0].power_limit = REG_DOMAIN_MKK1_POWER_LIMIT_CH_0;
	ch_rang_b[6].rang_elem[1].start = REG_DOMAIN_MKK1_START_CH_1;
	ch_rang_b[6].rang_elem[1].stop  = REG_DOMAIN_MKK1_STOP_CH_1;
	ch_rang_b[6].rang_elem[1].step = REG_DOMAIN_MKK1_STEP_OPT_1 | NO_OFDM_OPT;
	ch_rang_b[6].rang_elem[1].power_limit = REG_DOMAIN_MKK1_POWER_LIMIT_CH_1;
}

#define convert_rates(tv, rates_dest, rates_src, len)    		 \
do {                                            			 \
	int i, k;							 \
	for(i=0,k=0; i<len; i++)        				 \
		if(rates_src[i] == TIAP_PARAM_RATE_SUPPORTED)		 \
			rates_dest[k++] = tv[i];               		 \
		else if(rates_src[i] == TIAP_PARAM_RATE_BASIC_SUPPORTED) \
			rates_dest[k++] = tv[i] | 0x80;			 \
} while(0)


/*
#define read_proc_entry(dir, entry) 	\
({					\
char _buf[4096*3];				\
int _len, _ret=0;				\
	if( (_len = dda_read_proc_entry(dir, entry, _buf, sizeof(_buf))) == -1) \
		_ret = _len; \
	else _ret = write(1, _buf, _len);		\
	_ret; \
})
*/


/* This routine is called by the various primitives in order to check whether a Privacy is activated *
    * in the AP. For example: If Privacy is enabled, then the Multiple SSID should not enabled.         */
static int is_privacy_enabled(void)
{
	tiap_param_security_type_t security_type;
	__u8 priv_opt = 0;

	if( tiap_wcfg_get_basic(wd, TIAP_PARAM_SECURITY_TYPE, &security_type, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get security type.");
		return 0;
	}
	
	if( security_type == TIAP_PARAM_SECURITY_WEP ) {
		if( tiap_wcfg_get_basic(wd, TIAP_PARAM_PRIV_OPTION, &priv_opt, FROM_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to get privacy option.");
			return 0;
		}
	}

	if( priv_opt || security_type == TIAP_PARAM_SECURITY_802_1X ||
			security_type == TIAP_PARAM_SECURITY_WPA )
		return 1;

	return 0;
}

static int get_domain_elems_num(int band, __u8 domain)
{
	switch (band)
	{
		case BAND_A:
			switch (domain)
			{
				case TIAP_PARAM_RD_US:
					return NUM_OF_RANGE_ELEMENTS_US;

				case TIAP_PARAM_RD_WORLD:
					return NUM_OF_RANGE_ELEMENTS_WORLD;

				default:
					break;
			}
			break;

		case BAND_B:
			switch (domain)
			{
				case TIAP_PARAM_RD_FCC:
					return 1;

				case TIAP_PARAM_RD_IC:
					return 1;

				case TIAP_PARAM_RD_ETSI:
					return 1;

				case TIAP_PARAM_RD_SPAIN:
					return 1;

				case TIAP_PARAM_RD_FRANCE:
					return 1;

				case TIAP_PARAM_RD_MKK:
					return 1;

				case TIAP_PARAM_RD_MKK1:
					return 2;

				default:
					break;
			}
			break;

		default:
			break;
	}
	return 0;
}


int is_std_reg_domain(__u8 domain)
{
	switch (domain)
	{
		case TIAP_PARAM_RD_FCC:
		case TIAP_PARAM_RD_IC:
		case TIAP_PARAM_RD_ETSI:
		case TIAP_PARAM_RD_SPAIN:
		case TIAP_PARAM_RD_FRANCE:
		case TIAP_PARAM_RD_MKK:
		case TIAP_PARAM_RD_MKK1:
		case TIAP_PARAM_RD_US:
		case TIAP_PARAM_RD_WORLD:
			return 1;
	}
	return 0;
}

int wdrv_dbGetRangeElement(int band, tiap_param_cur_reg_domain_t cur_reg_domain,
			   UINT8 RangeIndex,tiap_param_channel_rang_elem_t *rang_elem);

extern int wapp_utilsConsoleCurrentContext;
void consoleTask(void);
//extern L2ADDRESS MAC_address;

static UINT8 currentConfigWoneInex;

void BITCB(ConsoleParameter_T parameters[]);
void MgmtCB(ConsoleParameter_T parameters[]);
void MgmtTstCB(ConsoleParameter_T parameters[]);
void WpaCB(ConsoleParameter_T parameters[]);
void WpaTstCB(ConsoleParameter_T parameters[]);
void PrivacyCB(ConsoleParameter_T parameters[]);
void ServCB(ConsoleParameter_T parameters[]);
void HalCB(ConsoleParameter_T parameters[]);
void HalDiagCB(ConsoleParameter_T parameters[]);
void ProdCB(ConsoleParameter_T parameters[]);
void SecurityCB(ConsoleParameter_T parameters[]);
void BringUpCB(ConsoleParameter_T parameters[]);
void BringUpTxCB(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						Root menu functions								*/
/************************************************************************/
void consoleMac(ConsoleParameter_T parameters[]);
void consoleReportLevel(ConsoleParameter_T parameters[]);
void consoleReportMode(ConsoleParameter_T parameters[]);
void consoleLastCommand(ConsoleParameter_T parameters[]);
void consoleReboot(ConsoleParameter_T parameters[]);
void consoleVersion(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						BIT sub-menu functions							*/
/************************************************************************/
void consoleBitFcc(ConsoleParameter_T parameters[]);
void consoleBitTelec(ConsoleParameter_T parameters[]);
void consoleBitTxCfg(ConsoleParameter_T parameters[]);
void consoleBitRxCfg(ConsoleParameter_T parameters[]);
void consoleBitClrStat(ConsoleParameter_T parameters[]);
void consoleBitTxStop(ConsoleParameter_T parameters[]);
void consoleBitRxStat(ConsoleParameter_T parameters[]);
void consoleBitTxStat(ConsoleParameter_T parameters[]);

void consoleBitStop(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						Mgmt sub-menu functions	 DONE						*/
/************************************************************************/
void printMgmtAccess(ConsoleParameter_T parameters[]);
void setAccessMAC(ConsoleParameter_T parameters[]);
void remAccessMAC(ConsoleParameter_T parameters[]);
void enableAccess(ConsoleParameter_T parameters[]);
void disableAccess(ConsoleParameter_T parameters[]);
void printHashTable(ConsoleParameter_T parameters[]);
void printStaTable(ConsoleParameter_T parameters[]);
void printRatesTable(ConsoleParameter_T parameters[]);
void printMgmtCounters(ConsoleParameter_T parameters[]);

void deAuthMng(ConsoleParameter_T parameters[]);
void disAssocMng(ConsoleParameter_T parameters[]);
void mgmtLog(ConsoleParameter_T parameters[]);
void mgmtAging(ConsoleParameter_T parameters[]);
void mgmtShow(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						Mgmt Test sub-menu functions DONE							*/
/************************************************************************/
void findSta(ConsoleParameter_T parameters[]);
void insertSta(ConsoleParameter_T parameters[]);
void removeSta(ConsoleParameter_T parameters[]);
void null(ConsoleParameter_T parameters[]);
void auth1(ConsoleParameter_T parameters[]);
void auth3(ConsoleParameter_T parameters[]);
void assoc(ConsoleParameter_T parameters[]);
void reAssoc(ConsoleParameter_T parameters[]);	 
void deAuth(ConsoleParameter_T parameters[]);
void disAssoc(ConsoleParameter_T parameters[]);
void class3(ConsoleParameter_T parameters[]);
void showChallenge(ConsoleParameter_T parameters[]);
void mgmtReset(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						WPA sub-menu functions	   WORKS						*/
/************************************************************************/
void wpaWorkingMode(ConsoleParameter_T parameters[]);
void wpaPassPhraseMode(ConsoleParameter_T parameters[]);
void wpaPskHex(ConsoleParameter_T parameters[]);
void wpaShow(ConsoleParameter_T parameters[]);
void wpaDefaultCipher(ConsoleParameter_T parameters[]);
void wpaGTKInterval(ConsoleParameter_T parameters[]);
void wpaPskPwd(ConsoleParameter_T parameters[]);
void wpaRadiusSecret(ConsoleParameter_T parameters[]);
void wpaRadiusPort(ConsoleParameter_T parameters[]);
void wpaRadiusAddr(ConsoleParameter_T parameters[]);
void wpaDefaultGateway(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						WPA Test sub-menu functions							*/
/************************************************************************/
void assocStation(ConsoleParameter_T parameters[]);
void reAssocStation(ConsoleParameter_T parameters[]);
void stationsRsnIe(ConsoleParameter_T parameters[]);
void macAuthorize(ConsoleParameter_T parameters[]);
void macDeAuthorize(ConsoleParameter_T parameters[]);
void showWpaConfig(ConsoleParameter_T parameters[]);
void isMacAuthorized(ConsoleParameter_T parameters[]);
void setStationSuite(ConsoleParameter_T parameters[]);
void setBcastSuite(ConsoleParameter_T parameters[]);
void testVectors(ConsoleParameter_T parameters[]);
void setRxMicKey(ConsoleParameter_T parameters[]);
void setTxMicKey(ConsoleParameter_T parameters[]);
void setMicReportInRx(ConsoleParameter_T parameters[]);
void setMicReportFromStation(ConsoleParameter_T parameters[]);
void generateTxMicFailure(ConsoleParameter_T parameters[]);

/************************************************************************/
/*						Privacy sub-menu functions WORKS						*/
/************************************************************************/
void privacyShowConfig(ConsoleParameter_T parameters[]);
void privacyShowNotify(ConsoleParameter_T parameters[]);
void privacyShowDefault(ConsoleParameter_T parameters[]);
void privacySetAuthAlgo(ConsoleParameter_T parameters[]);
void privacySetPrivacyInvoked(ConsoleParameter_T parameters[]);
void wlanPrintPrivacyCounters(ConsoleParameter_T parameters[]);
void privacySetPrivacyExclude(ConsoleParameter_T parameters[]);
void privacySetPrivacyBitFlag(ConsoleParameter_T parameters[]);
void privacySetPrivacyOptionImplemented(ConsoleParameter_T parameters[]);

/* not supported */
void privacyShowMapping(ConsoleParameter_T parameters[]);
void privacySetPrivacyWEPKeyMappingLength(ConsoleParameter_T parameters[]);
void privacySetMappingKey5(ConsoleParameter_T parameters[]);
void privacySetMappingKey13(ConsoleParameter_T parameters[]);
void privacySetMappingKey29(ConsoleParameter_T parameters[]);
void privacySetAuthRspTimeout(ConsoleParameter_T parameters[]);


/* wpa */
void privacySetPrivacyWEPDefaultKeyId(ConsoleParameter_T parameters[]);
void privacySetDefaultKey5(ConsoleParameter_T parameters[]);
void privacySetDefaultKey13(ConsoleParameter_T parameters[]);
void privacySetDefaultKey29(ConsoleParameter_T parameters[]);


/************************************************************************/
/* Service Application sub-menu functions				*/
/************************************************************************/
void wlanSetVhcf(ConsoleParameter_T parameters[]);
void servEnable(ConsoleParameter_T parameters[]);
void servDisable(ConsoleParameter_T parameters[]);
void wlanSetDualAp(ConsoleParameter_T parameters[]);
void wlanSetWoneConfIndex(ConsoleParameter_T parameters[]);
void wlanSetUsageTime(ConsoleParameter_T parameters[]);
void wlanRadioParams(ConsoleParameter_T parameters[]);
void wlanSetUsageTimeMode(ConsoleParameter_T parameters[]);
void wlanSetMacAddr(ConsoleParameter_T parameters[]);
void wlanSetRates(ConsoleParameter_T parameters[]);
void wlanSetGRates(ConsoleParameter_T parameters[]);
void wlanSetAdditionalRates(ConsoleParameter_T parameters[]);
void wlanSetRespRateMode(ConsoleParameter_T parameters[]);
void wlanSetChannel(ConsoleParameter_T parameters[]);
void wlanSetBeacon(ConsoleParameter_T parameters[]);
void wlanSetDtim(ConsoleParameter_T parameters[]);
void wlanSetRtsThreshold(ConsoleParameter_T parameters[]);
void wlanSetShoreRetryLimit(ConsoleParameter_T parameters[]);
void wlanSetLongRetryLimit(ConsoleParameter_T parameters[]);
void wlanSetRateFallback(ConsoleParameter_T parameters[]);
void wlanSetRateAdaptation(ConsoleParameter_T parameters[]);
void wlanSetFragmentationTreshold(ConsoleParameter_T parameters[]);
void wlanSetMaxTransmitMSDULifetime(ConsoleParameter_T parameters[]);
void wlanSetMaxReceiveLifetime(ConsoleParameter_T parameters[]);
void wlanPrintParams(ConsoleParameter_T parameters[]);
void wlanPrintRatesParams(ConsoleParameter_T parameters[]);
void wlanPrintCounters(ConsoleParameter_T parameters[]);
void wlanSetNvramDefaults(ConsoleParameter_T parameters[]);
void wlanSetAgile(ConsoleParameter_T parameters[]);
void wlanSetPreambleMode(ConsoleParameter_T parameters[]);
void wlanSetPBCCAlgorithmMode(ConsoleParameter_T parameters[]);
void wlanSetSlotTimeMode(ConsoleParameter_T parameters[]);
void wlanSetSlotTimeThreshold(ConsoleParameter_T parameters[]);
void wlanSetERPProtectionMode(ConsoleParameter_T parameters[]);
void wlanSetERPProtectionType(ConsoleParameter_T parameters[]);
void wlanSetDot11Mode(ConsoleParameter_T parameters[]);
void wlanSetCWmin(ConsoleParameter_T parameters[]);
void wlanSetDynAlgoTimeout(ConsoleParameter_T parameters[]);
void wlanSetRadioCalibrateOption(ConsoleParameter_T parameters[]);
void wlanSetRadioCalibrateInterval(ConsoleParameter_T parameters[]);
void wlanSetBssIsolation(ConsoleParameter_T parameters[]);
void wlanPrintBssIsolationState(ConsoleParameter_T parameters[]);
void wlanSetRadarDetect(ConsoleParameter_T parameters[]);
void wlanPrintRadarDetect(ConsoleParameter_T parameters[]);
void wlanSetApBridgeMode(ConsoleParameter_T parameters[]);

/************************************************************************/
/* SSID Features sub-menu functions                                     */
/************************************************************************/
void wlanSsidPrintParams(ConsoleParameter_T parameters[]);
void wlanSSID(ConsoleParameter_T parameters[]);
void wlanSetHiddenSSID(ConsoleParameter_T parameters[]);
void wlanSetMultipleSSID(ConsoleParameter_T parameters[]);
void wlanAddMultipleSsidElement(ConsoleParameter_T parameters[]);
void wlanRemoveMultipleSsidElement(ConsoleParameter_T parameters[]);

/************************************************************************/
/* 802.11 D & H sub-menu functions                                      */
/************************************************************************/
void wlan_dh_PrintParams(ConsoleParameter_T parameters[]);
void wlan_dh_PrintRegDomain(ConsoleParameter_T parameters[]);
void wlanSetMultiDomain(ConsoleParameter_T parameters[]);
void wlanSetSpectrumMgmt(ConsoleParameter_T parameters[]);
void wlanSetLegacyStation(ConsoleParameter_T parameters[]);
void wlanSetPowerConstraint(ConsoleParameter_T parameters[]);
void wlanSetRegulatoryDomain(ConsoleParameter_T parameters[]);
void wlanSetTxPowerLevel(ConsoleParameter_T parameters[]);
void wlanSetPowerLevel(ConsoleParameter_T parameters[]);
void wlanSetCountryString(ConsoleParameter_T parameters[]);
/*void wlanMakeRange(ConsoleParameter_T parameters[]);
void wlanChangeRange(ConsoleParameter_T parameters[]);
void wlanChangeRangeOption(ConsoleParameter_T parameters[]);*/

/************************************************************************/
/* Show sub-menu functions 		                                        */
/************************************************************************/
void showBssBridge(ConsoleParameter_T parameters[]);
void showPowerSave(ConsoleParameter_T parameters[]);
void showPrintTxStat(ConsoleParameter_T parameters[]);
void showMibWlan(ConsoleParameter_T parameters[]);
void showLanStat(ConsoleParameter_T parameters[]);
void showLanPool(ConsoleParameter_T parameters[]);
void showMemMngrStat(ConsoleParameter_T parameters[]);
void showRateAdaptation(ConsoleParameter_T parameters[]);

/************************************************************************/
/* Hal sub-menu functions												*/
/************************************************************************/

void whalMenu_printRxBufs(ConsoleParameter_T parameters[]);
void whalMenu_eed(ConsoleParameter_T parameters[]);
void whalMenu_eer(ConsoleParameter_T parameters[]);
void whalMenu_eew(ConsoleParameter_T parameters[]);
void whalMenu_printFwVersion(ConsoleParameter_T parameters[]);
void whalMenu_printAcxParams(ConsoleParameter_T parameters[]);
void whalMenu_printTxInfo(ConsoleParameter_T parameters[]);
void whalMenu_printRxInfo(ConsoleParameter_T parameters[]);
void whalMenu_printTxQueue(ConsoleParameter_T parameters[]);
void whalMenu_printTxIndicator(ConsoleParameter_T parameters[]);
void whalMenu_printRxQueue(ConsoleParameter_T parameters[]);
void whalMenu_printTxBufs(ConsoleParameter_T parameters[]);
void whalMenu_printIntr(ConsoleParameter_T parameters[]);
void whalMenu_printMbox(ConsoleParameter_T parameters[]);
void whalMenu_printAcxStat(ConsoleParameter_T parameters[]);
void whalMenu_printRestartStat(ConsoleParameter_T parameters[]);
void whalMenu_EnableEnergyDetect(ConsoleParameter_T parameters[]);
void whalMenu_EnergyDetectShow(ConsoleParameter_T parameters[]);
void whalMenu_setWAoptions(ConsoleParameter_T parameters[]);
void whalMenu_setAciRateThresh(ConsoleParameter_T parameters[]);
void whalMenu_setAciEventThresh(ConsoleParameter_T parameters[]);
void whalMenu_setAciTimeout(ConsoleParameter_T parameters[]);
void whalMenu_setNbTimeout(ConsoleParameter_T parameters[]);
void whalMenu_setPdThresh(ConsoleParameter_T parameters[]);
void whalMenu_setBusyMediumThresh(ConsoleParameter_T parameters[]);
void whalMenu_showACIparams(ConsoleParameter_T parameters[]);
void whalMenu_EnableRestartWA(ConsoleParameter_T parameters[]);
void whalMenu_VlynqErrorsCnt(ConsoleParameter_T parameters[]);
void whalMenu_gpio_owner(ConsoleParameter_T []);

/************************************************************************/
/* Hal Diag sub-menu functions											*/
/************************************************************************/
void whalMenu_SetBssPs(ConsoleParameter_T parameters[]);
void whalMenu_SetTxCompleteTrsh(ConsoleParameter_T parameters[]);
void whalMenu_PrintRegs(ConsoleParameter_T parameters[]);
void whalMenu_PhyRegWrite(ConsoleParameter_T parameters[]);
void whalMenu_PhyRegRead(ConsoleParameter_T parameters[]);
void whalMenu_MacRegWrite(ConsoleParameter_T parameters[]);
void whalMenu_MacRegRead(ConsoleParameter_T parameters[]);
void whalMenu_RxPromiscuous(ConsoleParameter_T parameters[]);
void whalMenu_ModeSniffer(ConsoleParameter_T parameters[]);
void whalMenu_PrintFwVersions(ConsoleParameter_T parameters[]);
void whalMenu_SetNvByte(ConsoleParameter_T parameters[]);
void whalMenu_TraceEnable(ConsoleParameter_T parameters[]);
void whalMenu_TracePrint(ConsoleParameter_T parameters[]);
void whalMenu_TracePrintRxStat(ConsoleParameter_T parameters[]);
void whalMenu_SelectFwNumber(ConsoleParameter_T parameters[]);
void whalMenu_SetQueueSizeType(ConsoleParameter_T parameters[]);
void whalMenu_SelectRadioNumber(ConsoleParameter_T parameters[]);
void whalMenu_PrintRadioVersions(ConsoleParameter_T parameters[]);
void whalMenu_DownloadFW(ConsoleParameter_T parameters[]);
void whalMenu_DM(ConsoleParameter_T parameters[]);

/************************************************************************/
/* production sub-menu functions                                        */
/************************************************************************/
#ifdef VXWORKS
void consoleDir(ConsoleParameter_T parameters[]);
void consoleErase(ConsoleParameter_T parameters[]);
void consoleDl(ConsoleParameter_T parameters[]);
void consoleSetDef(ConsoleParameter_T parameters[]);
void consoleProdShow(ConsoleParameter_T parameters[]);
void consoleProdSet(ConsoleParameter_T parameters[]);
void consoleProdDef(ConsoleParameter_T parameters[]);
void consolePassword(ConsoleParameter_T parameters[]);
#endif /* VXWORKS */


/************************************************************************/
/* 4X sub-menu functions  ----------------- DONE ----------------------												*/
/************************************************************************/

void fourXTable(ConsoleParameter_T parameters[]);
void show4xParams(ConsoleParameter_T parameters[]);
void set4xMaxConcatSize(ConsoleParameter_T parameters[]);
void set4x(ConsoleParameter_T parameters[]);
void setPacketBursting(ConsoleParameter_T parameters[]);
void setConcatDebug(ConsoleParameter_T parameters[]);
void wlanSet4xMixMode(ConsoleParameter_T parameters[]);
void set4xFeatureSet(ConsoleParameter_T parameters[]);
void setBurstLimit(ConsoleParameter_T parameters[]);

/* auxilary functions */

static void access_list_to_str(char *buff, int buff_size,
			       tiap_param_access_list_t access_list, 
			       int *num_entries);
static void set_enable_wa_restart(int val);

/************************************************************************/
/*						The console root menu							*/
/************************************************************************/
ConsoleCommand_T wapp_utilsConsoleRootCommandArray[] = {
   { "replevel",    1, consoleReportLevel,		{INTEGER_PRM,  NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "Update [set|reset] Report level: repl [-|+]<level_id>" } ,
   { "RepMode",    1, consoleReportMode,		{INTEGER_PRM,  NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "1 - IMMEDIATE, 0 - DEFERRED" }, 
   { "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   { "version",     0, consoleVersion,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "Display version information" },
   { LAST_COMMAND,  0, consoleLastCommand,		{NO_PARAM,     NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "Execute the last command" },
   WAPP_UTILS_CONSOLE_MAIN_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,						{NO_PARAM,     NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "Undefined" },
};

/**********************************************************/
/*						BIT sub-menu									 */
/**********************************************************/
ConsoleCommand_T ConsoleBITCommandArray[] = {
	{ "fcc",          0, consoleBitFcc		,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "fcc - interactive selection of band, channel, rate and mode" },
	{ "telec",        0, consoleBitTelec	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "telec - interactive selection of channel per current band" },
	{ "perTxCfg",     1, consoleBitTxCfg	,	{MAC_ADDR_PRM,  NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "perTxCfg <dstMAC>. Other parameters are intercative." },
	{ "perRxCfg",     0, consoleBitRxCfg	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "perRxCfg. Interactive command." },
	{ "perClrStat",   0, consoleBitClrStat	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "Clears PER statistics" },
	{ "perTxStop",		0, consoleBitTxStop	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "Stops Tx in PER test" },
	{ "perRxStat",    0, consoleBitRxStat	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "Shows Rx statistics" },
	{ "perTxStat",    0, consoleBitTxStat	,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "Shows Tx statistics" },
	{ "stop",         0, consoleBitStop    ,	{NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM,      NO_PARAM    }, "Stops test mode, and reboot (must)." },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",	0, NULL,                {NO_PARAM,      NO_PARAM,     NO_PARAM,       NO_PARAM,      NO_PARAM    }, "Undefined" },
};


/************************************************************************/
/*						Mgmt sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleMgmtCommandArray[] = {
	{ "accessPrint", 0, printMgmtAccess, {NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM}, "Print Access List"},
	{ "accessSetMAC", 1, setAccessMAC, {MAC_ADDR_PRM, NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM}, "Add MAC address to access list <mac>"},
	    { "accessRemMAC", 0, remAccessMAC, {NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM}, "Remove MAC address from access list"},
	{ "accessEnable", 1, enableAccess, {SHORT_PRM, NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM}, "Enable access list <type(1-black, 0-white)>"},
	{ "accessDisable", 0, disableAccess, {NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM}, "Disable access list"},
	{ "deauthmng",			2, deAuthMng,			{MAC_ADDR_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send a DeAuthentication message to a station <mac> <reason>" },
	{ "disassocmng",		2, disAssocMng,			{MAC_ADDR_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send a DisAssociation message to a station <mac> <reason>" },
	{ "staTable",			0, printStaTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station table" },
	{ "hashTable",			0, printHashTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the hash table" },
	{ "ratesTable",			0, printRatesTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station rates table" },
	{ "counters",			0, printMgmtCounters,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the mgmt counters" },
	{ "log",				1, mgmtLog		,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable Mgmt log <mode(1-On, 0-Off)>" },
	{ "aging",				1, mgmtAging		,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable Mgmt aging mechanism <mode(1-On, 0-Off)>" },
	{ "show",				0, mgmtShow,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Show parameters" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",			0, NULL,                {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						Mgmt Test sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleMgmtTstCommandArray[] = {
    { "ratesTable",			0, printRatesTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station rates table" },
    { "null",				4, null,				{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   NO_PARAM}, "Send a null mgmt frame <FC> <SA> <DA> <BSSID>" },
    { "a1",					2, auth1,				{INTEGER_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send an authentication#1 frame <SA> <AlgoNum>" },
    { "a3",					3, auth3,				{INTEGER_PRM,   SHORT_PRM,   INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Send an authentication#3 frame <SA> <AlgoNum> <challenge>" },
{ "assoc",				4, assoc,				{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM}, "Send an association frame <SA> <PBCC (1-On, 0-Off)> <privacy (1-On, 0-Off)> <four x (1-On, 0-Off)>" },
    { "reassoc",			4, reAssoc,				{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM}, "Send a ReAssociation frame <SA> <PBCC (1-On, 0-Off)> <privacy (1-On, 0-Off)> <four x (1-On, 0-Off)>" },
    { "deauth",				2, deAuth,				{INTEGER_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send a DeAuthentication frame <SA> <reason>" },
    { "disassoc",			2, disAssoc,			{INTEGER_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send a DisAssociation frame <SA> <reason>" },
    { "class3",				2, class3,				{INTEGER_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send class3 message to Mgmt task <SA> <index>" },
    { "challenge",			1, showChallenge,		{SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Show the challenge text that was sent to a station <index>" },
    { "staTable",			0, printStaTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station table" },
    { "hashTable",			0, printHashTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the hash table" },
    { "findSta",			1, findSta,				{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Find a station index <mac>" },
    { "insertSta",			1, insertSta,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Find and insert a station index <mac>" },
    { "removeSta",			1, removeSta,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Remove a station index <index>" },
    { "log",				1, mgmtLog		,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable Mgmt log <mode>" },
    { "reset",				0, mgmtReset		,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Reset Mgmt table" },
    { "showc",				0, mgmtShow,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Show parameters" },
    { "shows",			   0, wlanPrintParams,  {NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the WLAN configuration params" },
    { "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",         0, NULL,                {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						WPA sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleWpaCommandArray[] = {
	{ "show", 0, wpaShow,			{NO_PARAM}, "Show WPA configuration" },
	{ "staTable",			0, printStaTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station table" },
	{ "mode", 3, wpaWorkingMode,			{INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, NO_PARAM}, "Set allowed station types, 1 - On, 0 - Off <Legacy Stations> <EAP-TLS Stations> <WPA Stations>" },
	{ "pass", 1, wpaPassPhraseMode,			{INTEGER_PRM, NO_PARAM}, "Set the pass phrase mode (0 - None, 1 - HEX, 2 - ASCII)" },
	{ "hex", 8, wpaPskHex,			{UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM, UNSIGNED_INTEGER_PRM}, "Set PSK in HEX format, enter 8 numbers of 32 bits" },
	{ "pwd",            0, wpaPskPwd,               {NO_PARAM},    "Set PSK in ASCII format, maximum 63 characters"},  
	{ "cipher", 1, wpaDefaultCipher,			{INTEGER_PRM}, "Set default cipher, used only when EAP-TLS stations are allowed and Legacy stations are not allowed, (1 - WEP 40, 2 - WEP 104, 3 - WEP 232) " },
	{ "gtk", 1, wpaGTKInterval,			{INTEGER_PRM}, "Set Group key update interval, in seconds" },
	{ "secret",            0, wpaRadiusSecret,               {NO_PARAM},    "Set Radius Secret, maximum 63 characters"},  
	{ "port",            1, wpaRadiusPort,               {INTEGER_PRM},    "Set Radius Port <port>"},  
	{ "addr",            4, wpaRadiusAddr,               {INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM},    "Set Radius IP Address <addr 1> <addr 2> <addr 3> <addr 4>"},  
	{ "gateway",            4, wpaDefaultGateway,               {INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM},    "Set Default Gateway <addr 1> <addr 2> <addr 3> <addr 4>"},  
	{ "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",			0, NULL,                {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						WPA Test sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleWpaTstCommandArray[] = {
	{ "staTable",			0, printStaTable,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the station table" },
	{ "rsnTable",	0, stationsRsnIe,		{NO_PARAM}, "Print the station's RSN IE" },
	{ "insertSta",			1, insertSta,			{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Find and insert a station index <mac>" },
	{ "a1",					2, auth1,				{INTEGER_PRM,   SHORT_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Send an authentication#1 frame <SA> <AlgoNum>" },
	{ "assocStation",	4, assocStation,		{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   NO_PARAM}, "Send assoc from station <SA> <RNS IE (0, 1)> <RNS Ie Len> <RSN Ie Value>" },
	{ "reAssocStation",	4, reAssocStation,		{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   NO_PARAM}, "Send reAssoc from station <SA> <RNS IE (0, 1)> <RNS Ie Len> <RSN Ie Value>" },
	{ "auth",	1, macAuthorize,			{MAC_ADDR_PRM, NO_PARAM,   NO_PARAM,   NO_PARAM}, "Authorize a station <mac>" },
	{ "deauth",	1, macDeAuthorize,			{MAC_ADDR_PRM, NO_PARAM,   NO_PARAM,   NO_PARAM}, "De Authorize a station <mac>" },
	{ "show", 0, showWpaConfig,			{NO_PARAM}, "Show WPA configuration" },
	{ "mac", 1, isMacAuthorized,			{MAC_ADDR_PRM,   NO_PARAM}, "Is mac authorized in TX direction" },
	{ "suite", 2, setStationSuite,			{MAC_ADDR_PRM,   INTEGER_PRM, NO_PARAM}, "Set station suite <MAC> <0 - NONE, 1 - WEP, 2 - TKIP>" },
	{ "bcast", 1, setBcastSuite,			{INTEGER_PRM, NO_PARAM}, "Set broadcast suite <0 - NONE, 1 - WEP, 2 - TKIP>" },
	{ "vector", 0, testVectors,			{NO_PARAM}, "Run MICHAEL test vectors" },
	{ "setRxKey", 9, setRxMicKey,			{MAC_ADDR_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set Rx Mic key, <MAC> <key[1]> ....<key[8]>" },
	{ "setTxKey", 9, setTxMicKey,			{MAC_ADDR_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set Tx Mic key, <MAC> <key[1]> ....<key[8]>" },
	{ "micReportRx", 1, setMicReportInRx,			{INTEGER_PRM}, "Set Mic Failure report in the RX path, <1 - report, 0 - do not report>" },
	{ "micReportStation", 1, setMicReportFromStation,			{INTEGER_PRM}, "Set Mic Failure report from station, <1 - report, 0 - do not report>" },
	{ "genTxMicFailure",			1, generateTxMicFailure,			{MAC_ADDR_PRM}, "Generate a TX Mic failure for a station <mac>" },
	{ "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",			0, NULL,                {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						Privacy sub-menu								*/
/************************************************************************/
ConsoleCommand_T ConsolePrivacyCommandArray[] = {
	{ "showconfig",				0, privacyShowConfig,				{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print privacy configuration parameters" },
	{ "shownotify",				0, privacyShowNotify,	{NO_PARAM,   NO_PARAM}, "Show privacy notification information" },
	{ "showdefault",			0, privacyShowDefault,	{NO_PARAM,   NO_PARAM}, "Show WEP default keys" },
	{ "counters",			0, wlanPrintPrivacyCounters,  {NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the WLAN privacy counters " },
	{ "authalgo",				3, privacySetAuthAlgo,	{INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set authentication algorithm <index(0,1)> <algorithm(1-Open system, 2-Shared key)> <mode(1-Enable, 0-Disable)>" },
	{ "timeout",				1, privacySetAuthRspTimeout,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set authentication response timeout <1..4294967295>" },
	{ "option",					1, privacySetPrivacyOptionImplemented,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set privacy option <1-On,0-Off>" },
	{ "invoke",					1, privacySetPrivacyInvoked,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set privacy invoked <1-On,0-Off>" },
	{ "id",						1, privacySetPrivacyWEPDefaultKeyId,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set WEP default key ID <id (0..3)>" },
	{ "exclude",				1, privacySetPrivacyExclude,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set exclude unencrypted <1-On,0-Off>" },
	{ "def5",				6, privacySetDefaultKey5,	{INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set default key <index (0..3)> <key[1]> ..... <key[5]>" },
	{ "def13",				14, privacySetDefaultKey13,	{INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set default key <index (0..3)> <key[1]> ..... <key[13]>" },
	{ "def29",				30, privacySetDefaultKey29,	{INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set default key <index (0..3)> <key[1]> ..... <key[29]>" },
#if 0
	{ "showmapping",			0, privacyShowMapping,	{NO_PARAM,   NO_PARAM}, "Show WEP mapping keys" },
	{ "len",					1, privacySetPrivacyWEPKeyMappingLength,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set WEP key mapping length <len>" },
#endif
 	{ "map5",				8, privacySetMappingKey5,	{INTEGER_PRM,   MAC_ADDR_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM}, "Set WEP mapping key <index (0..9)> <mac addr> <1-On,0-Off> <key[1]> ...... <key[5]>" },
 	{ "map13",				16, privacySetMappingKey13,	{INTEGER_PRM,   MAC_ADDR_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set WEP mapping key <index (0..9)> <mac addr> <1-On,0-Off> <key[1]> ...... <key[13]>" },
 	{ "map29",				32, privacySetMappingKey29,	{INTEGER_PRM,   MAC_ADDR_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM,   INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM
															, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM}, "Set WEP mapping key <index (0..9)> <mac addr> <1-On,0-Off> <key[1]> ...... <key[29]>" },

	{ "bit",				1, privacySetPrivacyBitFlag,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM}, "Set privacy bit flag, when on, if the AP has privacy and the station does not have, don't associate the station. <1-On,0-Off>" },
	{ "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
  WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						Service Appilication sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleServiceAppCommandArray[] = {
    { "vhcf",			0, wlanSetVhcf,  			{NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set vHCF parameters"    },
	{ "Enable",			0, servEnable,				{NO_PARAM,	   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Service Enable" },
	{ "Disable",		0, servDisable,				{NO_PARAM,	   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Service Disable" },
    { "dualAP",	        1, wlanSetDualAp,           {INTEGER_PRM,  NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set Dual Ap status < 0= regular, Other = Dual>" },
    { "woneIndex",      1, wlanSetWoneConfIndex,    {INTEGER_PRM,  NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the Wone configuration Index" },
    { "macaddr",        1, wlanSetMacAddr,          {MAC_ADDR_PRM, NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the WLAN port MAC address <mac>" },
    { "rates",          2, wlanSetRates,            {INTEGER_PRM,  INTEGER_PRM}, "Set the 802.11b AP rates,  <Max basic rate> <Max supported rate>.\n The max supported rate must be higher or equal to the max basic rate.\n The available rates are: 1, 2, 5 (for 5.5), 11 & 22.\n" },
    { "grates",         0, wlanSetGRates,           {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the 802.11g AP rates used in Extended IE. For each rate enter :\n                 'Y'=Supported, 'B'=Basic Supported,\n                 'N'=Not supported, 'Enter'=unchanged" },
    { "addrates",       0, wlanSetAdditionalRates,  {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the additional 802.11g AP rates used in Legacy IE. For each rate enter :\n                 'Y'=Supported, 'B'=Basic Supported,\n                 'N'=Not supported, 'Enter'=unchanged" },
    { "respratemode",   1, wlanSetRespRateMode,     {INTEGER_PRM}, "Set the (re)Associate Response supported rates IE mode :\n                 0=All AP rates in D6.1 format, 1=Only AP rates supported by STA in STA format" },
    { "channel",        1, wlanSetChannel,          {INTEGER_PRM}, "Set the channel" },
    { "beacon",	        1, wlanSetBeacon,           {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the WLAN beacon period <1..65535>" },
    { "ssid",           0, wlanSSID,                {NO_PARAM},  "Set SSID"},  
    { "dtim",           1, wlanSetDtim,             {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the WLAN DTIM period <1..255>" },
    { "rts",            1, wlanSetRtsThreshold,     {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set RTS threhsold <0..2347>" },
    { "short",          1, wlanSetShoreRetryLimit,  {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the short retry limit <1..255>" },
    { "long",           1, wlanSetLongRetryLimit,   {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the long retry limit <1..255>" },
    { "fallback",       1, wlanSetRateFallback,     {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set rate fallback value" },
    { "adapt",          1, wlanSetRateAdaptation,   {SHORT_PRM,    NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set rate adaptation <0-Disable, 1-Enable>" },
    { "frag",           1, wlanSetFragmentationTreshold,    {SHORT_PRM,        NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the fragmentation threshold <256..2346>" },
    { "transmit",       1, wlanSetMaxTransmitMSDULifetime,  {INTEGER_PRM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the Max Transmit MSDU Lifetime <1..4294967295>" },
    { "receive",        1, wlanSetMaxReceiveLifetime,       {INTEGER_PRM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the Max Receive Lifetime <1..4294967295>" },
    { "show",           0, wlanPrintParams,         {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the WLAN configuration params" },
    { "printrates",	    0, wlanPrintRatesParams,    {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the Rates configuration params" },
    { "counters",       0, wlanPrintCounters,       {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the WLAN counters " },
    { "defaults",       0, wlanSetNvramDefaults,    {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "WARNING: FOR DEBUG USE ONLY!!! Restore nvram defaults" },
    { "reboot",         0, consoleReboot,           {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM}, "reboot the AP" },
    { "agile",          1, wlanSetAgile,            {INTEGER_PRM},  "Set agile attribute <1-On,0-Off>" },
    { "preamblemode",   1, wlanSetPreambleMode,     {SHORT_PRM},    "Set preamble mode :\n                 <0-Always Long, 1-Always Short, 2-Local STAs>" },
    { "dynalgotimeout", 1, wlanSetDynAlgoTimeout,   {INTEGER_PRM},  "Set Enhanced Dynamic Algorithms Timeout in [ms]" },
    { "pbccalgo",       1, wlanSetPBCCAlgorithmMode,{SHORT_PRM},    "Set PBCC algorithm Mode :\n		<0-Always off, 1-Always on, 2-Local STAs, 3-Dynamic, 4-Enhanced Dynamic>" },
    { "slotmode",       1, wlanSetSlotTimeMode,     {SHORT_PRM},    "Set Short Slot Time mode :\n                 <0-Always off, 1-Always on, 2-Local STAs, 3-Enhanced Dynamic>" },
    { "slotthreshold",  1, wlanSetSlotTimeThreshold,{SHORT_PRM},    "Set Short Slot Time threshold (# of B rate packets)" },
    { "protmode",       1, wlanSetERPProtectionMode,{SHORT_PRM},    "Set Protection Mode :\n                <0-Always off, 1-Always on, 2-Local STAs, 3-Dynamic, 4-Enhanced Dynamic>" },
    { "prottype",       1, wlanSetERPProtectionType,{SHORT_PRM},    "Set Protection Type <0-RTS/CTS, 1-CTS To Self, 2-TI proprietary>" },
    { "dot11mode",      1, wlanSetDot11Mode,        {SHORT_PRM},    "Set 802.11 Mode <0-Mixed mode, 1-802.11b only, 2-802.11b+, 3-802.11g only, 4-802.11a >" },
    { "CwMinMode",      1, wlanSetCWmin,            {SHORT_PRM},    "Set CwMin mode :\n  		 <0-(CwMin=31), 1-(CwMin=15), 2-(CwMin dot11mode dependent)> \n 	 	 Note that CwMin=15 in any mode when 4x is enabled" },
    { "caloption",      1, wlanSetRadioCalibrateOption,     {INTEGER_PRM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the radio calibration option" },
    { "calinterval",    1, wlanSetRadioCalibrateInterval,   {SHORT_PRM,        NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the radio calibration interval in [sec], 0-Disable" },
    { "usageTimeMode",  1, wlanSetUsageTimeMode,        {SHORT_PRM, NO_PARAM,    NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the band Usage Time type: 0 = short 1 = long" },
    { "setUsageTime",   1, wlanSetUsageTime,        {INTEGER_PRM, NO_PARAM,    NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the band Usage Time" },
    { "radioParams",    0, wlanRadioParams,         {NO_PARAM, NO_PARAM,    NO_PARAM,   NO_PARAM,   NO_PARAM}, "Edit Radio parameter table" },
    { "bssIsolation",   1, wlanSetBssIsolation,     {INTEGER_PRM}, "Set BSS Bridge isolation state <0-Disable, 1-Enable>" },	
    { "printBssIsolation",    0, wlanPrintBssIsolationState,         {NO_PARAM, NO_PARAM,    NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print BSS isolation state" },
    { "radarDetect",   1, wlanSetRadarDetect,     {SHORT_PRM}, "Set radar detect mode <0-Disable, 1-Enable>" },	
    { "printRadarDetect",    0, wlanPrintRadarDetect, {NO_PARAM, NO_PARAM,    NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print radar detect mode" },	
    { "apBridgeMode",   1, wlanSetApBridgeMode, {INTEGER_PRM}, "Set AP Bridge Mode <0-Disable, 1-Enable>" },	
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*					SSID SubAppilication sub-menu						*/
/************************************************************************/
ConsoleCommand_T ConsoleSsidAppCommandArray[] = {
    { "show",              0, wlanSsidPrintParams,           {NO_PARAM},  "Print the SSID params" },
    { "ssid",              0, wlanSSID,                      {NO_PARAM},  "Set SSID"},  
    { "hiddenssid",        1, wlanSetHiddenSSID,             {SHORT_PRM}, "Enable / Disable Hidden SSID mode" },
    { "multiplessid",      1, wlanSetMultipleSSID,           {SHORT_PRM}, "Enable / Disable Multiple SSID mode" },
    { "addssid",           0, wlanAddMultipleSsidElement,    {NO_PARAM},  "Add Multiple SSID element"},  
    { "removessid",        0, wlanRemoveMultipleSsidElement, {NO_PARAM},  "Remove Multiple SSID element from a list"}, 
    { "reboot",            0, consoleReboot,                 {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};


/************************************************************************/
/*					802.11 d & h SubAppilication sub-menu				*/
/************************************************************************/
ConsoleCommand_T Console_DH_AppCommandArray[] = {
    { "show",           0, wlan_dh_PrintParams,     {NO_PARAM},   "Show 802.11 d & h config params" },
    { "printreg",       0, wlan_dh_PrintRegDomain,  {NO_PARAM},   "Show Regulatory Domain information" },
    { "channel",        1, wlanSetChannel,          {INTEGER_PRM},"Set the channel" },
    { "multidomain",    1, wlanSetMultiDomain,      {SHORT_PRM},  "Enable - 1 and Disable - 0 multidomain capability (802.11d)" },  
#ifdef WLAN_801_11_H_IMPLEMENTED
    { "spectrummgmt",   1, wlanSetSpectrumMgmt,     {SHORT_PRM},  "Enable - 1 and Disable - 0 Apectrum Management Requirement (802.11h)" },
    { "legacystation",  1, wlanSetLegacyStation,    {SHORT_PRM},  "Enable - 1 and Disable - 0 Legacy equipment (802.11h)" },
#endif /* WLAN_801_11_H_IMPLEMENTED */
    { "powerconst",     1, wlanSetPowerConstraint,  {SHORT_PRM},  "Set power constraint (default = 0 dBm)" },  
    { "SetRegDomain",   0, wlanSetRegulatoryDomain, {NO_PARAM},   "Set Regulatory Domain from a list (default = FCC)" },  
    { "txpowerlevel",   1, wlanSetTxPowerLevel,     {SHORT_PRM},  "Set Max Tx Power Level <1..5>" }, 
    { "setpowerlevels", 6, wlanSetPowerLevel,       {INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, INTEGER_PRM},  "Set the 5 Tx power levels (dBm) per band (1st param, 0-G, 1-A)" }, 
    { "countrystring",  1, wlanSetCountryString,    {STRING_PRM}, "Set dot11CountryString (2 bytes)" }, 
    { "reboot",         0, consoleReboot,           {NO_PARAM,     NO_PARAM,   NO_PARAM,   NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};


/************************************************************************/
/*						Show sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleShowCommandArray[] = {
    { "bssbridge",          0, showBssBridge,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Bss Bridge Statistics" },
    { "powersave",          0, showPowerSave,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Power Save Status" },
    { "txstat"   ,          0, showPrintTxStat,	    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Tx Statistics" },
    { "mibwlan"  ,          0, showMibWlan,	        {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print WLAN MIB2 counters" },
    { "lanstat"  ,          0, showLanStat,	        {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print EMAC MIB2 counters" },
    { "lanpool"  ,          0, showLanPool,	        {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print EMAC buffer pool" },
    { "memmngrstat"  ,      0, showMemMngrStat,	    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Memory Manager statistics" },
    { "rateadapt"  ,        0, showRateAdaptation,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Rate Adaptation status" },  
    WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*					     4x sub-menu									*/                                                   
/************************************************************************/
ConsoleCommand_T Console4xCommandArray[] = {
	{ "show",				0, show4xParams,		{NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Show the 4x params" },
	{ "concatsize",			1, set4xMaxConcatSize,  {INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set the max concatenation size (1522-4095)" },    
	{ "set",			3, set4x		,			{INTEGER_PRM,   INTEGER_PRM,INTEGER_PRM,NO_PARAM}, "Enable/Disable 4x Feature, \n <4x Enable(1-On, 0-Off)> <Concatenation(1,0)> <Ack Emulation(1,0)> \n" },
	{ "mixmode",	    1, wlanSet4xMixMode ,		{SHORT_PRM,     NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable 4x with cck" },
    { "bursting",			1, setPacketBursting	,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable Packet bursting <mode(1-On, 0-Off)>" },
    { "dbg",			1, setConcatDebug		,	{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Enable/Disable concat debug <mode(1-On, 0-Off)>" },
	{ "table",			0, fourXTable,				{INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Displays four X table" },
	{ "featureset",     1, set4xFeatureSet,     {SHORT_PRM}, "4x FeatureSet (0/1)" }, 
	{ "burstLimit",     1, setBurstLimit,           {INTEGER_PRM}, "Set Packet burst time limit in MicroSec" },   
	{ "reboot",         0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
    WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",     0, NULL,                    {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};


/************************************************************************/
/*						Hal sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleHalCommandArray[] = {
	{ "fwVersion",			0, whalMenu_printFwVersion,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the firmware version" },
	{ "acxParams",			0, whalMenu_printAcxParams,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Acx100 nvram parameters" },
	{ "txinfo",				2, whalMenu_printTxInfo,		{INTEGER_PRM,INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Tx Info <Qid=0,1 EnableQprint = 0-FALSE/1-TRUE> (queues and buffers)" },
	{ "rxinfo",				0, whalMenu_printRxInfo,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Rx Info (queues and buffers)" },
	{ "txqueue",			1, whalMenu_printTxQueue,		{INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Tx queue <Qid=0,1> status" },
	{ "txIndicator",		0, whalMenu_printTxIndicator,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Tx Indicator" },
	{ "rxqueue",			1, whalMenu_printRxQueue,		{INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Rx queue <Qid=0> status" },
	{ "txbufs",				0, whalMenu_printTxBufs,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Tx buffers status" },
#if 0
	{ "rxbufs",				0, whalMenu_printRxBufs,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Rx buffers status" },
#endif
	{ "intr",				0, whalMenu_printIntr,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Interrupt object status" },
	{ "mbox",				0, whalMenu_printMbox,			{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print mailbox object status" },
	{ "acxstat",			0, whalMenu_printAcxStat,		{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Acx100 statistics" },
	{ "restartstat",		0, whalMenu_printRestartStat,	{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print restart statistics" },
	{ "restartenable",		1, whalMenu_EnableRestartWA,	{SHORT_PRM}, "Enable FW Watchdog WA <1-enable 0-disable>" },
    { "waoptions",			6, whalMenu_setWAoptions,		{SHORT_PRM, SHORT_PRM, SHORT_PRM, SHORT_PRM,SHORT_PRM, SHORT_PRM}, "Set WA options\n  Rx Free Mem (0-disable,1-enable)"
        " Beacon stuck(0-disable, N-trigger time[sec])\n    Tx Acx free (0-disable, N-trigger time[sec])\n  Rx Cons FCS (0-disable, N-trigger time[sec])\n"
		"    ACI (0-disable, 1-enable), NB (0-disable, 1-enable) "},
	{ "aciRateThreshold" ,  1, whalMenu_setAciRateThresh,  		{INTEGER_PRM}, "Set ACI Rate threshold"}, 	
	{ "aciEventThreshold" , 1, whalMenu_setAciEventThresh,  		{INTEGER_PRM}, "Set number of ACI events which triggers ACI state"}, 	
	{ "aciStateTimeout",	1, whalMenu_setAciTimeout,      {INTEGER_PRM}, "Set ACI Work Around timeout (in seconds)"},
	{ "nbStateTimeout",		1, whalMenu_setNbTimeout,       {INTEGER_PRM}, "Set NB Work Around timeout (in seconds)"},
	{ "pdThresh",			2, whalMenu_setPdThresh,        {INTEGER_PRM, INTEGER_PRM }, "Set packet detection thresholds: <low thresh> <high thresh>"},
	{ "mediumBusyThresh" ,    1, whalMenu_setBusyMediumThresh, 	{INTEGER_PRM}, "Set busy medium threshold in percents "}, 	 
	{ "showACIparams",		0, whalMenu_showACIparams,		{NO_PARAM}, "Show ACI and NB work around configuration"},
	{ "energydetectEn", 	1, whalMenu_EnableEnergyDetect, {SHORT_PRM}, "Enable Energy Detect <1-enable 0-disable>" },
	{ "energydetectSh", 	0, whalMenu_EnergyDetectShow, {SHORT_PRM}, "Displays energy detect status " },
	{ "vlynqerrorscnt",     0, whalMenu_VlynqErrorsCnt, {SHORT_PRM}, "Dispalys number of vlynq errors occurred "},
	{ "gpio_owner",		1, whalMenu_gpio_owner,	{SHORT_PRM}, "set gpio ownership <1-driver 0-fw 2-show>" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",			0, NULL,							{NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*						Hal Diag sub-menu									*/
/************************************************************************/
ConsoleCommand_T ConsoleHalDiagCommandArray[] = {
	{ "eed",			      0, whalMenu_eed,        	   {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Serial EEPROM dump" },
	{ "eer",			      1, whalMenu_eer,	            {INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Serial EEPROM read <addr>" },
	{ "eew",			      2, whalMenu_eew,	            {INTEGER_PRM,INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM}, "Serial EEPROM write <addr> <value>" },
	{ "SetTxCompleteTrsh",   1, whalMenu_SetTxCompleteTrsh, {INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Set Tx Complete Threshold (Val)" },
	{ "SetPsMode",			1, whalMenu_SetBssPs ,		{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "SetPsMode(Val) - Set Ps mode (0, 1)" },
	{ "PrintRegs",			0, whalMenu_PrintRegs ,		{NO_PARAM,		NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print low level registers" },
	{ "PhyRegWrite",		2, whalMenu_PhyRegWrite ,	{INTEGER_PRM,	INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM}, "PhyRegWrite(Addr, Val) - Write Phy register" },
	{ "PhyRegRead",			1, whalMenu_PhyRegRead ,	{INTEGER_PRM,	NO_PARAM,	NO_PARAM,   NO_PARAM,   NO_PARAM}, "PhyRegRead(Addr)       - Read  Phy register" },
	{ "MacRegWrite",		2, whalMenu_MacRegWrite ,	{INTEGER_PRM,	INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM}, "MacRegWrite(Addr, Val) - Write Mac register" },
	{ "MacRegRead",			1, whalMenu_MacRegRead ,	{INTEGER_PRM,	NO_PARAM,	NO_PARAM,   NO_PARAM,   NO_PARAM}, "MacRegRead(Addr)       - Read  Mac register" },
	{ "SetRxPromiscuous",	1, whalMenu_RxPromiscuous ,	{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "SetRxPromiscuous(Val)  - Set Promiscuous mode (0, 1)" },
	{ "ModeSniffer",		1, whalMenu_ModeSniffer ,	{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "ModeSniffer(Val)	   - Set Mode Sniffer (0, 1)" },
	{ "PrintFwVersions",	0, whalMenu_PrintFwVersions,{NO_PARAM,		NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Fw versions" },
	{ "SelectFwNumber",		1, whalMenu_SelectFwNumber,	{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "SelectFwNumber(Val)   - 0 or 1 (local), 2 (remote)" },
	{ "SetQueueSizeType",	1, whalMenu_SetQueueSizeType,{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "SetQueueSizeType(Val)  - Type = 0(more queues) or 1" },
	{ "PrintRadioVer",		0, whalMenu_PrintRadioVersions,{NO_PARAM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print Radio versions" },
	{ "SelectRadioNum",		1, whalMenu_SelectRadioNumber,{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "SelectRadioNumber(Val)   - 0 or 1 (local), 2 (remote)" },
	{ "SetNvByte",			2, whalMenu_SetNvByte ,		{INTEGER_PRM,	INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM}, "SetNvByte(Addr, Val)   - Set hal nvram byte" },
	{ "TraceEnable",		1, whalMenu_TraceEnable ,	{INTEGER_PRM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "TraceEnable(Val)       - Enable tracer (0, 1)" },
	{ "TracePrint",			2, whalMenu_TracePrint ,	{INTEGER_PRM,	INTEGER_PRM,NO_PARAM,   NO_PARAM,   NO_PARAM}, "TracePrint(Num, From)  - Print trace info" },
	{ "TraceRxStat",        0, whalMenu_TracePrintRxStat, {NO_PARAM,	NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Print the tracer Rx statistics" }, 
	{ "DownloadFW",			4,  whalMenu_DownloadFW ,	{INTEGER_PRM,	INTEGER_PRM, INTEGER_PRM, INTEGER_PRM, NO_PARAM}, "UploadFW <ip1> <ip2> <ip3> <ip4>  - Upload FW through TFTP (assumes file name is FW.bin" },
	{ "dm",            4,  whalMenu_DM, {STRING_PRM, INTEGER_PRM, INTEGER_PRM,   INTEGER_PRM,   NO_PARAM}, "dm <base addr> <offset> <size in bytes> <step: 1 - bytes, 2 - words> - ACX memory dump "},
    WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",			0, NULL,                {NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM,   NO_PARAM}, "Undefined" },
};

/************************************************************************/
/*                   Production sub-menu                                */
/************************************************************************/

#ifdef VXWORKS

ConsoleCommand_T consoleProductionCommandArray[] =
{
   { "reboot",   0, consoleReboot,        {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,NO_PARAM},"reboot the AP"}, 
   { "dir",      0, consoleDir,           {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "dir            - List available modem software versions"         },
   { "erase",    1, consoleErase,         {INTEGER_PRM,  NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "erase <sec #>  - Erase sector <sec#> from Flash"                 },
   { "dl",       3, consoleDl,            {INTEGER_PRM,  IP_ADDR_PRM,   STRING_PRM,    NO_PARAM,     NO_PARAM}, "dl <sec#> <srvIP> <name> - Downld <name> from <srvIP> to <sec>"  },
   { "setdef",   1, consoleSetDef,        {INTEGER_PRM,  NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "setdef <sec#>  - Set <sec#> as default modem software"           },
   { "prodshow", 0, consoleProdShow,      {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "prodshow       - Show production params"                         },
   { "prodset",  0, consoleProdSet,       {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "prodset        - Set production params"                          },
   { "proddef",  0, consoleProdDef,       {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "proddef        - Set production default params"                  },
   { "password", 0, consolePassword,      {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "password <pwrd>- Set production menu password"                   },
#if 0
   { "prodmib",  1, consoleProdMib,       {INTEGER_PRM,  NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "prodmib <level>- Set production MIB access level"                },
#endif
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,               {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "Undefined"                                                       }
};

#endif /* VXWORKS */

/************************************************************************/
/*          Build-in test sub-menu                                      */
/************************************************************************/
#ifdef INCLUDE_TESTAPP
ConsoleCommand_T consoleTestAppCommandArray[] =
{
   { "reboot",   0, consoleReboot,        {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"reboot the AP"                          },
   { "macr",     1, tstReadMacReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 MAC register"              },
   { "macw",     1, tstWriteMacReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 MAC register"            },
   { "pr",       1, tstReadPhyReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 PHY register"              },
   { "pw",       1, tstWritePhyReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 PHY register"            },
   { "phyregs",  0, tstDumpPHYRegs,       {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},   "Dump PHY registers"                     },  
   { "mr",       1, tstReadMem,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 memory"                    },
   { "mw",       1, tstWriteMem,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 memory location"         },
   { "eer",      1, tstReadEEPROM,        {INTEGER_PRM,  NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read from ACX100 EEPROM location"       },
   { "eew",      2, tstWriteEEPROM,       {INTEGER_PRM,  INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM},"Update ACX100 EEPROM location"          },
   { "agc",      1, tstReadWriteAGC,      {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read AGC table location"                },
   { "init",     1, tstInit,              {INTEGER_PRM,  NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"0=reboot_all 1=init_ACX 2=init_radio"   },
   { "status",   0, tstStatus,            {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Show current settings"                     },  
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,               {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "Undefined"                        }
};

ConsoleCommand_T consoleBringUpCommandArray[] =
{
   { "macr",     1, tstReadMacReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 MAC register"              },
   { "macw",     1, tstWriteMacReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 MAC register"            },
   { "pr",       1, tstReadPhyReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 PHY register"              },
   { "pw",       1, tstWritePhyReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 PHY register"            },
   { "phyregs",  0, tstDumpPHYRegs,       {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},   "Dump PHY registers"                  },  
   { "mr",       1, tstReadMem,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 memory"                    },
   { "mw",       1, tstWriteMem,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 memory location"         },
   { "eedump",   0, tstDumpEEPROM,        {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Dump ACX100 EEPROM"                     },
   { "eer",      1, tstReadEEPROM,        {INTEGER_PRM,  NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read from ACX100 EEPROM location"       },
   { "eew",      2, tstWriteEEPROM,       {INTEGER_PRM,  INTEGER_PRM,   NO_PARAM,   NO_PARAM,   NO_PARAM},"Update ACX100 EEPROM location"          },
   { "eeprog",   1, tstProgEEPROM,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,	NO_PARAM,   NO_PARAM},"eeprog <srvIP> <filename>"              },
   { "agc",      1, tstReadWriteAGC,      {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read AGC table location"                },
   { "init",     1, tstInit,              {INTEGER_PRM,  NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"0=reboot_all 1=init_ACX 2=init_radio"   },
   { "status",   0, tstStatus,            {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Show current settings"                     },  
   { "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,               {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "Undefined"                                                       }
};

ConsoleCommand_T consoleBringUpTxCommandArray[] = 
{
   { "macr",     1, tstReadMacReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 MAC register"              },
   { "macw",     1, tstWriteMacReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 MAC register"            },
   { "pr",       1, tstReadPhyReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 PHY register"              },
   { "pw",       1, tstWritePhyReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 PHY register"            },
   { "phyregs",  0, tstDumpPHYRegs,       {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},   "Dump PHY registers"                     },  
   { "channel",  1, tstChannel,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Select radio channel (1..14)"},
   { "status",   0, tstStatus,            {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Show current settings"                           },  
   { "enable",   1, tstTxEnable,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Enable TX path 1=enable 0=disable"         },   
   { "antenna",  1, tstSelectTxAntenna,   {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set Transmit antenna 1=antenna1 2=antenna2"},
   { "rate",     1, tstSelectTxRate,      {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set TX data rate in Mbps (1,2,5.5,11,22)"  }, 
   { "mod",      1, tstSelectTxModulation,{ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set TX modulation 0=CCK 1=PBCC"},
   { "carrier",  1, tstCarrierTx,         {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Enable TX carrier only mode 1=enable 0=disable"},
   { "pmble",    1, tstPreamble,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set preamble type 0=short 1=long"},
   { "length",   1, tstMPDULen,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set MPDU length"                           },
   { "power",    1, tstPower,             {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set TX power 0..63"                        },   
   { "pa"   ,    1, tstPAEnable,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set PA mode: 0=disable 1=enable 2=auto"    },   
   { "osc",      1, tstSetOscCalValue,    {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set/Get oscillator calibration (0-15)"     },     
   { "bias",     1, tstSetBias,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set/Get PA bias (0..15)"                   },     
   { "dpattern", 1, tstDataPattern,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Data pattern: 0 = PRBS, 1 = 010101"        },     
   { "scramb",   1, tstScramb,            {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Enable TX scrambler 0=disable 1=enable"    },  
   { "tx",       1, tstTX,                {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Start TX bursts c=cont.mode; 0=stop"       },   
	{ "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,               {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "Undefined"                                                       }
};

ConsoleCommand_T consoleBringUpRxCommandArray[] = 
{
   { "macr",     1, tstReadMacReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 MAC register"              },
   { "macw",     1, tstWriteMacReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 MAC register"            },
   { "pr",       1, tstReadPhyReg,        {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Read  ACX100 PHY register"              },
   { "pw",       1, tstWritePhyReg,       {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,   NO_PARAM},"Update  ACX100 PHY register"            },
   { "phyregs",  0, tstDumpPHYRegs,       {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},   "Dump PHY registers"                     },  
   { "channel",  1, tstChannel,           {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Select radio channel (1..14)"              },
   { "status",   0, tstStatus,            {NO_PARAM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Show current settings"                           },  
   { "enable" ,  1, tstRxEnable,          {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Enable RX path 1=enable 0=disable"         },   
   { "per",      1, tstPER,               {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Collect Packet Error Rate Statistics for <sec>"  },   
   { "diversity",1, tstSetAntDiversity,   {ARGS_PRM,     NO_PARAM,      NO_PARAM,   NO_PARAM,NO_PARAM},"Set Diversity 1=ant1 2=ant2 3=full 4=partial"    },
	{ "reboot",      0, consoleReboot,        {NO_PARAM,      NO_PARAM,     NO_PARAM,     NO_PARAM}, "reboot the AP" },
   WAPP_UTILS_CONSOLE_SUB_MENU_ARRAY_POSTFIX,
   { "nullcommand",0, NULL,               {NO_PARAM,     NO_PARAM,      NO_PARAM,      NO_PARAM,     NO_PARAM}, "Undefined"                        }
};

#endif /* INCLUDE_TESTAPP */

/**************************************************************************/
/* BIT sub-menu command definition                                        */
/**************************************************************************/
void BITCB(ConsoleParameter_T parameters[]){
   puts("BIT submenu");
}

/**************************************************************************/
/* Mgmt sub-menu command definition                                       */
/**************************************************************************/
void MgmtCB(ConsoleParameter_T parameters[]){
   printf("Mgmt submenu\n");
}

/**************************************************************************/
/* Mgmt Test sub-menu command definition                                  */
/**************************************************************************/
void MgmtTstCB(ConsoleParameter_T parameters[]){
   printf("Mgmt Test submenu\n");
}

/**************************************************************************/
/* WPA sub-menu command definition                                       */
/**************************************************************************/
void WpaCB(ConsoleParameter_T parameters[]){
   printf("WPA submenu\n");
}

/**************************************************************************/
/* Wpa Test sub-menu command definition                                  */
/**************************************************************************/
void WpaTstCB(ConsoleParameter_T parameters[]){
   printf("WPA Test submenu\n");
}

/**************************************************************************/
/* Privacy sub-menu command definition                                    */
/**************************************************************************/
void PrivacyCB(ConsoleParameter_T parameters[]){
   printf("Privacy submenu\n");
}

/**************************************************************************/
/* Service App sub-menu command definition                                */
/**************************************************************************/
void ServCB(ConsoleParameter_T parameters[]){
   printf("Service Application submenu\n");
}

/**************************************************************************/
/* Service App sub-menu command definition                                */
/**************************************************************************/
void ShowCB(ConsoleParameter_T parameters[]){
   printf("Show submenu\n");
}

/**************************************************************************/
/* Service App sub-menu command definition                                */
/**************************************************************************/
void x4CB(ConsoleParameter_T parameters[]){
   printf("4x submenu\n");
}


/**************************************************************************/
/* Hal sub-menu command definition                                        */
/**************************************************************************/
void HalCB(ConsoleParameter_T parameters[]){
   printf("Hal submenu\n");
}

/**************************************************************************/
/* Hal Diagnosticsub-menu command definition                              */
/**************************************************************************/
void HalDiagCB(ConsoleParameter_T parameters[]){
   printf("Hal Diagnostic submenu\n");
}

/**************************************************************************/
/* Production sub-menu command definition                                 */
/**************************************************************************/
void ProdCB(ConsoleParameter_T parameters[])
{/*
   UINT8 pbPassword[HW_PROD_PASSWORD_LEN];
   whal_nvram_getConsolePassword(pbPassword);
   if(strncmp(pbPassword,parameters[0].STRING,HW_PROD_PASSWORD_LEN) != 0)
   {
      puts("Invalid password");
      consoleQuit(parameters);
      return;
   }
   consoleHelp(parameters);*/
}
/**************************************************************************/
/* Security sub-menu command definition										  */
/**************************************************************************/
void SecurityCB(ConsoleParameter_T parameters[]){
   printf("Security submenu\n");
}

/**************************************************************************/
/* Security Test sub-menu command definition                                       */
/**************************************************************************/
void SecTstCB(ConsoleParameter_T parameters[]){
   printf("Security Test submenu\n");
}

/**************************************************************************/
/* Build-in test sub-menues command definition                              */
/**************************************************************************/
#ifdef INCLUDE_TESTAPP
void TestAppCB(ConsoleParameter_T parameters[])
{
   printf("Test application submenu\n");
}

void BringUpCB(ConsoleParameter_T parameters[])
{
   /*UINT8 pbPassword[HW_PROD_PASSWORD_LEN];
   
   whal_nvram_getConsolePassword(pbPassword);

   if(strncmp(pbPassword,parameters[0].STRING,HW_PROD_PASSWORD_LEN) != 0)
   {
      puts("Invalid password");
      consoleQuit(parameters);
      return;
   }
   // Stop WLAN tasks to enable bring-up tests 
   tstInitBringUpMode();
   printf("Bring up submenu\n");*/
}

void BringUpTxCB(ConsoleParameter_T parameters[])
{
   puts("TA/bringup/tx submenu");
}

#endif   /* INCLUDE_TESTAPP */

/*************************************************************************/
/*                     commmand functions                                */
/*************************************************************************/

/************************************************************************/
/*						Root menu functions								            */
/************************************************************************/
/***************************************************************************/
/* prints the MAC address of the device                                    */
/***************************************************************************/
void consoleMac(ConsoleParameter_T parameters[]) {
   /* number of parameters = 0  */
   /*unsigned char *mac;
   unsigned char prnBuffer[WAPP_UTILS_MAX_LINE_LENGTH];

   mac = (unsigned char*)&MAC_address;
   sprintf(prnBuffer,"CM MAC address is %02hhX-%02hhX-%02hhX-%02hhX-%02hhX-%02hhX",
            mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
   printf("%s\n",prnBuffer);
   wapp_utilsSetDevConsoleStatus(prnBuffer);
   */
}

/***************************************************************************/
/* sets the report level of the device                                     */
/***************************************************************************/
void consoleReportLevel(ConsoleParameter_T parameters[]) {
   /* number of parameters = 1    */
   /* display resulting value     */
   
/*
   WDRV_UTILS_REPORT_LEVEL value;
   int level,l;
   unsigned char prnBuffer[WAPP_UTILS_MAX_LINE_LENGTH], prn_parm[10];

   strcpy(prnBuffer,"");
   level = parameters[0].INTEGER;
   if (level > 0) 
	{ // set level 
		if (level == 27) 
		{ // set all 
			value = wdrv_utilsGetReportValue();
         wdrv_utilsSetReportValue(value | 0x07ffffff);
      } 
		else 
         wdrv_utilsSetReportLevel((WDRV_UTILS_REPORT_LEVEL)(level));

   } 
	
	else if (level < 0) 
	{
      if (level == -27) 
		{ // clear all 
         value = wdrv_utilsGetReportValue();
         wdrv_utilsSetReportValue(value & 0xf0000000);
      } 
		else 
		{
         level = -level;
         wdrv_utilsClearReportLevel((WDRV_UTILS_REPORT_LEVEL)(level));
      }
   }

   value = wdrv_utilsGetReportValue();


   value &= 0x0fffffff;

   strcat(prnBuffer,"Report levels ON: ");
   for (l=0;value;l++) 
	{
      if (value & 1) 
		{
         sprintf(prn_parm," %d",l);
         strcat(prnBuffer,prn_parm);
      }
      value >>= 1;
   }
   strcat(prnBuffer,"\n");

   if (level == 0) 
	{
      // display detailed list 
       strcat(prnBuffer," 1 ROOT\n");
       strcat(prnBuffer," 2 TEST\n");
       strcat(prnBuffer," 3 TCB\n");
       strcat(prnBuffer," 4 IDLE\n");
       strcat(prnBuffer," 5 DB\n");
       strcat(prnBuffer," 6 MAINSM\n");
       strcat(prnBuffer," 7 MGMT\n");
       strcat(prnBuffer," 8 HAL\n");
       strcat(prnBuffer," 9 TX\n");
       strcat(prnBuffer," 10 SM\n");
       strcat(prnBuffer," 11 RX\n");
       strcat(prnBuffer," 12 RX Sniffer\n");
       strcat(prnBuffer," 13 TX Sniffer\n");
       strcat(prnBuffer," 14 Bridge\n");
       strcat(prnBuffer," 15 WPA\n");
       strcat(prnBuffer," 16 HTTP\n");
       strcat(prnBuffer," 17 4X\n");
   }

   printf("%s\n",prnBuffer);
   wapp_utilsSetDevConsoleStatus(prnBuffer);
   */

	   unsigned char prnBuffer[MAX_LINE_LEN], mode_str[MAX_LINE_LEN], prn_parm[10];
	   int level,l, value;


	   strcpy(prnBuffer,"");
	   level = parameters[0].INTEGER;
	   if (level > 0) 
		{ /* set level */ 
		 
			if (level == MAX_REPLEV) { /* set all */
				
				for(l=1; l<MAX_REPLEV - 1; l++) 
				{
					/* the storage is not updated because of performance reasons*/
					if(tiap_wcfg_set_basic(wd, TIAP_PARAM_REPLEV, &l, !UPDATE_STORAGE)) {
						PRINT_CONFIG_ERR_MSG("Failed to set report level.\n");
						return;
					}
				}

				/* update the storage only in the last ioctl call */
				if(tiap_wcfg_set_basic(wd, TIAP_PARAM_REPLEV, &l, UPDATE_STORAGE)) {
						PRINT_CONFIG_ERR_MSG("Failed to set report level.\n");
						return;
				}

			} 
			else {
				 if(tiap_wcfg_set_basic(wd, TIAP_PARAM_REPLEV, &level, UPDATE_STORAGE)) {
					PRINT_CONFIG_ERR_MSG("Failed to set report level.\n");
					return;
				 }
			}

	   } 
		
	   else if (level < 0) 
		{
			if (level == MIN_REPLEV) { /* clear all */ 
				l = 0;
				if(tiap_wcfg_set_basic(wd, TIAP_PARAM_REPLEV, &l, UPDATE_STORAGE)) {
					PRINT_CONFIG_ERR_MSG("Failed to set report level.\n");
					return;
				 }
			} 
			else {
				if(tiap_wcfg_set_basic(wd, TIAP_PARAM_REPLEV, &level, UPDATE_STORAGE)) {
					PRINT_CONFIG_ERR_MSG("Failed to set report level.\n");
					return;
				}
			}
		}

	   if(tiap_wcfg_get_basic(wd, TIAP_PARAM_REPLEV, &value, !FROM_STORAGE)) {
		PRINT_CONFIG_ERR_MSG("Failed to get report level.\n");
		return;
	   }

	   value &= 0x0fffffff;

	   sprintf(mode_str, "Report mode: %s  ", (reportMode == IMMEDIATE ? "IMMEDIATE": "DEFERRED"));
	   strcat(prnBuffer, mode_str);
	   strcat(prnBuffer,"Report levels ON: ");
	   for (l=0;value;l++) 
	   {
	      if (value & 1) 
	      {
		 sprintf(prn_parm," %d",l);
		 strcat(prnBuffer,prn_parm);
	      }
	      value >>= 1;
	   }
	   strcat(prnBuffer,"\n");

	   if (level == 0) 
	{
	      // display detailed list 
	       strcat(prnBuffer," 1 ROOT\n");
	       strcat(prnBuffer," 2 TEST\n");
	       strcat(prnBuffer," 3 TCB\n");
	       strcat(prnBuffer," 4 IDLE\n");
	       strcat(prnBuffer," 5 DB\n");
	       strcat(prnBuffer," 6 MAINSM\n");
	       strcat(prnBuffer," 7 MGMT\n");
	       strcat(prnBuffer," 8 HAL\n");
	       strcat(prnBuffer," 9 TX\n");
	       strcat(prnBuffer," 10 SM\n");
	       strcat(prnBuffer," 11 RX\n");
	       strcat(prnBuffer," 12 RX Sniffer\n");
	       strcat(prnBuffer," 13 TX Sniffer\n");
	       strcat(prnBuffer," 14 Bridge\n");
	       strcat(prnBuffer," 15 WPA\n");
	       strcat(prnBuffer," 16 HTTP\n");
	       strcat(prnBuffer," 17 4X\n");
	       strcat(prnBuffer," 18 MEM\n");
	       strcat(prnBuffer," 19 DYNAMIC_ALG\n");
	       
	   }

	   printf("%s\n",prnBuffer);
}

void consoleReportMode(ConsoleParameter_T parameters[])
{
	int mode, idummy = 0, not_read;
	char dummy, buf[LOG_BUF_LEN];

	mode = parameters[0].INTEGER;

	if (mode != 0 && mode != 1) {
		printf("Wrong value\n");
		return;
	}

	reportMode = mode;
	
	if (reportMode == DEFERRED) {
		printf("Report mode was set to Deferred\n");

	    if (klogctl(6,  &dummy, idummy) < 0 ) /* disable printk's to console */
				   perror("Failed to disable printk to console\n");
			   
			   /* clear the kernel log buffer before starting the console */
			
			   if ( (not_read = klogctl(9, 0, 0)) ){ /* poll the log buffer */ 

					if( klogctl(2, buf, not_read) < 0 ) /* read and clear the buffer*/
						perror("Failed to clear kernel message buffer\n");
			   }
	}
	else {
		printf("Report mode was set to Immediate\n");
		if (klogctl(7,  &dummy, idummy) < 0 ) /* enable printk's to console */
				perror("Failed to enable printk to console\n");
	}
	return;
	
}

void consoleReboot(ConsoleParameter_T parameters[]) {
/*
	whal_apiAcxReset();
#ifdef VXWORKS
	cm_hwReset(); // nothing else matters... 
#else
	//	puts("Console can not reboot the system, reboot or reload the driver using other utilities"); 
	tiwlan_user_cleanup(0);
	
#endif
	  */
	
#if 0
	if ( !(wd = tiap_wcfg_restart(wd)) )
		exit(1);
#else
	tiap_wcfg_system_reboot();
#endif
}

void consoleVersion(ConsoleParameter_T parameters[])
{ /*
   unsigned char prn_buffer[81], *buf;

   buf = prn_buffer;
   cm_hwFormatBootInfo1(buf, 80);

   //print the version information of application, boot loader and FW. 
   printf("CPU type = %s\nBoard type = %s\n", GetCpuName(), GetBoardName());
   
 
#ifdef DEBUG_OPTION
   printf("APDK version %d.%d.%d.%d - Debug, Date: %s\n",
      SW_VERSION_MAJOR,SW_VERSION_MINOR,SW_RELEASE_MAJOR,SW_RELEASE_MINOR,__DATE__);
#else     
   printf("APDK version %d.%d.%d.%d, Date: %s\n",
      SW_VERSION_MAJOR,SW_VERSION_MINOR,SW_RELEASE_MAJOR,SW_RELEASE_MINOR,__DATE__);
#endif   
   whal_apiPrintFwVersion();
   puts(buf);*/


	int len;
	char buf[4096];

	if( (len = dda_read_proc_entry(WLAN_PROC_PROD_DIR_NAME,
                                        WLAN_PROC_PROD_VERSION, buf, sizeof(buf))) == -1 ) {
	
                PRINT_PROC_READ_ERR(WLAN_PROC_PROD_DIR_NAME, WLAN_PROC_PROD_VERSION);
				return;
	}
	
	buf[len] = '\0';
	printf("APDK version: %s\n", buf); fflush(NULL);
	whalMenu_printFwVersion(parameters);


}


/************************************************************/
/*                  BIT sub-menu  functions                 */
/************************************************************/

/* Following are some auxiliary routines to serve the BIT command routines */

BOOL IsChannelInsideBandRange(int band, int chID)
{
	/*
	BOOL found = FALSE;
	int ch;

	if (band == RADIO_BAND_2_4GHZ)
	{
		if ((chID < 1) || (chID > 14))
			return FALSE;
		return TRUE;
	}
	else
	{
		if ((chID < 36) || (chID > 161))
			return FALSE;
		// channel is inside the range, let's verify its value 
		for (ch=36; ch<=64;ch++)
			if (ch == chID)
			{
				found=TRUE;
				break;
			}
		if (!found)
			for (ch=100; ch<=140;ch++)
				if (ch == chID)
				{
					found=TRUE;
					break;
				}
		if (!found)
			for (ch=149; ch<=161;ch++)
				if (ch == chID)
				{
					found=TRUE;
					break;
				}
	}
	return found;
	*/
	return 1;
}

int ShowAndReturnBand(void)
{
	
	UINT8 boardType = 2;
	int band, len;
	char tmpBuffer[100];
	char buf[4096];

	if( (len = dda_read_proc_entry(WLAN_PROC_SERV_DIR_NAME,
                                        WLAN_PROC_SERV_RADIO_FREQ, buf, sizeof(buf))) == -1 )
                PRINT_PROC_READ_ERR(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RADIO_FREQ);

	sscanf(buf, "%hhu", &boardType);

	printf("Available Bands:\n");
	printf("----------------\n");
	printf("1. Band 'G' (2.4GHz)\n");
	if (boardType == TIAP_PARAM_RADIO_BAND_2_4_AND_5GHZ)
	{
		printf("2. Band 'A' (5GHz)\n");
	}
	printf("\nPlease enter the selected band:");

	fgets(tmpBuffer, 100, stdin);
	tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    band = atoi(tmpBuffer);
    if(band <= 0)
        return (-1);
	if (band > 2)
	{
		printf("Band out of range!\n");
        return (-1);
	}
	if (band == 1)
		band = TIAP_PARAM_RADIO_BAND_2_4GHZ;
	else
	{
		if (boardType != TIAP_PARAM_RADIO_BAND_2_4_AND_5GHZ)
		{
			printf("Band out of range!\n");
			return (-1);
		}
		band = TIAP_PARAM_RADIO_BAND_5GHZ;
	}
	return band; 
}


int ShowAndReturnChannel(int band)
{
	int chID;
    char tmpBuffer[100];

	printf("valid channels for this band:\n\t");
	if (band == TIAP_PARAM_RADIO_BAND_2_4GHZ)
		printf("1..14\n");
	else
		printf("[36..64] or [100..140] or [149-161] with step of 4 (e.g. 36,40,44,..)\n\n");
	printf("Please select a channel (or hit <Enter> to quit)");

    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chID = atoi(tmpBuffer);
    if(chID <= 0)
        return (-1);
	return chID;
	
}


int ShowAndReturnRate(void)
{
    char tmpBuffer[100];
	int rate;

	printf("\nAvailable rates:\n");
	printf("----------------\n");
	printf("\t1, 2, 5, 11, 22, 6, 9, 12, 18, 24, 36, 48, 54\n");
	printf("Please select a rate:");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    rate = atoi(tmpBuffer);
	switch(rate)
	{
		case 1:
		case 2:
		case 5:
		case 6:
		case 9:
		case 11:
		case 12:
		case 18:
		case 22:
		case 24:
		case 36:
		case 48:
		case 54:
			break;
		default:
			printf("Rate out of range!\n");
			return (-1);
	}
	return rate;
}

int ShowAndReturnModes(void)
{

    char tmpBuffer[100];
	int mode;

	printf("\nAvailable modes:\n");
	printf("----------------\n");
	printf("1 - QPSK\n");
	printf("2 - CCK\n");
	printf("3 - PBCC\n");
	printf("4 - OFDM\n");
	printf("\nPlease select a mode:");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    mode = atoi(tmpBuffer);
	switch(mode)
	{
		case 1:
		case 2:
		case 3:
		case 4:
			mode--;
			break;
		default:
			printf("Mode out of range!\n");
			return (-1);
	}
	return mode;
	
}


void consoleBitFcc(ConsoleParameter_T parameters[])
{
/*
    int chID, rate, mode, band;
    char tmpBuffer[100];
	BOOL found = FALSE;

	band = ShowAndReturnBand();
	if (band < 0)
		return;
    chID = ShowAndReturnChannel(band);
    if(chID <= 0)
        return;
    if (IsChannelInsideBandRange(band,chID) == FALSE)
	{
		printf("Channel out of range!\n");
		return;
	}

	// We have the channel, progressing to having the rate.. 
	rate = ShowAndReturnRate();
	if (rate <=0 )
		return;

	// last step - get the correct mode 
	mode = ShowAndReturnModes();
	if (mode < 0)
		return;

	// OK.. let's do it
	wdrv_dbSetEnRestart(0, FALSE);	// Disable Restart WA w/o writing to NV 

	whal_apiAcxBIT_Fcc(band, chID, rate, mode);
*/
	int chID, rate, mode, band, ret;
	
	proc_params proc_pars;
	


	band = ShowAndReturnBand();
	if (band < 0)
		return;
	chID = ShowAndReturnChannel(band);
	if(chID <= 0)
		return;
	if (IsChannelInsideBandRange(band,chID) == FALSE)
	{
		printf("Channel out of range!\n");
		return;
	}

	/* We have the channel, progressing to having the rate.. */
	rate = ShowAndReturnRate();
	if (rate <=0 )
		return;

	/* last step - get the correct mode */
	mode = ShowAndReturnModes();
	if (mode < 0)
		return;

	/* OK.. let's do it */

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = band;
	proc_pars.s.Param2 = chID;
	proc_pars.s.Param3 = rate;
	proc_pars.s.Param4 = mode;

	
	ret = dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_FCC, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_FCC);
	
}

static void set_enable_wa_restart(int val)
{
	tiap_param_wd_t wa;

	wa.cmd = TIAP_PARAM_WD_ENABLE;
	wa.value.val8 = val;
	
	if(tiap_wcfg_set_wd(wd, &wa, UPDATE_STORAGE))
		PRINT_CONFIG_ERR_MSG("Failed to set WA restart.");
}


void consoleBitTelec(ConsoleParameter_T parameters[])
{

	/*
   int chID;
   UINT8 band;
   char tmpBuffer[100];


   band = ShowAndReturnBand();
   if (band < 0)
	   return;
   chID = ShowAndReturnChannel(band);
   if(chID <= 0)
	   return;
   if (IsChannelInsideBandRange(band,chID) == FALSE)
   {
	   printf("Channel out of range!\n");
	   return;
   }

   wdrv_dbSetEnRestart(0, FALSE);	// Disable Restart WA w/o writing to NV 

   whal_apiAcxBIT_Telec(band, chID);
   printf("Done.\n");
*/
   int chID, band;
   proc_params proc_pars;
   int ret;


   band = ShowAndReturnBand();
   if (band < 0)
	   return;
   chID = ShowAndReturnChannel(band);
   if(chID <= 0)
	   return;
   if (IsChannelInsideBandRange(band,chID) == FALSE)
   {
	   printf("Channel out of range!\n");
	   return;
   }

   proc_pars.s.magic = PROC_PARAMS_MAGIC;
   proc_pars.s.Param1 = band;
   proc_pars.s.Param2 = chID;

   ret = dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TELEC, 
		(char *)&proc_pars, sizeof(proc_pars));

   if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TELEC);

   printf("Done.\n");
}

void consoleBitTxCfg(ConsoleParameter_T parameters[])
{

/*
   // perTxCfg <chID> <rate> <mod> <preamble 0-long |1-short> <destMAC> 
   UINT8 buf[100];
   int band, chID, rate, mode, preamble;
   unsigned char *destMac = parameters[0].MAC_ADDR;
   int numFrames = 10;
   int gap = 1000;
   int bodySize = 1200;
   
   band = ShowAndReturnBand();
   if (band < 0)
	   return;
   chID = ShowAndReturnChannel(band);
   if(chID <= 0)
	   return;
   if (IsChannelInsideBandRange(band,chID) == FALSE)
   {
	   printf("Channel out of range!\n");
	   return;
   }

   // We have the channel, progressing to having the rate.. 
   rate = ShowAndReturnRate();
   if (rate <=0 )
	   return;

   // last step - get the correct mode 
   mode = ShowAndReturnModes();
   if (mode < 0)
	   return;

   printf("\nRequired Preamble:\n");
   printf("------------------\n");
   printf("1 - long\n");
   printf("2 - short\n");
   printf("\nPlease type the preamble's id:");
   fgets(buf, 100, stdin);
   buf[strlen(buf) - 1] = 0; // remove newline 
   preamble = atoi(buf);
   switch(preamble)
   {
	   case 1:
	   case 2:
		   preamble--;
		   break;
	   default:
		   printf("Value out of range!\n");
		   return;
   }

   // This is not enough, we must ask for more parameters 
   buf[99] = 0;

   printf("Num of frames [%u] : ", numFrames);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      numFrames = atoi(buf);
      if( 0 == numFrames ) numFrames = 10;
   }

   printf("Gap time usec [%u] : ", gap);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      gap = atoi(buf);
      if( 0 == gap) gap = 1000;
   }

   printf("Frame body size [%u] : ", bodySize);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      bodySize = atoi(buf);
      if( (0 == bodySize) && (buf[0] != '0') ) bodySize = 1200;
   }

   wdrv_dbSetEnRestart(0, FALSE);	// Disable Restart WA w/o writing to NV 

   whal_apiAcxBIT_perTxCfg(
      band, chID, rate, mode, preamble,
      numFrames, gap, bodySize, destMac);
*/
	// perTxCfg <chID> <rate> <mod> <preamble 0-long |1-short> <destMAC> 
   UINT8 buf[100];
   int band, chID, rate, mode, preamble;
   unsigned char *destMac = parameters[0].MAC_ADDR;
   int numFrames = 10;
   int gap = 1000;
   int bodySize = 1200;
   proc_params proc_pars;
   int ret;
   
   band = ShowAndReturnBand();
   if (band < 0)
	   return;
   chID = ShowAndReturnChannel(band);
   if(chID <= 0)
	   return;
   if (IsChannelInsideBandRange(band,chID) == FALSE)
   {
	   printf("Channel out of range!\n");
	   return;
   }

   /* We have the channel, progressing to having the rate.. */
   rate = ShowAndReturnRate();
   if (rate <=0 )
	   return;

   /* last step - get the correct mode */
   mode = ShowAndReturnModes();
   if (mode < 0)
	   return;

   printf("\nRequired Preamble:\n");
   printf("------------------\n");
   printf("1 - long\n");
   printf("2 - short\n");
   printf("\nPlease type the preamble's id:");
   fgets(buf, 100, stdin);
   buf[strlen(buf) - 1] = 0; /* remove newline */
   preamble = atoi(buf);
   switch(preamble)
   {
	   case 1:
	   case 2:
		   preamble--;
		   break;
	   default:
		   printf("Value out of range!\n");
		   return;
   }

   /* This is not enough, we must ask for more parameters */
   buf[99] = 0;

   printf("Num of frames [%u] : ", numFrames);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      numFrames = atoi(buf);
      if( 0 == numFrames ) numFrames = 10;
   }

   printf("Gap time usec [%u] : ", gap);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      gap = atoi(buf);
      if( 0 == gap) gap = 1000;
   }

   printf("Frame body size [%u] : ", bodySize);
	 fgets(buf, 99, stdin);
	 buf[99] = 0;
   if( strlen(buf))
   {
      bodySize = atoi(buf);
      if( (0 == bodySize) && (buf[0] != '0') ) bodySize = 1200;
   }

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = band;
	proc_pars.s.Param2 = chID;
	proc_pars.s.Param3 = rate;
	proc_pars.s.Param4 = mode;
	proc_pars.s.Param5 = preamble;
	proc_pars.s.Param6 = numFrames;
	proc_pars.s.Param7 = gap;
	proc_pars.s.Param8 = bodySize;
	memcpy(proc_pars.s.mac, destMac, sizeof(proc_pars.s.mac));
	
	ret = dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXCFG, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXCFG);
}


void consoleBitRxCfg(ConsoleParameter_T parameters[])
{
    /*
	int band, chID;

	band = ShowAndReturnBand();
	if (band < 0)
		return;
	chID = ShowAndReturnChannel(band);
	if(chID <= 0)
		return;

	wdrv_dbSetEnRestart(0, FALSE);	// Disable Restart WA w/o writing to NV 

	whal_apiAcxBIT_perRxCfg(band, chID);
    */
	int band, chID;
	proc_params proc_pars;
	int ret;

	band = ShowAndReturnBand();
	if (band < 0)
		return;
	chID = ShowAndReturnChannel(band);
	if(chID <= 0)
		return;
			
	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = band;
	proc_pars.s.Param2 = chID;

	ret = dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_RXCFG, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_RXCFG);

}

void consoleBitClrStat(ConsoleParameter_T parameters[]){
   /*whal_apiAcxBIT_perClrStats();*/
	

	if (dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_CLRSTAT, NULL, 0))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_CLRSTAT);

}

void consoleBitTxStop(ConsoleParameter_T parameters[]){
   /*whal_apiAcxBIT_perTxStop();*/
	if (dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXSTOP, NULL, 0))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXSTOP);
}

void consoleBitRxStat(ConsoleParameter_T parameters[]){
   //whal_apiAcxBIT_perRxStats();
	if(dda_print_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_RXSTAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_RXSTAT);

}

void consoleBitTxStat(ConsoleParameter_T parameters[]){
   //whal_apiAcxBIT_perTxStats();
	if(dda_print_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXSTAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_TXSTAT);

}

void consoleBitStop(ConsoleParameter_T parameters[]){
/*
   whal_apiAcxBIT_ExitTest();
   puts("Must reboot now.");
	whal_apiAcxReset();
#ifdef VXWORKS
	cm_hwReset(); // nothing else matters... 
#else
	puts("Console can not reboot the system, reboot or reload the driver using other utilities");
#endif
	*/

	int ret;

	ret = dda_write_proc_entry(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_BITSTOP, NULL, 0);
	if (ret)
		PRINT_PROC_WRITE_ERR(WLAN_PROC_BIT_DIR_NAME, WLAN_PROC_BIT_BITSTOP);
}


/************************************************************************/
/*						Mgmt sub-menu functions							*/
/************************************************************************/

void printMgmtAccess(ConsoleParameter_T parameters[])
{
	/*
    char tmp_buf[80*25];
    UINT8 enable, type;
    int size = 80*25;
    int numOfElements;

    whal_nvram_getAccessListEnable(&enable);
	mgmtAccessListStatus((char*)tmp_buf, size, &numOfElements);
    if (enable == 0)
        printf("Access Control status is: Disable\n\n");
    else
    {
        whal_nvram_getAccessListType(&type);
        printf("Access Control status is: Enabled, Type : %s\n\n", (type==1) ? "Black" : "White");
    }
    if (numOfElements == 0 )
        printf("\tThe Access Control table is empty.\n");
	else
    {
        puts("Access Table content:");
        puts(tmp_buf);
    }
    */

    char buff[MAX_SCREEN_BUFF];
    int num_entries = 0;

    tiap_param_access_list_t	access_list;

    access_list.cmd = TIAP_PARAM_ACCESS_LST;
    if (tiap_wcfg_get_access_list(wd, &access_list, !FROM_STORAGE))
    {
	    PRINT_CONFIG_ERR_MSG("Reading configuration failed");
	    return;
    }
    
    //for (i=0; i<TIAP_PARAM_ACCESS_LIST_SIZE; i++)
   //	print_mac(access_list.list[i]);
    
    access_list_to_str(buff, MAX_SCREEN_BUFF, access_list, &num_entries);
    if (access_list.enabled == 0)
        printf("Access Control status is: Disable\n\n");
    else
    {
        printf("Access Control status is: Enabled, Type : %s\n\n", (access_list.type==1) ? "Black" : "White");
    }
    if (! num_entries)
        printf("\tThe Access Control table is empty.\n");
	else
    {
        puts("Access Table content:");
        puts(buff);
    }
    
    
}

void printStaTable(ConsoleParameter_T parameters[]){
	//wdrv_dbPrintStaTable();
	
	if(dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STATABLE) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STATABLE);
		
}

void printRatesTable(ConsoleParameter_T parameters[]){
	//wdrv_dbPrintRatesTable();
	if (dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STARATES) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STARATES);
}

void printHashTable(ConsoleParameter_T parameters[]){
	//wdrv_dbPrintHashTable();
	if (dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STAHASH) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_STAHASH);
}

void mgmtShow(ConsoleParameter_T parameters[]){
	
	/*BOOL	enable4x;
	dot11_TIcap_T	TIcap;

	wdrv_dbGet4xEnable(&enable4x);
	wdrv_dbGetTIInfoElement(TIcap.cap, &(TIcap.hdr.eleLen));		
	
	wdrv_dbPrintNumOfStations();

	if (wdrv_mgmtLogEnable())
		printf("Management Log:		Enable\n");
	else
		printf("Management Log:		Disable\n");

	if (wdrv_mgmtAgingEnable())
		printf("Management Aging:	Enable\n");
	else
		printf("Management Aging:	Disable\n");

	if (enable4x == TRUE)
	{
		int i;

		printf("4x:	Enable\n");
		printf("0x%x ", TIcap.hdr.eleId);
		printf("0x%x ", TIcap.hdr.eleLen);
		for(i=0;i<TIcap.hdr.eleLen;i++)
			printf("0x%x ", TIcap.cap[i]);
		printf("\n");
	}
	else
		printf("4x:	Disable\n");
	*/
	if (dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_SHOW) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_SHOW);
	
}



void servEnable(ConsoleParameter_T parameters[])
{
	//wdrv_WlanServiceEnable();
	__u8 state = 1;
	
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_OPER_STATE, &state, UPDATE_STORAGE) ) {
		fprintf(stderr, "Failed to set AP's operating state.\n\n");
		fflush(stderr);
	}
	else
		printf("\n\nAP operating state was set to Enabled\n\n");
}


void servDisable(ConsoleParameter_T parameters[])
{
	//wdrv_WlanServiceDisable();
	__u8 state = 0;
	
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_OPER_STATE, &state, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set AP's operating state.");
		return;
	}
	else
		printf("\n\nAP operating state was set to Disabled\n\n");
}



void deAuthMng(ConsoleParameter_T parameters[]){
	//wdrv_mgmtDeAuthMng(parameters[0].MAC_ADDR, parameters[1].SHORT);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[1].SHORT;
	memcpy(proc_pars.s.mac, &parameters[0].MAC_ADDR, sizeof(proc_pars.s.mac));

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_DEAUTH, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_DEAUTH);


}

/********************************************************************/
/*                                                                  */
/*              Management Access Control Commands                  */
/*                                                                  */
/********************************************************************/

void setAccessMAC(ConsoleParameter_T parameters[])
{
/*	char tmpTable[MGMT_ACCESS_LIST_SIZE*MAC_ADDR_LEN];
    int length = MGMT_ACCESS_LIST_SIZE*MAC_ADDR_LEN;
    STATUS status;

	if (mgmtAccessSetMAC(parameters[0].MAC_ADDR) != OK)
    {
        printf("Error - Unable to set this address to the table!\n");
        return;
    }
    // Update table in NVRAM 
	status = mgmtAccessGetList(tmpTable, &length);
    if (status != OK) 
    {
        printf("setAccessMAC: Fatal Error from mgmtAccessGetList (file %s)\n",__FILE__);
        return;
    }
	whal_nvram_setAccessList(tmpTable, IMMEDIATELY);
*/
    
    tiap_param_access_list_t access_lst;

	access_lst.cmd = TIAP_PARAM_ACCESS_LST;

	/*get access list type*/
	if (tiap_wcfg_get_access_list(wd, &access_lst, FROM_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Reading configuration failed");
		return;
	}

    access_lst.cmd = TIAP_PARAM_ACCESS_ADD;

    memcpy(access_lst.list[0], parameters[0].MAC_ADDR, ETH_ALEN);
    
	if (tiap_wcfg_set_access_list(wd, &access_lst))
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed");
		return;
	}
    
    return;
    	
}


void remAccessMAC(ConsoleParameter_T parameters[])
{
/*
    char tmp_buf[80*25];    // attention: multiple use of this buffer ahead.. 
	char tmpTable[MGMT_ACCESS_LIST_SIZE*MAC_ADDR_LEN];
    int length = MGMT_ACCESS_LIST_SIZE*MAC_ADDR_LEN;
    int numOfElements;
    STATUS status;
    UINT32 index, size=80*25;

    // print the table 
	mgmtAccessListStatus((char*)tmp_buf, size, &numOfElements);
    puts("Access Table content:");
	puts(tmp_buf);

    // get the index to remove 
    printf("Type MAC index to remove: ");
    fgets(tmp_buf, 100, stdin);
    tmp_buf[strlen(tmp_buf) - 1] = 0; // remove newline 
    index = atoi(tmp_buf);
    if ((index == 0) || (index > numOfElements))
    {
        printf("Bad value.\n");
        return;
    }

    // remove the index 
	if (mgmtAccessRemMAC((UINT16)index) != OK)
    {
        printf("Error - index not found!\n");
        return;
    }
    // Update table in NVRAM 
	status = mgmtAccessGetList(tmp_buf, &length);
    if (status != OK) 
    {
        printf("remAccessMAC: Fatal Error from mgmtAccessGetList (file %s)\n",__FILE__);
        return;
    }
	whal_nvram_setAccessList(tmp_buf, IMMEDIATELY);
*/

    char tmp_buf[MAX_SCREEN_BUFF];    /* attention: multiple use of this buffer ahead.. */
    int numOfElements, index; 

    tiap_param_access_list_t access_lst;

    access_lst.cmd = TIAP_PARAM_ACCESS_LST;
    if (tiap_wcfg_get_access_list(wd, &access_lst, FROM_STORAGE))
    {
	    PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	    return;
    }

    /* print the table */
    access_list_to_str(tmp_buf, MAX_SCREEN_BUFF, access_lst, &numOfElements);
    puts("Access Table content:");
    puts(tmp_buf);

    /* get the index to remove */
    printf("Type MAC index to remove: ");
    fgets(tmp_buf, MAX_PRINT_STRING, stdin);
    tmp_buf[strlen(tmp_buf) - 1] = 0; /* remove newline */
    index = atoi(tmp_buf);
    if ((index == 0) || (index > numOfElements))
    {
        printf("Bad value.\n");
        return;
    }

    /* remove the index */
  
    access_lst.cmd = TIAP_PARAM_ACCESS_DEL_BY_INDEX;
    access_lst.index = index;
    
    if (tiap_wcfg_set_access_list(wd, &access_lst)) {
	PRINT_CONFIG_ERR_MSG("Configuration failed.");
	return;
    }
    
    return;
}


void enableAccess(ConsoleParameter_T parameters[])
{
	/*
	whal_nvram_setAccessListEnable(1, IMMEDIATELY);
    whal_nvram_setAccessListType(parameters[0].SHORT, IMMEDIATELY);
    printf("Access Control is enabled. Type is: %s\n",(parameters[0].SHORT==0) ? "White" : "Black");
	printf("to take effect RESTART AP.\n");
	*/

	tiap_param_access_list_t access_lst;


	access_lst.cmd = TIAP_PARAM_ACCESS_LST;
	
	if (tiap_wcfg_get_access_list(wd, &access_lst, FROM_STORAGE))
	{
	    PRINT_CONFIG_ERR_MSG("Reading configuration failed");
	    return;
	}


	access_lst.enabled = 1;
	access_lst.type = parameters[0].SHORT;
	access_lst.cmd = TIAP_PARAM_ACCESS_LST;
    
	if (tiap_wcfg_set_access_list(wd, &access_lst))
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed");
		return;
	}
	printf("Access Control is enabled. Type is: %s\n",(parameters[0].SHORT==0) ? "White" : "Black");
	printf("to take effect RESTART AP.\n");
	
}


void disableAccess(ConsoleParameter_T parameters[])
{
	/*
	whal_nvram_setAccessListEnable(0, IMMEDIATELY);
	printf("Access Control is disabled\n");
	printf("to take effect RESTART AP.\n");
	*/
	tiap_param_access_list_t access_lst;

	access_lst.cmd = TIAP_PARAM_ACCESS_LST;
	
	if (tiap_wcfg_get_access_list(wd, &access_lst, FROM_STORAGE))
	{
	    PRINT_CONFIG_ERR_MSG("Reading configuration failed");
	    return;
	}
	
	access_lst.enabled = 0;
    
	if (tiap_wcfg_set_access_list(wd, &access_lst))
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed");
		return;
	}
	printf("Access Control is disabled\n");
	printf("to take effect RESTART AP.\n");

}

/*      End -  Management Access Control Commands - End             */


void disAssocMng(ConsoleParameter_T parameters[]){
	//wdrv_mgmtDisAssocMng(parameters[0].MAC_ADDR, parameters[1].SHORT);

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[1].SHORT;
	memcpy(proc_pars.s.mac, &parameters[0].MAC_ADDR, sizeof(proc_pars.s.mac));

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_DISASS, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_DISASS);
}

void mgmtLog(ConsoleParameter_T parameters[]){
	/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid Log mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_mgmtSetLog((BOOL)parameters[0].INTEGER);
	*/

	int ret;

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid Log mode: %ld\n", parameters[0].INTEGER);
		return;
	}

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_SETLOG, 
		(char *)&(parameters[0].INTEGER), sizeof(parameters[0].INTEGER));
	if (ret != sizeof(parameters[0].INTEGER))  
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_SETLOG);

}

void printMgmtCounters(ConsoleParameter_T parameters[]){
	//wdrv_mgmtPrintCounters();
	if (dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_COUNTERS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_COUNTERS);
		
}

void mgmtAging(ConsoleParameter_T parameters[]){
	/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid Aging mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_mgmtSetAging((BOOL)parameters[0].INTEGER);
	*/
	int ret;

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid Aging mode: %ld\n", parameters[0].INTEGER);
		return;
	}

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_AGING, 
		(char *)&(parameters[0].INTEGER), sizeof(parameters[0].INTEGER));

	if (ret != sizeof(parameters[0].INTEGER))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_AGING);

}

/************************************************************************/
/*						Mgmt-test sub-menu functions							*/
/************************************************************************/
void findSta(ConsoleParameter_T parameters[]){

	/*UINT16 idx;
	char mac[MAC_ADDR_LEN];
	memset(mac, parameters[0].INTEGER, MAC_ADDR_LEN);
	wdrv_dbFindStaIndex(mac, &idx);*/

	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_find_sta((char *)&parameters[0].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_find_sta failed !");
	else
		puts(buf);
}

void insertSta(ConsoleParameter_T parameters[]){

	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_insert_sta((char *)&parameters[0].INTEGER, parameters[1].INTEGER,  buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_insert_sta failed !");
	else
		puts(buf);
}

void removeSta(ConsoleParameter_T parameters[])
{
/*
    char macAddr[MAC_ADDR_LEN];

    wdrv_dbGetStaMacAddress(parameters[0].INTEGER,macAddr);
    wdrv_mgmtDeAuthMng(macAddr,12*//*STATUS_ASSOC_DENIED_OUT_OF_SCOPE*//*);*/
	/*wdrv_dbRemoveStaIndex(parameters[0].INTEGER);*/
     deAuthMng(parameters);
    
}

void null(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstNull(parameters[0].INTEGER, parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;
	proc_pars.s.Param3 = parameters[2].INTEGER;
	proc_pars.s.Param4 = parameters[3].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_NULL, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_NULL);



}

void auth1(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstAuth1(parameters[0].INTEGER, parameters[1].SHORT);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].SHORT;

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_AUTH1, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_AUTH1);

}

void auth3(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstAuth3(parameters[0].INTEGER, parameters[1].SHORT, parameters[2].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].SHORT;
	proc_pars.s.Param3 = parameters[2].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_AUTH3, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_AUTH3);


}

void assoc(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstAssoc(parameters[0].INTEGER, (BOOL)parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;
	proc_pars.s.Param3 = parameters[2].INTEGER;
	proc_pars.s.Param4 = parameters[3].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_ASS, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_ASS);

}

void reAssoc(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstReassoc(parameters[0].INTEGER, (BOOL)parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;
	proc_pars.s.Param3 = parameters[2].INTEGER;
	proc_pars.s.Param4 = parameters[3].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_REASS, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_REASS);

}

void deAuth(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstDeAuth(parameters[0].INTEGER, parameters[1].SHORT);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].SHORT;
	

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_DEAUTH, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_DEAUTH);
}

void disAssoc(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstDisAssoc(parameters[0].INTEGER, parameters[1].SHORT);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].SHORT;
	

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TS_DEASS, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TS_DEASS);


}

void class3(ConsoleParameter_T parameters[]){
	//wdrv_mgmtTstClass3(parameters[0].INTEGER, parameters[1].SHORT);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].SHORT;
	

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_CLASS3, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_CLASS3);

}

void showChallenge(ConsoleParameter_T parameters[]){
	//wdrv_mgmtPrintChallenge(parameters[0].SHORT);
#if 0
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].SHORT;
	

	ret = dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_CHALLENGE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_CHALLENGE);
#endif
	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_challenge(parameters[0].SHORT, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_challenge failed !");
	else
		puts(buf);
}

void mgmtReset(ConsoleParameter_T parameters[]){
	//wdrv_mgmtReset();
	dda_write_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_TST_RESET, NULL, 0);
}

/************************************************************************/
/*						WPA sub-menu functions							*/
/************************************************************************/

void wpaShow(ConsoleParameter_T parameters[])
{
	/*
	UINT32	value = 0;
	UINT32	hex[8];
	int i;
   UINT8 pwd[DOT11_MAX_PSK_PWD_LEN + 1];
   UINT8 secret[DOT11_MAX_RADIUS_SECRET_LEN + 1];
   UINT8 addr[4];


	if (wdrv_dbIsNvramIdenticalToDatabase() == FALSE)
	{
		printf("NOTICE:	The following parameters values are taken from the SDRAM,\n");
		printf("		some of them may be different from the values stored in the NVRAM!!!\n");
		printf("\n");
	}

	wdrv_dbGetWpaMode(&value);

	if (value & DOT11_WPA_STA_TYPE_WEP_LEGACY)
		printf("	Legacy Stations		- On\n");
	else
		printf("	Legacy Stations		- Off\n");

	if (value & DOT11_WPA_STA_TYPE_WEP_8021X)
		printf("	EAP-TLS Stations	- On\n");
	else
		printf("	EAP-TLS Stations	- Off\n");

	if (value & DOT11_WPA_STA_TYPE_WPA)
		printf("	WPA Stations		- On\n");
	else
		printf("	WPA Stations		- Off\n");


	wdrv_dbGetPassPhraseMode(&value);

	if (value == DOT11_WPA_PSK_PARAM_NONE)
		printf("	Pass Phrase Mode		- None\n");
	else if (value == DOT11_WPA_PSK_PARAM_HEX)
		printf("	Pass Phrase Mode		- HEX\n");
	else if (value == DOT11_WPA_PSK_PARAM_ASCII)
		printf("	Pass Phrase Mode		- ASCII\n");
	else 
		printf("	Pass Phrase Mode		- Invalid\n");

	wdrv_dbGetPskHex((UINT8 *)hex);
	printf("	PSK HEX number:			0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X\n", hex[0], hex[1], hex[2], hex[3], hex[4], hex[5], hex[6], hex[7]);
	wdrv_dbGetPskPwd(pwd);
	printf("	PSK Password:			%s\n", pwd);


	wdrv_dbGetDefaultCipher(&value);

	if (value == DOT11_CIPHER_WEP_40)
		printf("	Default Cipher		WEP - 40\n");
	else if (value == DOT11_CIPHER_WEP_104)
		printf("	Default Cipher		WEP - 104\n");
	else if (value == DOT11_CIPHER_WEP_232)
		printf("	Default Cipher		WEP - 232\n");
	else
		printf("	Default Cipher		Invalid\n");

	wdrv_dbGetGTKInterval(&value);
	printf("	Group Key update Interval:	%d	seconds\n", value / 1000);

	wdrv_dbGetRadiusSecret(secret);
	printf("	Radius Secret:			%s\n", secret);

	wdrv_dbGetRadiusPort(&value);
	printf("	Radius Port:			%d\n", value);

	wdrv_dbGetRadiusIpAddr(&addr[0], &addr[1], &addr[2], &addr[3]);
	printf("	Radius IP Address:			%d %d %d %d\n", addr[0], addr[1], addr[2], addr[3]);

	wdrv_dbGetDefaultGateway(&addr[0], &addr[1], &addr[2], &addr[3]);
	printf("	Default Gateway:			%d %d %d %d\n", addr[0], addr[1], addr[2], addr[3]);
	*/

	__u32	value = 0;
	tiap_param_security_type_t mode;
	__u8 len;
	__s8 passwd[TIAP_WPA_MAX_PSK_PWD_LEN+1];
	__s8 secret[TIAP_WPA_MAX_RADIUS_SECRET_LEN+1];
	struct in_addr addr;
	int ret;


   /*
	if (wdrv_dbIsNvramIdenticalToDatabase() == FALSE)
	{
		printf("NOTICE:	The following parameters values are taken from the SDRAM,\n");
		printf("		some of them may be different from the values stored in the NVRAM!!!\n");
		printf("\n");
	}*/

	if(tiap_wcfg_get_basic(wd, TIAP_PARAM_SECURITY_TYPE, &mode, !FROM_STORAGE)) {
		PRINT_CONFIG_ERR_MSG("Failed to get wpa mode.\n");
		return;
	}
    
	if (mode & TIAP_PARAM_SECURITY_WEP)
		printf("	Legacy Stations		- On\n");
	else
		printf("	Legacy Stations		- Off\n");

	if (mode & TIAP_PARAM_SECURITY_802_1X)
		printf("	EAP-TLS Stations	- On\n");
	else
		printf("	EAP-TLS Stations	- Off\n");

	if (mode & TIAP_PARAM_SECURITY_WPA)
		printf("	WPA Stations		- On\n");
	else
		printf("	WPA Stations		- Off\n");


	tiap_wcfg_get_psk_passphrase_mode(wd, &value);


	if (value == TIAP_WPA_PSK_PARAM_NONE)
		printf("	Pass Phrase Mode		- None\n");
	else if (value == TIAP_WPA_PSK_PARAM_HEX)
		printf("	Pass Phrase Mode		- HEX\n");
	else if (value == TIAP_WPA_PSK_PARAM_ASCII)
		printf("	Pass Phrase Mode		- ASCII\n");
	else 
		printf("	Pass Phrase Mode		- Invalid\n");

	tiap_wcfg_get_psk_passwd(wd, passwd, &len);
	passwd[len] = '\0';
	printf("	PSK Password:			%s\n", passwd);


	tiap_wcfg_get_default_cipher(wd, &value);

	if (value == TIAP_WPA_CIPHER_WEP_40)
		printf("	Default Cipher		WEP - 40\n");
	else if (value == TIAP_WPA_CIPHER_WEP_104)
		printf("	Default Cipher		WEP - 104\n");
	else if (value == TIAP_WPA_CIPHER_WEP_232)
		printf("	Default Cipher		WEP - 232\n");
	else
		printf("	Default Cipher		Invalid\n");

	tiap_wcfg_get_gtk_interval(wd, &value);
	printf("	Group Key update Interval:	%d	seconds\n", value / 1000);

	tiap_wcfg_get_radius_secret(wd, secret, &len);
	secret[len] = '\0';
	printf("	Radius Secret:			%s\n", secret);

	tiap_wcfg_get_radius_port(wd, (__u16*)&value);
	printf("	Radius Port:			%hu\n", value);

	tiap_wcfg_get_radius_ipaddr(wd, &value);
	addr.s_addr = value;

	printf("	Radius IP Address:			%s\n", inet_ntoa(addr));

	ret = tiap_wcfg_get_default_gateway(&value);	
	if (ret == NOK)
		return;
	else 
	{
	addr.s_addr = value;
	printf("	Default Gateway:			%s\n", inet_ntoa(addr));
	}
	
}

void wpaWorkingMode(ConsoleParameter_T parameters[])
{
	/*
	UINT32	value = 0, modeCount = 0;
    UINT16 MultipleSsidFlag;

	if ((parameters[0].INTEGER == FALSE) && (parameters[1].INTEGER == FALSE) && (parameters[2].INTEGER == FALSE))
	{
		printf("Invalid working mode, all station types are off \n");
		return;
	}
	
	// We don't allow to turn on WPA or 802.1x if multiple SSId is enabled 
    wdrv_dbGetMultipleSsidStatus(&MultipleSsidFlag);
	if ((MultipleSsidFlag == TRUE)  && (parameters[1].INTEGER == TRUE))
	{
		printf("802.1x can not be enabled while multiple SSID is ON\n");
		return;
	}
	if ((MultipleSsidFlag == TRUE)  && (parameters[2].INTEGER == TRUE))
	{
		printf("WPA can not be enabled while multiple SSID is ON\n");
		return;
	}
	
	
	if (parameters[0].INTEGER == TRUE)
	{
		value |= DOT11_WPA_STA_TYPE_WEP_LEGACY;
		modeCount++;
	}
	if (parameters[1].INTEGER == TRUE)
	{
		value |= DOT11_WPA_STA_TYPE_WEP_8021X;
		modeCount++;
	}
	if (parameters[2].INTEGER == TRUE)
	{
		value |= DOT11_WPA_STA_TYPE_WPA;
		modeCount++;
	}

	if (modeCount > 1)
		printf("NOTICE, this configuration will not be shown correctly in the privacy page due to WIFI restrictions!!!.\n");

	
	wdrv_dbSetWpaMode(value);
	printf("to take effect RESTART AP.\n");
	*/



	UINT32 modeCount = 0;
	tiap_param_multi_ssid_t multi_ssid;
	tiap_param_security_type_t mode = 0;

	if ((parameters[0].INTEGER == FALSE) && (parameters[1].INTEGER == FALSE) &&
		(parameters[2].INTEGER == FALSE))
	{
		printf("Invalid working mode, all station types are off \n");
		return;
	}
	

	// We don't allow to turn on WPA or 802.1x if multiple SSId is enabled 
	if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
		return;
	}

	if ((multi_ssid.enabled == TRUE)  && (parameters[1].INTEGER == TRUE))
	{
		printf("802.1x can not be enabled while multiple SSID is ON\n");
		return;
	}
	if ((multi_ssid.enabled == TRUE)  && (parameters[2].INTEGER == TRUE))
	{
		printf("WPA can not be enabled while multiple SSID is ON\n");
		return;
	}
	
	if (parameters[0].INTEGER == TRUE)
	{
		mode |= TIAP_PARAM_SECURITY_WEP;
		modeCount++;
	}
	if (parameters[1].INTEGER == TRUE)
	{
		mode |= TIAP_PARAM_SECURITY_802_1X;
		modeCount++;
	}
	if (parameters[2].INTEGER == TRUE)
	{
		mode |= TIAP_PARAM_SECURITY_WPA;
		modeCount++;
	}

	if (modeCount > 1)
		printf("NOTICE, this configuration will not be shown correctly in the privacy page due to WIFI restrictions!!!.\n");

	if(tiap_wcfg_set_basic(wd, TIAP_PARAM_SECURITY_TYPE, &mode, UPDATE_STORAGE)) {
		PRINT_CONFIG_ERR_MSG("Failed to set wpa mode.\n");
		return;
	}

	printf("to take effect RESTART AP.\n");

}

void wpaPassPhraseMode(ConsoleParameter_T parameters[])
{
	/*
	if ((parameters[0].INTEGER != DOT11_WPA_PSK_PARAM_NONE) && 
		(parameters[0].INTEGER != DOT11_WPA_PSK_PARAM_HEX) && 
		(parameters[0].INTEGER != DOT11_WPA_PSK_PARAM_ASCII))
	{
		printf("Invalid pass phrase mode\n");
		return;
	}
	
	wdrv_dbSetPassPhraseMode(parameters[0].INTEGER);
	printf("to take effect RESTART AP.\n");
	*/
	if ((parameters[0].INTEGER != TIAP_WPA_PSK_PARAM_NONE) && 
		(parameters[0].INTEGER != TIAP_WPA_PSK_PARAM_HEX) && 
		(parameters[0].INTEGER != TIAP_WPA_PSK_PARAM_ASCII))
	{
		printf("Invalid pass phrase mode\n");
		return;
	}

	if (parameters[0].INTEGER == TIAP_WPA_PSK_PARAM_HEX)
	{
		PRINT_NOT_SUPPORTED_MSG("Passphrase in Hex mode");
		return;
	}
	if (tiap_wcfg_set_psk_passphrase_mode(wd, parameters[0].INTEGER))
		PRINT_CONFIG_ERR_MSG("Failed to set psk passphrase mode");

}

void wpaPskHex(ConsoleParameter_T parameters[])
{/*
	UINT32	hex[8];
	int i;

	for (i = 0; i < 8; i++)
		hex[i] = parameters[i].UNSIGNED_INTEGER;
		
	wdrv_dbSetPskHex((UINT8 *)hex);
	printf("to take effect RESTART AP.\n");
*/
	PRINT_NOT_SUPPORTED_MSG("Psk hex mode");
}

void wpaPskPwd(ConsoleParameter_T parameters[])
{
   /* pwd is an input buffer for password + NULL + some arbitrary pad
    * to avoid problems with gets()
    */
/*
   UINT8 pwd[DOT11_MAX_PSK_PWD_LEN + 1 + 32];
   UINT8 bLen = DOT11_MAX_PSK_PWD_LEN;

   // Get password from NVRAM and terminate it with NULL 
   whal_nvram_getPskPwd(pwd, &bLen);
   pwd[bLen] = 0;
   printf("Password <%s>: ",pwd);
   // Input new password 
   gets(pwd);
   bLen = strlen(pwd);
   if( (bLen >= DOT11_MIN_PSK_PWD_LEN) && (bLen <= DOT11_MAX_PSK_PWD_LEN))
   {
      // Legal string 8-63 printable characters 
      pwd[bLen] = 0;
      printf("setting Password <%s>\n",pwd);
      whal_nvram_setPskPwd(pwd, bLen, IMMEDIATELY);
      puts("to take effect RESTART AP.");
   }
   else if( bLen > 0)
   {
      // Input is too short or too long, reject it 
      printf("According to WPA RFC2898 password length is [%u..%u]. Rejected.\n",
         DOT11_MIN_PSK_PWD_LEN, DOT11_MAX_PSK_PWD_LEN);
}
   // Empty string, do nothing 
   */

	 __u8 pwd[TIAP_WPA_MAX_PSK_PWD_LEN + 1];
	 __u8 len = TIAP_WPA_MAX_PSK_PWD_LEN;

	   /* Get password from local storage and terminate it with NULL */
	   tiap_wcfg_get_psk_passwd(wd, pwd, &len);
	   pwd[len] = '\0'; 
	   printf("Password <%s>: ",pwd);
	   /* Input new password*/
	   fgets(pwd, TIAP_WPA_MAX_PSK_PWD_LEN, stdin);
	   len = min(strlen(pwd),TIAP_WPA_MAX_PSK_PWD_LEN);
	   /* eat the \n char */
	   if (pwd[len-1] == '\n')
	   {
		pwd[len-1] = '\0';
		len -= 1;
	   }
	   if( (len >= TIAP_WPA_MIN_PSK_PWD_LEN) && (len <= TIAP_WPA_MAX_PSK_PWD_LEN))
	   {
	      /* Legal string 8-63 printable characters */
	      pwd[len] = 0;
	      printf("setting Password <%s>\n",pwd);
	      if (tiap_wcfg_set_psk_passwd(wd, pwd, len))
	      {
		  PRINT_CONFIG_ERR_MSG("Failed to set psk passphrase");
		  return;
	      }
	      puts("to take effect RESTART AP.");
	   }
	   else if( len > 0)
	   {
	      /* Input is too short or too long, reject it */
	      printf("According to WPA RFC2898 password length is [%u..%u]. Rejected.\n",
		 TIAP_WPA_MIN_PSK_PWD_LEN, TIAP_WPA_MAX_PSK_PWD_LEN);
	   }
   /* Empty string, do nothing */
}/* END wpaPskPwd() */

void wpaDefaultCipher(ConsoleParameter_T parameters[])
{/*
	if (parameters[0].INTEGER == 1)
		wdrv_dbSetDefaultCipher(DOT11_CIPHER_WEP_40);
	else if (parameters[0].INTEGER == 2)
		wdrv_dbSetDefaultCipher(DOT11_CIPHER_WEP_104);
	else if (parameters[0].INTEGER == 3)
		wdrv_dbSetDefaultCipher(DOT11_CIPHER_WEP_232);
	else
	{
		printf("Invalid default cipher\n");
		return;
	}
	
	printf("to take effect RESTART AP.\n");
*/
	switch(parameters[0].INTEGER)
	{
	case 1:
		if (tiap_wcfg_set_default_cipher(wd, TIAP_WPA_CIPHER_WEP_40))
		{
			PRINT_CONFIG_ERR_MSG("Failed to set default cipher");
			return;
		}

		break;
	case 2:
		if (tiap_wcfg_set_default_cipher(wd, TIAP_WPA_CIPHER_WEP_104))
		{
			PRINT_CONFIG_ERR_MSG("Failed to set default cipher");
			return;
		}
		break;
	
	case 3:
		if (tiap_wcfg_set_default_cipher(wd, TIAP_WPA_CIPHER_WEP_232))
		{
			PRINT_CONFIG_ERR_MSG("Failed to set default cipher");
			return;
		}
		break;
	default:
		printf("Invalid default cipher\n");
		
	}
	
	printf("to take effect RESTART AP.\n");
}

void wpaGTKInterval(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER > 0) && (parameters[0].INTEGER < MIN_GTK_PERIOD))
		parameters[0].INTEGER = MIN_GTK_PERIOD;

	wdrv_dbSetGTKInterval(parameters[0].INTEGER * 1000);
*/
	if ((parameters[0].INTEGER > 0) && (parameters[0].INTEGER < TIAP_WPA_MIN_GTK_PERIOD))
		parameters[0].INTEGER = TIAP_WPA_MIN_GTK_PERIOD;

	if (tiap_wcfg_set_gtk_interval(wd, parameters[0].INTEGER * 1000))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set gtk interval");
		return;
	}
}

void wpaRadiusSecret(ConsoleParameter_T parameters[])
{/*
   UINT8 secret[DOT11_MAX_RADIUS_SECRET_LEN + 1];
   UINT8 bLen = DOT11_MAX_RADIUS_SECRET_LEN;
   whal_nvram_getRadiusSecret(secret, &bLen);
   secret[bLen] = 0;
   
   printf("Secret <%s>: ",secret);
   gets(secret);
   bLen = min(strlen(secret),DOT11_MAX_RADIUS_SECRET_LEN);
   if(bLen > 0)
   {
      secret[bLen] = 0;
      printf("setting Radius Secret <%s>\n",secret);
      whal_nvram_setRadiusSecret(secret, bLen, IMMEDIATELY);
      puts("to take effect RESTART AP.");
   }
   */


	__s8 secret[TIAP_WPA_MAX_RADIUS_SECRET_LEN + 1];
	__u8 len = TIAP_WPA_MAX_RADIUS_SECRET_LEN;

	tiap_wcfg_get_radius_secret(wd, secret, &len);
		
	if( len > TIAP_WPA_MAX_RADIUS_SECRET_LEN ) {
		PRINT_CONFIG_ERR_MSG("Invalid len.");
		return;
	}
	secret[len] = 0;

	printf("Secret <%s>: ", secret);
	fgets(secret, TIAP_WPA_MAX_RADIUS_SECRET_LEN, stdin);
	len = min(strlen(secret), TIAP_WPA_MAX_RADIUS_SECRET_LEN);
	if (secret[len-1] == '\n')
	{
		secret[len-1] = '\0';
		len -= 1;
	}

	if(len > 0)
	{
		secret[len] = 0;
		printf("setting Radius Secret <%s>\n", secret);
		if( tiap_wcfg_set_radius_secret(wd, secret, len) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set radius secret.");
			return;
		}
		puts("to take effect RESTART AP.");
	}
}

void wpaRadiusPort(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetRadiusPort(parameters[0].INTEGER);
	printf("to take effect RESTART AP.\n");
*/

	if( tiap_wcfg_set_radius_port(wd, (__u16)parameters[0].INTEGER) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set radius port.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

void wpaRadiusAddr(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER > 255) ||
		(parameters[1].INTEGER > 255) ||
		(parameters[2].INTEGER > 255) ||
		(parameters[3].INTEGER > 255))
	{
		printf("Invalid IP address\n");
		return;
	}
	
	wdrv_dbSetRadiusIpAddr(parameters[0].INTEGER, parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
	printf("to take effect RESTART AP.\n");
*/

	char str_addr[20];
	struct in_addr in_addr;

	if ((parameters[0].INTEGER > 255) || (parameters[1].INTEGER > 255) ||
	   (parameters[2].INTEGER > 255) || (parameters[3].INTEGER > 255)) {
		printf("Invalid IP address\n");
		return;
	}

	sprintf(str_addr,"%hhu.%hhu.%hhu.%hhu",parameters[0].SHORT,parameters[1].SHORT,
					parameters[2].SHORT, parameters[3].SHORT);

	if (!inet_aton(str_addr, &in_addr))
	{
		perror("inet_aton");
		return;
	}

	if( tiap_wcfg_set_radius_ipaddr(wd, in_addr.s_addr) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set radius IP address.");
		return;
	}
	printf("to take effect RESTART AP.\n");

}

void whalMenu_DM(ConsoleParameter_T parameters[]) {
	int fd, addr, size, offset, i, step;
	char * mem = NULL;

	fd = open("/dev/kmem", O_RDONLY);
	if (fd < 0) {
		perror("Can't open /dev/kmem");
		return;
	}

	sscanf(parameters[0].STRING, "0x%x", &addr);
	offset  = parameters[1].INTEGER;
	size = parameters[2].INTEGER;
	step = parameters[3].INTEGER;

	if ( (step != 1) && (step != 2) ) {
		printf("Wrong argument: step can be only 1 for bytes or 2 for words\n");
		return;
	}
	printf("Base addess : %#x, Offset : %#x, Size : %#x, Format: %s\n", addr, offset, size,
		    ( step == 1 ? "bytes" : "words") );

	mem = mmap(NULL, size+offset, PROT_READ, MAP_SHARED, fd, addr - 0xA0000000);
	if (mem == MAP_FAILED) {
		perror("mmap() failed!");
		return;
	}

	 for (i=0; i<size; i+=step){
		if (! (i % 16))
			printf("\n%#x : ", addr+offset+i);

		if (step == 1) /* print byte */
			printf("%02hhx ", mem[offset+i]);
		else if (step == 2) /* print word */
			printf("%02hhx%02hhx ", mem[offset+i], mem[offset+i+1]);
    }
	puts("");
	close(fd);
}

#define TMP_DIR "/var/tmp"

void whalMenu_DownloadFW(ConsoleParameter_T parameters[]) {
	char str_addr[20];
	char cmd_str[128];
	struct stat s;

	if ((parameters[0].INTEGER > 255) || (parameters[1].INTEGER > 255) ||
			(parameters[2].INTEGER > 255) || (parameters[3].INTEGER > 255)) {
		printf("Invalid IP address\n");
		return;
	}

	sprintf(str_addr,"%hhu.%hhu.%hhu.%hhu",parameters[0].SHORT,parameters[1].SHORT,
					parameters[2].SHORT, parameters[3].SHORT);

	printf("Downloading \"FW.bin\" FW image from %s\n", str_addr);

	snprintf(cmd_str, 128, "cd %s && tftp -g -r FW.bin %s ", TMP_DIR, str_addr);

	puts(cmd_str);

	if (system(cmd_str) == -1) {
		printf("FW download failed");
		return ;
	}

	snprintf(cmd_str, 128, "%s/FW.bin", TMP_DIR);
	if (stat(cmd_str, &s) != 0 || s.st_size <= 0) {
		printf("FW file does not exist or has 0 size. Download probably failed !\n");
		return ;
	}

	snprintf(wd->fw_filename, sizeof(wd->fw_filename), "%s/FW.bin", TMP_DIR);

	if ( !(wd = tiap_wcfg_restart(wd)))
		puts("Restart with new FW failed !");
	wd->fw_filename[0] = 0;

	unlink(wd->fw_filename);
}

void wpaDefaultGateway(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER > 255) ||
		(parameters[1].INTEGER > 255) ||
		(parameters[2].INTEGER > 255) ||
		(parameters[3].INTEGER > 255))
	{
		printf("Invalid Default Gateway \n");
		return;
	}
	
	wdrv_dbSetDefaultGateway(parameters[0].INTEGER, parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
	printf("to take effect RESTART AP.\n");
*/

	__u32 i, gateway;
	__u8 *p = (__u8 *)&gateway;

	if ((parameters[0].INTEGER > 255) || (parameters[1].INTEGER > 255) ||
	    (parameters[2].INTEGER > 255) || (parameters[3].INTEGER > 255)) {
		printf("Invalid Default Gateway \n");
		return;
	}

	for(i=0; i<4; i++)
		p[i] = (__u8)parameters[i].INTEGER;

	if( tiap_wcfg_set_route(wd->dev_name, 0, 0, gateway, SIOCADDRT) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set default route.");
		return;	
	}
}

/************************************************************************/
/*						WPA-test sub-menu functions							*/
/************************************************************************/
void assocStation(ConsoleParameter_T parameters[])
{/*
	if ((parameters[1].INTEGER == TRUE) && (parameters[2].INTEGER > DOT11_RSNE_MAX)) 
		printf("RSN IE len is too big\n");
	if ((parameters[1].INTEGER == TRUE) && (parameters[2].INTEGER < 3)) 
		printf("RSN IE len is too small\n");
	else
		wdrv_wpaTstAssocStation(parameters[0].INTEGER, parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
*/
}

void reAssocStation(ConsoleParameter_T parameters[])
{/*
	if ((parameters[1].INTEGER == TRUE) && (parameters[2].INTEGER > DOT11_RSNE_MAX)) 
		printf("RSN IE len is too big\n");
	if ((parameters[1].INTEGER == TRUE) && (parameters[2].INTEGER < 3)) 
		printf("RSN IE len is too small\n");
	else
		wdrv_wpaTstReAssocStation(parameters[0].INTEGER, parameters[1].INTEGER, parameters[2].INTEGER, parameters[3].INTEGER);
*/
}

void stationsRsnIe(ConsoleParameter_T parameters[])
{
	//wdrv_wpaPrintStationRsnIe();
}

void macAuthorize(ConsoleParameter_T parameters[])
{/*
	char bcastMac[MAC_ADDR_LEN];

	memset(bcastMac, 0xFF, MAC_ADDR_LEN);

	if (memcmp(bcastMac, parameters[0].MAC_ADDR, MAC_ADDR_LEN) == 0)
		setBcastState(TRUE);
	else
		wdrv_mgmtMacAuthorize(parameters[0].MAC_ADDR);
*/
}

void macDeAuthorize(ConsoleParameter_T parameters[])
{/*
	char bcastMac[MAC_ADDR_LEN];

	memset(bcastMac, 0xFF, MAC_ADDR_LEN);

	if (memcmp(bcastMac, parameters[0].MAC_ADDR, MAC_ADDR_LEN) == 0)
		setBcastState(FALSE);
	else
		wdrv_mgmtMacDeAuthorize(parameters[0].MAC_ADDR);
*/
}


void showWpaConfig(ConsoleParameter_T parameters[])
{/*
	char mac[MAC_ADDR_LEN];
	UINT8 suite;
	

	if (wdrv_mgmtIsBroadcastAuthorized())
		printf("Broadcast MAC:	Authorized\n");
	else
		printf("Broadcast MAC:	Not Authorized\n");

	wdrv_dbGetBroadcastSuiteType(&suite);

	if (suite == CIPHER_NONE)
		printf("Broadcast cipher:	None\n");
	else if (suite == CIPHER_WEP)
		printf("Broadcast cipher:	WEP\n");
	else if (suite == CIPHER_TKIP)
		printf("Broadcast cipher:	TKIP\n");
	else
		printf("Broadcast cipher:	Invalid %d\n", suite);

	if (wdrv_wpaGetMicFailureReportInRx() == TRUE)
		printf("MIC Failure Report In the Rx path:	TRUE\n");
	else
		printf("MIC Failure Report In the Rx path:	FALSE\n");

	if (wdrv_wpaGetMicFailureReportFromStation() == TRUE)
		printf("MIC Failure Report from station:	TRUE\n");
	else
		printf("MIC Failure Report from station:	FALSE\n");
*/
}

void isMacAuthorized(ConsoleParameter_T parameters[])
{/*
	UINT16 staIndex;

    if( wdrv_dbFindStaIndex(parameters[0].MAC_ADDR, &staIndex) != OK )
	{
		printf("Sattion has no index\n");
		return;
	}

	if (wdrv_mgmtIsStationAuthorized(staIndex) == TRUE)
		printf("			Yes\n");
	else
		printf("			No\n");*/
}

void setStationSuite(ConsoleParameter_T parameters[])
{/*
	UINT16 staIndex;

	if ((parameters[1].INTEGER != CIPHER_NONE) && (parameters[1].INTEGER != CIPHER_WEP) && (parameters[1].INTEGER != CIPHER_TKIP))
	{
		printf("Invalid suite\n");
		return;
	}

	wdrv_dbFindStaIndex(parameters[0].MAC_ADDR, &staIndex);

	wdrv_dbSetStationSuiteType(staIndex, parameters[1].INTEGER);*/
}

void setBcastSuite(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER != CIPHER_NONE) && (parameters[0].INTEGER != CIPHER_WEP) && (parameters[0].INTEGER != CIPHER_TKIP))
	{
		printf("Invalid suite\n");
		return;
	}

	wdrv_dbSetBroadcastSuiteType(parameters[0].INTEGER);*/
}

void testVectors(ConsoleParameter_T parameters[])
{
	//wdrv_wpaTstVector();
}

void setRxMicKey(ConsoleParameter_T parameters[])
{/*
	UINT16	index;
	int status, i;
	UINT8	micKey[8];

	status = wdrv_dbFindStaIndex(parameters[0].MAC_ADDR, &index);

	if (status != OK)
	{
		printf("Station not found \n");
		return;
	}
	
	for (i = 0; i < 8; i++)
		micKey[i] = parameters[i + 1].INTEGER;

	wdrv_dbSetStationRxMicKey(index, micKey);*/
}

void setTxMicKey(ConsoleParameter_T parameters[])
{/*
	UINT16	index;
	int status, i;
	UINT8	micKey[8];

	status = wdrv_dbFindStaIndex(parameters[0].MAC_ADDR, &index);

	if (status != OK)
	{
		printf("Station not found \n");
		return;
	}
	
	for (i = 0; i < 8; i++)
		micKey[i] = parameters[i + 1].INTEGER;

	wdrv_dbSetStationTxMicKey(index, micKey);*/
}

void setMicReportInRx(ConsoleParameter_T parameters[])
{
	//wdrv_wpaSetMicFailureReportInRx(parameters[0].INTEGER);
}

void setMicReportFromStation(ConsoleParameter_T parameters[])
{
	//wdrv_wpaSetMicFailureReportFromStation(parameters[0].INTEGER);
}

void generateTxMicFailure(ConsoleParameter_T parameters[]){
	//wdrv_dbGenerateTxMicFailure(parameters[0].MAC_ADDR);
}

/************************************************************************/
/*						Privacy sub-menu functions							*/
/************************************************************************/
void privacyShowConfig(ConsoleParameter_T parameters[])
{/*
	UINT32	value32;
	UINT16	value16;
	UINT8	value8;
	int i;
	BOOL value;

	if (wdrv_dbIsNvramIdenticalToDatabase() == FALSE)
	{
		printf("NOTICE:	The following parameters values are taken from the SDRAM,\n");
		printf("		some of them may be different from the values stored in the NVRAM!!!\n");
		printf("\n");
	}
	
	wdrv_dbGetStationConfigPrivacyOptionImplemented(&value);
	if (value == TRUE)
		printf("Privacy option:		On\n");
	else
		printf("Privacy option:		Off\n");

	wdrv_dbGetPrivacyInvoked(&value);
	if (value == TRUE)
		printf("Privacy Invoked:	On\n");
	else
		printf("Privacy Invoked:	Off\n");

	wdrv_dbGetPrivacyExcludeUnencrypted(&value);
	if (value == TRUE)
		printf("Exclude Unencrypted:	On\n");
	else
		printf("Exclude Unencrypted:	Off\n");

	wdrv_dbGetPrivacyWEPDefaultKeyId(&value8);
	printf("WEP Default Key Id:	%d\n", value8);

#if 0
	wdrv_dbGetPrivacyWEPKeyMappingLength(&value32);
	printf("WEP Key Mapping Length:	%d\n", value32);
#endif

	wdrv_dbGetStationConfigAuthRspTimeout(&value32);
	printf("Auth response timeout:	%d msecs\n", value32);

	for (i = 0; i < MAX_AUTH_ALGORITHM_SUPPORTED; i++)
	{
		wdrv_dbGetAuthAlgo(i, &value16);
		if (value16 == MIB_OPEN_SYSTEM)
			printf("Authentication algorithm: Open system	");
		else if (value16 == MIB_SHARED_KEY)
			printf("Authentication algorithm: Shared key	");
		else 
			printf("Authentication algorithm: Unknown	");

		wdrv_dbGetAuthAlgoEnable(i, &value);
		if (value == TRUE)
			printf("Enable\n");
		else
			printf("Disable\n");
	}

	wdrv_dbGetPrivacyBitFlag(&value);
	if (value == TRUE)
		printf("Privacy bit flag:	On\n");
	else
		printf("Privacy bit flag:	Off\n");
*/
	if (dda_print_proc_entry(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_CFG) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_CFG);
}

void privacyShowNotify(ConsoleParameter_T parameters[])
{/*
	UINT16	value;
	char macaddr[MAC_ADDR_LEN];

	wdrv_dbGetStationConfigDisassociateReason(&value);
	wdrv_dbGetStationConfigDisassociateStation(macaddr);
	printf("Disassociate reason: %d\n", value);
	printf("Disassociates station: <%hhX-%hhX-%hhX-%hhX-%hhX-%hhX>\n", macaddr[0],macaddr[1],macaddr[2],macaddr[3],
		  macaddr[4],macaddr[5]);

	wdrv_dbGetStationConfigDeauthenticateReason(&value);
	wdrv_dbGetStationConfigDeauthenticateStation(macaddr);
	printf("Deauthenticate reason: %d\n", value);
	printf("Deauthenticate station: <%hhX-%hhX-%hhX-%hhX-%hhX-%hhX>\n", macaddr[0],macaddr[1],macaddr[2],macaddr[3],
		  macaddr[4],macaddr[5]);

	wdrv_dbGetStationConfigDeauthenticateFailStatus(&value);
	wdrv_dbGetStationConfigeauthenticateFailStation(macaddr);
	printf("Deauthenticate Fail status: %d\n", value);
	printf("Deauthenticate Fail station: <%hhX-%hhX-%hhX-%hhX-%hhX-%hhX>\n", macaddr[0],macaddr[1],macaddr[2],macaddr[3],
		  macaddr[4],macaddr[5]);*/

	if (dda_print_proc_entry(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_NOTIFY) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_NOTIFY);

}

void privacyShowDefault(ConsoleParameter_T parameters[])
{/*
	char key[WEP_KEY_LEN_MAX];
	int i, j;
	UINT8 len;

	for (i = 0; i < DOT11_DEFS_KEY_NAL_LEN; i++)
	{
      memset( key, 0, sizeof(key));
		wdrv_dbGetWEPDefaultKeys(i, &len, key);
		printf("Default key index: %d\n", i);
		printf("len: %d\n", len);
		printf("key value: ");
		for (j = 0; j < len; j++)
			printf("0x%hh02X ", key[j]);
		printf("\n\n");
	}*/

	PRINT_NOT_SUPPORTED_MSG("Show wep default keys");
}

void privacyShowMapping(ConsoleParameter_T parameters[])
{/*
	char key[WEP_KEY_LEN_MAX], mac[MAC_ADDR_LEN];
	int i, len, j;
	UINT8 keyLen;
	BOOL enable;

	wdrv_dbGetPrivacyWEPKeyMappingLength(&len);
	
	for (i = 0; i < len; i++)
	{
		wdrv_dbGetWEPKeyMappingAddress(i, mac);
		wdrv_dbGetWEPKeyMappingWEPOn(i, &enable);
		wdrv_dbGetWEPKeyMappingValue(i, &keyLen, key);
		printf("Mapping key index: %d\n", i);
		printf("mac address: %hhX %hhX %hhX %hhX %hhX %hhX\n", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
		if (enable == TRUE)
			printf("On\n");
		else
			printf("Off\n");
		printf("len: %d\n", keyLen);
		printf("value:"); 
		for (j = 0; j < keyLen; j++)	
			printf("0x%hhX ", key[j]);
		printf("\n");
		printf("\n");
	}*/
	PRINT_NOT_SUPPORTED_MSG("show mapping");
}

void privacySetPrivacyWEPKeyMappingLength(ConsoleParameter_T parameters[]){
	/*if (parameters[0].INTEGER > DEF_WEP_KEY_MAPPING_LEN)
	{
		printf("Invalid key mapping length: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetPrivacyWEPKeyMappingLength(parameters[0].INTEGER);*/
	PRINT_NOT_SUPPORTED_MSG("set wep key mapping length");
}

void privacySetMappingKey5(ConsoleParameter_T parameters[])
{/*
	char key[5];
	int i;

	if ((parameters[0].INTEGER < 0) || (parameters[0].INTEGER >= DEF_WEP_KEY_MAPPING_LEN))
	{
		printf("Invalid key mapping index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 5; i++)
		key[i] = (UINT8)parameters[i + 3].INTEGER;
	
	wdrv_dbSetWEPKeyMappingAddress(parameters[0].INTEGER, parameters[1].MAC_ADDR);	
	wdrv_dbSetWEPKeyMappingWEPOn(parameters[0].INTEGER, (BOOL)parameters[2].INTEGER);	
	wdrv_dbSetWEPKeyMappingValue(parameters[0].INTEGER, 5, key);	

    whal_apiSetMappingKey(WEP_ACTION_ADD, parameters[1].MAC_ADDR, 5,KEY_WEP_ADDR,ENTRY_INDEX_IGNORE,IGNORE_KEY_ID, key);
*/
	PRINT_NOT_SUPPORTED_MSG("set mapping key 5");
}

void privacySetMappingKey13(ConsoleParameter_T parameters[])
{/*
	char key[13];
	int i;

	if ((parameters[0].INTEGER < 0) || (parameters[0].INTEGER >= DEF_WEP_KEY_MAPPING_LEN))
	{
		printf("Invalid key mapping index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 13; i++)
		key[i] = (UINT8)parameters[i + 3].INTEGER;
	
	wdrv_dbSetWEPKeyMappingAddress(parameters[0].INTEGER, parameters[1].MAC_ADDR);	
	wdrv_dbSetWEPKeyMappingWEPOn(parameters[0].INTEGER, (BOOL)parameters[2].INTEGER);	
	wdrv_dbSetWEPKeyMappingValue(parameters[0].INTEGER, 13, key);	

    whal_apiSetMappingKey(WEP_ACTION_ADD, parameters[1].MAC_ADDR, 13,KEY_WEP_ADDR,ENTRY_INDEX_IGNORE,IGNORE_KEY_ID, key);
*/
	PRINT_NOT_SUPPORTED_MSG("set mapping key 13");
}

void privacySetMappingKey29(ConsoleParameter_T parameters[])
{/*
	char key[29];
	int i;

	if ((parameters[0].INTEGER < 0) || (parameters[0].INTEGER >= DEF_WEP_KEY_MAPPING_LEN))
	{
		printf("Invalid key mapping index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 29; i++)
		key[i] = (UINT8)parameters[i + 3].INTEGER;
	
	wdrv_dbSetWEPKeyMappingAddress(parameters[0].INTEGER, parameters[1].MAC_ADDR);	
	wdrv_dbSetWEPKeyMappingWEPOn(parameters[0].INTEGER, (BOOL)parameters[2].INTEGER);	
	wdrv_dbSetWEPKeyMappingValue(parameters[0].INTEGER, 29, key);	

    whal_apiSetMappingKey(WEP_ACTION_ADD, parameters[1].MAC_ADDR, 29,KEY_WEP_ADDR,ENTRY_INDEX_IGNORE,IGNORE_KEY_ID, key);
*/
	PRINT_NOT_SUPPORTED_MSG("set mapping key 29");
}

void wlanPrintPrivacyCounters(ConsoleParameter_T parameters[]){
/*	UINT32 count14, count15, count16, count17;

	wdrv_dbGetCountersWEPUndecryptableCount(&count14);
	wdrv_dbGetPrivacyWEPICVErrorCount(&count15);
	wdrv_dbGetPrivacyWEPExcludedCount(&count16);
	wdrv_dbGetPrivacyTKIPMicFailure(&count17);

	printf("***Privacy Counters***\n"); 
	printf("WEP Undecryptable Count				= %d\n", count14); 
	printf("WEP ICV Error Count				= %d\n", count15); 
	printf("WEP Excluded Count				= %d\n", count16); 
	printf("TKIP MIC Failure Count				= %d\n", count17); 
*/
	if (dda_print_proc_entry(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_COUNTERS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_COUNTERS);



}

void privacySetAuthAlgo(ConsoleParameter_T parameters[]){
/*	if ((parameters[1].INTEGER != MIB_OPEN_SYSTEM) && (parameters[1].INTEGER != MIB_SHARED_KEY))
	{
		printf("Invalid Authentication  algorithm: %d\n", parameters[1].INTEGER);
		return;
	}
	if ((parameters[2].INTEGER != 0) && (parameters[2].INTEGER != 1))
	{
		printf("Invalid alrorithm enable mode: %d\n", parameters[2].INTEGER);
		return;
	}
	wdrv_dbSetAuthAlgo(parameters[0].INTEGER, parameters[1].INTEGER);
	wdrv_dbSetAuthAlgoEnable(parameters[0].INTEGER, parameters[2].INTEGER);
	printf("to take effect RESTART AP.\n");*/

	tiap_param_auth_algo_t tbl[TIAP_PARAM_MAX_AUTH_ALG_SUPPORTED];
	int index;

	if ( (parameters[0].INTEGER < 0) || (parameters[0].INTEGER > TIAP_PARAM_MAX_AUTH_ALG_SUPPORTED-1))
	{
		printf("Invalid authentication  algorithm index: %ld\n", parameters[0].INTEGER);
		return;
	}
	if ((parameters[1].INTEGER != TIAP_PARAM_MIB_OPEN_SYSTEM) && (parameters[1].INTEGER != TIAP_PARAM_MIB_SHARED_KEY))
	{
		printf("Invalid Authentication  algorithm: %ld\n", parameters[1].INTEGER);
		return;
	}
	if ((parameters[2].INTEGER != 0) && (parameters[2].INTEGER != 1))
	{
		printf("Invalid alrorithm enable mode: %ld\n", parameters[2].INTEGER);
		return;
	}


	if (tiap_wcfg_get_auth_type(wd, tbl, FROM_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to get authentication algorithm table");
		return;
	}

	index = parameters[0].INTEGER;
	tbl[index].algo = parameters[1].INTEGER;
	tbl[index].enable = parameters[2].INTEGER;

	if (tiap_wcfg_set_auth_type(wd, tbl))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set authentication algorithm table");
		return;
	}


	printf("to take effect RESTART AP.\n");
}

void privacySetAuthRspTimeout(ConsoleParameter_T parameters[]){
/*
	if ((parameters[0].INTEGER < MIN_AUTH_RESP_TO_MS) || (parameters[0].INTEGER > MAX_AUTH_RESP_TO_MS))
	{
		printf("Invalid auth response timeout: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetStationConfigAuthRspTimeout(parameters[0].INTEGER);*/
	PRINT_NOT_SUPPORTED_MSG("Set auth response timeout");

}

void privacySetPrivacyOptionImplemented(ConsoleParameter_T parameters[])
{/*
    UINT16 MultipleSsidFlag;
	
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid privacy option mode: %d\n", parameters[0].INTEGER);
		return;
	}

	//We don't allow to turn on the privacy option if multiple SSId is enabled 
    wdrv_dbGetMultipleSsidStatus(&MultipleSsidFlag);
	if ((MultipleSsidFlag == TRUE) && (parameters[0].INTEGER == 1))
	{
		printf("Privacy can not be enbled while multiple SSID is ON\n");
		return;
	}

	wdrv_dbSetStationConfigPrivacyOptionImplemented((BOOL)parameters[0].INTEGER);
	printf("Setting Privacy Option Implemented = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n");
*/
	UINT8 privopt;
	tiap_param_multi_ssid_t multi_ssid;

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid privacy option mode: %ld\n", parameters[0].INTEGER);
		return;
	}

	/* We don't allow to turn on the privacy option if multiple SSId is enabled */
	privopt = parameters[0].INTEGER;

	if (tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid");
		return;
	}
	if ((multi_ssid.enabled == TRUE) && (privopt == 1))
	{
		printf("Privacy can not be enabled while multiple SSID is ON\n");
		return;
	}


	if (tiap_wcfg_set_basic(wd, TIAP_PARAM_PRIV_OPTION, &privopt, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("failed to set privacy option");
		return;
	}

	printf("Setting Privacy Option Implemented = %ld\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n");
}

void privacySetPrivacyInvoked(ConsoleParameter_T parameters[]){
	/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid privacy invoked mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetPrivacyInvoked((BOOL)parameters[0].INTEGER);
	printf("Setting Privacy Invoked = %d\n", parameters[0].INTEGER); */
	
	proc_params proc_pars;
	int ret; 

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid privacy invoked mode: %ld\n", parameters[0].INTEGER);
		return;
	}
	printf("Warning: this parameter is not used by driver and is not saved in non-volatile storage\n");

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_INVOKE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_INVOKE);


}

void privacySetPrivacyWEPDefaultKeyId(ConsoleParameter_T parameters[]){
	/*
	if ((parameters[0].INTEGER < MIN_KEY_ID) || (parameters[0].INTEGER > MAX_KEY_ID))
	{
		printf("Invalid default key id: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetPrivacyWEPDefaultKeyId((UINT8)parameters[0].INTEGER);*/

	if ((parameters[0].INTEGER < TIAP_PARAM_MIN_KEY_ID) || (parameters[0].INTEGER > TIAP_PARAM_MAX_KEY_ID))
	{
		printf("Invalid default key id: %ld\n", parameters[0].INTEGER);
		return;
	}
	if (tiap_wcfg_set_wep_default_key_id(wd, (UINT8)parameters[0].INTEGER))
		PRINT_CONFIG_ERR_MSG("failed to set wep default key id");
}

void privacySetPrivacyExclude(ConsoleParameter_T parameters[]){
	/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid exclude unencrypted mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetPrivacyExcludeUnencrypted((BOOL)parameters[0].INTEGER);*/

	proc_params proc_pars;
	int ret; 

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid exclude unencrypted mode: %ld\n", parameters[0].INTEGER);
		return;
	}
	

	printf("Warning: this parameter is not used by driver and is not saved in non-volatile storage\n");

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_EXCLUDE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_PRIVACY_DIR_NAME, WLAN_PROC_PRIVACY_EXCLUDE);
}

void privacySetDefaultKey5(ConsoleParameter_T parameters[])
{/*
	char key[5];
	int i;
	UINT32	value = 0;
	
	wdrv_dbGetWpaMode(&value);

	// Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
	//	is forbidden 
	if (!(value & DOT11_WPA_STA_TYPE_WEP_LEGACY))
	{
		printf("Can not configure default key ID, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < MIN_KEY_ID) || (parameters[0].INTEGER > MAX_KEY_ID))
	{
		printf("Invalid default key index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 5; i++)
		key[i] = (UINT8)parameters[i + 1].INTEGER;
	
	wdrv_dbSetWEPDefaultKeys(parameters[0].INTEGER, 5, key);
	*/
	
	tiap_param_security_type_t security_type;
	tiap_wpa_wep_key_t wep_key;
	int i;

	if (tiap_wcfg_get_basic(wd, TIAP_PARAM_SECURITY_TYPE, &security_type, FROM_STORAGE))
	{	
		PRINT_CONFIG_ERR_MSG("failed to read security type");
		return;
	}

	/* Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
		is forbidden */
	if ( security_type != TIAP_PARAM_SECURITY_WEP )
	{
		printf("Can not configure default key 5, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < TIAP_PARAM_MIN_KEY_ID) || (parameters[0].INTEGER > TIAP_PARAM_MAX_KEY_ID))
	{
		printf("Invalid default key index: %ld\n", parameters[0].INTEGER);
		return;
	}

	for (i = 0; i < 5; i++)
		wep_key.key[i] = parameters[i + 1].INTEGER;
	wep_key.len = 5;

	if(tiap_wcfg_set_def_wep_key(wd, parameters[0].INTEGER, &wep_key))
		PRINT_CONFIG_ERR_MSG("failed to set wep default key 5");
		

}

void privacySetDefaultKey13(ConsoleParameter_T parameters[])
{/*
	char key[13];
	int i;

	UINT32	value = 0;
	wdrv_dbGetWpaMode(&value);

	// Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
	//is forbidden 
	if (!(value & DOT11_WPA_STA_TYPE_WEP_LEGACY))
	{
		printf("Can not configure default key ID, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < MIN_KEY_ID) || (parameters[0].INTEGER > MAX_KEY_ID))
	{
		printf("Invalid default key index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 13; i++)
		key[i] = (UINT8)parameters[i + 1].INTEGER;
	
	wdrv_dbSetWEPDefaultKeys(parameters[0].INTEGER, 13, key);
*/
	tiap_param_security_type_t security_type;
	tiap_wpa_wep_key_t wep_key;
	int i;

	if (tiap_wcfg_get_basic(wd, TIAP_PARAM_SECURITY_TYPE, &security_type, FROM_STORAGE))
	{	
		PRINT_CONFIG_ERR_MSG("failed to read security type");
		return;
	}

	/* Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
		is forbidden */
	if ( security_type != TIAP_PARAM_SECURITY_WEP )
	{
		printf("Can not configure default key 13, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < TIAP_PARAM_MIN_KEY_ID) || (parameters[0].INTEGER > TIAP_PARAM_MAX_KEY_ID))
	{
		printf("Invalid default key index: %ld\n", parameters[0].INTEGER);
		return;
	}

	for (i = 0; i < 13; i++)
		wep_key.key[i] = parameters[i + 1].INTEGER;
	wep_key.len = 13;

	if(tiap_wcfg_set_def_wep_key(wd, parameters[0].INTEGER, &wep_key))
		PRINT_CONFIG_ERR_MSG("failed to set wep default key 13");
}

void privacySetDefaultKey29(ConsoleParameter_T parameters[])
{/*
	char key[29];
	int i;

	UINT32	value = 0;
	wdrv_dbGetWpaMode(&value);

	// Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
	//	is forbidden 
	if (!(value & DOT11_WPA_STA_TYPE_WEP_LEGACY))
	{
		printf("Can not configure default key ID, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < MIN_KEY_ID) || (parameters[0].INTEGER > MAX_KEY_ID))
	{
		printf("Invalid default key index: %d\n", parameters[0].INTEGER);
		return;
	}
	for (i = 0; i < 29; i++)
		key[i] = (UINT8)parameters[i + 1].INTEGER;
	
	wdrv_dbSetWEPDefaultKeys(parameters[0].INTEGER, 29, key);
	*/

		tiap_param_security_type_t security_type;
	tiap_wpa_wep_key_t wep_key;
	int i;

	if (tiap_wcfg_get_basic(wd, TIAP_PARAM_SECURITY_TYPE, &security_type, FROM_STORAGE))
	{	
		PRINT_CONFIG_ERR_MSG("failed to read security type");
		return;
	}

	/* Configuring the default Key ID & default Keys in a working mode that does not include legacy stations 
		is forbidden */
	if ( security_type != TIAP_PARAM_SECURITY_WEP )
	{
		printf("Can not configure default key 29, the WPA working mode does not include legacy stations \n");
		return;
	}

	if ((parameters[0].INTEGER < TIAP_PARAM_MIN_KEY_ID) || (parameters[0].INTEGER > TIAP_PARAM_MAX_KEY_ID))
	{
		printf("Invalid default key index: %ld\n", parameters[0].INTEGER);
		return;
	}

	for (i = 0; i < 29; i++)
		wep_key.key[i] = parameters[i + 1].INTEGER;
	wep_key.len = 29;

	if(tiap_wcfg_set_def_wep_key(wd, parameters[0].INTEGER, &wep_key))
		PRINT_CONFIG_ERR_MSG("failed to set wep default key 29");

}

void privacySetPrivacyBitFlag(ConsoleParameter_T parameters[]){
/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid privacy bit mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetPrivacyBitFlag((BOOL)parameters[0].INTEGER);*/
	PRINT_NOT_SUPPORTED_MSG("Privacy bit flag");
}

/************************************************************************/
/*						Service Application sub-menu functions 					*/
/************************************************************************/

/***************************************************/
/*        Configure vHCF Parameters                */
/***************************************************/
        
void wlanSetVhcf(ConsoleParameter_T parameters[])
{/*
   char inbuf[0xFF];
   UINT8 mIP[4];
   UINT8 *tok;
   UINT16 w_service;
   int  tmp;
   UINT idx;
   tVHCF_PARAMS  vhcfParams;
   UINT8  num_sup_wone;

   wdrv_dbGetVhcfParams(&vhcfParams);  // Get current configuration. 

   // If Dual AP is enabled, reject vHCF command and exit. 
   wdrv_dbGetNumSupWone(&num_sup_wone);
   if (num_sup_wone == WONE_DUAL_BAND)
   {
	   printf("\nRejected!! Can't enable vHCF while Dual AP is enabled!!\n");
	   return;
   }

   // ------------------------ 
   // Edit vHCF enable/disable 
   // ------------------------ 
   while(1)
   {
      printf("vHCF On(1) or Off(0) - [%u] > ", (UINT)vhcfParams.vhcfEnable);
      gets(inbuf);

      if(inbuf[0] == '0')
      {
		vhcfParams.vhcfEnable = FALSE;
		break;
      }
      else if(inbuf[0] == '1')
      {
		vhcfParams.vhcfEnable = TRUE;
		break;
      }
	  else if (strlen(inbuf) == 0)    // User pressed ENTER, so no change. 
		  break;
      printf("Invalid value [0..1]\n");
   }

   // -------------------------------------------- 
   // Edit vHCF Classifiers (Only if vHCF enabled) 
   // -------------------------------------------- 
       
   if(vhcfParams.vhcfEnable)   
   {
	   // Classifiers Dest IP
	   //  =================== 
	   while(1)
	   {
		   // Show current setting: 
		   printf("Dest-IP   [%u.%u.%u.%u] > ",
			   (vhcfParams.vhcfClassifier[0].DestIp >> 24) & 0xFF, 
			   (vhcfParams.vhcfClassifier[0].DestIp >> 16) & 0xFF,
			   (vhcfParams.vhcfClassifier[0].DestIp >>  8) & 0xFF,  
			   (vhcfParams.vhcfClassifier[0].DestIp      ) & 0xFF );
	  
		   // Get new setting: 
		   tmp = get_ip_parameter(mIP);
		   if(tmp == OK)
		   {
			   // Both classifiers use the same IP address (separated for flexibility). 
			   memcpy((char*)&(vhcfParams.vhcfClassifier[0].DestIp), mIP, 4);
			   memcpy((char*)&(vhcfParams.vhcfClassifier[1].DestIp), mIP, 4);
			   break;
		   }
		   else if( tmp == (-ERROR))   // User pressed ENTER, so no change. 
			   break;

		   // Else, Syntax Error - try again (err msg sent by get_ip_parameter). 
	   }

	  for(idx = 0; idx < MAX_VHCF_CLASSIFIERS ; idx++)
	  {
		  // Classifier Protocol
             //=================== 
		  while(1)
		  {
			  // Show current setting: 
              printf("Classifier#%u: Protocol (0-None, 1-TCP, 2-UDP)   [%u] > ", 
				  idx, (UINT)(vhcfParams.vhcfClassifier[idx].Protocol) );

			  // Get new setting: 
              gets(inbuf);
              if ( inbuf[0] >= '0'  &&  inbuf[0] <= '2' )
			  {
				  vhcfParams.vhcfClassifier[idx].Protocol = (VhcfProtocol_e)(inbuf[0] - '0');
				  break;
			  }
			  if (strlen(inbuf) == 0)      // User pressed ENTER, so no change. 
				  break;
			  
			  printf("Invalid value!\n");  // Syntax Error - try again. 
		  }

		  // If classifier not used (protocol=0), go to next classifier. 
		  if (vhcfParams.vhcfClassifier[idx].Protocol == VHCF_PROT_NONE)
			  continue;  // advance for-loop. 

          // Classifier Dest Port
            // ==================== 
		  // Show current setting: 
		  while(1)
		  {
			  printf("Classifier#%u: Dest-Port (0=Any)   [%u] > ",
				  idx, vhcfParams.vhcfClassifier[idx].DestPort);
			  
			  // Get new setting: 
			  gets(inbuf);
			  if( isdigit(inbuf[0]) )
			  {
				  vhcfParams.vhcfClassifier[idx].DestPort = atoi(inbuf);
				  break;
			  }
			  if (strlen(inbuf) == 0)      // User pressed ENTER, so no change. 
				  break;

			  printf("Invalid value!\n");  // Syntax Error - try again. 
		  }
	  } // end of for-loop. 
   } // end of "if(vhcfParams.vhcfEnable)" 

   // --------------------------- 
   //  Save parameters or cancel  
   // --------------------------- 
   while(1)
   {
	   printf("To save settings press 'Y', to cancel press 'N' > ");
	   gets(inbuf);

	   if( (inbuf[0] == 'Y') || (inbuf[0] == 'y'))
	   {
		   wdrv_dbSetVhcfParams(&vhcfParams);    // Save new setting to DB and NVRAM. 
		   printf("\nTo take effect RESTART AP!\n");
		   break;
	   }

	   else if( (inbuf[0] == 'N') || (inbuf[0] == 'n'))
	   {
		   printf("Exited without saving changes.\n");
		   break;
	   }

      if(inbuf[0] == '0')
      {
		  vhcfParams.vhcfEnable = FALSE;
		  break;
      }
      else if(inbuf[0] == '1')
      {
		  vhcfParams.vhcfEnable = TRUE;
		  break;
      }
	  else
	  {
		  printf("Invalid value!\n");
		  continue;
	  }
   }
   */


__u8 wone_nr;
tiap_param_vhcf_t vhcf;
tiap_param_4x_t _4x;
char inbuf[0xFF];
UINT idx;
char ip[20];
struct in_addr in;
	


   
	if( tiap_wcfg_get_basic(wd, TIAP_PARAM_WONE_NUM, &wone_nr, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get wone number.");
		return;
	}

	/* If Dual AP is enabled, reject vHCF command and exit.*/
	if (wone_nr == TIAP_PARAM_WONE_DUAL_BAND) {
		printf("\nRejected!! Can't enable vHCF while Dual AP is enabled!!\n");
		return;
	}

	_4x.cmd = TIAP_PARAM_4X_4X;
	if (tiap_wcfg_get_4x(wd, &_4x, FROM_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
		return;
	}
		

	if (_4x.value == TRUE) {
		printf("\nRejected!! Can't enable vHCF while 4X is enabled!!\n");
		return;
	}

	if( tiap_wcfg_get_vhcf(wd, &vhcf, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get vhcf parameter.");
		return;
	}


   // ------------------------ 
   // Edit vHCF enable/disable 
   // ------------------------ 
   while(1)
   {
      printf("vHCF On(1) or Off(0) - [%hhu] > ", vhcf.enable); fflush(stdout);
      read(0, inbuf, sizeof(inbuf)-1);

      if(inbuf[0] == '0')
      {
		vhcf.enable = FALSE;
		break;
      }
      else if(inbuf[0] == '1')
      {
		vhcf.enable = TRUE;
		break;
      }
	  else if (inbuf[0] == '\n')    // User pressed ENTER, so no change. 
		  break;
      printf("Invalid value [0..1]\n"); fflush(stdout);
   }

   // -------------------------------------------- 
   // Edit vHCF Classifiers (Only if vHCF enabled) 
   // -------------------------------------------- 
       
   if(vhcf.enable)   
   {
	   // Classifiers Dest IP
	   //  =================== 
	   while(1)
	   {
		   // Show current setting: 
		   in.s_addr = vhcf.classifier[0].dest_ip;
		   printf("Dest-IP   [%s] > ",inet_ntoa(in));
		   fflush(stdout);
	  
		   // Get new setting:
		   read(0, ip, sizeof(ip)-1);
		   if( inet_aton(ip, &in) )
		   {
			   // Both classifiers use the same IP address (separated for flexibility). 
			   memcpy((char*)&(vhcf.classifier[0].dest_ip), &in.s_addr, 4);
			   memcpy((char*)&(vhcf.classifier[1].dest_ip), &in.s_addr, 4);
			   break;
		   }
		   else  // User pressed ENTER, so no change. 
			   break;

		   // Else, Syntax Error - try again (err msg sent by get_ip_parameter). 
	   }

	  for(idx = 0; idx < TIAP_PARAM_MAX_VHCF_CLASSIFIERS; idx++)
	  {
		  // Classifier Protocol
             //=================== 
		  while(1)
		  {
			  // Show current setting: 
              printf("Classifier#%u: Protocol (0-None, 1-TCP, 2-UDP)   [%hhu] > ", 
				  idx, (vhcf.classifier[idx].proto) );
	      fflush(stdout);

			  // Get new setting: 
	      read(0, inbuf, sizeof(inbuf)-1);
              if ( inbuf[0] >= '0'  &&  inbuf[0] <= '2' )
			  {
				  vhcf.classifier[idx].proto = (tiap_param_vhcf_proto_t)(inbuf[0] - '0');
				  break;
			  }
			  if (inbuf[0] == '\n')      // User pressed ENTER, so no change. 
				  break;
			  
			  printf("Invalid value!\n");  // Syntax Error - try again. 
		  }

		  // If classifier not used (protocol=0), go to next classifier. 
		  if (vhcf.classifier[idx].proto == vhcf_prot_none)
			  continue;  // advance for-loop. 

          // Classifier Dest Port
            // ==================== 
		  // Show current setting: 
		  while(1)
		  {
			  printf("Classifier#%u: Dest-Port (0=Any)   [%u] > ",
					  idx, vhcf.classifier[idx].dest_port);
			  fflush(stdout);

			  // Get new setting: 
			  read(0, inbuf, sizeof(inbuf)-1);
			  if( isdigit(inbuf[0]) )
			  {
				  vhcf.classifier[idx].dest_port = atoi(inbuf);
				  break;
			  }
			  if (inbuf[0] == '\n')      // User pressed ENTER, so no change. 
				  break;

			  printf("Invalid value!\n");  // Syntax Error - try again. 
		  }
	  } // end of for-loop. 
   } // end of "if(vhcfParams.vhcfEnable)" 

   // --------------------------- 
   //  Save parameters or cancel  
   // --------------------------- 
   while(1)
   {
	   printf("To save settings press 'Y', to cancel press 'N' > ");
	   fflush(stdout);
	   read(0, inbuf, sizeof(inbuf)-1);

	   if( (inbuf[0] == 'Y') || (inbuf[0] == 'y'))
	   {
		   if( tiap_wcfg_set_vhcf(wd, &vhcf, UPDATE_STORAGE) ) {
			   PRINT_CONFIG_ERR_MSG("Failed to set vhcf parameters."); // Save new setting to DB and NVRAM. 
			   return;
		   }
		   printf("\nTo take effect RESTART AP!\n");
		   break;
	   }

	   else if( (inbuf[0] == 'N') || (inbuf[0] == 'n'))
	   {
		   printf("Exited without saving changes.\n");
		   break;
	   }

      if(inbuf[0] == '0')
      {
	      vhcf.enable = FALSE;
	      break;
      }
      else if(inbuf[0] == '1')
      {
	      vhcf.enable = TRUE;
	      break;
      }
	  else
	  {
		  printf("Invalid value!\n");
		  continue;
	  }
   }
}

/* Util function to print rate in MBPS units */
void printOFDMRateInMbpsUnit(UINT8 *rate)
{
	UINT8 rates[TIAP_PARAM_OFDM_RATES_MAX] = {6,9,12,18,24,36,48,54};
	int   i;

	for(i=0; i<TIAP_PARAM_OFDM_RATES_MAX; i++)
	{
		if(rate[i] == TIAP_PARAM_RATE_SUPPORTED)
			printf("%dMbps ", rates[i]);
		else if(rate[i] == TIAP_PARAM_RATE_BASIC_SUPPORTED)
			printf("%dMbpsB ", rates[i]);
	}
}

/* Util function to print rate in MBPS units */
void printRateInMbpsUnit(UINT8 *rate)
{
	UINT8 rates[TIAP_PARAM_CCK_PBCC_RATES_MAX] = {1,2,5,11,22};
	int   i;

	for(i=0; i<TIAP_PARAM_CCK_PBCC_RATES_MAX; i++)
	{
		if(rates[i] != 5)
		{
			if(rate[i] == TIAP_PARAM_RATE_SUPPORTED)
				printf("%dMbps ", rates[i]);
			else if(rate[i] == TIAP_PARAM_RATE_BASIC_SUPPORTED)
				printf("%dMbpsB ", rates[i]);
		}
		else
		{
			if(rate[i] == TIAP_PARAM_RATE_SUPPORTED)
				printf("%d.5Mbps", 5);
			else if(rate[i] == TIAP_PARAM_RATE_BASIC_SUPPORTED)
				printf("%d.5MbpsB", 5);
		}
	}
}


/* util function that check if rate is included in ratesList */
/* output in str string as Y(exist), B(exist & basic) or N(not exist) */
static void isRateInList(UINT8 *ratesList, UINT8 ratesLen, UINT8 rate, char *str)
{
	int i;
	BOOL found=FALSE;

	for (i=0; i<ratesLen; i++)
	{
		if (rate == (ratesList[i]&0x7F))
		{
			if (ratesList[i]&0x80)
			{
				strcpy(str, "B");
			}
			else
			{
				strcpy(str, "Y");
			}
			found= TRUE;
			break;
		}
	}

	if (!found)
	{
		strcpy(str, "N");
	}

}

void wlanSetDualAp(ConsoleParameter_T parameters[])
{/*
    UINT8 RadioFrequency;
    wdrv_dbGetRadioFrequency(&RadioFrequency);
    if (parameters[0].INTEGER == 0)
    {                    
        // Reguler AP 
        wdrv_dbSetNumSupWone(1,TRUE);
        currentConfigWoneInex = 0;
        printf("\nSet Dual AP Off\n");
        printf("\nWone configuration Index set to 0\n");
    }
    else if ( !wdrv_dbIsVhcfEnabled() )  // Allow dual AP only if vHCF is disabled 
    {
        if(RadioFrequency != RADIO_BAND_2_4_AND_5GHZ)
        {
            printf("\n Error: This board support only 2.4 Ghz \n");
            return;
        }
        // Dual AP 
        wdrv_dbSetNumSupWone(2,TRUE);
        printf("\nSet Dual AP On\n");
    }
	else
        printf("\nRejected!! Can't enable Dual AP while vHCF is enabled!!\n")*/


    UINT8 RadioFrequency;
    tiap_param_vhcf_t vhcf;
    __u8 wone_nr;
    char buf[4096];
    int len;

    if( tiap_wcfg_get_vhcf(wd, &vhcf, FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get vhcf parameters.");
	    return;
    }
       

    if( (len = dda_read_proc_entry(WLAN_PROC_SERV_DIR_NAME,
                                        WLAN_PROC_SERV_RADIO_FREQ, buf, sizeof(buf))) == -1 )
                PRINT_PROC_READ_ERR(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RADIO_FREQ);

    sscanf(buf, "%hhu", &RadioFrequency);
    printf("radio freq: %hhu\n", RadioFrequency); fflush(NULL);
    if (parameters[0].INTEGER == 0)
    {                    
        /* Regular AP */
        
		wone_nr = TIAP_PARAM_WONE_SINGLE_BAND;
		if( tiap_wcfg_set_basic(wd, TIAP_PARAM_WONE_NUM, &wone_nr, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set wone number.");
			return;
		}
			currentConfigWoneInex = 0;
			printf("\nSet Dual AP Off\n");
			printf("\nWone configuration Index set to 0\n");
	}
    else if ( !vhcf.enable )  /* Allow dual AP only if vHCF is disabled */
    {
        if(RadioFrequency != TIAP_PARAM_RADIO_BAND_2_4_AND_5GHZ)
        {
            printf("\n Error: This board support only 2.4 Ghz \n");
            return;
        }
        /* Dual AP */
		wone_nr = TIAP_PARAM_WONE_DUAL_BAND;
		if(tiap_wcfg_set_dual_ap(wd, wone_nr)) {
			PRINT_CONFIG_ERR_MSG("Failed to set wone number.");
			return;
	}
        printf("\nSet Dual AP On\n");
	printf("to take effect RESTART AP.\n");
    }
    else
	    printf("\nRejected!! Can't enable Dual AP while vHCF is enabled!!\n");
}

void wlanSetWoneConfIndex(ConsoleParameter_T parameters[])
{/*
    UINT8  num_sup_wone;

    wdrv_dbGetNumSupWone(&num_sup_wone);

   if((parameters[0].INTEGER >= num_sup_wone)||(parameters[0].INTEGER < 0 ))
    {
        printf("\nError:  %d > num_sup_wone (%d)   \n",parameters[0].INTEGER,num_sup_wone); 
    }
    else
    {
        currentConfigWoneInex = parameters[0].INTEGER;
        printf("\n setting Current Config Wone Index To %d \n",currentConfigWoneInex); 
    } 
    */


	__u8 num_sup_wone;

	if( tiap_wcfg_get_basic(wd, TIAP_PARAM_WONE_NUM, &num_sup_wone, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get wone number.");
		return;
	}

	if((parameters[0].INTEGER >= num_sup_wone)||(parameters[0].INTEGER < 0 ))
	{
		printf("\nError:  %ld > num_sup_wone (%hhu)   \n",parameters[0].INTEGER,num_sup_wone); 
	}
	else
	{
		currentConfigWoneInex = parameters[0].INTEGER;
		printf("\n setting Current Config Wone Index To %d \n",currentConfigWoneInex); 
	} 

}

void wlanSetUsageTime(ConsoleParameter_T parameters[])
{/*
    wdrv_dbSetUsageTime(currentConfigWoneInex, parameters[0].INTEGER);
    printf("Setting Wone %d UsageTime %d\n", currentConfigWoneInex, parameters[0].INTEGER); */

	tiap_param_wone_t wone;

	wone.index = currentConfigWoneInex;
	wone.type = wone_usage_time;
	wone.elem.usage_time = parameters[0].INTEGER;

	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set usage time.");
		return;
	}
}

/********************************************************************************************
Sign extension is done to convert signed characters into signed integers, thus causing
printf("%d", MyInteger) to display the correct signed value. Sign bit (MSB) is duplicated,
(extended) to the MSB of the integer (32bit) to form the correct value.
 
for example:
0x02  -> 0x00000002 = +2    - bit 7 = 0, no need to "or".
0xFE  -> 0xFFFFFFFE = -2  -  duplicating bit 7 (i.e. or with 0xFFFFFF00)
********************************************************************************************/
#if 0
static int sign_extend8( char c)
{/*
   int retv = c;
   if( c & 0x80) {
      // duplicate sign bit 
      retv |= 0xffffff00;
   }
   return retv;
   */
   return 1;
}
#endif

void wlanRadioParams( ConsoleParameter_T parameters[])
{/*
   int i, selRate, selLevel, idx, val, ovd, modified=0;
   char buf[180];
   const char *sMsg1[] =
   {
      "100%", 
      "50%",
      "25%",
      "12.5%",
      "lowest"
   };
   RadioParam_t rdp = {0};

   wdrv_dbGetRadioParams( &rdp);

   // Display the table 
   puts( "\n\tRates\t:\t54-48\t36-18\t 12-6\t 11b");
   puts( "-------------------------------------------------------------------");
   for( i =0 ; i < MAX_RADIO_PARAM_POWER_LEVELS; i++) {
      int j = i * MAX_RADIO_PARAM_POWER_RATES;
      printf( "LVL %d (%s)\t:\t", i+1, sMsg1[i]);
      printf( "%4d\t%4d\t%4d\t%4d\n",
         sign_extend8(rdp.powerTable_param[j  ]),
         sign_extend8(rdp.powerTable_param[j+1]),
         sign_extend8(rdp.powerTable_param[j+2]),
         sign_extend8(rdp.powerTable_param[j+3])
         );
   }
   if( ovd = (rdp.overrideBitmask & RADIO_PARAM_OVERRIDE_POWERTABLE)) {
      puts("Radio Power table overrides HW settings");
   } else {
      puts("Radio Power table uses HW settings");
   }

   // Ask if user wants to edit this setting 
   printf( "Edit this setting [y/n] ? ");
   buf[0] = '\0';
   fgets( buf, sizeof(buf), stdin);
   if( tolower(buf[0]) == 'y' )
   {
      // ask what to edit. 
      printf( "\nSelect Rate:\n"
         "[1] 54-48\n"
         "[2] 36-18\n"
         "[3] 12-6\n"
         "[4] 11b\n"
         "Enter selection [1-%d]: ", MAX_RADIO_PARAM_POWER_RATES);
      buf[0] = '\0';
      fgets( buf, sizeof(buf), stdin);
      if( 1 != sscanf( buf, "%d", &selRate))
         return;
      if( (selRate >= 1) && (selRate <= MAX_RADIO_PARAM_POWER_RATES))
         --selRate;
      else{
         puts("Invalid selection");
         return;
      }

      puts( "\nSelect level:");
      for( i = 0; i<MAX_RADIO_PARAM_POWER_LEVELS; ++i) {
         printf( "[%d] %s\n", i+1, sMsg1[i]);
      }
      printf( "Enter selection [1-%d]: ", i);
      buf[0] = '\0';
      fgets( buf, sizeof(buf), stdin);
      if( 1 != sscanf( buf, "%d", &selLevel))
         return;
      if( (selLevel>= 1) && (selLevel<= i))
         --selLevel;
      else{
         puts("Invalid selection");
         return;
      }
   
      idx = selLevel * MAX_RADIO_PARAM_POWER_RATES + selRate;
      printf( "Enter new value [%d]: ", sign_extend8(rdp.powerTable_param[idx]));
      buf[0] = '\0';
      fgets( buf, sizeof(buf), stdin);
      if( (buf[0] == '-') || (isdigit(buf[0])))
      {
         if( 1 != sscanf( buf, "%d", &val)) {
            val = rdp.powerTable_param[idx];
         } else {
            val &= 0xff;
            rdp.powerTable_param[idx] = val;
         }
         wdrv_dbSetRadioParams( &rdp, RADIO_PARAM_POWER_TABLE, FALSE);
         modified = 1;
      }
   }

   // Ask if user wants to override HW power table 
   printf( "Override HW radio power table [y/n] <%c> ? ", ovd ? 'y':'n');
   buf[0] = '\0';
   fgets( buf, sizeof(buf), stdin);
   if( buf[0] != '\0') {
      if( tolower(buf[0]) == 'y' ) {
         if( !ovd)  modified = 1;
         ovd = 1;
         rdp.overrideBitmask |= 1;
      } else if( tolower(buf[0]) == 'n') {
         if( ovd ) modified = 1;
         ovd = 0;
         rdp.overrideBitmask &= ~1;
      };
   }
   wdrv_dbSetRadioParams( &rdp, RADIO_PARAM_OVERRIDE_BMASK, modified);

   // set the radio params according to the new configuration 
   whal_apiSetRadioParams();
   */



	   int i, selRate, selLevel, idx, val, ovd, modified=0;
   char buf[180];
   int len;
   const char *sMsg1[] =
   {
	   "100%", 
	   "50%",
	   "25%",
	   "12.5%",
	   "lowest"
   };
   tiap_param_radio_t radio = {0};
   
   if( (len = dda_read_proc_entry(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RADIO_PARAMS,
				   (char *)&radio, sizeof(radio))) == -1) {
	   printf("%s: Failed to read %s %s\n", __func__,
			   WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RADIO_PARAMS);
	   return;
   }

   // Display the table 
   puts( "\n\tRates\t:\t54-48\t36-18\t 12-6\t 11b");
   puts( "-------------------------------------------------------------------");
   for( i =0 ; i < TIAP_PARAM_MAX_RADIO_PARAM_POW_LEVELS; i++) {
      int j = i * TIAP_PARAM_MAX_RADIO_PARAM_POW_RATES;
      printf( "LVL %d (%s)\t:\t", i+1, sMsg1[i]);
      printf( "%4d\t%4d\t%4d\t%4d\n",
         radio.tbl.param[j  ],
         radio.tbl.param[j+1],
         radio.tbl.param[j+2],
         radio.tbl.param[j+3]
         );
   }
   if( (ovd = (radio.mask & RADIO_PARAM_OVERRIDE_POWERTABLE))) {
      puts("Radio Power table overrides HW settings");
   } else {
      puts("Radio Power table uses HW settings");
   }

   

   // Ask if user wants to edit this setting 
   printf( "Edit this setting [y/n] ? ");
   buf[0] = '\0';
   fgets( buf, sizeof(buf), stdin);
   if( tolower(buf[0]) == 'y' )
   {
	   // ask what to edit. 
	   printf( "\nSelect Rate:\n"
			   "[1] 54-48\n"
			   "[2] 36-18\n"
			   "[3] 12-6\n"
			   "[4] 11b\n"
			   "Enter selection [1-%d]: ", TIAP_PARAM_MAX_RADIO_PARAM_POW_RATES);
	   buf[0] = '\0';
	   fgets( buf, sizeof(buf), stdin);
	   if( 1 != sscanf( buf, "%d", &selRate))
		   return;
	   if( (selRate >= 1) && (selRate <= TIAP_PARAM_MAX_RADIO_PARAM_POW_RATES))
		   --selRate;
	   else{
		   puts("Invalid selection");
		   return;
	   }

	   puts( "\nSelect level:");
	   for( i = 0; i<TIAP_PARAM_MAX_RADIO_PARAM_POW_LEVELS; ++i) {
		   printf( "[%d] %s\n", i+1, sMsg1[i]);
	   }
	   printf( "Enter selection [1-%d]: ", i);
	   buf[0] = '\0';
	   fgets( buf, sizeof(buf), stdin);
	   if( 1 != sscanf( buf, "%d", &selLevel))
		   return;
	   if( (selLevel>= 1) && (selLevel<= i))
		   --selLevel;
	   else{
		   puts("Invalid selection");
		   return;
	   }

	   idx = selLevel * TIAP_PARAM_MAX_RADIO_PARAM_POW_RATES + selRate;
	   printf( "Enter new value [%hhd]: ", radio.tbl.param[idx]);
	   buf[0] = '\0';
	   fgets( buf, sizeof(buf), stdin);
	   if( (buf[0] == '-') || (isdigit(buf[0])))
	   {
		   if( 1 != sscanf( buf, "%d", &val)) {
			   val = radio.tbl.param[idx];
		   } else {
			   val &= 0xff;
			   radio.tbl.param[idx] = val;
		   }
		   radio.mask &= ~1;
		   if( tiap_wcfg_set_cfg_pow_tbl(wd, &radio, !UPDATE_STORAGE) ) {
			   PRINT_CONFIG_ERR_MSG("Failed to set radio power table.");
			   return;
		   }

		   modified = 1;
	   }
   }

   // Ask if user wants to override HW power table 
   printf( "Override HW radio power table [y/n] <%c> ? ", ovd ? 'y':'n');
   buf[0] = '\0';
   fgets( buf, sizeof(buf), stdin);

   if( buf[0] == '\n') /* user pressed Enter*/
	   buf[0] = (ovd ? 'y':'n');
   
	if( tolower(buf[0]) == 'y' ) {
		   if( !ovd)  modified = 1;
		   ovd = 1;
		   radio.mask |= 1;
	
	} else if( tolower(buf[0]) == 'n') {
		   if( ovd ) modified = 1;
		   ovd = 0;
		   radio.mask &= ~1;
	}
	else
	{
		printf("\nThe valid answer is only 'y' or 'n'\n");
		return;
	}
   
   if( tiap_wcfg_set_cfg_pow_tbl(wd, &radio, modified) ) {
		   PRINT_CONFIG_ERR_MSG("Failed to set radio power table.");
		   return;
	}
   
	   
}/* END wlanRadioParams() */

void wlanSetUsageTimeMode(ConsoleParameter_T parameters[])
{/*
   UINT8  num_sup_wone;

   // If Dual AP is disable, reject usagetimeMode command and exit. 
   wdrv_dbGetNumSupWone(&num_sup_wone);
   if (num_sup_wone == WONE_SINGLE_BAND)
   {
	   printf("\nRejected!! Can't change Usage Time Mode while Dual AP is disable !!\n");
	   return;
   }
   wdrv_dbSetUsageTimeMode(parameters[0].SHORT, TRUE);

   printf("\n parameters[0].INTEGER = %x \n",parameters[0].SHORT );
   
   if (parameters[0].INTEGER == FALSE)
       printf("Set Short Usage Time\n" ); 
   else
       printf("Set Long Usage Time\n" ); 
       */

	   UINT8  num_sup_wone, usage_timemod;

	   /* If Dual AP is disable, reject usagetimeMode command and exit. */

	   if( tiap_wcfg_get_basic(wd, TIAP_PARAM_WONE_NUM, &num_sup_wone, FROM_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to get wone number.");
			return;
	   }
	   if (num_sup_wone == TIAP_PARAM_WONE_SINGLE_BAND)
	   {
		   printf("\nRejected!! Can't change Usage Time Mode while Dual AP is disable !!\n");
		   return;
	   }


	   usage_timemod = (UINT8)parameters[0].SHORT;

	   if( tiap_wcfg_set_basic(wd, TIAP_PARAM_WONE_TIME_MODE, &usage_timemod,UPDATE_STORAGE) ) 
	   {
			PRINT_CONFIG_ERR_MSG("Failed to set wone usage time mode.");
			return;
	   }

	   /* printf("\n parameters[0].INTEGER = %x \n",parameters[0].SHORT );*/
   
	   if (parameters[0].INTEGER == FALSE)
	       printf("Set Short Usage Time\n" ); 
	   else
	       printf("Set Long Usage Time\n" ); 

}

void wlanSetMacAddr(ConsoleParameter_T parameters[]){
/*
   wdrv_dbSetOperationMacAddress(parameters[0].MAC_ADDR);
   printf("setting WLAN MAC = <%02hhX-%02hhX-%02hhX-%02hhX-%02hhX-%02hhX>\n",
          parameters[0].MAC_ADDR[0],parameters[0].MAC_ADDR[1],parameters[0].MAC_ADDR[2],parameters[0].MAC_ADDR[3],
          parameters[0].MAC_ADDR[4],parameters[0].MAC_ADDR[5] );
   printf("to take effect RESTART AP.\n");*/


	if( tiap_wcfg_set_hwaddr(wd, parameters[0].MAC_ADDR) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set hardware address.");
		return;
	}
	
	printf("setting WLAN MAC = <%02hhX-%02hhX-%02hhX-%02hhX-%02hhX-%02hhX>\n",
			parameters[0].MAC_ADDR[0],parameters[0].MAC_ADDR[1],
			parameters[0].MAC_ADDR[2],parameters[0].MAC_ADDR[3],
			parameters[0].MAC_ADDR[4],parameters[0].MAC_ADDR[5] );
	printf("to take effect RESTART AP.\n");
}

/************************************************/
/*                  S S I D                     */
/************************************************/

void wlanSsidPrintParams(ConsoleParameter_T parameters[])
{/*
    char  macaddr[6], ssid[50];
    int i;
    UINT16 HiddenSSID, MultipleSsidFlag;
    char MultipleSsidTable[NUM_MULTIPLE_SSID][WHAL_SSID_STRING_LEN];
    UINT32 length = NUM_MULTIPLE_SSID*WHAL_SSID_STRING_LEN;

    wdrv_dbGetSsid(ssid);
    wdrv_dbGetHiddenSsidStatus(&HiddenSSID);
    wdrv_dbGetMultipleSsidStatus(&MultipleSsidFlag);
    whal_nvram_getMultipleSsidTable(MultipleSsidTable[0],&length);

    printf("SSID = %s\n", ssid); 

    printf("Hidden SSID mode is %s\n", (HiddenSSID==1) ? "Enabled" : "Disabled");
    if (wdrv_dbIsPrivacyEnabled())
    {
        printf("Multiple SSID features is DISABLED, due to Privacy use.\n\n");
    }
    else
        printf("Multiple SSID mode is %s\n", (MultipleSsidFlag==1) ? "Enabled" : "Disabled");
    
    if (MultipleSsidTable[0][0] == '\0')
    {
        printf("Multiple SSID table is empty.\n");
    }
    else
    {
        printf("\nList of Multiple SSID:\n");
        for (i=0; i<NUM_MULTIPLE_SSID; i++) 
        {
            if (MultipleSsidTable[i][0] == '\0')
                break;
            printf("\t%d. %s\n",i+1,MultipleSsidTable[i]);
        }
        if (i==0)
            printf("\tNone.\n");
    }*/


	char  ssid[IW_ESSID_MAX_SIZE+1];
	int i;
	__u16 hidden_ssid;
	tiap_param_multi_ssid_t multi_ssid;

	if( tiap_wcfg_giwessid(wd, ssid, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get ssid.");
		return;
	}

	if( tiap_wcfg_get_basic(wd, TIAP_PARAM_HIDDEN_SSID, &hidden_ssid, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get hidden ssid.");
		return;
	}

	if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
		return;
	}

	printf("SSID = %s\n", ssid); 

	printf("Hidden SSID mode is %s\n", (hidden_ssid==1) ? "Enabled" : "Disabled");

	if( is_privacy_enabled() )
		printf("Multiple SSID features is DISABLED, due to Privacy use.\n\n");
	else printf("Multiple SSID mode is %s\n", (multi_ssid.enabled==1) ? "Enabled" : "Disabled");


	if (multi_ssid.tbl.ssid[0][0] == '\0')
	{
		printf("Multiple SSID table is empty.\n");
	}
	else
	{
		printf("\nList of Multiple SSID:\n");
		for (i=0; i<TIAP_PARAM_NUM_MULTIPLE_SSID; i++) 
		{
			if (multi_ssid.tbl.ssid[i][0] == '\0')
				break;
			printf("\t%d. %s\n",i+1,multi_ssid.tbl.ssid[i]);
		}
		if (i==0)
			printf("\tNone.\n");
	}
}


void wlanSSID(ConsoleParameter_T parameters[])
{/*
    UINT8 pbSSID[WHAL_SSID_STRING_LEN+1];
    UINT8 bLen = WHAL_SSID_STRING_LEN;
    whal_nvram_getSsid(pbSSID, &bLen);
    pbSSID[bLen] = 0;
   
    printf("SSID <%s>: ",pbSSID);
    fgets(pbSSID, WHAL_SSID_STRING_LEN, stdin);
    pbSSID[strlen(pbSSID) - 1] = 0; // remove newline 
    bLen = min(strlen(pbSSID),WHAL_SSID_STRING_LEN);
    if(bLen > 0)
    {
        pbSSID[bLen] = 0;
        printf("setting SSID <%s>\n",pbSSID);
        whal_nvram_setSsid(pbSSID,bLen,IMMEDIATELY);
        puts("to take effect RESTART AP.");
    }*/

	char ssid[IW_ESSID_MAX_SIZE+2];
	__u8 len;

	if( tiap_wcfg_giwessid(wd, ssid, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get ssid.");
		return;
	}

	printf("SSID <%s>: ", ssid);
	fgets(ssid, IW_ESSID_MAX_SIZE+2, stdin);
	len = strlen(ssid);
	ssid[len-1] = '\0'; /* remove new line character */

	if( strlen(ssid) )
	{
		if( tiap_wcfg_siwessid(wd, ssid, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set ssid.");
			return;
		}
		printf("setting SSID <%s>\n", ssid);
		puts("to take effect RESTART AP.");
	}
}

void wlanSetHiddenSSID(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) &&
		(parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetHiddenSsidStatus(parameters[0].SHORT);
	printf("Setting Hidden SSID mode to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");*/

	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}

	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_HIDDEN_SSID, &parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set hidden ssid.");
		return;
	}

	printf("Setting Hidden SSID mode to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");
}

void wlanSetMultipleSSID(ConsoleParameter_T parameters[])
{/*
    if (wdrv_dbIsPrivacyEnabled())
    {
        printf("Multiple SSID features is DISABLED, due to Privacy use.\n");
        return;
    }
	if ((parameters[0].SHORT != 0) &&
		(parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetMultipleSsidStatus(parameters[0].SHORT);
	printf("Setting Multiple SSID mode to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");*/

	tiap_param_multi_ssid_t multi_ssid;

	if( is_privacy_enabled() )
	{
		printf("Multiple SSID feature is DISABLED, due to Privacy use.\n");
		return;
	}
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}

	/* Here is a trick, which Alexandra taught me,
	   though she says that I'd taught her in the first place.*/
	if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
		return;
	}

	multi_ssid.enabled = parameters[0].SHORT;
	
	multi_ssid.cmd = TIAP_PARAM_MULTI_SSID_SET;
	if( tiap_wcfg_set_multi_ssid(wd, &multi_ssid, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set multiple ssid status.");
		return;
	}
	printf("Setting Multiple SSID mode to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");
}

void wlanAddMultipleSsidElement(ConsoleParameter_T parameters[]) 
{/*
    UINT8 pbSSID[WHAL_SSID_STRING_LEN+4];
    UINT8 apSSID[WHAL_SSID_STRING_LEN+1];
    UINT8 bLen = WHAL_SSID_STRING_LEN, apSsidLen;
    char tempTable[NUM_MULTIPLE_SSID][WHAL_SSID_STRING_LEN];
    UINT32 len = NUM_MULTIPLE_SSID*WHAL_SSID_STRING_LEN;
    int index,loop;
    UINT16 multipleSsidFlag;

    whal_nvram_getMultipleSsidStatus(&multipleSsidFlag);
    if (multipleSsidFlag == 0) 
    {
        printf("The Multiple SSID mode is disable. Enable it first.\n");
        return;
    }
    // Look for an empty place in Multiple SSID table 
    whal_nvram_getMultipleSsidTable(tempTable[0],&len);
    index = 0;
    while (index < NUM_MULTIPLE_SSID) 
    {
        if (tempTable[index][0] == '\0') 
            break;
        index++;
    }
    if (index == NUM_MULTIPLE_SSID) 
    {
        printf("The Multiple SSID table is full.\n");
        return;
    }

    printf("Type SSID: ");
    memset(pbSSID,0,WHAL_SSID_STRING_LEN+1);
    fgets(pbSSID, WHAL_SSID_STRING_LEN+3, stdin);
    pbSSID[strlen(pbSSID) - 1] = 0; // remove newline 
    if (strlen(pbSSID) > WHAL_SSID_STRING_LEN) 
    {
        printf("String too long! must be lower than %d.\n",WHAL_SSID_STRING_LEN+1);
        return;
    }
    bLen = min(strlen(pbSSID),WHAL_SSID_STRING_LEN);
    if(bLen > 0)
    {
        // Check that the new value differs from AP SSID 
        whal_nvram_getSsid(apSSID, &apSsidLen);
        apSSID[apSsidLen] = 0;
        if (strcmp(pbSSID,apSSID)==0)
        {
            printf("The new SSID equals the AP SSID. Setting aborted!\n");
            return;
        }
        // Check that the new SSID not exists 
        for (loop=0; loop<index;loop++)
        {
            if (memcmp(pbSSID,tempTable[loop],WHAL_SSID_STRING_LEN) == 0)
            {
                printf("The new SSID already exists in the Multiple SSID table. Setting aborted!\n");
                return;
            }
        }
       pbSSID[bLen] = 0;
       printf("setting new SSID element to Multiple SSID table <%s>\n",pbSSID);
       wdrv_dbSetElementToMultipleSsidTable(pbSSID,bLen);
       puts("to take effect RESTART AP.");
    }*/

	tiap_param_multi_ssid_t multi_ssid;
	UINT8 pbSSID[IW_ESSID_MAX_SIZE+4];
	UINT8 ssid[IW_ESSID_MAX_SIZE+1];
	UINT8 bLen = IW_ESSID_MAX_SIZE;
	//char tempTable[NUM_MULTIPLE_SSID][WHAL_SSID_STRING_LEN];
	int index,loop;

	if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
		return;
	}
	if (!multi_ssid.enabled) 
	{
		printf("The Multiple SSID mode is disable. Enable it first.\n");
		return;
	}
	// Look for an empty place in Multiple SSID table 
	index = 0;
	while (index < TIAP_PARAM_NUM_MULTIPLE_SSID) 
	{
		if (multi_ssid.tbl.ssid[index][0] == '\0') 
			break;
		index++;
	}
	if (index == TIAP_PARAM_NUM_MULTIPLE_SSID) 
	{
		printf("The Multiple SSID table is full.\n");
		return;
	}

	printf("Type SSID: ");
	memset(pbSSID,0,IW_ESSID_MAX_SIZE+1);
	fgets(pbSSID, IW_ESSID_MAX_SIZE+3, stdin);
	pbSSID[strlen(pbSSID) - 1] = 0; // remove newline 
	if (strlen(pbSSID) > IW_ESSID_MAX_SIZE)
	{
		printf("String too long! must be lower than %d.\n",IW_ESSID_MAX_SIZE+1);
		return;
	}
	bLen = min(strlen(pbSSID),IW_ESSID_MAX_SIZE);
	if(bLen > 0)
	{
		/* Check that the new value differs from AP SSID */
		if( tiap_wcfg_giwessid(wd, ssid, FROM_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to get ssid.");
			return;
		}

		if (strcmp(pbSSID, ssid)==0)
		{
			printf("The new SSID equals the AP SSID. Setting aborted!\n");
			return;
		}
		
		/* Check that the new SSID doesn't exist (in the STORAGE)  */
		
		if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
			return;
		}

		for (loop=0; loop<index;loop++)
		{
			if (memcmp(pbSSID,multi_ssid.tbl.ssid[loop],IW_ESSID_MAX_SIZE) == 0)
			{
				printf("The new SSID already exists in the Multiple SSID table. Setting aborted!\n");
				return;
			}
		}
		pbSSID[bLen] = 0;
		printf("setting new SSID element to Multiple SSID table <%s>\n",pbSSID);
		multi_ssid.cmd = TIAP_PARAM_MULTI_SSID_ADD;
		strncpy(multi_ssid.tbl.ssid[0], pbSSID, IW_ESSID_MAX_SIZE);
		if( tiap_wcfg_set_multi_ssid(wd, &multi_ssid, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to add ssid to multiple ssid table.");
			return;
		}
		puts("to take effect RESTART AP.");
		
	}
}

void wlanRemoveMultipleSsidElement(ConsoleParameter_T parameters[])
{/*
    UINT8 pbSSID[WHAL_SSID_STRING_LEN+1];
    UINT8 bLen = WHAL_SSID_STRING_LEN;
    char tempTable[NUM_MULTIPLE_SSID][WHAL_SSID_STRING_LEN];
    UINT32 len = NUM_MULTIPLE_SSID*WHAL_SSID_STRING_LEN;
    int index, chosen;
    UINT16 multipleSsidFlag;

    whal_nvram_getMultipleSsidStatus(&multipleSsidFlag);
    if (multipleSsidFlag == 0) 
    {
        printf("The Multiple SSID mode is disable. Enable it first.\n");
        return;
    }

    whal_nvram_getMultipleSsidTable(tempTable[0],&len);
    index = 0;
    while (index < NUM_MULTIPLE_SSID) 
    {
        if (tempTable[index][0] == '\0') 
            break;
        index++;
        if (index == 1)
            printf("List of Multiple SSID:\n");
        printf("%d. %s\n",index,tempTable[index-1]);
    }
    if (index == 0) 
    {
        printf("The Multiple SSID table is empty.\n");
        return;
    }

    printf("Type SSID index: ");
    fgets(pbSSID, WHAL_SSID_STRING_LEN, stdin);
    pbSSID[strlen(pbSSID) - 1] = 0; // remove newline 
    chosen = atoi(pbSSID);
    if(chosen > 0)
    {
       if (chosen > index) 
       {
           printf("index not exists!\n");
           return;
       }
       printf("removing SSID element #%d from the Multiple SSID table\n",chosen);
       wdrv_dbRemoveElementFromMultipleSsidTable(chosen);
       puts("to take effect RESTART AP.");
    }*/

	UINT8 pbSSID[IW_ESSID_MAX_SIZE+1];
	int index, chosen;
	tiap_param_multi_ssid_t multi_ssid;

	
	if( tiap_wcfg_get_multi_ssid(wd, &multi_ssid, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get multiple ssid status.");
		return;
	}
	
	if (!multi_ssid.enabled) 
	{
		printf("The Multiple SSID mode is disable. Enable it first.\n");
		return;
	}

	index = 0;
	while (index < TIAP_PARAM_NUM_MULTIPLE_SSID) 
	{
		if (multi_ssid.tbl.ssid[index][0] == '\0') 
			break;
		index++;
		if (index == 1)
			printf("List of Multiple SSID:\n");
		printf("%d. %s\n",index,multi_ssid.tbl.ssid[index-1]);
	}
	if (index == 0) 
	{
		printf("The Multiple SSID table is empty.\n");
		return;
	}

	printf("Type SSID index: ");
	fgets(pbSSID, IW_ESSID_MAX_SIZE, stdin);
	pbSSID[strlen(pbSSID) - 1] = 0; // remove newline 
	chosen = atoi(pbSSID);
	
	if(chosen > 0)
	{
		if (chosen > index) 
		{
			printf("index does not exist!\n");
			return;
		}
		printf("removing SSID element #%d from the Multiple SSID table\n",chosen);
		multi_ssid.cmd = TIAP_PARAM_MULTI_SSID_DEL;
		multi_ssid.tbl.ssid_id = chosen-1;
		if( tiap_wcfg_set_multi_ssid(wd, &multi_ssid, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to delete from multiple ssid table.");
			return;
		}
		puts("to take effect RESTART AP.");
	}
	else
		printf("index out of range\n");
}

/****************************************************/
/*                  802.11 D & H                    */
/****************************************************/

void wlan_dh_PrintParams(ConsoleParameter_T parameters[])
{/*
    UINT8 value, band, regDomain, uint8value;
    INT8  int8value;
    UINT32   level, i;
    wlan_bandType bandType;
    IntegerRegulatoryDomains_e RegDomain;
    tChannelRangeElementStruct RangeElementStruct;
    char countryString[3];


    whal_nvram_getBand(currentConfigWoneInex, &band);

#ifdef WLAN_801_11_H_IMPLEMENTED
	printf("802.11D and 802.11H parameters:\n");
    printf("===============================\n");
#else
	printf("802.11D parameters:\n");
    printf("===================\n");
#endif // WLAN_801_11_H_IMPLEMENTED 
    wdrv_dbGetdot11MultiDomainCapabilityStatus(&value);
    printf("Multi Domain Capability status is: %s\n",(value == 0) ? "Disable" : "Enable");
#ifdef WLAN_801_11_H_IMPLEMENTED
    wdrv_dbGetdot11SpectrumManagementRequiredStatus(&value);
    printf("Spectrum Management Requirement status is: %s\n",(value == 0) ? "Disable" : "Enable");
    wdrv_dbGetLegacyStatusEnableStatus(&value);
    printf("Legacy Station establishment status is : %s\n",(value == 0) ? "Disable" : "Enable");
#endif // WLAN_801_11_H_IMPLEMENTED 
    wdrv_dbGetdot11LocalPowerConstraint(&uint8value);
    printf("Power Constraint is %d (dB)\n",uint8value);
    printf("Band is: %s\n",(band == RADIO_BAND_2_4GHZ) ? "RADIO_BAND_2_4GHZ (G)" : "RADIO_BAND_5GHZ (A)");
    wdrv_dbGetdot11CurrentRegDomain(band,&regDomain);
    printf("Regulatory Domain is: ");

    // compute regularity domain 
    switch (band) 
    {
        case RADIO_BAND_2_4GHZ: // g 
            switch (regDomain)
            {
                case REG_DOMAIN_FCC:
                    printf("REG_DOMAIN_FCC (0x10)\n");
                    break;
                case REG_DOMAIN_IC:
                    printf("REG_DOMAIN_IC (0x20)\n");
                    break;
                case REG_DOMAIN_ETSI:
                    printf("REG_DOMAIN_ETSI (0x30)\n");
                    break;
                case REG_DOMAIN_SPAIN:
                    printf("REG_DOMAIN_SPAIN (0x31)\n");
                    break;
                case REG_DOMAIN_FRANCE:
                    printf("REG_DOMAIN_FRANCE (0x32)\n");
                    break;
                case REG_DOMAIN_MKK:
                    printf("REG_DOMAIN_MKK (0x40)\n");
                    break;
                case REG_DOMAIN_MKK1:
                    printf("REG_DOMAIN_MKK1 (0x41)\n");
                    break;
                default :
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n",regDomain);
                    break;
            }
            break;
    
        case RADIO_BAND_5GHZ:   // a 
            switch (regDomain)
            {
                case REG_DOMAIN_US:
                    printf("REG_DOMAIN_US (0x50)\n");
                    break;
                case REG_DOMAIN_WORLD:
                    printf("REG_DOMAIN_WORLD (0x51)\n");
                    break;
                default:
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n",regDomain);
                    break;
            }
            break;
    }

    wdrv_dbGetMaxTxPowerLevel(&int8value);
    printf("Max Tx Power is %d (dBm)\n",int8value);
    printf("Tx Power levels for band 5GHz: (dBm)\n");
    for (level=1; level<=5; level++)
    {
        wdrv_dbGetTxPowerLevels(RADIO_BAND_5GHZ, level,&int8value);
        printf("\t%d.\t%d\n",level,(int)int8value);
    }
    printf("Tx Power levels for band 2.4GHz: (dBm)\n");
    for (level=1; level<=5; level++)
    {
        wdrv_dbGetTxPowerLevels(RADIO_BAND_2_4GHZ, level,&int8value);
        printf("\t%d.\t%d\n",level,(int)int8value);
    }
    wdrv_dbGetdot11CountryString(countryString);
    printf("Country String is: %c%c, type: %c ",
           countryString[0],
           countryString[1],
           countryString[2]);
    if (countryString[2] == 'I') 
        printf("(Indoor)\n");
    else if (countryString[2] == 'O') 
            printf("(Outdoor)\n");
    else
        printf("(Other)\n");*/


UINT8 value, uint8value;
    __u8  int8value;
    UINT32   level;
    char countryString[3];
    tiap_param_wone_t wone;
    tiap_param_cur_reg_domain_t cur_regdomain;
    tiap_param_txpower_t txpow;


    wone.index = currentConfigWoneInex;
    wone.type = wone_band;
    if( tiap_wcfg_get_wone(wd, &wone, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get band.");
	    return;
    }

#ifdef WLAN_801_11_H_IMPLEMENTED
	printf("802.11D and 802.11H parameters:\n");
    printf("===============================\n");
#else
	printf("802.11D parameters:\n");
    printf("===================\n");
#endif // WLAN_801_11_H_IMPLEMENTED 

    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_MULTI_DOMAIN_CAPAB, &value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get multiple domain capability.");
	    return;
    }
    printf("Multi Domain Capability status is: %s\n",(value == 0) ? "Disable" : "Enable");
#ifdef WLAN_801_11_H_IMPLEMENTED
    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_SPECTRUM_MGMT, &value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get spectrum management required.");
	    return;
    }
    printf("Spectrum Management Requirement status is: %s\n",(value == 0) ? "Disable" : "Enable");
    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_SPECTRUM_MGMT, &value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get spectrum management required.");
	    return;
    }
    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_LEGACY_STA, &value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get legacy station establishment status.");
	    return;
    }
    printf("Legacy Station establishment status is : %s\n",(value == 0) ? "Disable" : "Enable");
#endif // WLAN_801_11_H_IMPLEMENTED 
    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_LOCAL_POWER_CONS, &uint8value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get power constraint.");
	    return;
    }
    printf("Power Constraint is %d (dB)\n",uint8value);
    printf("Band is: %s\n",(wone.elem.band == TIAP_PARAM_RADIO_BAND_2_4GHZ) ?
		    "RADIO_BAND_2_4GHZ (G)" : "RADIO_BAND_5GHZ (A)");
    cur_regdomain.band = wone.elem.band;
    if( tiap_wcfg_get_cur_regdomain(wd, &cur_regdomain, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get power constraint.");
	    return;
    }
    printf("Regulatory Domain is: ");

    // compute regularity domain 
    switch (wone.elem.band) 
    {
        case TIAP_PARAM_RADIO_BAND_2_4GHZ: // g 
            switch ((__u8)cur_regdomain.type)
            {
                case TIAP_PARAM_RD_FCC:
                    printf("REG_DOMAIN_FCC (0x10)\n");
                    break;
                case TIAP_PARAM_RD_IC:
                    printf("REG_DOMAIN_IC (0x20)\n");
                    break;
                case TIAP_PARAM_RD_ETSI:
                    printf("TIAP_PARAM_RD_ETSI (0x30)\n");
                    break;
                case TIAP_PARAM_RD_SPAIN:
                    printf("TIAP_PARAM_RD_SPAIN (0x31)\n");
                    break;
                case TIAP_PARAM_RD_FRANCE:
                    printf("TIAP_PARAM_RD_FRANCE (0x32)\n");
                    break;
                case TIAP_PARAM_RD_MKK:
                    printf("TIAP_PARAM_RD_MKK (0x40)\n");
                    break;
                case TIAP_PARAM_RD_MKK1:
                    printf("TIAP_PARAM_RD_MKK1 (0x41)\n");
                    break;
                default :
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n", (__u8)cur_regdomain.type);
                    break;
            }
            break;
    
        case TIAP_PARAM_RADIO_BAND_5GHZ:   // a 
            switch ((__u8)cur_regdomain.type)
            {
                case TIAP_PARAM_RD_US:
                    printf("REG_DOMAIN_US (0x50)\n");
                    break;
                case TIAP_PARAM_RD_WORLD:
                    printf("REG_DOMAIN_WORLD (0x51)\n");
                    break;
                default:
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n", (__u8)cur_regdomain.type);
                    break;
            }
            break;
    }

    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_MAX_TX_POWER_LEVEL, &int8value, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get max tx power.");
	    return;
    }
    printf("Max Tx Power index is %d\n",int8value);
    printf("Tx Power levels for band 5GHz: (dBm)\n");

    txpow.hr = txpower_a;
    if( tiap_wcfg_giwtxpow(wd, &txpow, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get tx powers.");
	    return;
    }
    for (level=1; level<=5; level++)
        printf("\t%d.\t%d\n", level, (int)txpow.txpower[level-1]);


    txpow.hr = txpower_g;
    if( tiap_wcfg_giwtxpow(wd, &txpow, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get tx powers.");
	    return;
    }
    printf("Tx Power levels for band 2.4GHz: (dBm)\n");
    for (level=1; level<=5; level++)
        printf("\t%d.\t%d\n", level, (int)txpow.txpower[level-1]);

    if( tiap_wcfg_get_basic(wd, TIAP_PARAM_COUNTRY_STR, &countryString, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get power constraint.");
	    return;
    }
    printf("Country String is: %c%c, type: %c ", countryString[0], countryString[1], countryString[2]);
    if (countryString[2] == 'I') 
        printf("(Indoor)\n");
    else if (countryString[2] == 'O') 
            printf("(Outdoor)\n");
    else
        printf("(Other)\n");
}


void wlan_dh_PrintRegDomain(ConsoleParameter_T parameters[])
{/*
    UINT8 value, band, regDomainA, regDomainB, regDomain, uiRanges;
    INT8  int8value;
    UINT32   level, numOfRanges, index, chosen;
    wlan_bandType bandType;
    IntegerRegulatoryDomains_e RegDomain;
    tChannelRangeElementStruct RangeElementStruct;
    char countryString[3], tmpBuffer[100];

    whal_nvram_getBand(currentConfigWoneInex, &band);
    printf("Band is: %s\n",(band == RADIO_BAND_2_4GHZ) ? "RADIO_BAND_2_4GHZ (G)" : "RADIO_BAND_5GHZ (A)");
    wdrv_dbGetdot11CurrentRegDomain(band, &regDomain);
    printf("Current Regularity Domain is: ");

    // compute regularity domain 
    switch (band) 
    {
        case RADIO_BAND_2_4GHZ: // g 
            switch (regDomain)
            {
                case REG_DOMAIN_FCC:
                    printf("REG_DOMAIN_FCC (0x10)\n");
                    break;
                case REG_DOMAIN_IC:
                    printf("REG_DOMAIN_IC (0x20)\n");
                    break;
                case REG_DOMAIN_ETSI:
                    printf("REG_DOMAIN_ETSI (0x30)\n");
                    break;
                case REG_DOMAIN_SPAIN:
                    printf("REG_DOMAIN_SPAIN (0x31)\n");
                    break;
                case REG_DOMAIN_FRANCE:
                    printf("REG_DOMAIN_FRANCE (0x32)\n");
                    break;
                case REG_DOMAIN_MKK:
                    printf("REG_DOMAIN_MKK (0x40)\n");
                    break;
                case REG_DOMAIN_MKK1:
                    printf("REG_DOMAIN_MKK1 (0x41)\n");
                    break;
                default :
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n",regDomain);
                    break;
            }
            break;
    
        case RADIO_BAND_5GHZ:   // a 
            switch (regDomain)
            {
                case REG_DOMAIN_US:
                    printf("REG_DOMAIN_US (0x50)\n");
                    break;
                case REG_DOMAIN_WORLD:
                    printf("REG_DOMAIN_WORLD (0x51)\n");
                    break;
                default:
                    printf("CUSTOM_REG_DOMAIN (0x%X)\n",regDomain);
                    break;
            }
            break;
    }

    printf("Type one of the following:\n");
    printf("Regulatory Domains for 802.11g:\n");
    printf("-------------------------------\n");
    printf("1. REG_DOMAIN_FCC    (0x10)\n");
    printf("2. REG_DOMAIN_IC     (0x20)\n");
    printf("3. REG_DOMAIN_ETSI   (0x30)\n");
    printf("4. REG_DOMAIN_SPAIN  (0x31)\n");
    printf("5. REG_DOMAIN_FRANCE (0x32)\n");
    printf("6. REG_DOMAIN_MKK    (0x40)\n");
    printf("7. REG_DOMAIN_MKK1   (0x41)\n");
    whal_nvram_getPrivateRegDomain(&regDomainB);
    if (regDomain != 0)
        printf("8. CUSTOM_REG_DOMAIN (0x%X)\n",regDomainB);
    else
        printf("Note: CUSTOM_REG_DOMAIN undefined\n",regDomainB);
    printf("\nRegulatory Domains for 802.11a:\n");
    printf("-------------------------------\n");
    printf("9. REG_DOMAIN_US     (0x50)\n");
    printf("10. REG_DOMAIN_WORLD  (0x51)\n");
    whal_nvram_getPrivateRegDomain(&regDomainA);
    if (regDomain != 0)
        printf("11. CUSTOM_REG_DOMAIN (0x%X)\n",regDomainA);
    else
        printf("Note: CUSTOM_REG_DOMAIN undefined\n",regDomainA);


    printf("\nType index number:");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen <= 0)
        return;
    
    if (chosen > 12) 
    {
        printf("index not exists!\n");
        return;
    }

    switch (chosen)
    {
        case 1:
            regDomain = REG_DOMAIN_FCC;    
            bandType = WLAN_BAND_B;
            break;
            
        case 2:
            regDomain = REG_DOMAIN_IC;    
            bandType = WLAN_BAND_B;
            break;
            
        case 3:
            regDomain = REG_DOMAIN_ETSI;    
            bandType = WLAN_BAND_B;
            break;

        case 4:
            regDomain = REG_DOMAIN_SPAIN;    
            bandType = WLAN_BAND_B;
            break;

        case 5:
            regDomain = REG_DOMAIN_FRANCE;    
            bandType = WLAN_BAND_B;
            break;

        case 6:
            regDomain = REG_DOMAIN_MKK;    
            bandType = WLAN_BAND_B;
            break;

        case 7:
            regDomain = REG_DOMAIN_MKK1;    
            bandType = WLAN_BAND_B;
            break;

        case 8:
            if (regDomainB==0)
            {
                printf("Custom Regulatory Domain for Band G is undefined.\n");
                return;
            }
            regDomain = regDomainB;
            bandType = WLAN_BAND_B;
            break;

        case 9:
            regDomain = REG_DOMAIN_US;    
            bandType = WLAN_BAND_A;
            break;
            
        case 10:
            regDomain = REG_DOMAIN_WORLD;    
            bandType = WLAN_BAND_A;
            break;
            
        case 11:
            if (regDomainA==0)
            {
                printf("Custom Regulatory Domain for Band A is undefined.\n");
                return;
            }
            regDomain = regDomainA;
            bandType = WLAN_BAND_A;
            break;
    }
    switch (chosen) 
    {
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 7:
        case 9:
        case 10:
            numOfRanges = wdrv_dbGetNumberOfDomainElements(bandType,regDomain);
            printf("Start Ch.    Stop Ch.    Step    OFDM    Power Limit\n");
            printf("---------    --------    ----    ----    -----------\n");
            for (index = 1; index <= numOfRanges; index++) 
            {
                wdrv_dbGetRangeElement(bandType,regDomain,index,&RangeElementStruct);
                printf("%d \t     %d \t %d \t %s \t %d\n",
                       RangeElementStruct.startCh,
                       RangeElementStruct.stopCh,
                       RangeElementStruct.stepOpt & 0xF,
                       (RangeElementStruct.stepOpt & 0x10) ? "No" : "Yes",
                       RangeElementStruct.powerLimit);
            }
            printf("\n");
            break;

        case 8:     // private "G" 
        case 11:    // private "A" 
            wdrv_dbGetNumOfPrivateRanges(bandType,&uiRanges);
            if (uiRanges == 0) 
            {
                printf("Not configured yet.\n");
                return;
            }
            printf("Start Ch.    Stop Ch.    Step    OFDM    Power Limit\n");
            printf("---------    --------    ----    ----    -----------\n");
            for (index = 1; index <= uiRanges; index++) 
            {
                wdrv_dbGetPrivateRangeElement(bandType,index,&RangeElementStruct);
                printf("%d \t     %d \t %d \t %s \t %d\n",
                       RangeElementStruct.startCh,
                       RangeElementStruct.stopCh,
                       RangeElementStruct.stepOpt & 0xF,
                       (RangeElementStruct.stepOpt & 0x10) ? "No" : "Yes",
                       RangeElementStruct.powerLimit);
            }
            printf("\n");
            break;
#if 0
        case 11:    // private "A" 
            wdrv_dbGetNumOfPrivateRanges(bandType,&uiRanges);
            if (uiRanges == 0) 
            {
                printf("Not configured yet.\n");
                return;
            }
            printf("Start Ch.    Stop Ch.    Step    OFDM    Power Limit\n");
            printf("---------    --------    ----    ----    -----------\n");
            for (index = 1; index <= uiRanges; index++) 
            {
                wdrv_dbGetPrivateRangeElement(WLAN_BAND_A,index,&RangeElementStruct);
                printf("%d \t     %d \t    %d \t%s \t%d\n",
                       RangeElementStruct.startCh,
                       RangeElementStruct.stopCh,
                       RangeElementStruct.stepOpt & 0xF,
                       (RangeElementStruct.stepOpt & 0x10) ? "No" : "Yes",
                       RangeElementStruct.powerLimit);
            }
            printf("\n");
            break;
#endif    
    }*/


    __u32 index, chosen, num_ranges;
    int band_type = BAND_B;
    char tmpBuffer[100];
    tiap_param_wone_t wone;
    tiap_param_cur_reg_domain_t cur_regdomain;
    tiap_param_priv_reg_domain_t priv_regdomain, priv_regdomain_a, priv_regdomain_b;
    tiap_param_channel_rang ch_rang;
    tiap_param_channel_rang_elem_t *ch_rang_a_g, range_elem;

    wone.index = currentConfigWoneInex;
    wone.type = wone_band;
    if( tiap_wcfg_get_wone(wd, &wone, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get band.");
	    return;
    }

    printf("Band is: %s\n",(wone.elem.band == TIAP_PARAM_RADIO_BAND_2_4GHZ) ? 
		    "RADIO_BAND_2_4GHZ (G)" : "RADIO_BAND_5GHZ (A)");

    cur_regdomain.band = wone.elem.band;
    if( tiap_wcfg_get_cur_regdomain(wd, &cur_regdomain, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get current regulatory domain.");
	    return;
    }

    printf("Current Regularity Domain is: ");

    // compute regularity domain 
    switch (wone.elem.band) 
    {
	    case TIAP_PARAM_RADIO_BAND_2_4GHZ: // g 
		    switch (cur_regdomain.type)
		    {
			    case TIAP_PARAM_RD_FCC:
				    printf("REG_DOMAIN_FCC (0x10)\n");
				    break;
			    case TIAP_PARAM_RD_IC:
				    printf("REG_DOMAIN_IC (0x20)\n");
				    break;
			    case TIAP_PARAM_RD_ETSI:
				    printf("REG_DOMAIN_ETSI (0x30)\n");
				    break;
			    case TIAP_PARAM_RD_SPAIN:
				    printf("TIAP_PARAM_RD_SPAIN (0x31)\n");
				    break;
			    case TIAP_PARAM_RD_FRANCE:
				    printf("TIAP_PARAM_RD_FRANCE (0x32)\n");
				    break;
			    case TIAP_PARAM_RD_MKK:
				    printf("TIAP_PARAM_RD_MKK (0x40)\n");
				    break;
			    case TIAP_PARAM_RD_MKK1:
				    printf("TIAP_PARAM_RD_MKK1 (0x41)\n");
				    break;
			    default :
				    printf("CUSTOM_REG_DOMAIN (0x%X)\n", cur_regdomain.type);
				    break;
		    }
		    break;

	    case TIAP_PARAM_RADIO_BAND_5GHZ:   // a 
		    switch (cur_regdomain.type)
		    {
			    case TIAP_PARAM_RD_US:
				    printf("TIAP_PARAM_RD_US (0x50)\n");
				    break;
			    case TIAP_PARAM_RD_WORLD:
				    printf("TIAP_PARAM_RD_WORLD (0x51)\n");
				    break;
			    default:
				    printf("CUSTOM_REG_DOMAIN (0x%X)\n", cur_regdomain.type);
				    break;
		    }
		    break;
    }

    printf("Type one of the following:\n");
    printf("Regulatory Domains for 802.11g:\n");
    printf("-------------------------------\n");
    printf("1. REG_DOMAIN_FCC    (0x10)\n");
    printf("2. REG_DOMAIN_IC     (0x20)\n");
    printf("3. REG_DOMAIN_ETSI   (0x30)\n");
    printf("4. REG_DOMAIN_SPAIN  (0x31)\n");
    printf("5. REG_DOMAIN_FRANCE (0x32)\n");
    printf("6. REG_DOMAIN_MKK    (0x40)\n");
    printf("7. REG_DOMAIN_MKK1   (0x41)\n");

    priv_regdomain_b.band = BAND_B;
    if( tiap_wcfg_get_priv_regdomain(wd, &priv_regdomain_b, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get current regulatory domain.");
	    return;
    }

    if (priv_regdomain_b.domain != 0)
	    printf("8. CUSTOM_REG_DOMAIN (0x%X)\n", priv_regdomain_b.domain);
    else
	    printf("Note: CUSTOM_REG_DOMAIN undefined (0x%X)\n", priv_regdomain_b.domain);
    printf("\nRegulatory Domains for 802.11a:\n");
    printf("-------------------------------\n");
    printf("9. REG_DOMAIN_US     (0x50)\n");
    printf("10. REG_DOMAIN_WORLD  (0x51)\n");

    priv_regdomain_a.band = BAND_A;
    if( tiap_wcfg_get_priv_regdomain(wd, &priv_regdomain_a, !FROM_STORAGE) ) {
	    PRINT_CONFIG_ERR_MSG("Failed to get current regulatory domain.");
	    return;
    }

    if (priv_regdomain_a.domain != 0)
	    printf("11. CUSTOM_REG_DOMAIN (0x%X)\n", priv_regdomain_a.domain);
    else
	    printf("Note: CUSTOM_REG_DOMAIN undefined (0x%X)\n", priv_regdomain_a.domain);


    printf("\nType index number:");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen <= 0)
	    return;

    if (chosen > 12) 
    {
	    printf("index not exists!\n");
	    return;
    }

    switch (chosen)
    {
	    case 1:
		    cur_regdomain.type = TIAP_PARAM_RD_FCC;    
		    band_type = BAND_B;
		    break;

	    case 2:
		    cur_regdomain.type = TIAP_PARAM_RD_IC;    
		    band_type = BAND_B;
		    break;

	    case 3:
		    cur_regdomain.type = TIAP_PARAM_RD_ETSI;    
		    band_type = BAND_B;
		    break;

	    case 4:
		    cur_regdomain.type = TIAP_PARAM_RD_SPAIN;    
		    band_type = BAND_B;
		    break;

	    case 5:
		    cur_regdomain.type = TIAP_PARAM_RD_FRANCE;    
		    band_type = BAND_B;
		    break;

	    case 6:
		    cur_regdomain.type = TIAP_PARAM_RD_MKK;    
		    band_type = BAND_B;
		    break;

	    case 7:
		    cur_regdomain.type = TIAP_PARAM_RD_MKK1;    
		    band_type = BAND_B;
		    break;

	    case 8:
		    if (priv_regdomain_b.domain==0)
		    {
			    printf("Custom Regulatory Domain for Band G is undefined.\n");
			    return;
		    }
		    cur_regdomain.type = priv_regdomain_b.domain;
		    band_type = BAND_B;
		    break;

	    case 9:
		    cur_regdomain.type = TIAP_PARAM_RD_US;    
		    band_type = BAND_A;
		    break;

	    case 10:
		    cur_regdomain.type = TIAP_PARAM_RD_WORLD;    
		    band_type = BAND_A;
		    break;

	    case 11:
		    if (priv_regdomain_a.domain==0)
		    {
			    printf("Custom Regulatory Domain for Band A is undefined.\n");
			    return;
		    }
		    cur_regdomain.type = priv_regdomain_a.domain;
		    band_type = BAND_A;
		    break;
    }
    switch (chosen) 
    {
	    case 1:
	    case 2:
	    case 3:
	    case 4:
	    case 5:
	    case 6:
	    case 7:
	    case 9:
	    case 10:
		    num_ranges = get_domain_elems_num(band_type, cur_regdomain.type);
		    printf("Start Ch.    Stop Ch.    Step    OFDM    Power Limit\n");
		    printf("---------    --------    ----    ----    -----------\n");
		    for (index = 1; index <= num_ranges; index++) 
		    {
				wdrv_dbGetRangeElement(band_type,cur_regdomain,index,&range_elem);
				printf("%d \t     %d \t %d \t %s \t %d\n",
					   range_elem.start,
					   range_elem.stop,
					   range_elem.step & 0xF,
					   (range_elem.step & 0x10) ? "No" : "Yes",
					   range_elem.power_limit);
			}
		    printf("\n");
		    break;

	    case 8:     // private "G" 
	    case 11:    // private "A" 
		    ch_rang.type = priv_regdomain.band;
		    if( tiap_wcfg_get_ch_range(wd, &ch_rang, !FROM_STORAGE) ) {
			    PRINT_CONFIG_ERR_MSG("Failed to get channel range.");
			    return;
		    }
		    
		    ch_rang_a_g = (ch_rang.type == TIAP_PARAM_RANG_A ?
				    ch_rang.rng.a : (ch_rang.type == TIAP_PARAM_RANG_G ? 
				    ch_rang.rng.g : NULL));
		    if( !ch_rang_a_g ) {
			    fprintf(stderr, "%s: invalid channel\n", __func__);
			    return;
		    }

		    if (!ch_rang.ranges_nr) 
		    {
			    printf("Not configured yet.\n");
			    return;
		    }
		    printf("Start Ch.    Stop Ch.    Step    OFDM    Power Limit\n");
		    printf("---------    --------    ----    ----    -----------\n");
		    for (index = 1; index <= ch_rang.ranges_nr; index++) 
		    {
			    printf("%d \t     %d \t %d \t %s \t %d\n",
					    ch_rang_a_g->start,
					    ch_rang_a_g->stop,
					    ch_rang_a_g->step & 0xF,
					    (ch_rang_a_g->step & 0x10) ? "No" : "Yes",
					    ch_rang_a_g->power_limit);
		    }
		    printf("\n");
		    break;
    }
}


void wlanSetMultiDomain(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) &&
		(parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetdot11MultiDomainCapabilityStatus(parameters[0].SHORT);
	printf("Setting dot11MultiDomainCapabilityEnable to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");*/

	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_MULTI_DOMAIN_CAPAB, &parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set mullti-domain capability.\n");
		return;
	}
		
	printf("Setting dot11MultiDomainCapabilityEnable to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n");
}


void wlanSetSpectrumMgmt(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) &&
		(parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetdot11SpectrumManagementRequiredStatus(parameters[0].SHORT);
	printf("Setting dot11SpectrumManagementRequired to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n"); */
}


void wlanSetLegacyStation(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) &&
		(parameters[0].SHORT != 1))
	{
		printf("Invalid mode: %d. Only 0 and 1 are legal values.\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetLegacyStatusEnableStatus(parameters[0].SHORT);
	printf("Setting whalEnableLegacyStations to: %s\n",(parameters[0].SHORT==1) ? "Enable":"Disable");
	printf("to take effect RESTART AP.\n"); */
}


void wlanSetPowerConstraint(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetdot11LocalPowerConstraint(parameters[0].SHORT);
	printf("Setting dot11LocalPowerConstraint to: %d\n",parameters[0].SHORT);
	printf("to take effect RESTART AP.\n"); */

	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_LOCAL_POWER_CONS, &parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set tx power constraint.\n");
		return;
	}
	
	printf("Setting dot11LocalPowerConstraint to: %d\n",parameters[0].SHORT);
	printf("to take effect RESTART AP.\n");
}


void wlanSetRegulatoryDomain(ConsoleParameter_T parameters[])
{/*
    char tmpBuffer[100];
    int chosen, maxChosen;
    UINT8 regDomain=0, band;
    wlan_bandType bandType;

    // read current band 
    whal_nvram_getBand(currentConfigWoneInex, &band);
    switch (band) 
    {
        case RADIO_BAND_2_4GHZ: // g 
            printf("Type one of the following:\n");
            printf("1. REG_DOMAIN_FCC    (0x10)\n");
            printf("2. REG_DOMAIN_IC     (0x20)\n");
            printf("3. REG_DOMAIN_ETSI   (0x30)\n");
            printf("4. REG_DOMAIN_SPAIN  (0x31)\n");
            printf("5. REG_DOMAIN_FRANCE (0x32)\n");
            printf("6. REG_DOMAIN_MKK    (0x40)\n");
            printf("7. REG_DOMAIN_MKK1   (0x41)\n");
            whal_nvram_getPrivateRegDomain(&regDomain);
            if (regDomain != 0)
            {
                printf("8. CUSTOM_REG_DOMAIN (0x%X)\n",regDomain);
                maxChosen = 8;
            }
            else
            {
                printf("Note: CUSTOM_REG_DOMAIN undefined\n",regDomain);
                maxChosen = 7;
            }
            break;
    
        case RADIO_BAND_5GHZ:   // a 
            printf("1. REG_DOMAIN_US     (0x50)\n");
            printf("2. REG_DOMAIN_WORLD  (0x51)\n");
            whal_nvram_getPrivateRegDomain(&regDomain);
            if (regDomain != 0)
            {
                printf("3. PRIVATE_REG_DOMAIN (0x%X)\n",regDomain);
                maxChosen = 3;
            }
            else
            {
                printf("Note: CUSTOM_REG_DOMAIN undefined\n",regDomain);
                maxChosen = 2;
            }
            break;
    }

    printf("\nType index number:");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen <= 0)
        return;
    
    if (chosen > maxChosen) 
    {
        printf("index not exists!\n");
        return;
    }

    switch (band) 
    {
        case RADIO_BAND_2_4GHZ: // g 
            bandType = WLAN_BAND_B;
            switch (chosen)
            {
                case 1:
                    regDomain = REG_DOMAIN_FCC;    
                    break;

                case 2:
                    regDomain = REG_DOMAIN_IC;    
                    break;

                case 3:
                    regDomain = REG_DOMAIN_ETSI;    
                    break;

                case 4:
                    regDomain = REG_DOMAIN_SPAIN;    
                    break;

                case 5:
                    regDomain = REG_DOMAIN_FRANCE;    
                    break;

                case 6:
                    regDomain = REG_DOMAIN_MKK;    
                    break;

                case 7:
                    regDomain = REG_DOMAIN_MKK1;    
                    break;
                
                default: // 8  - regDomain already set 
                    break;
            }
            break;

        case RADIO_BAND_5GHZ:   // a
            bandType = WLAN_BAND_A;
            switch (chosen)
            {
                case 1:
                    regDomain = REG_DOMAIN_US;    
                    break;

                case 2:
                    regDomain = REG_DOMAIN_WORLD;    
                    break;

                default: // 3  - regDomain already set 
                    break;
            }
            break;
    }

	if (wdrv_dbSetdot11CurrentRegDomain(regDomain) != OK)
	{
		printf("Error setting new regulatory domain into wdrv_dbSetdot11CurrentRegDomain.\n");
		return;
	}
	printf("to take effect RESTART AP.\n"); */


	char tmpBuffer[100];
	int chosen, maxChosen=0;
	tiap_param_wone_t wone;
	tiap_param_priv_reg_domain_t priv_regdomain;
	tiap_param_cur_reg_domain_t cur_regdomain;

	wone.index = currentConfigWoneInex;
	wone.type = wone_band;
	// read current band 
	if( tiap_wcfg_get_wone(wd, &wone, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}

	switch (wone.elem.band) 
	{
		case TIAP_PARAM_RADIO_BAND_2_4GHZ: // g 
			printf("Type one of the following:\n");
			printf("1. REG_DOMAIN_FCC    (0x10)\n");
			printf("2. REG_DOMAIN_IC     (0x20)\n");
			printf("3. REG_DOMAIN_ETSI   (0x30)\n");
			printf("4. REG_DOMAIN_SPAIN  (0x31)\n");
			printf("5. REG_DOMAIN_FRANCE (0x32)\n");
			printf("6. REG_DOMAIN_MKK    (0x40)\n");
			printf("7. REG_DOMAIN_MKK1   (0x41)\n");
			
			priv_regdomain.band = BAND_B;
			if( tiap_wcfg_get_priv_regdomain(wd, &priv_regdomain, !FROM_STORAGE) ) {
				PRINT_CONFIG_ERR_MSG("Failed to get private regulatory domain.");
				return;
			}
			
			if (priv_regdomain.domain != 0)
			{
				printf("8. CUSTOM_REG_DOMAIN (0x%X)\n", priv_regdomain.domain);
				maxChosen = 8;
			}
			else
			{
				printf("Note: CUSTOM_REG_DOMAIN undefined (0x%X)\n", priv_regdomain.domain);
				maxChosen = 7;
			}
			break;

		case TIAP_PARAM_RADIO_BAND_5GHZ:   // a 
			printf("1. REG_DOMAIN_US     (0x50)\n");
			printf("2. REG_DOMAIN_WORLD  (0x51)\n");

			priv_regdomain.band = BAND_B;
			if( tiap_wcfg_get_priv_regdomain(wd, &priv_regdomain, !FROM_STORAGE) ) {
				PRINT_CONFIG_ERR_MSG("Failed to get private regulatory domain.");
				return;
			}

			if (priv_regdomain.domain != 0)
			{
				printf("3. PRIVATE_REG_DOMAIN (0x%X)\n", priv_regdomain.domain);
				maxChosen = 3;
			}
			else
			{
				printf("Note: CUSTOM_REG_DOMAIN undefined (0x%X)\n", priv_regdomain.domain);
				maxChosen = 2;
			}
			break;
	}

	printf("\nType index number:");
	fgets(tmpBuffer, 100, stdin);
	tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
	chosen = atoi(tmpBuffer);
	if(chosen <= 0)
		return;

	if (chosen > maxChosen) 
	{
		printf("index not exists!\n");
		return;
	}

	/* Felix R.: exactly as in original code, 
	   though I think we should have informed user in case of invalid input. */
	priv_regdomain.domain = 0; 
	switch (wone.elem.band) 
	{
		case TIAP_PARAM_RADIO_BAND_2_4GHZ: // g 
			priv_regdomain.band = BAND_B;
			switch (chosen)
			{
				case 1:
					priv_regdomain.domain = TIAP_PARAM_RD_FCC;
					break;

				case 2:
					priv_regdomain.domain = TIAP_PARAM_RD_IC;
					break;

				case 3:
					priv_regdomain.domain = TIAP_PARAM_RD_ETSI;
					break;

				case 4:
					priv_regdomain.domain = TIAP_PARAM_RD_SPAIN;
					break;

				case 5:
					priv_regdomain.domain = TIAP_PARAM_RD_FRANCE;
					break;

				case 6:
					priv_regdomain.domain = TIAP_PARAM_RD_MKK;
					break;

				case 7:
					priv_regdomain.domain = TIAP_PARAM_RD_MKK1;
					break;

				default: // 8  - regDomain already set 
					break;
			}
			break;

		case TIAP_PARAM_RADIO_BAND_5GHZ:   // a
			priv_regdomain.band = BAND_A;
			switch (chosen)
			{
				case 1:
					priv_regdomain.domain = TIAP_PARAM_RD_US;
					break;

			case 2:
					priv_regdomain.domain = TIAP_PARAM_RD_WORLD;
					break;

				default: // 3  - regDomain already set 
					break;
			}
			break;
	}

	cur_regdomain.type = priv_regdomain.domain;
	cur_regdomain.band = priv_regdomain.band;  
	
	//if( tiap_wcfg_set_priv_regdomain(wd, &priv_regdomain) ) {
	if( tiap_wcfg_set_cur_regdomain(wd, &cur_regdomain, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set current regulatory domain.");
		return;
	}
	
	printf("to take effect RESTART AP.\n"); 
}


void wlanSetTxPowerLevel(ConsoleParameter_T parameters[])
{/*
    if ((parameters[0].SHORT < 1) || (parameters[0].SHORT > 5))
    {
        printf("Out of range.\n");
        return;
    }
	wdrv_dbSetMaxTxPowerLevel((UINT8)parameters[0].SHORT);
	printf("to take effect RESTART AP.\n"); */

	if ((parameters[0].SHORT < 1) || (parameters[0].SHORT > 5))
	{
		printf("Out of range.\n");
		return;
	}

	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_MAX_TX_POWER_LEVEL, &parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set tx power level.\n");
		return;
	}
	
	printf("to take effect RESTART AP.\n"); 
}


void wlanSetPowerLevel(ConsoleParameter_T parameters[])
{/*
    // Check band 
    if ((parameters[0].INTEGER < 0) || (parameters[0].INTEGER > 1)) 
    {
        printf("Band is out of range. Use: 1 for band A (5 Ghz) and 0 for G (2.4 Ghz).\n");
        return;
    }
    // Check range 
    if ((parameters[5].INTEGER < -127) || (parameters[1].INTEGER > 128)) 
    {
        printf("Parameters are out of range.\n");
        return;
    }
    // Check that values are given in incrementally order 
    if (parameters[2].INTEGER >= parameters[1].INTEGER) 
    {
        printf("Invalid value! level 1 (%d) Must be greater than level 2 (%d)\n",
               parameters[0].SHORT,
               parameters[1].SHORT);
        return;
    }
    if (parameters[3].INTEGER >= parameters[2].INTEGER) 
    {
        printf("Invalid value! level 2 (%d) Must be greater than level 3 (%d)\n",
               parameters[1].SHORT,
               parameters[2].SHORT);
        return;
    }
    if (parameters[4].INTEGER >= parameters[3].INTEGER) 
    {
        printf("Invalid value! level 3 (%d) Must be greater than level 4 (%d)\n",
               parameters[2].SHORT,
               parameters[3].SHORT);
        return;
    }
    if (parameters[5].INTEGER >= parameters[4].INTEGER) 
    {
        printf("Invalid value! level 4 (%d) Must be greater than level 5 (%d)\n",
               parameters[3].INTEGER,
               parameters[4].INTEGER);
        return;
    }
	if (wdrv_dbSetTxPowerLevels((INT8)parameters[0].INTEGER,
                                (INT8)parameters[1].INTEGER,
                                (INT8)parameters[2].INTEGER,
                                (INT8)parameters[3].INTEGER,
                                (INT8)parameters[4].INTEGER,
                                (INT8)parameters[5].INTEGER) == ERROR)
    {
        printf("Error setting new power levels!\n");
        return;
    }
	printf("to take effect RESTART AP.\n"); */

	tiap_param_txpower_t txpow;
	
	// Check band 
	if ((parameters[0].INTEGER < 0) || (parameters[0].INTEGER > 1)) 
	{
		printf("Band is out of range. Use: 1 for band A (5 Ghz) and 0 for G (2.4 Ghz).\n");
		return;
	}
	// Check range 
	if ((parameters[5].INTEGER < -127) || (parameters[1].INTEGER > 128)) 
	{
		printf("Parameters are out of range.\n");
		return;
	}
	// Check that values are given in incrementally order 
	if (parameters[2].INTEGER >= parameters[1].INTEGER) 
	{
		printf("Invalid value! level 1 (%d) Must be greater than level 2 (%d)\n",
				parameters[0].SHORT,
				parameters[1].SHORT);
		return;
	}
	if (parameters[3].INTEGER >= parameters[2].INTEGER) 
	{
		printf("Invalid value! level 2 (%d) Must be greater than level 3 (%d)\n",
				parameters[1].SHORT,
				parameters[2].SHORT);
		return;
	}
	if (parameters[4].INTEGER >= parameters[3].INTEGER) 
	{
		printf("Invalid value! level 3 (%d) Must be greater than level 4 (%d)\n",
				parameters[2].SHORT,
				parameters[3].SHORT);
		return;
	}
	if (parameters[5].INTEGER >= parameters[4].INTEGER) 
	{
		printf("Invalid value! level 4 (%ld) Must be greater than level 5 (%ld)\n",
				parameters[3].INTEGER,
				parameters[4].INTEGER);
		return;
	}

	txpow.hr = parameters[0].INTEGER;
	txpow.txpower[0] = parameters[1].INTEGER;
	txpow.txpower[1] = parameters[2].INTEGER;
	txpow.txpower[2] = parameters[3].INTEGER;
	txpow.txpower[3] = parameters[4].INTEGER;
	txpow.txpower[4] = parameters[5].INTEGER;

	if( tiap_wcfg_siwtxpow(wd, &txpow, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set tx powers.");
		return;
	}
    
	printf("to take effect RESTART AP.\n"); 
}


void wlanSetCountryString(ConsoleParameter_T parameters[])
{/*
    char tmpBuffer[100], countryString[3];
    int chosen;

	if (strlen(parameters[0].STRING) != 2)
	{
		printf("Invalid length: %d. Must be 2.\n", strlen(parameters[0].STRING));
		return;
	}

    printf("Current Type is: ");
    wdrv_dbGetdot11CountryString(countryString);
    if (countryString[2] == 'I') 
        printf("'I' (Indoor)\n");
    else if (countryString[2] == 'O') 
            printf("'O' (Outdoor)\n");
    else
        printf("(Other - not Indoor nor Outdoor)\n\n");

    printf("Type new type no. or hit <Enter> to keep the same type:\n");
    printf("1. Indoor\n");
    printf("2. Outdoor\n");
    printf("3. Other\n");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    switch (chosen) 
    {
        case 0:
            break;
            
        case 1:
            countryString[2] = 'I';
            break;
            
        case 2:
            countryString[2] = 'O';
            break;
            
        case 3:
            countryString[2] = ' ';
            break;

        default:
            printf("Invalid value. Command aborted\n");
            return;
    }
    countryString[0] = parameters[0].STRING[0];
    countryString[1] = parameters[0].STRING[1];
	wdrv_dbSetdot11CountryString(countryString);
    printf("Setting Country String to: \"%c%c%c\"\n",countryString[0],countryString[1],countryString[2]);
	printf("to take effect RESTART AP.\n"); */


	char tmpBuffer[100];
	int chosen;
	__s8 country_str[TIAP_PARAM_COUNTRY_STRING_LEN];

	if (strlen(parameters[0].STRING) != 2)
	{
		printf("Invalid length: %d. Must be 2.\n", strlen(parameters[0].STRING));
		return;
	}

	printf("Current Type is: ");
	
	if( tiap_wcfg_get_basic(wd, TIAP_PARAM_COUNTRY_STR, country_str, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get country string.");
		return;
	}
	
	if (country_str[2] == 'I') 
		printf("'I' (Indoor)\n");
	else if (country_str[2] == 'O') 
		printf("'O' (Outdoor)\n");
	else
		printf("(Other - not Indoor nor Outdoor)\n\n");

	printf("Type new type no. or hit <Enter> to keep the same type:\n");
	printf("1. Indoor\n");
	printf("2. Outdoor\n");
	printf("3. Other\n");
	fgets(tmpBuffer, 100, stdin);
	tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
	chosen = atoi(tmpBuffer);
	switch (chosen) 
	{
		case 0:
			break;

		case 1:
			country_str[2] = 'I';
			break;

		case 2:
			country_str[2] = 'O';
			break;

		case 3:
			country_str[2] = ' ';
			break;

		default:
			printf("Invalid value. Command aborted\n");
			return;
	}
	country_str[0] = parameters[0].STRING[0];
	country_str[1] = parameters[0].STRING[1];
	
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_COUNTRY_STR, country_str, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set country string.");
		return;
	}

	printf("Setting Country String to: \"%c%c%c\"\n", country_str[0], country_str[1], country_str[2]);
	printf("to take effect RESTART AP.\n"); 
}


void wlanMakeRange(ConsoleParameter_T parameters[])
{/*
    wlan_bandType bandType;
    UINT8 numOfRanges;
    char tmpBuffer[100], hexBuffer[20];
    int chosen, RegDomain;

	if (strlen(parameters[0].STRING) != 1)  // only 'a' and 'g' are valid bands 
	{
		printf("Invalid value: %s. Must be either 'a' or 'g'.\n", strlen(parameters[0].STRING));
		return;
	}
    switch (parameters[0].STRING[0]) 
    {
        case 'a':
        case 'A':
            bandType = WLAN_BAND_A;
            break;
        case 'g':
        case 'G':
            bandType = WLAN_BAND_B;
            break;
        default:
            printf("Invalid band. Must be either 'a' or 'g'.\n");
            return;
    }
    // analyzes RegDomain 
	if (strlen(parameters[1].STRING) != 2)
	{
		printf("Invalid value: %s. Must be an Hexa value (e.g. for 0xA0 type A0.\n", parameters[1].STRING);
		return;
	}
    if ((isxdigit(parameters[1].STRING[0]) == 0) || (isxdigit(parameters[1].STRING[1]) == 0)) 
    {
        printf("Bad Hex value. (Example: for 0xA0 tyoe A0)\n");
        return;
    }
    sprintf(hexBuffer,"0x%c%c",parameters[1].STRING[0],parameters[1].STRING[1]);
    sscanf(hexBuffer,"%x",&RegDomain);
    printf("RegDomain is 0x%x\n",RegDomain);
    if (wdrv_dbIsStdRegDomain((UINT8)RegDomain)) 
    {
        printf("Error - This Regulatory Domain is already defined as standard.\n");
        return;
    }

    printf("Type number of ranges (1-");
    if (bandType==WLAN_BAND_A)
        printf("%d) <default=%d> ",8,1);
    else
        printf("%d) <default=%d> ",4,1);

    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen < 0)
        return;
    if (chosen == 0)
    {
        numOfRanges = 1;
    }
    else
        numOfRanges = (UINT8)chosen;
    if (bandType==WLAN_BAND_A) 
    {
        if (numOfRanges > 8)
        {
            printf("Invalid range. Must be up to 8.\n");
            return;
        }
    }
    else    // G BAND 
        if (numOfRanges > 4)
        {
            printf("Invalid range. Must be up to 4.\n");
            return;
        }
    wdrv_dbSetPrivateRegulatoryDomain(RegDomain);
    if (wdrv_dbSetNumOfPrivateRanges(bandType, numOfRanges) != OK)
    {
        printf("Error setting new range to the given band.\n");
        return;
    }
	printf("to take effect RESTART AP.\n"); */


}


void wlanChangeRange(ConsoleParameter_T parameters[])
{/*
    wlan_bandType bandType;
    UINT8 numOfRanges, index;
    char tmpBuffer[100];
    int chosen, startCh, stopCh;
    tChannelRangeElementStruct rangeElement;

	if (strlen(parameters[0].STRING) != 1)
	{
		printf("Invalid value: %s. Must be either 'a' or 'g'.\n", strlen(parameters[0].STRING));
		return;
	}
    switch (parameters[0].STRING[0]) 
    {
        case 'a':
        case 'A':
            bandType = WLAN_BAND_A;
            wdrv_dbGetNumOfPrivateRanges(bandType, &numOfRanges);
            break;
        case 'g':
        case 'G':
            bandType = WLAN_BAND_B;
            wdrv_dbGetNumOfPrivateRanges(bandType, &numOfRanges);
            break;
        default:
            printf("Invalid band. Must be either 'a' or 'g'.\n");
            return;
    }
    index = parameters[1].SHORT;
    if (index > numOfRanges) 
    {
        printf("Invalid index. Must be no greater than %d.\n",numOfRanges);
        return;
    }
    startCh = parameters[2].SHORT;
    stopCh  = parameters[3].SHORT;
    if (stopCh < startCh) 
    {
        printf("Invalid values! startCh is greater than stopCh.\n");
        return;
    }
    //verify that earlier range is lower than the current one 
    if (index>1) 
    {
        whal_nvram_getRangeElement4RegDomain(bandType, index, &rangeElement);
        if (startCh <= rangeElement.stopCh) 
        {
            printf("Invalid values! earlier range is greater.\n");
            return;
        }
    }
    rangeElement.startCh = startCh;
    rangeElement.stopCh  = stopCh;
    // check optional values 
    printf("Enter step between channels <default=%d>\n",(bandType==WLAN_BAND_A) ? 4 : 1);
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen < 0)
        return;
    if (chosen == 0)
        rangeElement.stepOpt = (bandType==WLAN_BAND_A) ? 4 : 1;
    else if (chosen > 15) 
    {
        printf("Invalid step. Must be lower than 16.\n");
        return;
    }
    else
        rangeElement.stepOpt = chosen;

    printf("Enter Power limit <default=20>\n");
    fgets(tmpBuffer, 100, stdin);
    tmpBuffer[strlen(tmpBuffer) - 1] = 0; // remove newline 
    chosen = atoi(tmpBuffer);
    if(chosen < 0)
        return;
    if (chosen == 0)
        rangeElement.powerLimit = 20;
    else
        rangeElement.powerLimit = chosen;


    if (whal_nvram_setRangeElement4RegDomain(bandType, index, rangeElement, IMMEDIATELY) != OK)
    {
        printf("Error setting values to the given range.\n");
        return;
    }
	printf("to take effect RESTART AP.\n"); */

}


void wlanChangeRangeOption(ConsoleParameter_T parameters[])
{ /*
    wlan_bandType bandType;
    UINT8 numOfRanges, index, option;
    char tmpBuffer[100];
    tChannelRangeElementStruct rangeElement;

	if (strlen(parameters[0].STRING) != 1)
	{
		printf("Invalid value: %s. Must be either 'a' or 'g'.\n", strlen(parameters[0].STRING));
		return;
	}
    switch (parameters[0].STRING[0]) 
    {
        case 'a':
        case 'A':
            bandType = WLAN_BAND_A;
            wdrv_dbGetNumOfPrivateRanges(bandType, &numOfRanges);
            break;
        case 'g':
        case 'G':
            bandType = WLAN_BAND_B;
            wdrv_dbGetNumOfPrivateRanges(bandType, &numOfRanges);
            break;
        default:
            printf("Invalid band. Must be either 'a' or 'g'.\n");
            return;
    }
    index = parameters[1].SHORT;
    if (index > numOfRanges) 
    {
        printf("Invalid index. Must be no greater than %d.\n",numOfRanges);
        return;
    }
    option = parameters[2].SHORT;
    if (option > 1) 
    {
        printf("Invalid values! <opt> should be either 0 (OFDM) or 1 (NO_OFDM).\n");
        return;
    }
    option <<= 4; // set bit 4 if option is 1 
    whal_nvram_getRangeElement4RegDomain(bandType, index, &rangeElement);
    rangeElement.stepOpt = (rangeElement.stepOpt & 0xF) | option;
    if (whal_nvram_setRangeElement4RegDomain(bandType, index, rangeElement, IMMEDIATELY) != OK)
    {
        printf("Error setting values to the given range.\n");
        return;
    }
	printf("to take effect RESTART AP.\n"); */

}

/****************************************************/

static UINT8 setOFDMrates(UINT8 *curRates, UINT8 curRatesLen, UINT8 *newRates)
{/*
	UINT8 i, newRatesLen=0;
	BOOL quit;
	char str[4];
	char inbuf[255];
	char rateString[OFDM_RATES_MAX][3] =
				{ " 6", " 9", "12", "18", "24", "36", "48", "54" };
	UINT8 rateValue[OFDM_RATES_MAX] =
				{ DOT11_RATE_6,  DOT11_RATE_9,
				  DOT11_RATE_12, DOT11_RATE_18,
				  DOT11_RATE_24, DOT11_RATE_36,
				  DOT11_RATE_48, DOT11_RATE_54 };

	printf ("\nSet Rate List\n");
	printf ("[ Y ] = Supported\n[ N ] = Not Supported\n[ B ] = Basic Supported\n\n");

	for (i=0; i<OFDM_RATES_MAX; i++)
	{
		isRateInList(curRates, curRatesLen, rateValue[i], str);
		
		quit = FALSE;
		while (!quit)
		{
			printf("Rate %s Mbps - [%s] > ", rateString[i], str);
			gets(inbuf);

			// if enter was pressed, use previous value 
			if (strlen(inbuf) == 0)
			{
				strcpy(inbuf, str);
			}
		
			if ((inbuf[0] == 'Y') || (inbuf[0] == 'y'))
			{
				newRates[newRatesLen++] = rateValue[i];
				quit = TRUE;
			}
			else if ((inbuf[0] == 'B') || (inbuf[0] == 'b'))
			{
				newRates[newRatesLen++] = (rateValue[i] | 0x80);
				quit = TRUE;
			}
			else if ((inbuf[0] == 'N') || (inbuf[0] == 'n'))
			{
				// do not add rate ! 
				quit = TRUE;
			}
			// else illegal input was pressed, try again 
		}
	}

	if (newRatesLen == 0)
	{
		printf("Setting Rates = None"); 
	}
	else
	{
		printf("Setting Rates = ");
		for (i=0; i<newRatesLen; i++)
		{
			printf("  "); 
			printRateInMbpsUnit(newRates[i]);
		}
	}
	printf("\nWait ... ");

	return newRatesLen; */



	UINT8 i, newRatesLen=0;
	BOOL quit;
	char str[4];
	char inbuf[255];
	char rateString[TIAP_PARAM_OFDM_RATES_MAX][3] =
				{ " 6", " 9", "12", "18", "24", "36", "48", "54" };
	UINT8 rateValue[TIAP_PARAM_OFDM_RATES_MAX] =
				{ DOT11_RATE_6,  DOT11_RATE_9,
				  DOT11_RATE_12, DOT11_RATE_18,
				  DOT11_RATE_24, DOT11_RATE_36,
				  DOT11_RATE_48, DOT11_RATE_54 };

	printf ("\nSet Rate List\n");
	printf ("[ Y ] = Supported\n[ N ] = Not Supported\n[ B ] = Basic Supported\n\n");

	for (i=0; i<TIAP_PARAM_OFDM_RATES_MAX; i++)
	{
		isRateInList(curRates, curRatesLen, rateValue[i], str);
		
		quit = FALSE;
		while (!quit)
		{
			printf("Rate %s Mbps - [%s] > ", rateString[i], str);
			fflush(stdout);
			read(0, inbuf, sizeof(inbuf)-1);
					
			// if enter was pressed, use previous value 
			if (strlen(inbuf) == 0)
			{
				strcpy(inbuf, str);
			}
		
			if ((inbuf[0] == 'Y') || (inbuf[0] == 'y'))
			{
				newRates[newRatesLen++] = TIAP_PARAM_RATE_SUPPORTED;
				quit = TRUE;
			}
			else if ((inbuf[0] == 'B') || (inbuf[0] == 'b'))
			{
				newRates[newRatesLen++] = TIAP_PARAM_RATE_BASIC_SUPPORTED;
				quit = TRUE;
			}
			else if ((inbuf[0] == 'N') || (inbuf[0] == 'n'))
			{
				// do not add rate !
				newRates[newRatesLen++] = TIAP_PARAM_RATE_NOT_SUPPORTED;
				quit = TRUE;
			}
			// else illegal input was pressed, try again 
		}
	}

	if (newRatesLen == 0)
	{
		printf("Setting Rates = None"); 
	}
	else
	{
		printf("Setting Rates = ");
/*		for (i=0; i<newRatesLen; i++)
		{
			printf("  "); */
		printOFDMRateInMbpsUnit(newRates);
/*
		}
*/
	}
	printf("\nWait ... ");

	return newRatesLen; 
}

void wlanSetGRates(ConsoleParameter_T parameters[])
{/*
	UINT8 curRates[OFDM_RATES_MAX];
	UINT8 curRatesLen=0;
	UINT8 newRates[OFDM_RATES_MAX];
	UINT8 newRatesLen;

	UINT8 band;
	wdrv_dbGetBand(currentConfigWoneInex,&band);
    if (band == RADIO_BAND_5GHZ)
        {
            printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
            printf("802.11 A Not support CCK Rates\n");  
            return;
        }

	// Read current rates setting 
	whal_nvram_getOperationalOFDMRateSetLength(currentConfigWoneInex,&curRatesLen);
	whal_nvram_getOperationalOFDMRateSet(currentConfigWoneInex,curRates, curRatesLen);

    printf("\n---------------------\n");
    printf("-  Wone Index is %d  -\n",currentConfigWoneInex);
    printf("----------------------\n");
	newRatesLen = setOFDMrates(curRates, curRatesLen, newRates);

	wdrv_dbSetStationConfigOperationalOFDMRateSet(currentConfigWoneInex,newRates, newRatesLen);

	printf("done, to take effect RESTART AP.\n"); */


	UINT8 curRates[TIAP_PARAM_OFDM_RATES_MAX];
	UINT8 newRatesLen;
	__u8 ofdmRateValue[TIAP_PARAM_OFDM_RATES_MAX] =
		{DOT11_RATE_6,DOT11_RATE_9,DOT11_RATE_12,DOT11_RATE_18,DOT11_RATE_24,
		DOT11_RATE_36,DOT11_RATE_48,DOT11_RATE_54 };
	tiap_param_wone_t wone;

	wone.index = currentConfigWoneInex;
	wone.type = wone_band;
	if( tiap_wcfg_get_wone(wd, &wone, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}


	if (wone.elem.band == TIAP_PARAM_RADIO_BAND_5GHZ)
	{
            printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
            printf("802.11 A Not support CCK Rates\n");  
            return;
        }

	// Read current rates setting 
	wone.index = currentConfigWoneInex;
	wone.type = wone_oper_ofdm;
	if( tiap_wcfg_get_wone(wd, &wone, !FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}
	
	printf("\n---------------------\n");
	printf("-  Wone Index is %d  -\n",currentConfigWoneInex);
	printf("----------------------\n");
	
	convert_rates(ofdmRateValue, curRates, wone.elem.ofdm_extend.rates, TIAP_PARAM_OFDM_RATES_MAX);
	newRatesLen = setOFDMrates(curRates, wone.elem.ofdm_extend.len, wone.elem.ofdm_extend.rates);
	wone.elem.ofdm_extend.len = newRatesLen;
	
	tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE);

	printf("done, to take effect RESTART AP.\n"); 
}

void wlanSetAdditionalRates(ConsoleParameter_T parameters[])
{/*
	UINT8 curRates[OFDM_RATES_MAX];
	UINT8 curRatesLen=0;
	UINT8 newRates[OFDM_RATES_MAX];
	UINT8 newRatesLen;
	UINT8 band;


	// Read current rates setting 
	whal_nvram_getOperationalAdditionalRateSetLength(currentConfigWoneInex,&curRatesLen);
	whal_nvram_getOperationalAdditionalRateSet(currentConfigWoneInex,curRates, curRatesLen);

    printf("\n---------------------\n");
    printf("-  Wone Index is %d  -\n",currentConfigWoneInex);
    printf("----------------------\n");

	newRatesLen = setOFDMrates(curRates, curRatesLen, newRates);

	wdrv_dbSetStationConfigOperationalAdditionalRateSet(currentConfigWoneInex,newRates, newRatesLen);

	printf("done, to take effect RESTART AP.\n"); */


	UINT8 curRates[TIAP_PARAM_OFDM_RATES_MAX];
	UINT8 newRatesLen;
	__u8 ofdmRateValue[TIAP_PARAM_OFDM_RATES_MAX] =
		{DOT11_RATE_6,DOT11_RATE_9,DOT11_RATE_12,DOT11_RATE_18,DOT11_RATE_24,
		DOT11_RATE_36,DOT11_RATE_48,DOT11_RATE_54 };
	tiap_param_wone_t wone;

	// Read current rates setting 
	wone.index = currentConfigWoneInex;
	wone.type = wone_oper_add;
	if( tiap_wcfg_get_wone(wd, &wone, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}

	printf("\n---------------------\n");
	printf("-  Wone Index is %d  -\n",currentConfigWoneInex);
	printf("----------------------\n");

	convert_rates(ofdmRateValue, curRates, wone.elem.ofdm_legacy.rates, TIAP_PARAM_OFDM_RATES_MAX);
	newRatesLen = setOFDMrates(curRates, wone.elem.ofdm_legacy.len, wone.elem.ofdm_legacy.rates);
	wone.elem.ofdm_legacy.len = newRatesLen;

	tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE);

	printf("done, to take effect RESTART AP.\n"); 
	
}

void wlanSetRates(ConsoleParameter_T parameters[])
{ /*
	char rates[CCK_PBCC_RATES_MAX];
	UINT8 ratesLen = 0, i;
	UINT8 band;
	wdrv_dbGetBand(currentConfigWoneInex,&band);
    if (band == RADIO_BAND_5GHZ)
        {
            printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
            printf("802.11 A Not support CCK Rates\n");  
            return;
        }
	
	memset(rates, 0, sizeof(rates));
	
	if (parameters[0].INTEGER > parameters[1].INTEGER)
	{
		printf("Invalid Rates configuration, basic rate is higher than supported. basic rate: %d, supported rate: %d\n", parameters[0].INTEGER, parameters[1].INTEGER); 
		return;
	}

	switch(parameters[1].INTEGER)
	{
	case 22:
		rates[4] = DOT11_RATE_22;
		ratesLen++;

	case 11:
		rates[3] = DOT11_RATE_11;
		ratesLen++;

	case 5:
		rates[2] = DOT11_RATE_5_5;
		ratesLen++;

	case 2:
		rates[1] = DOT11_RATE_2;
		ratesLen++;

	case 1:
		rates[0] = DOT11_RATE_1;
		ratesLen++;
		break;

	default:
		printf("Invalid rate = %d", parameters[1].INTEGER); 
		return;
	}

	
	switch(parameters[0].INTEGER)
	{
	case 11:
		rates[3] |= 0x80;

	case 5:
		rates[2] |= 0x80;

	case 2:
		rates[1] |= 0x80;

	case 1:
		rates[0] |= 0x80;
		break;

	default:
		printf("Invalid basic rate = %d", parameters[0].INTEGER);
		return;
	}

	wdrv_dbSetStationConfigOperationalRateSet(currentConfigWoneInex,rates, ratesLen);

	printf("Wone index %d Setting Rates = ",currentConfigWoneInex); 
	for (i = 0; i < ratesLen; i++)
	{
		printf("  "); 
		printRateInMbpsUnit(rates[i]);
	}
	printf("\n"); 
	printf("to take effect RESTART AP.\n"); */




	char rates[TIAP_PARAM_CCK_PBCC_RATES_MAX];
	__u8 cckRateValue[TIAP_PARAM_CCK_PBCC_RATES_MAX] =
		{DOT11_RATE_1,DOT11_RATE_2,DOT11_RATE_5_5,DOT11_RATE_11,DOT11_RATE_22};
	UINT8 ratesLen = 0;
	tiap_param_wone_t wone;

	wone.index = currentConfigWoneInex;
	wone.type = wone_band;
	if( tiap_wcfg_get_wone(wd, &wone, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}

	if (wone.elem.band == TIAP_PARAM_RADIO_BAND_5GHZ)
        {
            printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
            printf("802.11 A Not support CCK Rates\n");  
            return;
        }
	
	memset(rates, 0, sizeof(rates));
	
	if (parameters[0].INTEGER > parameters[1].INTEGER)
	{
		printf("Invalid Rates configuration, basic rate is higher than supported.\n"
		"Basic rate: %ld, supported rate: %ld\n", parameters[0].INTEGER, parameters[1].INTEGER); 
		return;
	}

	switch(parameters[1].INTEGER)
	{
		case 22:
			rates[4] = TIAP_PARAM_RATE_SUPPORTED;
			ratesLen++;

		case 11:
			rates[3] = TIAP_PARAM_RATE_SUPPORTED;
			ratesLen++;

		case 5:
			rates[2] = TIAP_PARAM_RATE_SUPPORTED;
			ratesLen++;

		case 2:
			rates[1] = TIAP_PARAM_RATE_SUPPORTED;
			ratesLen++;

		case 1:
			rates[0] = TIAP_PARAM_RATE_SUPPORTED;
			ratesLen++;
			break;

		default:
			printf("Invalid rate = %ld", parameters[1].INTEGER); 
			return;
	}


	switch(parameters[0].INTEGER)
	{
		case 11:
			rates[3] = TIAP_PARAM_RATE_BASIC_SUPPORTED;

		case 5:
			rates[2] = TIAP_PARAM_RATE_BASIC_SUPPORTED;

		case 2:
			rates[1] = TIAP_PARAM_RATE_BASIC_SUPPORTED;

		case 1:
			rates[0] = TIAP_PARAM_RATE_BASIC_SUPPORTED;
			break;

		default:
			printf("Invalid basic rate = %ld", parameters[0].INTEGER);
			return;
	}




	wone.index = currentConfigWoneInex;
	wone.type = wone_oper_rate;
	memcpy((void *)&wone.elem.b_legacy.rates, (void *)&rates,
			sizeof(wone.elem.b_legacy.rates));
	wone.elem.b_legacy.len = TIAP_PARAM_CCK_PBCC_RATES_MAX;
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set operational rates.");
		return;
	}
		
	

	convert_rates(cckRateValue, rates, wone.elem.b_legacy.rates, TIAP_PARAM_CCK_PBCC_RATES_MAX);
	printf("Wone index %d Setting Rates = ",currentConfigWoneInex); 
/*	for (i = 0; i < ratesLen; i++)
	{
*/
		printf("  "); 
		printRateInMbpsUnit(rates);
/*
	}
*/
	printf("\n"); 
	printf("to take effect RESTART AP.\n");
	
}

void wlanSetRespRateMode(ConsoleParameter_T parameters[])
{ /*
	if ((parameters[0].INTEGER != ASSOCRESP_RATE_ALL_AP) &&
		(parameters[0].INTEGER != ASSOCRESP_RATE_AP_AND_STA))
	{
		printf("Invalid mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetRespRateMode((UINT8)(parameters[0].INTEGER));
	printf("Setting Associate Response supported rate IE mode = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	PRINT_NOT_SUPPORTED_MSG("");
}


int wdrv_dbGetRangeElement(int band,
		tiap_param_cur_reg_domain_t cur_reg_domain,
		UINT8         RangeIndex,
		tiap_param_channel_rang_elem_t *rang_elem)
{
	if (RangeIndex == 0)    /* index is a positive number */
		return 1;

	switch (band)
	{
		case BAND_A:
			switch((__u8)cur_reg_domain.type)
			{
				case TIAP_PARAM_RD_US:
					if (RangeIndex > NUM_OF_RANGE_ELEMENTS_US)
						return 1;
					memcpy(rang_elem, &ch_rang_a[0].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_WORLD:
					if (RangeIndex > NUM_OF_RANGE_ELEMENTS_WORLD)
						return 1;
					memcpy(rang_elem, &ch_rang_a[1].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				default: return 1;
			}
			break;
		case BAND_B:
			switch((__u8)cur_reg_domain.type)
			{
				case TIAP_PARAM_RD_FCC:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[0].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_IC:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[1].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_ETSI:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[2].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_SPAIN:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[3].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_FRANCE:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[4].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_MKK:
					if (RangeIndex > 1)
						return 1;
					memcpy(rang_elem, &ch_rang_b[5].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				case TIAP_PARAM_RD_MKK1:
					if (RangeIndex > 2)
						return 1;
					memcpy(rang_elem, &ch_rang_b[6].rang_elem[RangeIndex-1],
						sizeof(*rang_elem));
					break;

				default:
					return 1;
			}

			break;

		default:
			return 1;
	}
	return OK;
}


/* This routine tests if the channel is allowed according to the band and the current regulatory domain */
BOOL IsChannelAllowed(UINT8 woneIndex, UINT8 channel)
{
	UINT8 isPrivateDomain, ranges_nr = 0, i;
	int band;
	UINT8 step, ch;
	tiap_param_wone_t wone;
	tiap_param_cur_reg_domain_t cur_regdomain;
	tiap_param_channel_rang ch_rang;
	tiap_param_channel_rang_elem_t rang_elem;

	wone.index = woneIndex;
	wone.type = wone_band;

	if( tiap_wcfg_get_wone(wd, &wone, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return FALSE;
	}

	band = (wone.elem.band == TIAP_PARAM_RADIO_BAND_2_4GHZ) ? BAND_B : BAND_A;

	cur_regdomain.band = band;
	if( tiap_wcfg_get_cur_regdomain(wd, &cur_regdomain, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get current regulatory domain.");
		return FALSE;
	}

	ch_rang.type = band;
	if( tiap_wcfg_get_ch_range(wd, &ch_rang, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get channel range.");
		return FALSE;
	}

	isPrivateDomain = FALSE;
	if( band == BAND_A )
	{
	    
		if (channel > 64) { /* currently we assume that such channels are not supported */
			return FALSE;
		}
		/*Alexa: TODO: check the type of the board and if it supports
		 channels higher than 64 to allow them */

		switch( (__u8)cur_regdomain.type )
		{
			case TIAP_PARAM_RD_FCC:
			case TIAP_PARAM_RD_US:
				ranges_nr = NUM_OF_RANGE_ELEMENTS_US;
				break;
				
			case TIAP_PARAM_RD_IC:
			case TIAP_PARAM_RD_ETSI:
			case TIAP_PARAM_RD_SPAIN:
			case TIAP_PARAM_RD_FRANCE:
			case TIAP_PARAM_RD_MKK:
			case TIAP_PARAM_RD_MKK1:
			case TIAP_PARAM_RD_WORLD:
				ranges_nr = NUM_OF_RANGE_ELEMENTS_WORLD;
				break;
			default:
				ranges_nr = ch_rang.ranges_nr;
				isPrivateDomain = TRUE;
		}
	}
	else if( band == BAND_B )
	{
		switch( (__u8)cur_regdomain.type )
		{
			case TIAP_PARAM_RD_FCC:
			case TIAP_PARAM_RD_IC:
			case TIAP_PARAM_RD_ETSI:
			case TIAP_PARAM_RD_SPAIN:
			case TIAP_PARAM_RD_FRANCE:
			case TIAP_PARAM_RD_MKK:
				ranges_nr = 1;
				break;
			case TIAP_PARAM_RD_MKK1:
				ranges_nr = 2;
				break;
			default:
				ranges_nr = ch_rang.ranges_nr;
				isPrivateDomain = TRUE;
		}
	}
	else return FALSE;

	for (i = 1; i <= ranges_nr; i++)
	{

		if (!isPrivateDomain)
			wdrv_dbGetRangeElement(band, cur_regdomain, i, &rang_elem);
		
		else rang_elem = (band == BAND_A ? ch_rang.rng.a[i] : ch_rang.rng.g[i]);
		
		step = rang_elem.step & 0xF;
		for (ch =  rang_elem.start; ch <= rang_elem.stop; ch += step) {
			if (ch == channel)
				return TRUE;
		}
	}

	return FALSE;
}



void wlanSetChannel(ConsoleParameter_T parameters[])
{/*
    UINT8 channel = (UINT8)parameters[0].INTEGER; 

    if (IsChannelAllowed(currentConfigWoneInex,channel) == FALSE) 
    {
        printf("This channel is not in the scope of the Current Regulatory Domain.\n");
        printf("(Use the \"printreg\" command under the 'features' directory for channels list.)\n");
        return;
    }
	wdrv_dbSetChannel(currentConfigWoneInex,channel);
	printf("Setting Wone %d Radio Channel = %d\n", currentConfigWoneInex, parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	UINT8 channel = (UINT8)parameters[0].INTEGER; 
	tiap_param_wone_t wone;

	if (IsChannelAllowed(currentConfigWoneInex, channel) == FALSE) 
	{
		printf("This channel is not in the scope of the Current Regulatory Domain.\n");
		printf("(Use the \"printreg\" command under the 'features' directory for channels list.)\n");
		return;
	}
	
	wone.index = currentConfigWoneInex;
	wone.type = wone_ch;
	wone.elem.ch = parameters[0].INTEGER;
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set channel.");
		return;
	}

	printf("Setting Wone %d Radio Channel = %ld\n", currentConfigWoneInex, parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); 
}


void wlanSetBeacon(ConsoleParameter_T parameters[])
{/*

   if ((parameters[0].SHORT < MIN_BEACON_PERIOD) || (parameters[0].SHORT > MAX_BEACON_PERIOD))
	{
		printf("Invalid beacon period: %d\n", parameters[0].SHORT);
		return;
	}
		
	wdrv_dbSetStationConfigBeaconPeriod(parameters[0].SHORT);
	printf("Setting beacon period = %d msecs\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */


	if ((parameters[0].SHORT < MIN_BEACON_PERIOD) || (parameters[0].SHORT > MAX_BEACON_PERIOD))
	{
		printf("Invalid beacon period: %d\n", parameters[0].SHORT);
		return;
	}
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_BEACON_PERIOD, &parameters[0].SHORT,UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set beacon period.\n");
		return;
	}
	printf("Setting beacon period = %d msecs\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetDtim(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT < MIN_DTIM_PERIOD) || (parameters[0].SHORT > MAX_DTIM_PERIOD))
	{
		printf("Invalid DTIM period: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetStationConfigDtimPeriod(parameters[0].SHORT);
	printf("Setting DTIM period = %d beacons\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");*/
	
	if ((parameters[0].SHORT < MIN_DTIM_PERIOD) || (parameters[0].SHORT > MAX_DTIM_PERIOD))
	{
		printf("Invalid DTIM period: %d\n", parameters[0].SHORT);
		return;
	}
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_DTIM_PERIOD, &parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set DTIM period.\n");
		return;
	}
	printf("Setting DTIM period = %d beacons\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetRtsThreshold(ConsoleParameter_T parameters[])
{/*
	// It is enough to compare the max range only, since the it is unsigned. 
	if (parameters[0].SHORT > MAX_RTS_THRESHOLD)
	{
		printf("Invalid Rts Threshold: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetOperationRTSThreshold(parameters[0].SHORT);
	printf("Setting RTS threshold = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	if (parameters[0].SHORT > MAX_RTS_THRESHOLD)
	{
		printf("Invalid Rts Threshold: %d\n", parameters[0].SHORT);
		return;
	}
	if( tiap_wcfg_siwrts(wd, parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set rts period.\n");
		return;
	}
	printf("Setting RTS threshold = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetShoreRetryLimit(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT < MIN_SHORT_RETRY_LIMIT) || (parameters[0].SHORT > MAX_SHORT_RETRY_LIMIT))
	{
		printf("Invalid short retry limit: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetOperationShortRetryLimit((UINT8)parameters[0].SHORT);
	printf("Setting short retry limit = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */
	
	if ((parameters[0].SHORT < MIN_SHORT_RETRY_LIMIT) || (parameters[0].SHORT > MAX_SHORT_RETRY_LIMIT))
	{
		printf("Invalid short retry limit: %d\n", parameters[0].SHORT);
		return;
	}
	if( tiap_wcfg_siwretry(wd, (UINT8)parameters[0].SHORT, 2, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set short retry limit.");
		return;
	}
		
	printf("Setting short retry limit = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetLongRetryLimit(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT < MIN_LONG_RETRY_LIMIT) || (parameters[0].SHORT > MAX_LONG_RETRY_LIMIT))
	{
		printf("Invalid long retry limit: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetOperationLongRetryLimit((UINT8)parameters[0].SHORT);
	printf("Setting long retry limit = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	if ((parameters[0].SHORT < MIN_LONG_RETRY_LIMIT) || (parameters[0].SHORT > MAX_LONG_RETRY_LIMIT))
	{
		printf("Invalid long retry limit: %d\n", parameters[0].SHORT);
		return;
	}
	if( tiap_wcfg_siwretry(wd, (UINT8)parameters[0].SHORT, 2, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set short retry limit.");
		return;
	}
	printf("Setting long retry limit = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetRateFallback(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetRateFallback((UINT8)parameters[0].SHORT);
	printf("Setting Rate fallback = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_RATE_FALLBACK, (__u8 *)&parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set rate fallback.");
		return;
	}
	printf("Setting Rate fallback = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetRateAdaptation(ConsoleParameter_T parameters[])
{/*

	wdrv_dbSetRateAdaptation(currentConfigWoneInex,(UINT8)parameters[0].SHORT);
	printf("Wone index %d Setting Rate adaptation = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */
	
	tiap_param_wone_t wone;

	wone.index = currentConfigWoneInex;
	wone.type = wone_rate_adapt;
	wone.elem.rate_adapt = (UINT8)parameters[0].SHORT;
	
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set rate adaptation.");
		return;
	}
	printf("Wone index %d Setting Rate adaptation = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetFragmentationTreshold(ConsoleParameter_T parameters[])
{/*
	BOOL Status4x;
  
	if ((parameters[0].SHORT < MIN_FRAG_THRESHOLD) || (parameters[0].SHORT > MAX_FRAG_THRESHOLD))
	{
		printf("Invalid fragmentation threshold: %d\n", parameters[0].SHORT);
		return;
	}
	if ((parameters[0].SHORT % 2) !=0 )
	{
		printf("Invalid fragmentation threshold, must be an even number.\n");
		return;
	}


   wdrv_dbGet4xEnable(&Status4x);

   if(( parameters[0].SHORT != MAX_FRAG_THRESHOLD )&&( Status4x == TRUE ))
   {
      printf("Fragmentation Treshold must be %d when 4X is enabled.\n", MAX_FRAG_THRESHOLD);
      return;
   }

	wdrv_dbSetOperationFragmentationThreshold(parameters[0].SHORT);
   printf("Setting fragmentation threshold = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_4x_t _4x;

	if ((parameters[0].SHORT < MIN_FRAG_THRESHOLD) || (parameters[0].SHORT > MAX_FRAG_THRESHOLD))
	{
		printf("Invalid fragmentation threshold: %d\n", parameters[0].SHORT);
		return;
	}
	if ((parameters[0].SHORT % 2) !=0 )
	{
		printf("Invalid fragmentation threshold, must be an even number.\n");
		return;
	}

	
	_4x.cmd = TIAP_PARAM_4X_4X;
	if( tiap_wcfg_get_4x(wd, &_4x, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get 4x enable.");
		return;
	}
	if(( parameters[0].SHORT != MAX_FRAG_THRESHOLD )&&( _4x.value == TRUE ))
	{
		printf("Fragmentation Treshold must be %d when 4X is enabled.\n", MAX_FRAG_THRESHOLD);
		return;
	}

	if( tiap_wcfg_siwfrag(wd, parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set fragmentation threshold.");
		return;
	}
			
	printf("Setting fragmentation threshold = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetMaxTransmitMSDULifetime(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER < MIN_TRANSMIT_MSDU_LIFETIME) || (parameters[0].INTEGER > MAX_TRANSMIT_MSDU_LIFETIME))
	{
		printf("Invalid Max transmit MSDU lifetime: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetOperationMaxTransmitMSDULifetime(parameters[0].INTEGER);
	printf("Setting max transmit MSDU lifetime = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	if ((parameters[0].INTEGER < MIN_TRANSMIT_MSDU_LIFETIME) || (parameters[0].INTEGER > MAX_TRANSMIT_MSDU_LIFETIME))
	{
		printf("Invalid Max transmit MSDU lifetime: %ld\n", parameters[0].INTEGER);
		return;
	}

	if( tiap_wcfg_siwretry(wd, parameters[0].INTEGER, TIAP_PARAM_LIFETIME_TX, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set max transmit MSDU lifetime.");
		return;
	}
	printf("Setting max transmit MSDU lifetime = %ld\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); 
}

void wlanSetMaxReceiveLifetime(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER < MIN_RECEIVE_MSDU_LIFETIME) || (parameters[0].INTEGER > MAX_RECEIVE_MSDU_LIFETIME))
	{
		printf("Invalid Max receive lifetime: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetOperationMaxReceiveLifetime(parameters[0].INTEGER);
	printf("Setting max receive MSDU lifetime = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	if ((parameters[0].INTEGER < MIN_RECEIVE_MSDU_LIFETIME) || (parameters[0].INTEGER > MAX_RECEIVE_MSDU_LIFETIME))
	{
		printf("Invalid Max receive lifetime: %ld\n", parameters[0].INTEGER);
		return;
	}

	if( tiap_wcfg_siwretry(wd, parameters[0].INTEGER, TIAP_PARAM_LIFETIME_RX, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set max receive MSDU lifetime.");
		return;
	}
	printf("Setting max receive MSDU lifetime = %ld\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); 
}

void wlanPrintRatesParams(ConsoleParameter_T parameters[])
{/*
	int i;

	char rates[CCK_PBCC_RATES_MAX+OFDM_RATES_MAX];
	UINT8 ratesLen;
	char extRates[OFDM_RATES_MAX];
	UINT8 extRatesLen;
	char allRates[CCK_PBCC_RATES_MAX+OFDM_RATES_MAX];
	UINT8 allRatesLen;

    UINT8 wone_index;
    UINT8  num_sup_wone;
    wdrv_dbGetNumSupWone(&num_sup_wone);
    for (wone_index = 0 ; wone_index < num_sup_wone; wone_index ++)
    {
        wdrv_dbGetStationConfigOperationalRateSet(wone_index, rates, &ratesLen);
        wdrv_dbGetStationConfigOperationalOFDMRateSet(wone_index, extRates, &extRatesLen);
        wdrv_dbGetStationConfigOperationalAllRateSet(wone_index, allRates, &allRatesLen);

	printf("\n"); 
        printf("Wone Index %d\n",wone_index); 

	printf("Rates in Legacy IE =    "); 
	for (i = 0; i < ratesLen; i++)
	{
		printf("  "); 
		printRateInMbpsUnit(rates[i]);
	}
	printf("\n\n"); 
	printf("Rates in Extended IE =    "); 
	for (i = 0; i < extRatesLen; i++)
	{
		printf("  "); 
		printRateInMbpsUnit(extRates[i]);
	}
	printf("\n\n"); 
	printf("All Rates =    "); 
	for (i = 0; i < allRatesLen; i++)
	{
		printf("  "); 
		printRateInMbpsUnit(allRates[i]);
	}
        printf("\n"); 
    } */


	dda_print_proc_entry(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RATES);
}

void wlanPrintParams(ConsoleParameter_T parameters[])
{/*
	char  macaddr[6], ssid[50], bssid[6];
	UINT8 shortRetryLimit, longRetryLimit, dtim, channel, defaultActiveRate;
	UINT8 RateFallback, RateAdaptation;
	int i;
	UINT16 capabilities, beacon, rtsThreshold, fragThreshold, stationsNotPBCCCapabale;
	UINT32 transmitLifetime, receiveLifetime;
	BOOL currentPBCCSupport;
	UINT8 PBCCAlgorithmMode; 
	UINT32 swMinor, swMajor;
	UINT8 SlotTimeMode, PreambleMode;
	UINT16 SlotTimeThreshold;
	UINT16 stationsNotSlotTimeCapabale, stationsNotShortPreambleCapabale;
	BOOL currentShortSlotTimeSupport, currentShortPreambleSupport;
	UINT8 ERPProtectionMode, ERPProtectionType;
	UINT8 ERPProtectionTI;
	BOOL currentERPProtectionMode;
	char allRates[CCK_PBCC_RATES_MAX+OFDM_RATES_MAX];
	UINT8 allRatesLen;
	UINT8 respRateMode;
	UINT8 dot11Mode,CWminMode;
	UINT16 CWminWindowSize;
	UINT32	DynAlgoTimeout;
	UINT32 RadioCalibrateOption;
	UINT16 RadioCalibrateInterval;
   UINT8 band;
   UINT8 num_sup_wone;
   UINT16 HiddenSSID;

   UINT8 usageTimeMode;
   UINT8 usageTime;

        UINT16 MultipleSsidFlag;
        char MultipleSsidTable[NUM_MULTIPLE_SSID][WHAL_SSID_STRING_LEN];
   UINT8  idx;
   tVHCF_PARAMS  vhcfParams;

	if (wdrv_dbIsNvramIdenticalToDatabase() == FALSE)
	{
		printf("NOTICE:	The following parameters values are taken from the SDRAM,\n");
		printf("		some of them may be different from the values stored in the NVRAM!!!\n");
		printf("\n");
	}
    wdrv_dbGetNumSupWone(&num_sup_wone);
    if (num_sup_wone == WONE_DUAL_BAND )
    {
        printf("\n---------  Dual AP ---------\n");

        wdrv_dbGetUsageTimeMode(&usageTimeMode);
        if(usageTimeMode)
           printf("\n--------- Long Usage Time ---------\n");
        else  

           printf("\n---------  Short Usage Time ---------\n");
    }
    printf("\n--------- Active Set Wone Index is %d ---------\n",currentConfigWoneInex);  

    wdrv_dbGetBand(currentConfigWoneInex,&band);


	swMajor = GET_MAJOR_SW_VER;
	swMinor = GET_MINOR_SW_VER;

	wdrv_dbGetOperationMacAddress(macaddr);
	wdrv_dbGetBssid(bssid);	
	wdrv_dbGetSsid(ssid);
    wdrv_dbGetHiddenSsidStatus(&HiddenSSID);
    wdrv_dbGetMultipleSsidStatus(&MultipleSsidFlag);
    if (MultipleSsidFlag)
    {
        UINT32 length = NUM_MULTIPLE_SSID*WHAL_SSID_STRING_LEN;
        whal_nvram_getMultipleSsidTable(MultipleSsidTable[0],&length);
    }
    wdrv_dbGetStationConfigOperationalAllRateSet(currentConfigWoneInex,allRates, &allRatesLen);
	wdrv_dbGetDefaultActiveRate(currentConfigWoneInex,&defaultActiveRate);
	wdrv_dbGetApCapabilities(currentConfigWoneInex,&capabilities);
    wdrv_dbGetChannel(currentConfigWoneInex,&channel);
	wdrv_dbGetStationConfigBeaconPeriod(&beacon);
	wdrv_dbGetStationConfigDtimPeriod(&dtim);

	wdrv_dbGetOperationRTSThreshold(&rtsThreshold);
	wdrv_dbGetOperationShortRetryLimit(&shortRetryLimit);
	wdrv_dbGetOperationLongRetryLimit(&longRetryLimit);
	wdrv_dbGetRateFallback(&RateFallback);
	wdrv_dbGetRateAdaptation(currentConfigWoneInex,&RateAdaptation);
	wdrv_dbGetOperationFragmentationThreshold(&fragThreshold);
	wdrv_dbGetOperationMaxTransmitMSDULifetime(&transmitLifetime);
	wdrv_dbGetOperationMaxReceiveLifetime(&receiveLifetime);
	wdrv_dbGetPBCCAlgorithmMode(currentConfigWoneInex,&PBCCAlgorithmMode);
	wdrv_dbGetNumOfStationNotPBCCCapable(&stationsNotPBCCCapabale);
	wdrv_dbGetCurrentPBCCSupportMode(&currentPBCCSupport);
	wdrv_dbGetDot11Mode(currentConfigWoneInex,&dot11Mode);
	wdrv_dbGetRadioCalibrateOption(&RadioCalibrateOption);
	wdrv_dbGetRadioCalibrateInterval(&RadioCalibrateInterval);

	wdrv_dbGetPreambleMode(currentConfigWoneInex,&PreambleMode);
	wdrv_dbGetNumOfStationNotShortPreambleCapable(&stationsNotShortPreambleCapabale);
	wdrv_dbGetCurrentShortPreambleSupport(&currentShortPreambleSupport);

	wdrv_dbGetSlotTimeMode(currentConfigWoneInex,&SlotTimeMode);
	wdrv_dbGetSlotTimeThreshold(&SlotTimeThreshold);
        wdrv_dbGetNumOfStationNotSlotTimeCapable(&stationsNotSlotTimeCapabale);
	wdrv_dbGetCurrentShortSlotTimeSupport(&currentShortSlotTimeSupport);

	wdrv_dbGetERPProtectionMode(currentConfigWoneInex,&ERPProtectionMode);
	wdrv_dbGetCurrentERPProtectionMode(&currentERPProtectionMode);
	wdrv_dbGetERPProtectionType(currentConfigWoneInex,&ERPProtectionType);
	wdrv_dbGetERPProtectionTI(currentConfigWoneInex,&ERPProtectionTI);

	wdrv_dbGetDynamicAlgorithmsTimeout(&DynAlgoTimeout);

	wdrv_dbGetRespRateMode(&respRateMode);

	wdrv_dbGetCwMinMode(currentConfigWoneInex,&CWminMode);
	wdrv_dbGetCwMinWinSize(&CWminWindowSize);
   wdrv_dbGetUsageTime(currentConfigWoneInex,&usageTime);
   wdrv_dbGetVhcfParams(&vhcfParams);


	printf("Software Version:	%d.%d\n",swMajor, swMinor);
#ifdef VXWORKS
   {
      unsigned char prn_buffer[81], *buf;
      buf = prn_buffer;
      cm_hwFormatBootInfo1(buf, 80);
      puts(buf);
   }
#endif // VXWORKS 

	printf("WLAN MAC = <%02hhX-%02hhX-%02hhX-%02hhX-%02hhX-%02hhX>\n",		
		  macaddr[0],macaddr[1],macaddr[2],macaddr[3],
		  macaddr[4],macaddr[5] );

	printf("WLAN BSSID = <%02hhX-%02hhX-%02hhX-%02hhX-%02hhX-%02hhX>\n",		
		  bssid[0],bssid[1],bssid[2],bssid[3],
		  bssid[4],bssid[5] );

	printf("SSID = %s\n", ssid); 

    if (band == RADIO_BAND_5GHZ)    
        printf("Band = 5 MHZ\n");  
    else
        printf("Band = 2.4 MHZ\n"); 

    printf("Hidden SSID mode is %s\n", (HiddenSSID==1) ? "Enabled" : "Disabled");
    printf("Multiple SSID mode is %s\n", (MultipleSsidFlag==1) ? "Enabled" : "Disabled");
    if (MultipleSsidFlag==1) 
    {
        printf("List of Multiple SSID:\n");
        for (i=0; i<NUM_MULTIPLE_SSID; i++) 
        {
            if (MultipleSsidTable[i][0] == '\0')
                break;
            printf("\t%d. %s\n",i+1,MultipleSsidTable[i]);
        }
        if (i==0)
            printf("\tNone.\n");
    }

	printf("Capabilities = AGILE  PBCC  ShortPreamble  Privacy  CFPollReq  CFPoll  IBSS  ESS\n"); 

	printf("                 %d    ", ((capabilities >> CAP_AGILE_SHIFT) & CAP_AGILE_MASK));
	printf("  %d   ", ((capabilities >> CAP_PBCC_SHIFT) & CAP_PBCC_MASK));
	printf("      %d       ", ((capabilities >> CAP_PREAMBLE_SHIFT) & CAP_PREAMBLE_MASK));
	printf("    %d     ", ((capabilities >> CAP_PRIVACY_SHIFT) & CAP_PRIVACY_MASK));
	printf("    %d      ", ((capabilities >> CAP_CF_REQ_SHIFT) & CAP_CF_REQ_MASK));
	printf("   %d    ", ((capabilities >> CAP_CF_POLL_SHIFT) & CAP_CF_POLL_MASK));
	printf("  %d   ", ((capabilities >> CAP_IBSS_SHIFT) & CAP_IBSS_MASK));
	printf("  %d\n", ((capabilities >> CAP_ESS_SHIFT) & CAP_ESS_MASK));
	
	printf("Capabilities = RSN  ShortSlotTime\n"); 
	printf("                %d         ", ((capabilities >> CAP_RSN_SHIFT) & CAP_RSN_MASK));
	printf("%d\n", ((capabilities >> CAP_SLOTTIME_SHIFT) & CAP_SLOTTIME_MASK));

	printf("Rates =	"); 
	for (i = 0; i < allRatesLen; i++)
	{
		printf("  "); 
		printRateInMbpsUnit(allRates[i]);
	}
	printf("\n"); 

	printf("Default active rate = "); 
	printf("  "); 
	printRateInMbpsUnit(defaultActiveRate);
	printf("\n"); 

	printf("Channel = %d\n", channel); 

	if (channel == 14)
		printf("Domain = MKK\n"); 
	else
		printf("Domain = ETSI\n"); 

	printf("Beacon period = %d msecs\n", beacon); 
	
	printf("DTIM period = %d beacons\n", dtim); 

	printf("rtsThreshold = %d bytes\n", rtsThreshold); 
	printf("shortRetryLimit = %d\n", shortRetryLimit); 
	printf("longRetryLimit = %d\n", longRetryLimit); 
	printf("rate fallback = %d\n", RateFallback); 
	if (RateAdaptation)
	{
		printf("rate adaptation = Enabled\n");
	}
	else
	{
		printf("rate adaptation = Disabled\n");
	}
	printf("fragThreshold = %d bytes\n", fragThreshold); 
	printf("transmitLifetime = %d msecs\n", transmitLifetime); 
	printf("receiveLifetime = %d msecs\n", receiveLifetime); 
	printf("Radio Calibrate option=%d interval=%d\n", RadioCalibrateOption, RadioCalibrateInterval); 

	if (dot11Mode == DOT11_MODE_MIXED)
	{
		printf("Dot11 mode = Mixed mode\n");
	}
	else if (dot11Mode == DOT11_MODE_B_ONLY)
	{
		printf("Dot11 mode = B only mode\n");
	}
	else if(dot11Mode == DOT11_MODE_OFDM_ONLY)
	{
		printf("Dot11 mode = G only mode\n");
	}
	else if(dot11Mode == DOT11_MODE_B_ONLY_PLUS)
	{
		printf("Dot11 mode = B+ only mode\n");
	}
	else
		printf("Dot11 mode = A only mode\n");

	
	if (respRateMode == ASSOCRESP_RATE_ALL_AP)
	{
		printf("AssocResp rate mode = %d (All AP rates)\n", ASSOCRESP_RATE_ALL_AP);
	}
	else if (ASSOCRESP_RATE_AP_AND_STA)
	{
		printf("AssocResp rate mode = %d (Only AP rates supported by STA)\n", ASSOCRESP_RATE_AP_AND_STA);
	}

	printf("Enhanced Dynamic Algorithms Timeout = %d ms\n", DynAlgoTimeout);

	printf("CWmin mode = %d, CWminWindowSize = %d\n", CWminMode,CWminWindowSize);


	// PBCC support section
	printf("--------------------------------------------\n"); 
	if (PBCCAlgorithmMode == PBCC_ALGO_DISABLED)
		printf("PBCC Algorithm			Always off\n");
	else if (PBCCAlgorithmMode == PBCC_ALGO_LOCAL_STATIONS)
		printf("PBCC Algorithm			Local Stations\n");
	else if (PBCCAlgorithmMode == PBCC_ALGO_DYNAMIC)
		printf("PBCC Algorithm			Dynamic\n");
	else if (PBCCAlgorithmMode == PBCC_ALGO_ENHANCED_DYNAMIC)
		printf("PBCC Algorithm			Enhanced Dynamic\n");	
	else if (PBCCAlgorithmMode == PBCC_ALGO_ENABLED)
		printf("PBCC Algorithm			Always on\n");
	else
		printf("PBCC Algorithm			Unrecognized\n");

	if ((PBCCAlgorithmMode == PBCC_ALGO_LOCAL_STATIONS) || (PBCCAlgorithmMode == PBCC_ALGO_DYNAMIC) || (PBCCAlgorithmMode == PBCC_ALGO_ENHANCED_DYNAMIC))
	{
		printf("Number of station that are not PBCC capable:	%d\n", stationsNotPBCCCapabale);
		if ((capabilities >> CAP_PBCC_SHIFT) & CAP_PBCC_MASK)
		{	
			if (currentPBCCSupport)
				printf("Current PBCC support		On\n");
			else
				printf("Current PBCC support		Off\n");
		}
	}

	// Preamble support section
	printf("--------------------------------------------\n"); 
	if (PreambleMode == PREAMBLE_MODE_LONG)
		printf("Preamble Mode                   Always Long\n");
	else if (PreambleMode == PREAMBLE_MODE_SHORT)
		printf("Preamble Mode                   Always Short\n");
	else if (PreambleMode == PREAMBLE_MODE_LOCAL_STATIONS)
	{
		printf("Preamble Mode                   Local Stations\n");
		if (currentShortPreambleSupport)
			printf("Current Short Preamble support  On\n");
		else
			printf("Current Short Preamble support  Off\n");
		printf("Num of stations not capable     %d\n", stationsNotShortPreambleCapabale);
	}

	// Slot Time support section
	printf("--------------------------------------------\n"); 
	if (SlotTimeMode == SLOTTIME_MODE_DISABLED)
		printf("Slot Time Mode                  Always off\n");
	else if (SlotTimeMode == SLOTTIME_MODE_ENABLED)
		printf("Slot Time Mode                  Always on\n");
	else if (SlotTimeMode == SLOTTIME_MODE_LOCAL_STATIONS)
	{
		printf("Slot Time Mode                  Local Stations\n");
		printf("Slot Time Threshold             %d\n", SlotTimeThreshold);
		if (currentShortSlotTimeSupport)
			printf("Current Short Slot Time support On\n");
		else
			printf("Current Short Slot Time support Off\n");
		printf("Num of stations not capable     %d\n", stationsNotSlotTimeCapabale);
	}
	else if (SlotTimeMode == SLOTTIME_MODE_ENHANCED_DYNAMIC)
	{
		printf("Slot Time Mode                  Enhanced Dynamic\n");
		printf("Slot Time Threshold             %d\n", SlotTimeThreshold);
		if (currentShortSlotTimeSupport)
			printf("Current Short Slot Time support On\n");
		else
			printf("Current Short Slot Time support Off\n");
		printf("Num of stations not capable     %d\n", stationsNotSlotTimeCapabale);
	}

	

	// ERP Protection support section
	printf("--------------------------------------------\n"); 
	if (ERPProtectionMode == PROTECTION_MODE_DISABLED)
	{
		printf("ERP Protection Mode             Always off\n");
	}
	else
	{
		if(ERPProtectionMode == PROTECTION_MODE_LOCAL_STATIONS)		
			printf("ERP Protection Mode             Local Stations\n");
		else if(ERPProtectionMode == PROTECTION_MODE_DYNAMIC)
			printf("ERP Protection Mode             Dynamic\n");
		else if(ERPProtectionMode == PROTECTION_MODE_ENHANCED_DYNAMIC)
			printf("ERP Protection Mode             Enhanced Dynamic\n");
		else if (ERPProtectionMode == PROTECTION_MODE_ENABLED)
			printf("ERP Protection Mode             Always on\n");
		else
			printf(" Undefined ERP Protection Mode\n");


		if (currentERPProtectionMode)
		{
			printf("Current ERP Protection Mode     On\n");
		}
		else
		{
			printf("Current ERP Protection Mode     Off\n");
		}

		if(ERPProtectionTI)
			printf("ERP Protection Type             TI-proprietary\n");
		else
		{
			if (ERPProtectionType == PROTECTION_TYPE_RTS_CTS)
				printf("ERP Protection Type             RTS/CTS\n");
			else
				printf("ERP Protection Type             CTS TO SELF\n");
		}
	}
   if(num_sup_wone == 2)
   printf("Wone Usage Time is %d\n",usageTime);

   // Show vHCF configuration parameters 
   printf("--------------------------------------------\n"); 
   if(vhcfParams.vhcfEnable)   
   {	
	  printf("vHCF Enabled:\n");
	  for(idx = 0; idx < MAX_VHCF_CLASSIFIERS ; idx++)
	  {
		  if (vhcfParams.vhcfClassifier[idx].Protocol != VHCF_PROT_NONE)
		  {
			  printf("Classifier #%u: Prot = %s, Dest_IP = %u.%u.%u.%u, Dest_Port = %u\n",
				  idx, 
				  (vhcfParams.vhcfClassifier[idx].Protocol == VHCF_PROT_TCP) ? "TCP" : "UDP",
				  (vhcfParams.vhcfClassifier[idx].DestIp >> 24) & 0xFF,
				  (vhcfParams.vhcfClassifier[idx].DestIp >> 16) & 0xFF,
				  (vhcfParams.vhcfClassifier[idx].DestIp >>  8) & 0xFF,
				  (vhcfParams.vhcfClassifier[idx].DestIp      ) & 0xFF,
				   vhcfParams.vhcfClassifier[idx].DestPort);
		  }
		  else
			  printf("Classifier #%u: Not Used.\n", idx);
	  }
	}
	else
		printf("vHCF Disabled!\n"); */

	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_wlan_params(currentConfigWoneInex, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_wlan_params failed !");
	else
		puts(buf);
	
	
}

void wlanPrintCounters(ConsoleParameter_T parameters[]){
	/*
	UINT32 count1, count2, count3, count4, count5, count6, count7;
	UINT32 count8, count9, count10, count11, count12, count13, count14;
	UINT32 count15, count16;

	wdrv_dbGetCountersTransmittedFragmentCount(&count1);
	wdrv_dbGetCountersMulticastTransmittedFrameCount(&count2);
	wdrv_dbGetCountersFailedCount(&count3);
	wdrv_dbGetCountersRetryCount(&count4);
	wdrv_dbGetCountersMultipleRetryCount(&count5);
	wdrv_dbGetCountersFrameDuplicateCount(&count6);
	wdrv_dbGetCountersRTSSuccessCount(&count7);
	wdrv_dbGetCountersRTSFailureCount(&count8);
	wdrv_dbGetCountersACKFailureCount(&count9);
	wdrv_dbGetCountersReceivedFragmentCount(&count10);
	wdrv_dbGetCountersMulticastReceivedFrameCount(&count11);
	wdrv_dbGetCountersFCSErrorCount(&count12);
	wdrv_dbGetCountersTransmittedFrameCount(&count13);
	wdrv_dbGetCountersWEPUndecryptableCount(&count14);
	wdrv_dbGetPrivacyWEPICVErrorCount(&count15);
	wdrv_dbGetPrivacyWEPExcludedCount(&count16);

	printf("***Counters***\n"); 
	printf("Transmitted Fragment Count			= %d\n", count1); 
	printf("Multicast Transmitted Frame Count		= %d\n", count2); 
	printf("Failed Count					= %d\n", count3); 
	printf("Retry Count					= %d\n", count4); 
	printf("Multiple Retry Count				= %d\n", count5); 
	printf("Frame Duplicate Count				= %d\n", count6); 
	printf("RTS Success Count				= %d\n", count7); 
	printf("RTS Failure Count				= %d\n", count8); 
	printf("ACK Failure Count				= %d\n", count9); 
	printf("Received Fragment Count				= %d\n", count10); 
	printf("Multicast Received Frame Count			= %d\n", count11); 
	printf("FCS Error Count					= %d\n", count12); 
	printf("Transmitted Frame Count				= %d\n", count13); 
	printf("WEP Undecryptable Count				= %d\n", count14); 
	printf("WEP ICV Error Count				= %d\n", count15); 
	printf("WEP Excluded Count				= %d\n", count16); 
*/


	dda_print_proc_entry(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_COUNTERS);
}

void wlanSetNvramDefaults(ConsoleParameter_T parameters[])
{/*
	wdrv_dbRestoreNvramDefaults();
	printf("Restoring nvram defaults\n"); 
	printf("to take effect RESTART AP.\n"); */

	if (tiap_wcfg_set_defaults(wd)){
		PRINT_CONFIG_ERR_MSG("Failed to set defaults.");
		return;
	}
	printf("Restoring nvram defaults\n"); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetAgile(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid agile mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_dbSetAgile((BOOL)(parameters[0].INTEGER));
	printf("Setting Agile = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	PRINT_NOT_SUPPORTED_MSG("Setting Agile");
}

void wlanSetPreambleMode(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != PREAMBLE_MODE_LONG) &&
		(parameters[0].SHORT != PREAMBLE_MODE_SHORT) &&
		(parameters[0].SHORT != PREAMBLE_MODE_LOCAL_STATIONS))
	{
		printf("Invalid preamble mode: %d\n", parameters[0].SHORT);
		return;
	}

	wdrv_dbSetPreambleMode(currentConfigWoneInex,parameters[0].SHORT);
	printf("Wone Index %d Setting Preamble mode = %d\n", currentConfigWoneInex, parameters[0].SHORT);
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;

	if ((parameters[0].SHORT != TIAP_PARAM_PREAMBLE_MODE_LONG) &&
			(parameters[0].SHORT != TIAP_PARAM_PREAMBLE_MODE_SHORT) &&
			(parameters[0].SHORT != TIAP_PARAM_PREAMBLE_MODE_LOCAL_STATIONS))
	{
		printf("Invalid preamble mode: %d\n", parameters[0].SHORT);
		return;
	}

	wone.index = currentConfigWoneInex;
	wone.type = wone_pream_mode;
	wone.elem.pream_mode = parameters[0].SHORT;

	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
		return;
	}


	printf("Wone Index %d Setting Preamble mode = %d\n", currentConfigWoneInex, parameters[0].SHORT);
	printf("to take effect RESTART AP.\n");
}

void wlanSetSlotTimeMode(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != SLOTTIME_MODE_DISABLED) &&
		(parameters[0].SHORT != SLOTTIME_MODE_ENABLED) &&
		(parameters[0].SHORT != SLOTTIME_MODE_LOCAL_STATIONS) &&
		(parameters[0].SHORT != SLOTTIME_MODE_ENHANCED_DYNAMIC))
	{
		printf("Invalid Slot Time mode: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetSlotTimeMode(currentConfigWoneInex, parameters[0].SHORT);
	printf("Wone Index %d Setting Slot Time mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;
	
	if ((parameters[0].SHORT != TIAP_PARAM_SLOTTIME_MODE_DISABLED) &&
			(parameters[0].SHORT != TIAP_PARAM_SLOTTIME_MODE_ENABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_SLOTTIME_MODE_LOCAL_STATIONS) &&
		(parameters[0].SHORT != TIAP_PARAM_SLOTTIME_MODE_ENHANCED_DYNAMIC))
	{
		printf("Invalid Slot Time mode: %d\n", parameters[0].SHORT);
		return;
	}


	wone.index = currentConfigWoneInex;
	wone.type = wone_slot_mode;
	wone.elem.slot_mode = parameters[0].SHORT;
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
		return;
	}

	printf("Wone Index %d Setting Slot Time mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetSlotTimeThreshold(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetSlotTimeThreshold(parameters[0].SHORT);
	printf("Setting Slot Time threshold = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	PRINT_NOT_SUPPORTED_MSG("Slot Time threshold");
}

void wlanSetERPProtectionMode(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != PROTECTION_MODE_DISABLED) &&
		(parameters[0].SHORT != PROTECTION_MODE_ENABLED) &&
		(parameters[0].SHORT != PROTECTION_MODE_LOCAL_STATIONS) &&
		(parameters[0].SHORT != PROTECTION_MODE_DYNAMIC) &&
		(parameters[0].SHORT != PROTECTION_MODE_ENHANCED_DYNAMIC))
	{
		printf("Invalid Protection mode: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetERPProtectionMode(currentConfigWoneInex, parameters[0].SHORT);
	printf("Wone Index %d Setting Protection mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;
	
	if ((parameters[0].SHORT != TIAP_PARAM_PROTECTION_MODE_DISABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_MODE_ENABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_MODE_LOCAL_STATIONS) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_MODE_DYNAMIC) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_MODE_ENHANCED_DYNAMIC))
	{
		printf("Invalid Protection mode: %d\n", parameters[0].SHORT);
		return;
	}

	wone.index = currentConfigWoneInex;
	wone.type = wone_erp_mode;
	wone.elem.erp_mode = parameters[0].SHORT;
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
		return;
	}

	printf("Wone Index %d Setting Protection mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetERPProtectionType(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != PROTECTION_TYPE_RTS_CTS) &&
		(parameters[0].SHORT != PROTECTION_TYPE_CTS_TOSELF) &&
		(parameters[0].SHORT != PROTECTION_TYPE_TI))
	{
		printf("Invalid Protection type: %d\n", parameters[0].SHORT);
		return;
	}
	// if protection type is TIprotection, set it internally to CTS_TOSELF,
	//   because there might be STAs that don't support TIprotection 
	if(parameters[0].SHORT != PROTECTION_TYPE_TI)
	{
		wdrv_dbSetERPProtectionTI(currentConfigWoneInex,PROTECTION_TI_DISABLED);
		wdrv_dbSetERPProtectionType(currentConfigWoneInex,parameters[0].SHORT);
	}
	else
	{
		wdrv_dbSetERPProtectionTI(currentConfigWoneInex,PROTECTION_TI_ENABLED);
		wdrv_dbSetERPProtectionType(currentConfigWoneInex,PROTECTION_TYPE_CTS_TOSELF);
	}
		
	printf("Wone Index %d Setting Protection type = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;

	if ((parameters[0].SHORT != TIAP_PARAM_PROTECTION_TYPE_RTS_CTS) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_TYPE_CTS_TOSELF) &&
		(parameters[0].SHORT != TIAP_PARAM_PROTECTION_TYPE_TI))
	{
		printf("Invalid Protection type: %d\n", parameters[0].SHORT);
		return;
	}

	if(parameters[0].SHORT != TIAP_PARAM_PROTECTION_TYPE_TI)
	{
		wone.index = currentConfigWoneInex;
		wone.type = wone_erp_ti;
		wone.elem.erp_ti = TIAP_PARAM_PROTECTION_TI_DISABLED;
		if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
			return;
		}

		wone.index = currentConfigWoneInex;
		wone.type = wone_erp_type;
		wone.elem.erp_type = parameters[0].SHORT;
		if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
			return;
		}
	}
	else
	{
		wone.index = currentConfigWoneInex;
		wone.type = wone_erp_ti;
		wone.elem.erp_ti = TIAP_PARAM_PROTECTION_TI_ENABLED;
		if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
			return;
		}

		wone.index = currentConfigWoneInex;
		wone.type = wone_erp_type;
		wone.elem.erp_type = TIAP_PARAM_PROTECTION_TYPE_CTS_TOSELF;
		if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to set preamble mode.");
			return;
		}
	}

	printf("Wone Index %d Setting Protection type = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetDot11Mode(ConsoleParameter_T parameters[])
{/*
	char  rates[CCK_PBCC_RATES_MAX];
	UINT8 grates[OFDM_RATES_MAX];
	UINT8 ratesLen = 0;
	UINT8 pbccMode;	
    UINT8 RadioFrequency;
	

	if ((parameters[0].SHORT != DOT11_MODE_MIXED) &&
		(parameters[0].SHORT != DOT11_MODE_B_ONLY) &&
		(parameters[0].SHORT != DOT11_MODE_OFDM_ONLY) &&
		(parameters[0].SHORT != DOT11_MODE_B_ONLY_PLUS)&&
        (parameters[0].SHORT != DOT11_MODE_A_ONLY))
	{
		printf("Invalid Dot11 mode: %d\n", parameters[0].SHORT);
		return;
	}

    wdrv_dbGetRadioFrequency(&RadioFrequency);

    switch (RadioFrequency){
    case RADIO_BAND_2_4_AND_5GHZ:
        // nothing to check 
        break;

    case RADIO_BAND_2_4GHZ:
        // check for modes 0,1,2,3 
        if (parameters[0].SHORT == DOT11_MODE_A_ONLY) {
            printf("  Invalid Dot11 mode: %d RadioFrequency is 2.4 GHZ only \n", parameters[0].SHORT);
            return;
        }

        break;
    case RADIO_BAND_5GHZ:
        if(parameters[0].SHORT != DOT11_MODE_A_ONLY){
            printf("  Invalid Dot11 mode: %d RadioFrequency is 5 GHZ only \n", parameters[0].SHORT);
            return;
        }
        break;
    default:
        printf("Invalid RadioFrequency parameter \n");
        return;
        break;
        

    }

	wdrv_dbSetDot11Mode(currentConfigWoneInex,parameters[0].SHORT);

	whal_nvram_setDefaultsPartial(currentConfigWoneInex, (UINT8)parameters[0].SHORT);


	printf("Wone Index %d Dot11 mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect AP is restarting now...\n");
    rt_osTimerWakeAfter(200);
	consoleReboot(0); */


	UINT8 RadioFrequency;
	char buf[4096];
	int len;

	if ((parameters[0].SHORT != TIAP_PARAM_D11MODE_MIXED) &&
			(parameters[0].SHORT != TIAP_PARAM_D11MODE_B) &&
			(parameters[0].SHORT != TIAP_PARAM_D11MODE_OFDM) &&
			(parameters[0].SHORT != TIAP_PARAM_D11MODE_B_PLUS)&&
			(parameters[0].SHORT != TIAP_PARAM_D11MODE_A))
	{
		printf("Invalid Dot11 mode: %d\n", parameters[0].SHORT);
		return;
	}

	if( (len = dda_read_proc_entry(WLAN_PROC_SERV_DIR_NAME,
					WLAN_PROC_SERV_RADIO_FREQ, buf, sizeof(buf))) == -1 )
		PRINT_PROC_READ_ERR(WLAN_PROC_SERV_DIR_NAME, WLAN_PROC_SERV_RADIO_FREQ);

	sscanf(buf, "%hhu", &RadioFrequency);

	switch (RadioFrequency){
		case TIAP_PARAM_RADIO_BAND_2_4_AND_5GHZ:
			// nothing to check 
			break;

		case TIAP_PARAM_RADIO_BAND_2_4GHZ:
			// check for modes 0,1,2,3 
			if (parameters[0].SHORT == TIAP_PARAM_D11MODE_A) {
				printf("  Invalid Dot11 mode: %d RadioFrequency is 2.4 GHZ only \n", parameters[0].SHORT);
				return;
			}

			break;
		case TIAP_PARAM_RADIO_BAND_5GHZ:
			if(parameters[0].SHORT != TIAP_PARAM_D11MODE_A){
				printf("  Invalid Dot11 mode: %d RadioFrequency is 5 GHZ only \n", parameters[0].SHORT);
				return;
			}
			break;
		default:
			printf("Invalid RadioFrequency parameter \n");
			return;
			break;
	}

	if( tiap_wcfg_set_dot11mode(wd, parameters[0].SHORT, currentConfigWoneInex, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set .11 mode.");
		return;
	}

	printf("Wone Index %d Dot11 mode = %d\n",currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect AP is restarting now...\n");
	tiap_wcfg_restart(wd);
}

void wlanSetCWmin(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != DOT11_CWMIN_DISABLED) &&
		(parameters[0].SHORT != DOT11_CWMIN_ENABLED) &&
		(parameters[0].SHORT != DOT11_CWMIN_DOT11_MODE))
	{
		printf("Invalid CWmin mode: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetCwMinMode(currentConfigWoneInex,parameters[0].SHORT);
	printf("Wone Index %d CWmin mode = %d\n", currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;

	if ((parameters[0].SHORT != TIAP_PARAM_DOT11_CWMIN_DISABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_DOT11_CWMIN_ENABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_DOT11_CWMIN_DOT11_MODE))
	{
		printf("Invalid CWmin mode: %d\n", parameters[0].SHORT);
		return;
	}

	wone.index = currentConfigWoneInex;
	wone.type = wone_cwmin_mode;
	wone.elem.cwmin_mode = parameters[0].SHORT;
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set CWmin mode.");
		return;
	}

	printf("Wone Index %d CWmin mode = %d\n", currentConfigWoneInex, parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void wlanSetRadioCalibrateOption(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetRadioCalibrateOption(parameters[0].INTEGER);
	printf("Radio Calibrate Option = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n"); */

	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_RADIO_CAL, (__u32 *)&parameters[0].INTEGER, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set radio calibrate option.");
		return;
	}
}

void wlanSetRadioCalibrateInterval(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetRadioCalibrateInterval(parameters[0].SHORT);
	printf("Radio Calibrate Interval = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");*/
	
	if( tiap_wcfg_set_basic(wd, TIAP_PARAM_RADIO_CAL_INT, (__u16 *)&parameters[0].SHORT, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set radio calibrate interval.");
		return;
	}
}

void wlanSetBssIsolation(ConsoleParameter_T parameters[])
{
	tiap_param_bss_br_state_t bss_bridge_state;
	int bss_isolation;

	bss_isolation = parameters[0].INTEGER;

	switch (bss_isolation)
	{
		case DISABLE:
			bss_bridge_state = TIAP_PARAM_BSS_BR_ENABLE;
			break;
		case ENABLE:
			bss_bridge_state = TIAP_PARAM_BSS_BR_BLOCK;
			break;
		default:
			printf("\nInvalid Bss Isolation State: can be 1 or 0\n");
			return;

	}
	if (tiap_wcfg_set_basic(wd, TIAP_PARAM_BSS_BRIDGE_STATE, &bss_bridge_state, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set BSS Bridge isolation state.");
		return;
	}
	printf("\n\nSetting Bss Isolation state to %s\n\n", (bss_isolation == DISABLE) ? "Disabled" : "Enabled");
}

void wlanPrintBssIsolationState(ConsoleParameter_T parameters[])
{
	__u32 bss_bridge_state;

	if (tiap_wcfg_get_basic(wd, TIAP_PARAM_BSS_BRIDGE_STATE, &bss_bridge_state, !FROM_STORAGE)){
		PRINT_CONFIG_ERR_MSG("Failed to get BSS isolation state.");
		return;
	}
	printf("\n\nBss Isolation state is %s\n\n", (bss_bridge_state == TIAP_PARAM_BSS_BR_BLOCK) ? "Enabled" : "Disabled" );
}

void wlanSetRadarDetect(ConsoleParameter_T parameters[])
{
	if (tiap_wcfg_set_basic(wd, TIAP_PARAM_RADAR_DETECT_MODE,
				(__u8 *)&parameters[0].SHORT, UPDATE_STORAGE)) {
		PRINT_CONFIG_ERR_MSG("Failed to set radar detect mode.");
		return;
	}
	printf("\n\nSetting radar detect mode to %s\n\n", (parameters[0].SHORT) ? "Enabled" : "Disabled");
	printf("to take effect RESTART AP.\n");

}
void wlanPrintRadarDetect(ConsoleParameter_T parameters[])
{
	__u8 radar_detect;

	if (tiap_wcfg_get_basic(wd, TIAP_PARAM_RADAR_DETECT_MODE, &radar_detect, !FROM_STORAGE)){
		PRINT_CONFIG_ERR_MSG("Failed to get radar detect mode.");
		return;
	}
	printf("\n\nRadar detect mode is %s\n\n", (radar_detect) ?  "Enabled" : "Disabled");
}

void wlanSetApBridgeMode(ConsoleParameter_T parameters[])
{
	if (tiap_wcfg_set_basic(wd, TIAP_PARAM_AP_BRIDGE_MODE, (__u8 *)&parameters[0].SHORT,
				UPDATE_STORAGE)) {
		PRINT_CONFIG_ERR_MSG("Failed to set ap bridge mode.");
		return;
	}
	printf("\n\nSetting ap bridge mode to %s\n\n", (parameters[0].SHORT) ? "Enabled" : "Disabled");
	printf("to take effect RESTART AP.\n");
}

void wlanSetPBCCAlgorithmMode(ConsoleParameter_T parameters[])
{/*

	UINT8 band;
	wdrv_dbGetBand(currentConfigWoneInex,&band);
    if (band == RADIO_BAND_5GHZ)
        {
            printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
            printf("802.11 A Not support PBCC Algorithm\n");  
            return;
        }

	if ((parameters[0].SHORT != PBCC_ALGO_ENABLED) && (parameters[0].SHORT != PBCC_ALGO_DISABLED) &&
		(parameters[0].SHORT != PBCC_ALGO_LOCAL_STATIONS) && (parameters[0].SHORT != PBCC_ALGO_DYNAMIC) &&
		(parameters[0].SHORT != PBCC_ALGO_ENHANCED_DYNAMIC))
	{
		printf("Invalid PBCC algorithm mode: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetPBCCAlgorithmMode(currentConfigWoneInex, parameters[0].SHORT);
	printf("Setting PBCC algorithm mode = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wone_t wone;
	
	wone.index = currentConfigWoneInex;
	wone.type = wone_band;

	if( tiap_wcfg_get_wone(wd, &wone, FROM_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to get band.");
		return;
	}
	
	if (wone.elem.band == TIAP_PARAM_RADIO_BAND_5GHZ)
	{
		printf("\nError Active Set Wone Index is %d\n",currentConfigWoneInex);  
		printf("802.11 A Not support PBCC Algorithm\n");  
		return;
	}

	if ((parameters[0].SHORT != TIAP_PARAM_PBCC_ALGO_ENABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_PBCC_ALGO_DISABLED) &&
		(parameters[0].SHORT != TIAP_PARAM_PBCC_ALGO_LOCAL_STATIONS) && 
		(parameters[0].SHORT != TIAP_PARAM_PBCC_ALGO_DYNAMIC) &&
		(parameters[0].SHORT != TIAP_PARAM_PBCC_ALGO_ENHANCED_DYNAMIC))
	{
		printf("Invalid PBCC algorithm mode: %d\n", parameters[0].SHORT);
		return;
	}

	wone.index = currentConfigWoneInex;
	wone.type = wone_pbcc;
	wone.elem.pbcc_mode = parameters[0].SHORT;
	
	if( tiap_wcfg_set_wone(wd, &wone, UPDATE_STORAGE) ) {
		PRINT_CONFIG_ERR_MSG("Failed to set pbcc algorithm mode.");
		return;
	}
	
	printf("Setting PBCC algorithm mode = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); 
}

void wlanSetDynAlgoTimeout(ConsoleParameter_T parameters[])
{/*
	wdrv_dbSetDynamicAlgorithmsTimeout(parameters[0].INTEGER);
	printf("Setting Enhanced Dynamic Algorithm timeout = %d\n", parameters[0].INTEGER); 
	printf("to take effect RESTART AP.\n");*/

	PRINT_NOT_SUPPORTED_MSG("Enhanced Dynamic Algorithm timeout");
}

/************************************************************************/
/*						Hal sub-menu functions							*/
/************************************************************************/

void whalMenu_printFwVersion(ConsoleParameter_T parameters[]){
	//whal_apiPrintFwVersion();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_FWVER) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_FWVER);
	
}

void whalMenu_printAcxParams(ConsoleParameter_T parameters[]){
	//whal_apiPrintAcxParams();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_ACX_PARAM) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_ACX_PARAM);

}

void whalMenu_printTxInfo(ConsoleParameter_T parameters[]){
	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_tx_info(parameters[0].INTEGER, parameters[1].INTEGER,  buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_tx_info failed !");
	else
		puts(buf);
}

void whalMenu_printRxInfo(ConsoleParameter_T parameters[]){
	//whal_apiPrintRxInfo();

	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_INFO) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_INFO);
}

void whalMenu_printTxQueue(ConsoleParameter_T parameters[]){
	//whal_apiPrintTxQueue(parameters[0].INTEGER);
	
	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_tx_queue(parameters[0].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_tx_queue failed !");
	else
		puts(buf);

}

void whalMenu_printTxIndicator(ConsoleParameter_T parameters[]){
	//whal_apiPrintTxIndicator();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TX_IDNT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TX_IDNT);
}

void whalMenu_printRxQueue(ConsoleParameter_T parameters[]){
	//whal_apiPrintRxQueue(parameters[0].INTEGER);
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_QUEUE) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_QUEUE);
}

void whalMenu_printTxBufs(ConsoleParameter_T parameters[]){
	//whal_apiPrintTxBufs();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TXBUF) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TXBUF);
}

void whalMenu_printRxBufs(ConsoleParameter_T parameters[]){
	//whal_apiPrintRxBufs();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_BUFFS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RX_BUFFS);
	
}

void whalMenu_printIntr(ConsoleParameter_T parameters[]){
	//whal_apiPrintIntr();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_INTR) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_INTR);
}

void whalMenu_printMbox(ConsoleParameter_T parameters[]){
	//whal_apiPrintMbox();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MBOX) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MBOX);

}

void whalMenu_printAcxStat(ConsoleParameter_T parameters[]){
	//whal_apiPrintAcxStatistics();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_ACXSTAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_ACXSTAT);
}

void whalMenu_printRestartStat(ConsoleParameter_T parameters[]){
	//whal_apiPrintRestartStatistics();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RESTART_STAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RESTART_STAT);
}

void whalMenu_EnableRestartWA(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid enable restart WA value: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetEnRestart(parameters[0].SHORT, TRUE);	
	printf("Enable restart WA = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n"); */
	
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid enable restart WA value: %d\n", parameters[0].SHORT);
		return;
	}

	set_enable_wa_restart(parameters[0].SHORT);
	printf("Enable restart WA = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}


void whalMenu_gpio_owner(ConsoleParameter_T parameters[])
{
	if (parameters[0].SHORT == 2) {
		char buf[50];
		dda_read_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_LED, buf, sizeof(buf));
		printf("%s\n", buf); fflush(stdout);
		return;		
	}
	
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid gpio ownership value: %d\n", parameters[0].SHORT);
		return;
	}

	tiap_wcfg_set_gpio_owner(wd, parameters[0].SHORT);
	printf("Enable restart WA = %d\n", parameters[0].SHORT); 
	printf("to take effect RESTART AP.\n");
}

void whalMenu_setWAoptions(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid Rx Free Mem option: %d\n", parameters[0].SHORT);
		return;
	}
	if (parameters[1].SHORT > 30)
	{
		printf("Invalid Beacon not sent option: %d\n", parameters[1].SHORT);
		return;
	}
	if (parameters[2].SHORT > 30)
	{
		printf("Invalid Tx Acx free option: %d\n", parameters[2].SHORT);
		return;
	}
	if (parameters[3].SHORT > 30)
	{
		printf("Invalid Rx Cons FCS option: %d\n", parameters[3].SHORT);
		return;
	}


	wdrv_dbSetWAoptions(parameters[0].SHORT, parameters[1].SHORT, parameters[2].SHORT, parameters[3].SHORT, IMMEDIATELY);	
	printf("Rx Free Mem option     = %d\n", parameters[0].SHORT); 
	printf("Beacon not sent option = %d\n", parameters[1].SHORT); 
	printf("Tx Acx free option     = %d\n", parameters[2].SHORT); 
	printf("Rx Cons FCS threshold  = %d\n", parameters[3].SHORT); 
	printf("to take effect RESTART AP.\n"); */

	tiap_param_wd_t wa;

	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid Rx Free Mem option: %d\n", parameters[0].SHORT);
		return;
	}
	if (parameters[1].SHORT > 30)
	{
		printf("Invalid Beacon not sent option: %d\n", parameters[1].SHORT);
		return;
	}
	if (parameters[2].SHORT > 30)
	{
		printf("Invalid Tx Acx free option: %d\n", parameters[2].SHORT);
		return;
	}
	if (parameters[3].SHORT > 30)
	{
		printf("Invalid Rx Cons FCS option: %d\n", parameters[3].SHORT);
		return;
	}
    if ((parameters[4].SHORT != 0) && (parameters[4].SHORT != 1))
	{
		printf("Invalid ACI WA option: %d\n", parameters[4].SHORT);
		return;
	}
	
	if ((parameters[5].SHORT != 0) && (parameters[5].SHORT != 1))
	{
		printf("Invalid NB WA option: %d\n", parameters[5].SHORT);
		return;
	}


	wa.cmd = TIAP_PARAM_WD_RXFREE;
	wa.value.val8 = parameters[0].SHORT;

	if(tiap_wcfg_set_wd(wd, &wa, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set Rx Free Mem WA.");
		return;
	}

	wa.cmd = TIAP_PARAM_WD_BEACONS;
	wa.value.val8 = parameters[1].SHORT;

	if(tiap_wcfg_set_wd(wd, &wa, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set Beacon not sent WA.");
		return;
	}

	wa.cmd = TIAP_PARAM_WD_TXSTUCK;
	wa.value.val8 = parameters[2].SHORT;

	if(tiap_wcfg_set_wd(wd, &wa, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set Tx Acx free WA.");
		return;
	}

	wa.cmd = TIAP_PARAM_WD_FCSERR;
	wa.value.val16 = parameters[3].SHORT;

	if(tiap_wcfg_set_wd(wd, &wa, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set Rx Cons FCS WA.");
		return;
	}
	wa.cmd = TIAP_PARAM_WD_ACI;
	wa.value.val8 = parameters[4].SHORT;

	if(tiap_wcfg_set_wd(wd, &wa, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set ACI WA.");
		return;
	}

	wa.cmd = TIAP_PARAM_WD_NB;
	wa.value.val8 = parameters[5].SHORT;

	/* write to the storage only in the last call */
	if(tiap_wcfg_set_wd(wd, &wa, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set NB WA.");
		return;
	}

	printf("Rx Free Mem option     = %d\n", parameters[0].SHORT); 
	printf("Beacon not sent option = %d\n", parameters[1].SHORT); 
	printf("Tx Acx free option     = %d\n", parameters[2].SHORT); 
	printf("Rx Cons FCS threshold  = %d\n", parameters[3].SHORT); 
    printf("ACI WA option          = %d\n", parameters[4].SHORT); 
	printf("NB WA option           = %d\n", parameters[5].SHORT); 

	printf("to take effect RESTART AP.\n"); 

}

void whalMenu_setAciRateThresh(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t aci_rate_thr;

	aci_rate_thr.cmd = TIAP_PARAM_ACI_RATE_THR;
	aci_rate_thr.value.val32 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &aci_rate_thr, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set ACI rate threshold.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

void whalMenu_setAciEventThresh(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t aci_event_thr;

	aci_event_thr.cmd = TIAP_PARAM_ACI_EVENT_THR;
	aci_event_thr.value.val32 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &aci_event_thr, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set ACI rate threshold.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

void whalMenu_setAciTimeout(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t interf_param;

	interf_param.cmd = TIAP_PARAM_ACI_TIMEOUT;
	interf_param.value.val32 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &interf_param, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set ACI state timeout.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

void whalMenu_setNbTimeout(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t interf_param;

	interf_param.cmd = TIAP_PARAM_NB_TIMEOUT;
	interf_param.value.val32 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &interf_param, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set NB state timeout.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

void whalMenu_setPdThresh(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t interf_param;

	interf_param.cmd = TIAP_PARAM_PD_LOW;
	interf_param.value.val16 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &interf_param, !UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set low PD threshold.");
		return;
	}

	interf_param.cmd = TIAP_PARAM_PD_HIGH;
	interf_param.value.val16 = parameters[1].INTEGER;

	/*update storage only with the last parameter*/
	if (tiap_wcfg_set_interf_wd_config(wd, &interf_param, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set high PD threshold.");
		return;
	}

	printf("to take effect RESTART AP.\n");
}


void whalMenu_setBusyMediumThresh(ConsoleParameter_T parameters[])
{
	tiap_param_interference_wd_t interf_param;

	interf_param.cmd = TIAP_PARAM_MEDIUM_BUSY_THR;
	interf_param.value.val32 = parameters[0].INTEGER;

	if (tiap_wcfg_set_interf_wd_config(wd, &interf_param, UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set busy medium threshold.");
		return;
	}
	printf("to take effect RESTART AP.\n");
}

/* Prints interference Workaround configuration*/
void whalMenu_showACIparams(ConsoleParameter_T parameters[])
{
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_INTERF_WD_PARAMS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_INTERF_WD_PARAMS);
}


void whalMenu_VlynqErrorsCnt(ConsoleParameter_T parameters[])
{/*
	UINT32 count;

	count = get_acx111_vlynq_errorCount();
	printf("%d Vlynq errors encountered\n",count); */

	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_VLYNC_ERR) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_VLYNC_ERR);
	
}

void whalMenu_EnergyDetectShow(ConsoleParameter_T parameters[])
{/*
	UINT8 energyDetect;

	wdrv_dbGetEnergyDetect(&energyDetect);
	if(energyDetect)
		printf("Energy Detect Enabled\n");
	else
		printf("Energy Detect Disabled\n"); */

	UINT8 energy_detect;

	if(tiap_wcfg_get_basic(wd, TIAP_PARAM_ENERGY_DETECT, &energy_detect, !FROM_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to get energy detect configuration.");
		return;
	}

	if(energy_detect)
		printf("Energy Detect Enabled\n");
	else
		printf("Energy Detect Disabled\n");

}

void whalMenu_EnableEnergyDetect(ConsoleParameter_T parameters[])
{/*
	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid energy enable value: %d\n", parameters[0].SHORT);
		return;
	}
	wdrv_dbSetEnergyDetect(parameters[0].SHORT, IMMEDIATELY);
	printf("Enable Energy Detect = %d\n", parameters[0].SHORT); 
	printf("to take effect RSTART AP.\n"); */

	if ((parameters[0].SHORT != 0) && (parameters[0].SHORT != 1))
	{
		printf("Invalid energy enable value: %d\n", parameters[0].SHORT);
		return;
	}
	
	if(tiap_wcfg_set_basic(wd, TIAP_PARAM_ENERGY_DETECT, &(parameters[0].SHORT), UPDATE_STORAGE))
	{
		PRINT_CONFIG_ERR_MSG("Failed to set energy detect.");
		return;
	}

	printf("Enable Energy Detect = %d\n", parameters[0].SHORT); 
	printf("to take effect RSTART AP.\n");

}

/************************************************************************/
/*						Hal Diag sub-menu functions						*/
/************************************************************************/

void whalMenu_eed(ConsoleParameter_T parameters[]){
   //whal_apiDumpEEPROM();

	if (dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_EED) == -1) {
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_EED);
	}
}

void whalMenu_eer(ConsoleParameter_T parameters[]){

   //whal_apiReadEEPROM(parameters[0].INTEGER);

	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_eer(parameters[0].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_eer failed !");
	else
		puts(buf);

	
}

void whalMenu_eew(ConsoleParameter_T parameters[]){
   //whal_apiWriteEEPROM(parameters[0].INTEGER, parameters[1].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_EEW, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_EEW);
	
}

void whalMenu_SetBssPs(ConsoleParameter_T parameters[]){
	//whal_apiSetBssPs(parameters[0].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SETPS_MODE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SETPS_MODE);

}

void whalMenu_SetTxCompleteTrsh(ConsoleParameter_T parameters[]){
	/*int sts;

	sts = whal_apiSetTxCompleteThreshold(parameters[0].INTEGER);
	if(sts == OK)
	{
		printf("The Tx Complete Interrupt Threshold set to %d\n",parameters[0].INTEGER);
	} */

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_TX_COMPTRSH, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_TX_COMPTRSH);
}

void whalMenu_PrintRegs(ConsoleParameter_T parameters[]){
	//whal_apiPrintRegs();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_PRINTREGS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_PRINTREGS);

}

void whalMenu_PhyRegWrite(ConsoleParameter_T parameters[]){
	//whal_apiPhyWrite(parameters[0].INTEGER, parameters[1].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_PHY_REG_WRITE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_PHY_REG_WRITE);

}

void whalMenu_PhyRegRead(ConsoleParameter_T parameters[]){
	//whal_apiPhyRead(parameters[0].INTEGER);
	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_phy_reg_read(parameters[0].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_phy_reg_read failed !");
	else
		puts(buf);

}

void whalMenu_MacRegWrite(ConsoleParameter_T parameters[]){
	//whal_apiMacWrite(parameters[0].INTEGER, parameters[1].INTEGER);

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MAC_REG_WRITE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MAC_REG_WRITE);
}

void whalMenu_MacRegRead(ConsoleParameter_T parameters[]){
	//whal_apiMacRead(parameters[0].INTEGER);
	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_mac_reg_read(parameters[0].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_mac_reg_read failed !");
	else
		puts(buf);

}

void whalMenu_RxPromiscuous(ConsoleParameter_T parameters[]){
	//whal_apiRxPromiscuous(parameters[0].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_RX_PROMIS, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_RX_PROMIS);

}

void whalMenu_ModeSniffer(ConsoleParameter_T parameters[]){
	//whal_apiModeSniffer(parameters[0].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MODE_SNIFFER, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_MODE_SNIFFER);

}

void whalMenu_PrintFwVersions(ConsoleParameter_T parameters[]){
	//whal_apiPrintFwVersions();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_FW_VERS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_FW_VERS);

}

void whalMenu_SetNvByte(ConsoleParameter_T parameters[]){
	//whal_apiSetNvByte(parameters[0].INTEGER, parameters[1].INTEGER);

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.Param2 = parameters[1].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_NVBYTE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SET_NVBYTE);


}

void whalMenu_TraceEnable(ConsoleParameter_T parameters[]){
	//whal_apiTraceEnable(parameters[0].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TRACE_ENABLE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TRACE_ENABLE);

}


void whalMenu_TracePrint(ConsoleParameter_T parameters[]){

	char buf[GENERIC_IOCTL_BUF_SIZE];

	if (ioctl_get_trace_print(parameters[0].INTEGER, parameters[1].INTEGER, buf, GENERIC_IOCTL_BUF_SIZE, wd->dev_name)) 
		puts("ioctl_get_trace_print failed !");
	else
		puts(buf);

}

void whalMenu_TracePrintRxStat(ConsoleParameter_T parameters[]){

	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TRACE_RX_STAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_TRACE_RX_STAT);

}

void whalMenu_SelectFwNumber(ConsoleParameter_T parameters[]){

	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SELEC_FW_NUM, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SELEC_FW_NUM);
}

void whalMenu_SetQueueSizeType(ConsoleParameter_T parameters[]){
	//whal_apiSetQueueSizeType(parameters[0].INTEGER);
	proc_params proc_pars;
	int ret;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SETY_Q_SIZE_TYPE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SETY_Q_SIZE_TYPE);

}

void whalMenu_SelectRadioNumber(ConsoleParameter_T parameters[]){
	//whal_apiSelectRadioNumber(parameters[0].INTEGER);
	int ret;
	proc_params proc_pars;

	proc_pars.s.magic = PROC_PARAMS_MAGIC;
	proc_pars.s.Param1 = parameters[0].INTEGER;

	ret = dda_write_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SELEC_RADIO_NUM, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_SELEC_RADIO_NUM);
}

void whalMenu_PrintRadioVersions(ConsoleParameter_T parameters[]){
	//whal_apiPrintRadioVersions();
	if(dda_print_proc_entry(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RADIO_VER) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_HAL_DIR_NAME, WLAN_PROC_HAL_RADIO_VER);
}


/***************************************************************************/
/* Show submenu subroutines                                                */
/***************************************************************************/
void showBssBridge(ConsoleParameter_T parameters[]) 
{
	//wdrv_bssBridgeShowStatistics();
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_BSS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_BSS);


}
void showPowerSave(ConsoleParameter_T parameters[])
{
	//wdrv_powerSavePrintDb();
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_PS) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_PS);

}

void showPrintTxStat(ConsoleParameter_T parameters[]){
	//wdrv_txPrintStatistics();
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_TX_STAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_TX_STAT);
}

void showMibWlan(ConsoleParameter_T parameters[])
{/*
#ifdef VXWORKS
   wlanMib2StatShow(0);
#else
	 puts("What do you want from me ?");
#endif // VXWORKS */
	int ret;

	ret = dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_MIB);
	printf("ret : %d\n",ret);
	if( ret == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_MIB);	

}

void showLanStat(ConsoleParameter_T parameters[])
{/*
#ifdef VXWORKS
   extern void sysEmacStatShow( int  unit);
   sysEmacStatShow(0);
#else
	 puts("What do you want from me ?");
#endif // VXWORKS */
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_STAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_STAT);	
}

void showLanPool(ConsoleParameter_T parameters[])
{/*
#ifdef VXWORKS
   extern void sysEmacNetPoolShow( int  unit);
   sysEmacNetPoolShow(0);
#else
	 puts("What do you want from me ?");
#endif // VXWORKS */
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_POOL) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_LAN_POOL);	

}

void showMemMngrStat(ConsoleParameter_T parameters[])
{/*
   memMngr_Statistics_T s;

   puts("------------ MemMngr Stat ------------");
   if( OK == wlan_memMngrPrintStatistics(&s))
   {
      printf("msduPool BDs location   @ %p\n", s.msduPool);
      printf("bdPool data BDs         @ %p\n", s.bdPool);
      printf("List of data buffers    @ %p\n", s.dataBufPool);

      printf("firstFreeMSDU           @ %p\n", s.firstFreeMSDU);
      printf("firstFreeBD             @ %p\n", s.firstFreeBD);
      printf("firstFreeDataBuf        @ %p\n", s.firstFreeDataBuf);

      printf("numFreeMSDU             = %d\n", s.numFreeMSDU     );
      printf("numFreeBD               = %d\n", s.numFreeBD       );
      printf("numFreeDataBuf          = %d\n", s.numFreeDataBuf  );
   } */

	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_MEM_STAT) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_MEM_STAT);	

}

void showRateAdaptation(ConsoleParameter_T parameters[])
{
	//wdrv_txPrintRateAdaptation();
	if(dda_print_proc_entry(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_RATE_ADAP) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_SHOW_DIR_NAME, WLAN_PROC_SHOW_RATE_ADAP);	
}


/***************************************************************************/
/* 4x submenu subroutines                                                  */
/***************************************************************************/
void show4xParams(ConsoleParameter_T parameters[])
{
	tiap_param_4x_t _4x;


	/*if(dda_print_proc_entry(WLAN_PROC_4X_DIRNAME, WLAN_PROC_SHOW_4X_MAX_CONCATSIZE) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_4X_DIRNAME, WLAN_PROC_SHOW_4X_MAX_CONCATSIZE);	*/
	if(dda_print_proc_entry(WLAN_PROC_4X_DIRNAME, WLAN_PROC_SHOW_4X_MAX_CONCATSIZE) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_4X_DIRNAME, WLAN_PROC_SHOW_4X_MAX_CONCATSIZE);
	
	_4x.cmd = TIAP_PARAM_4X_4X;
	if (tiap_wcfg_get_4x(wd, &_4x, !FROM_STORAGE))
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	else
	{

		if (_4x.value == TRUE)
		{
			printf("4x:		Enable\n");
		}
		else
			printf("4x:		Disable\n");
	}

	_4x.cmd = TIAP_PARAM_4X_CAT;

	if (tiap_wcfg_get_4x(wd, &_4x, !FROM_STORAGE))
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	else
	{
		if (_4x.value == TRUE)
		{
			printf("Concatenation:	Enable\n");
		}
		else
			printf("Concatenation:	Disable\n");
	}


	/* Ack emulation is not supported*/
	/*
	wdrv_dbGetAckEmulEnable(&enable);
	
	if (enable == TRUE)
	{
		printf("Ack Emulation:	Enable\n");
	}
	else
		printf("Ack Emulation:	Disable\n");
	*/


	_4x.cmd = TIAP_PARAM_4X_MIXMOD;

	if (tiap_wcfg_get_4x(wd, &_4x, !FROM_STORAGE))
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	else
	{
	    if (_4x.value == TRUE)
		printf("Mix Mode:   Enable\n");
	    else
		printf("Mix Mode:   Disable\n");
	}


	_4x.cmd = TIAP_PARAM_4X_FEATSET;

	if (tiap_wcfg_get_4x(wd, &_4x, !FROM_STORAGE))
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	else
		printf("FeatureSet:   %d\n", _4x.value);

	
	//whal_txGetPacketBursting(&burst);

	/* Felix R.: actually it should have been TIAP_PARAM_4X_PKTBURST,
	   but for now we based on TIAP_PARAM_4X_4X */
	_4x.cmd = TIAP_PARAM_4X_4X;

	if (tiap_wcfg_get_4x(wd, &_4x, !FROM_STORAGE))
		PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
	else
	{
	    if(_4x.value)
	    {
	       printf("Packet Bursting:		Enable\n");
	    }
	    else
	    {
	       printf("Packet Bursting:		Disable\n");
	    }
	}

	#ifdef TIWLAN_DEBUG
	{
		__u32 burst_limit;

		if (tiap_wcfg_get_basic(wd, TIAP_PARAM_BURST_LIMIT, &burst_limit, !FROM_STORAGE)) 
			PRINT_CONFIG_ERR_MSG("Reading configuration failed.");
		else
			printf("Packet burst time limit is %d MicroSec\n", burst_limit);	
	}
	#endif
}

void set4xMaxConcatSize(ConsoleParameter_T parameters[])
{
	//wdrv_txSetMaxConcatSize(parameters[0].INTEGER);
	
	int ret;
	proc_params proc_pars;
	
	proc_pars.s.Param1 = parameters[0].INTEGER;
	proc_pars.s.magic = PROC_PARAMS_MAGIC;

	ret = dda_write_proc_entry(WLAN_PROC_4X_DIRNAME, WLAN_PROC_4X_MAX_CONCATSIZE, 
		(char *)&proc_pars, sizeof(proc_pars));

	if (ret != sizeof(proc_pars))
		PRINT_PROC_WRITE_ERR(WLAN_PROC_4X_DIRNAME, WLAN_PROC_4X_MAX_CONCATSIZE);
	
}

void set4x(ConsoleParameter_T parameters[])
{
	tiap_param_4x_t _4x;

	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid 4x mode: %ld\n", parameters[0].INTEGER);
		return;
	}

	if ((parameters[1].INTEGER != 0) && (parameters[1].INTEGER != 1))
	{
		printf("Invalid concatenation mode: %ld\n", parameters[1].INTEGER);
		return;
	}

	/*
	if ((parameters[2].INTEGER != 0) && (parameters[2].INTEGER != 1))
	{
		printf("Invalid Ack Emulation mode: %d\n", parameters[2].INTEGER);
		return;
	}
	*/


	if ((BOOL)parameters[0].INTEGER == FALSE)
	{
		/*
		wdrv_dbSet4xEnable(FALSE);
		wdrv_dbSetConcatEnable(FALSE);
		wdrv_dbSetAckEmulEnable(FALSE);*/

		printf("Setting all 4X features to FALSE \n");

		_4x.cmd = TIAP_PARAM_4X_4X;
		_4x.value = FALSE;

		if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
		{
			PRINT_CONFIG_ERR_MSG("Configuration failed.");
			return;
		}

		_4x.cmd = TIAP_PARAM_4X_CAT;
		_4x.value = FALSE;

		if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
		{
			PRINT_CONFIG_ERR_MSG("Configuration failed.");
			return;
		}

		/* ACK emulation feature is not supported in apdk 5.6 */		
		
	}

	else
	{
		tiap_param_vhcf_t vhcf;

		printf("Setting 4X enable to TRUE \n");
		
		//wdrv_dbSet4xEnable(TRUE);

		if( tiap_wcfg_get_vhcf(wd, &vhcf, FROM_STORAGE) ) {
			PRINT_CONFIG_ERR_MSG("Failed to get vhcf parameters.");
			return;
		}

		if (vhcf.enable) {
			printf("\nRejected!! Can't enable 4x while vHCF is enabled!!\n");
			return;
		}
		_4x.cmd = TIAP_PARAM_4X_4X;
		_4x.value = TRUE;

		if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
		{
			PRINT_CONFIG_ERR_MSG("Configuration failed.");
			return;
		}

		/* Concatenation  */
		if ((BOOL)parameters[1].INTEGER == TRUE)
		{
			printf("Setting concatenation to TRUE \n");

			_4x.cmd = TIAP_PARAM_4X_CAT;
			_4x.value = TRUE;
			
			//wdrv_dbSetConcatEnable(TRUE);

			if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
			{
				PRINT_CONFIG_ERR_MSG("Configuration failed.");
				return;
			}

		}
		else
		{
			printf("Setting concatenation to FALSE \n");
			
			//wdrv_dbSetConcatEnable(FALSE);

			_4x.cmd = TIAP_PARAM_4X_CAT;
			_4x.value = FALSE;
			
			if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
			{
				PRINT_CONFIG_ERR_MSG("Configuration failed.");
				return;
			}
			
		}
	
		
		// Ack Emulation 
		PRINT_NOT_SUPPORTED_MSG ("Ack emulation");
		
		/*
		if ((BOOL)parameters[2].INTEGER == TRUE)
		{
			
			
			printf("Setting Ack Emulation to TRUE \n");
			
			wdrv_dbSetAckEmulEnable(TRUE);
			
		}
		else
		{
			printf("Setting Ack Emulation to FALSE \n");
			
			wdrv_dbSetAckEmulEnable(FALSE);
			
		}*/			
	}
}


void setPacketBursting(ConsoleParameter_T parameters[])
{
        tiap_param_4x_t _4x;

	   if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	   {
	       printf("Invalid mode: %ld\n", parameters[0].INTEGER);
	       return;
	   }
   //whal_txSetPacketBursting((BOOL)parameters[0].INTEGER); 
   
	
	_4x.cmd = TIAP_PARAM_4X_PKTBURST;
	_4x.value = parameters[0].SHORT;

	if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed.");
	}


}

void setConcatDebug(ConsoleParameter_T parameters[])
{
	PRINT_NOT_SUPPORTED_MSG("Concat debug");
	/*
	if ((parameters[0].INTEGER != 0) && (parameters[0].INTEGER != 1))
	{
		printf("Invalid concat debug mode: %d\n", parameters[0].INTEGER);
		return;
	}
	wdrv_txSetConcatDebug((BOOL)parameters[0].INTEGER); */
}

void fourXTable(ConsoleParameter_T parameters[])
{

	if(dda_print_proc_entry(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_4XTABLE) == -1)
		PRINT_PROC_READ_ERR(WLAN_PROC_MGMT_DIR_NAME, WLAN_PROC_MGMT_4XTABLE);	

}



void set4xFeatureSet(ConsoleParameter_T parameters[])
{
	tiap_param_4x_t _4x;

	if(parameters[0].SHORT != 0 && parameters[0].SHORT != 1)
		printf("Wrong FeatureSet value\n");

	/* when setting/resetting FeatureSet, the ERPProtectionTI must be set/reset too 
	   In apdk5.6 this logic is implemented in the shared library */
	
	//wdrv_dbSetFeatureSet(parameters[0].SHORT);
	
	
	_4x.cmd = TIAP_PARAM_4X_FEATSET;
	_4x.value = parameters[0].SHORT;

	/* the wone index is needed in order to set the ERPProtectionTI */
	if (tiap_wcfg_set_4x(wd, &_4x, currentConfigWoneInex, UPDATE_STORAGE)) 
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed.");
	}
	else
	{
		printf("Wone Index %d: Setting 4x FeatureSet to %d\n",currentConfigWoneInex, parameters[0].SHORT);
		printf("NOTE: Setting the FeatureSet sets automatically the ERPProtectionTI variable to the same value!!!\n"); 
		printf("If you would like a different value for this variable you have to change it manually.\n"); 
		printf("to take effect RESTART AP.\n"); 
	}
}


void setBurstLimit(ConsoleParameter_T parameters[])
{/*
      whal_nvram_setTxopLimitParams(parameters[0].INTEGER, IMMEDIATELY);
      printf("\n Set Packet Burst time limit is %d MicroSec\n",parameters[0].INTEGER); */
      
	  #ifdef TIWLAN_DEBUG
		  if (tiap_wcfg_set_basic(wd, TIAP_PARAM_BURST_LIMIT, &(parameters[0].INTEGER), UPDATE_STORAGE)) 
		  {
			  PRINT_CONFIG_ERR_MSG("Configuration failed.");
		  }
		  else
		  {
			  printf("\nPacket Burst time limit was set to %ld MicroSec\n",parameters[0].INTEGER); 
			  printf("to take effect RESTART AP.\n");
		  }
	  #else
		  printf("Burst limit is configurable only in the DEBUG version\n");

	  #endif
		  
}

void wlanSet4xMixMode(ConsoleParameter_T parameters[])
{

	tiap_param_4x_t _4x;
	
	_4x.cmd = TIAP_PARAM_4X_MIXMOD;
	_4x.value = parameters[0].SHORT;

	if (tiap_wcfg_set_4x(wd, &_4x, 0, UPDATE_STORAGE)) 
	{
		PRINT_CONFIG_ERR_MSG("Configuration failed.");
	}
	else
	{
	   if( parameters[0].SHORT == 0 )
		   printf("4x mix disabled \n"); 
	   else
	      printf("4x mix enabled\n");
	}


}



/***************************************************************************/
/* Execute the last command                                                */
/***************************************************************************/
void consoleLastCommand(ConsoleParameter_T parameters[])
{
	
   unsigned char lastCommand[WAPP_UTILS_MAX_LINE_LENGTH];

   getDevConsoleCommand(lastCommand);
   consoleExecuteCommand(lastCommand, (ConsoleCommand_T *)NULL);
   
}

/***************************************************************************/
/*                      production submenu items                           */
/***************************************************************************/

#ifdef VXWORKS 

void consoleDir(ConsoleParameter_T parameters[])
{
   //cm_serviceDir();
}
void consoleErase(ConsoleParameter_T parameters[])
{
   //cm_serviceErase(parameters[0].INTEGER);
}
void consoleDl(ConsoleParameter_T parameters[])
{
   //cm_serviceDownload(parameters[0].INTEGER,
                      parameters[1].IP_ADDR,
                      parameters[2].STRING);
}
void consoleSetDef(ConsoleParameter_T parameters[])
{
   //cm_serviceSetDef(parameters[0].INTEGER);
}
void consoleProdShow(ConsoleParameter_T parameters[])
{
   //cm_serviceShow();
}
void consoleProdSet(ConsoleParameter_T parameters[])
{
   //cm_serviceSet();
}
void consoleProdDef(ConsoleParameter_T parameters[])
{/*
   int   wone_index;
   for (wone_index = 0 ;wone_index < MAX_WONE_NET; wone_index++)
   {
       whal_nvram_setDefaults(wone_index);
   }
   cm_serviceSetDefs();*/
}

void consolePassword(ConsoleParameter_T parameters[])
{/*
   char pbuf1[256] = {0};
   char pbuf2[256] = {0};
   printf("Enter new password> ");
	 fgets(pbuf1, 255, stdin);
	 pbuf1[255] = 0;
   if(!strlen(pbuf1))
   {
      return;
   }
   printf("Reenter password> ");
	 fgets(pbuf2, 255, stdin);
	 pbuf2[255] = 0;
   if(strcmp(pbuf1,pbuf2))
   {
      puts("Error: Password isnt match");
      return;
   }
   whal_nvram_setConsolePassword(pbuf1,IMMEDIATELY);
   */
}

#endif /* VXWORKS */

/***************************************************************************/
/* Add sub menu to the console                                             */
/***************************************************************************/
long wapp_utilsAddSubMenusToConsole(void)
{
	int ret, servRet;
	/*int iTestSubmenuContext;
   	int iBringUpSubmenuContext;*/
	ConsoleCommandParameter_T cParams[] =  {NO_PARAM,  NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM};
	//ConsoleCommandParameter_T subMenuParams[] = {STRING_PRM,NO_PARAM, NO_PARAM, NO_PARAM, NO_PARAM};

   ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"BIT> ",
         ConsoleBITCommandArray,
         "ACX100 Built In Tests (BIT) sub menu",
         cParams,0,
         BITCB);

   if( ret == -1)
      puts("AddConsoleMenu failed while adding 'BIT' sub-menu.");
         

	ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"mgmt> ",
			ConsoleMgmtCommandArray,
			"Mgmt parameters",
			cParams,0,
			MgmtCB);


	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'MGMT' sub-menu\n");

	else
	{
		ret = addConsoleSubMenu(
				ret,
				"test-mgmt> ",
				ConsoleMgmtTstCommandArray,
				"Mgmt Test sub menu",
				cParams,0,
				MgmtTstCB);


		if (ret == -1)
			printf("AddConsoleMenu failed while adding 'MGMT-TEST' sub-menu\n");
	}


	ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"wpa> ",
			ConsoleWpaCommandArray,
			"Wpa parameters",
			cParams,0,
			WpaCB);


	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'WPA' sub-menu\n");

	else
	{
		ret = addConsoleSubMenu(
				ret,
				"test-wpa> ",
				ConsoleWpaTstCommandArray,
				"Wpa Test sub menu",
				cParams,0,
				WpaTstCB);


		if (ret == -1)
			printf("AddConsoleMenu failed while adding 'WPA-TEST' sub-menu\n");
	}


	ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"privacy> ",
			ConsolePrivacyCommandArray,
			"Privacy parameters",
			cParams,0,
			PrivacyCB);

	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'PRIVACY' sub-menu\n");

	servRet = addConsoleSubMenu(
                wapp_utilsConsoleCurrentContext,
                "serv> ",
                ConsoleServiceAppCommandArray,
                "WLAN Port Set-Up",
                cParams,0,
                ServCB);

	if (servRet == -1)
		printf("AddConsoleMenu failed while adding 'SERVICE' sub-menu\n");
    else
    {
        ret = addConsoleSubMenu(
                    servRet,
                    "SsidLib> ",
                    ConsoleSsidAppCommandArray,
                    "SSID Library Features set-up",
                    cParams,0,
                    ServCB);
        if (ret == -1)
            printf("AddConsoleMenu failed while adding 'SSID' sub-menu\n");
        else
        {
            ret = addConsoleSubMenu(
                        servRet,
                        "features> ",
                        Console_DH_AppCommandArray,
                        "Advanced features (e.g. 802.11d) configuration",
                        cParams,0,
                        ServCB);
            if (ret == -1)
                printf("AddConsoleMenu failed while adding 'features' sub-menu\n");
        }
    }

   ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"show> ",
			ConsoleShowCommandArray,
			"Show WLAN statistics",
			cParams,0,
			ShowCB);

	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'SHOW' sub-menu\n");

    ret = addConsoleSubMenu(
         wapp_utilsConsoleCurrentContext,
         "4x> ",
         Console4xCommandArray,
         "Set 4x parameters ",
         cParams,0,
         x4CB);

   if (ret == -1)
     printf("AddConsoleMenu failed while adding 'SHOW' sub-menu\n");


	ret = addConsoleSubMenu(
			wapp_utilsConsoleCurrentContext,
			"hal> ",
			ConsoleHalCommandArray,
			"Hal parameters",
			cParams,0,
			HalCB);
	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'HAL' sub-menu\n");
	else
	{
		ret = addConsoleSubMenu(
				ret,
				"Diag> ",
				ConsoleHalDiagCommandArray,
				"Hal diagnostic parameters",
				cParams,0,
				HalDiagCB);


		if (ret == -1)
			printf("AddConsoleMenu failed while adding 'HAL-DIAG' sub-menu\n");
	}

#ifdef VXWORKS 

   ret = addConsoleSubMenu(
         wapp_utilsConsoleCurrentContext,
         "production> ",
         consoleProductionCommandArray,
         "Production <password>",
         subMenuParams,1,
         ProdCB);
	if (ret == -1)
		printf("AddConsoleMenu failed while adding 'production' sub-menu\n");

#endif /* VXWORKS */



#ifdef INCLUDE_TESTAPP
	iTestSubmenuContext = addConsoleSubMenu(wapp_utilsConsoleCurrentContext,
                                           "ta>",
                                           consoleTestAppCommandArray,
                                           "Test Application",
                                           cParams,0,
                                           TestAppCB);
   if (iTestSubmenuContext == -1)
   {
      puts("AddConsoleMenu failed while adding 'TA' sub-menu");
   }
   else
   {
      iBringUpSubmenuContext = addConsoleSubMenu(iTestSubmenuContext,
                              "bringup>",
                              consoleBringUpCommandArray ,         
                              "bringup <password>",
                              subMenuParams,1,
                              BringUpCB);
      if (iBringUpSubmenuContext == -1)
      {
         puts("AddConsoleMenu failed while adding 'TA->Bringup' sub-menu");
         return;
      }
   }
   /* Add bringup->tx submenu */
   ret = addConsoleSubMenu(iBringUpSubmenuContext,
      "tx>",
      consoleBringUpTxCommandArray ,         
      "tx",
      cParams,0,
      BringUpTxCB);
   if(ret == -1)
   {
      puts("AddConsoleMenu failed while adding 'Bringup->TX' sub-menu");
      return -1;
   }
   ret = addConsoleSubMenu(iBringUpSubmenuContext,
      "rx>",
      consoleBringUpRxCommandArray ,         
      "rx",
      cParams,0,
      BringUpTxCB);
   if(ret == -1)
   {
      puts("AddConsoleMenu failed while adding 'Bringup->RX' sub-menu");
      return -1;
   }
#endif   /* INCLUDE_TESTAPP */
   return 0;
}  /* END wapp_utilsAddSubMenusToConsole() */



void dbg_switch_atu_flushall(void)
{/*
   int is_sw = tnetd53xx_emac_phy_is_switch(0);
   int result;

   if (is_sw <= 0)
   {
      puts("command not supported");
      return;
   }

   // flush all ATU entries 
   result = mv_tnetd53xx_emac_phy_atu_mng(
      0, MV_ATU_OP_FLUSH_ALL_ENTRIES, 0, NULL);

   if( result == 0)
      puts("Flushing all entries");
   else
      printf("Error code %d\n", result);*/
}

void dbg_switch_atu_flushunlocked(void)
{/*
   int result;
   int is_sw;

   is_sw = tnetd53xx_emac_phy_is_switch(0);
   if( is_sw <= 0)
   {
      puts( "command not supported");
      return;
   }

   // flush all ATU entries 
   result = mv_tnetd53xx_emac_phy_atu_mng(
      0, MV_ATU_OP_FLUSH_ALL_UNLOCKED_ENTRIES, 0, NULL);

   if( result == 0)
      puts("Flushing all unlocked entries");
   else
      printf("Error code %d\n", result);*/
}

void dbg_switch_atu_flushall_db(void)
{/*
   int is_sw = tnetd53xx_emac_phy_is_switch(0);
   int result;
   UINT32 dbn=0; 

   if (is_sw <= 0)
   {
      puts("Command not supported");
      return;
   }

   // flush all ATU entries 
   result = mv_tnetd53xx_emac_phy_atu_mng(
      0, MV_ATU_OP_FLUSH_DB, dbn, NULL);

   if( result == 0)
      printf("Flushing all entries in db %d\n", dbn);
   else
      printf("Error code %d\n", result);*/
}

void dbg_switch_atu_flushunlocked_db(void)
{/*
   int is_sw = tnetd53xx_emac_phy_is_switch(0);
   int result;
   UINT32 dbn=0;  //  this should be an argument

   if (is_sw <= 0)
   {
      puts("Command not supported");
      return;
   }

   // flush all ATU entries 
   result = mv_tnetd53xx_emac_phy_atu_mng(
      0, MV_ATU_OP_FLUSH_UNLOCKED_DB, dbn, NULL);

   if( result == 0)
      printf("Flushing all unlocked entries in db %d\n", dbn);
   else
      printf("Error code %d\n", result);*/
}

void dbg_switch_datu(void)
{/*
   // Display switch valid entries 

   UINT32 dbn = 0; // this should be an argument 
   int i;
   int result;
   int is_sw = tnetd53xx_emac_phy_is_switch(0);
   MV_SWITCH_ATU_ENTRY entry;

   if (is_sw <= 0)
   {
      puts("command not supported");
      return;
   }

   printf( "Displaying all learned MAC addresses at DB#%d:\n", dbn);
   memset( &(entry.atu_mac[0]), 0xff, sizeof(entry.atu_mac));
   i =0;
   do{
      mv_tnetd53xx_emac_phy_atu_mng( 0, MV_ATU_OP_GETNEXT, dbn, &entry);
      printf( "%5d   %02x-%02x-%02x-%02x-%02x-%02x  pri=0x%x pv=0x%02x state=0x%x %cCAST\n",
         ++i, (UINT)(entry.atu_mac[0]), (UINT)(entry.atu_mac[1]),
         (UINT)(entry.atu_mac[2]), (UINT)(entry.atu_mac[3]),
         (UINT)(entry.atu_mac[4]), (UINT)(entry.atu_mac[5]),
         (UINT)(entry.atu_data_entryPri),
         (UINT)(entry.atu_data_portVec),
         (UINT)(entry.atu_data_entryState),
         mv_tnetd53xx_emac_atu_is_mcast_addr(&entry) ? 'M':'U'
         );
   }while( ((entry.atu_mac[0] & entry.atu_mac[1] & entry.atu_mac[2] & entry.atu_mac[3] &
             entry.atu_mac[4] & entry.atu_mac[5]) != 0xff)
           && (entry.atu_data_entryState != MV_SWITCH_ATU_ENTRY_STATE_INVALID)
           );*/
}

void dbg_switch_atu_delMAC(UINT8 *p_buff)
{/*
   int result;
   char* tok = p_buff;
   unsigned int mac[6] = {0};
   UINT32 dbn =0;    // Add this as an argument 
   MV_SWITCH_ATU_ENTRY entry;

   // delete a MAC address from entry: rem <MAC> <dbNum> 
   int is_sw = tnetd53xx_emac_phy_is_switch(0);

   if (is_sw <= 0)
   {
      puts("Command not supported");
      return;
   }

   // validate MAC 
   if(! tok)
   {
      puts("Usage: rem <MAC> <dbNum>");
      return;
   }

   if( (sscanf( tok, fmtMac, &mac[0], &mac[1], &mac[2], &mac[3], &mac[4], &mac[5]) !=  6)
      || (mac[0] > 255) || (mac[1] > 255) || (mac[2] > 255)
      || (mac[3] > 255) || (mac[4] > 255) || (mac[5] > 255) )
   {
      puts("Invalid MAC address");
      return;
   }


   // Build command for switch 
   memset(&entry, 0, sizeof(entry));
   entry.atu_mac[0] = (UINT8)(mac[0]);
   entry.atu_mac[1] = (UINT8)(mac[1]);
   entry.atu_mac[2] = (UINT8)(mac[2]);
   entry.atu_mac[3] = (UINT8)(mac[3]);
   entry.atu_mac[4] = (UINT8)(mac[4]);
   entry.atu_mac[5] = (UINT8)(mac[5]);
   entry.atu_data_entryState = MV_SWITCH_ATU_ENTRY_STATE_INVALID;

   result = mv_tnetd53xx_emac_phy_atu_mng( 0, MV_ATU_OP_LOAD_PURGE_ENTRY, dbn, &entry);
   if( result == 0)
      printf( "Removing %02x-%02x-%02x-%02x-%02x-%02x from DB#%u\n", 
         mac[0],      mac[1],      mac[2],
         mac[3],      mac[4],      mac[5],
         dbn
         );
   else
      puts( "Failed");*/
}


int main(int argc, char **argv)
{	
	wcfginit init;


	memset(&init, 0, sizeof(init));
	strcpy(init.storage_file, WCFG_MTDBLOCK);

	if( !(wd = tiap_wcfg_init(&init)) )
		return 1;

	wdrv_dbInitRangeTables();

	wapp_utilsConsoleInit();
	consoleTask();

	return 0;
}


static void access_list_to_str(char *buff, int buff_size, tiap_param_access_list_t access_list, 
			       int *num_entries)
{
	 int i, res, count;
	 
	 char zeromac[ETH_ALEN];

	memset(zeromac, 0, sizeof(zeromac));
	*buff = '\0';
      
	    for (i=0, count=0, *num_entries=0; i<TIAP_PARAM_ACCESS_LIST_SIZE; ++i) 
	    {
	       /* if empty mac, return */

		if(! memcmp(access_list.list[i], zeromac, ETH_ALEN))
		{
		    return;     /* end of table */
		}
	
		res = sprintf(buff+count,   
			      "%2d : %02hhx-%02hhx-%02hhx-%02hhx-%02hhx-%02hhx\n", 
			      i+1, 
			      access_list.list[i][0], access_list.list[i][1],
			      access_list.list[i][2], access_list.list[i][3],
			      access_list.list[i][4], access_list.list[i][5]);
		if (count+5 > buff_size)    /* almost end of given buffer */
		    return;
		if (res<0) 
		    return;
		else
		    count+=res;
		(*num_entries)++;
	    }

}




//#undef _COMMAND_C_
